IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfPropertyValueUpdate')
	BEGIN
		PRINT 'Dropping Procedure adfPropertyValueUpdate'
		DROP  Procedure  adfPropertyValueUpdate
	END

GO

PRINT 'Creating Procedure adfPropertyValueUpdate'
GO
/******************************************************************************
**		File: 
**		Name: adfPropertyValueUpdate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**     ----------							-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfPropertyValueUpdate
	@DocumentClass TClass,
	@DocumentID TIdentifier,
	@PropertyID TIdentifier,
	@Value TPropertyValue
AS
	SET NOCOUNT ON

	DELETE [PropertyValue] WHERE [DocumentClass] = @DocumentClass AND [DocumentID] = @DocumentID AND
		[PropertyID] = @PropertyID
	IF @Value IS NOT NULL
	BEGIN
		INSERT INTO [PropertyValue]
			([DocumentClass], [DocumentID], [PropertyID], [Value])
		VALUES
			(@DocumentClass, @DocumentID, @PropertyID, @Value)
	END

	RETURN 0
GO

GRANT EXEC ON adfPropertyValueUpdate TO PUBLIC

GO
