IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfSetLabel')
	BEGIN
		PRINT 'Dropping Procedure adfSetLabel'
		DROP  Procedure  adfSetLabel
	END

GO

PRINT 'Creating Procedure adfSetLabel'
GO
/******************************************************************************
**		File: 
**		Name: adfSetLabel
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**     ----------							-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfSetLabel
	@Class TClass,
	@ID TIdentifier,
	@Color TColor
AS
	SET NOCOUNT ON
	DECLARE @ClassCode TCode
	SELECT @ClassCode = [Code] FROM [Class] WHERE [Class].[Class] = @Class
	
	IF @ClassCode = 'Pjm5.TimeEntry'
	BEGIN
		UPDATE [TimeEntry]
		SET
			[Color] = @Color,
			[CreatedBy] = DEFAULT,
			[Created] = DEFAULT
		WHERE
			[ID] = @ID
	END
	ELSE IF @ClassCode = 'Pjm5.ResourceRequest'
	BEGIN
		UPDATE [ResourceRequest]
		SET
			[Color] = @Color,
			[CreatedBy] = DEFAULT,
			[Created] = DEFAULT
		WHERE
			[ID] = @ID
	END
	ELSE IF @ClassCode = 'Pjm5.MeetingRequest'
	BEGIN
		UPDATE [MeetingRequest]
		SET
			[Color] = @Color,
			[CreatedBy] = DEFAULT,
			[Created] = DEFAULT
		WHERE
			[ID] = @ID
	END
	ELSE
	BEGIN
		RAISERROR('Unsupported class', 18, -1)
		RETURN 1
	END

	RETURN 0
GO

GRANT EXEC ON adfSetLabel TO PUBLIC
GO
