IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanyUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanyUpdate'
		DROP PROCEDURE [dbo].[adfCompanyUpdate]
	END
GO

PRINT 'Creating procedure adfCompanyUpdate'
GO

/******************************************************************************
**		File: adfCompanyUpdate.sql
**		Name: adfCompanyUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/04/2004 12:32:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		17.02.10	PAM				    LegalCode
**
**		6.05.10		KOV				  ApplyVAT
**    
**		21.05.10	KOV				  @ExchangeBanned, @ExportFinanceOnce
**		04.08.11	PAM				      
*******************************************************************************/
CREATE PROCEDURE adfCompanyUpdate
	@Xml XML,
	@ExtendedProperties XML
AS
	
	DECLARE @doc INT,
			@result INT,
			@ID TIdentifier,
			@FileAs TName,
			@FileAsOld	TName,
			@FoundationDate TDate,
			@LegalName TName,
			@KPP TCode,
			@LegalCode TCode,
			@BankAccountID TIdentifier,
			@ExecutiveEmployeeID TIdentifier,
			@AccountantEmployeeID TIdentifier,
			@ManagerEmployeeID TIdentifier,
			@Own TBool,
			@CompanySizeID TIdentifier,
			@CompanyTurnoverID TIdentifier,
			@CompanyStatusID TIdentifier,
			@Comments TNotes,
			@Class TClass,
			@LastContact TDate,
			@NextContact TDate,
			@Private TBool,
			@ApplyVAT TBool,
			@PaymentCurrencyPoint TBool,
			@ExchangeBanned TBool,
			@ExportFinanceOnce TBool,
			@Number TCode

	
			
	SET NOCOUNT ON
	
	
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	
	SELECT
		@ID	= [ID],
		@FileAs = [FileAs],
		@FoundationDate = CONVERT(datetime, [FoundationDate], 126),
		@LegalName = [LegalName],
		@KPP = [KPP],
		@LegalCode = CASE WHEN [LegalCode] = '' THEN NULL ELSE [LegalCode] END,
		@ApplyVAT = [ApplyVAT],
		@BankAccountID = [BankAccountID],
		@ExecutiveEmployeeID = [ExecutiveEmployeeID],
		@AccountantEmployeeID = [AccountantEmployeeID],
		@Own = (CASE [Own] WHEN 'false' THEN 0 ELSE 1 END),
		@ManagerEmployeeID = [ManagerEmployeeID],
		@CompanySizeID = [CompanySizeID],
		@CompanyTurnoverID = [CompanyTurnoverID],
		@CompanyStatusID = [CompanyStatusID],
		@Comments = [Comments],
		@LastContact = CONVERT(datetime, [LastContact], 126),
		@NextContact = CONVERT(datetime, [NextContact], 126),
		@Private = CASE WHEN [Private]='f' THEN 0 ELSE 1 END,
		@PaymentCurrencyPoint = [PaymentCurrencyPoint],
		@ExchangeBanned = [ExchangeBanned],
		@ExportFinanceOnce = [ExportFinanceOnce],
		@Number = [Number]

	FROM
		OPENXML(@doc, '/adfCompanyGet/Company', 2)
			WITH (
				[ID] INT,
				[FileAs] nvarchar(256),
				[FoundationDate] varchar(19),
				[LegalName] nvarchar(256),
				[KPP] varchar(32),
				[LegalCode] varchar(32),
				[ApplyVAT] varchar(5),
				[BankAccountID] INT,
				[ExecutiveEmployeeID] INT,
				[AccountantEmployeeID] INT,
				[Own] varchar(5),
				[ManagerEmployeeID] INT,
				[CompanySizeID] INT,
				[CompanyTurnoverID] INT,
				[CompanyStatusID] INT,
				[Comments] nvarchar(max),
				[LastContact] varchar(19),
				[NextContact] varchar(19),
				[Private] varchar(1),
				[PaymentCurrencyPoint] INT,
				[ExchangeBanned] varchar(5),
				[ExportFinanceOnce] varchar(5),
				[Number] varchar(32)
				)


	IF (@Own = 1 OR (SELECT [Own] FROM [Company] WHERE [ID] = @ID) = 1) AND dbo.adfHasAccessRightByName('ManageOwnCompanies') = 0
	BEGIN
		EXEC sp_xml_removedocument @doc
		RAISERROR('#accessdenied', 16, -1)
		RETURN 1
	END

	SET @FileAsOld = (SELECT [FileAs] FROM [Company] WHERE [ID] = @ID)

	BEGIN TRANSACTION
	
	UPDATE [Company]
	SET
		@Class = [Company].[Class],
		[Company].[FileAs] = @FileAs,
		[Company].[FoundationDate] = @FoundationDate,
		[Company].[LegalName] = @LegalName,
		[Company].[KPP] = @KPP,
		[Company].[LegalCode] = @LegalCode,
		[Company].[ApplyVAT] = @ApplyVAT,
		[Company].[BankAccountID] = @BankAccountID,
		[Company].[ExecutiveEmployeeID] = @ExecutiveEmployeeID,
		[Company].[AccountantEmployeeID] = @AccountantEmployeeID,
		[Company].[Own] = @Own,
		[Company].[ManagerEmployeeID] = @ManagerEmployeeID,
		[Company].[LastContact] = @LastContact,
		[Company].[NextContact] = @NextContact,
		[Company].[CompanySizeID] = @CompanySizeID,
		[Company].[CompanyTurnoverID] = @CompanyTurnoverID,
		[Company].[CompanyStatusID] = @CompanyStatusID,
		[Company].[Comments] = @Comments,
		[Company].[Modified] = DEFAULT,
		[Company].[ModifiedBy] = DEFAULT,
		[Company].[PaymentCurrencyPoint] = @PaymentCurrencyPoint,
		[Company].[ExchangeBanned] = @ExchangeBanned,
		[Company].[ExportFinanceOnce] = @ExportFinanceOnce,
		[Company].[Number] = @Number
	WHERE
		[Company].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	DECLARE @CurrentUserID TIdentifier
	
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	
	IF @Private = 1
	BEGIN
		IF NOT EXISTS(SELECT * FROM [UserContact] WHERE [UserID] = @CurrentUserID AND [BusinessCardClass] = @Class AND [BusinessCardID] = @ID)
		BEGIN
			INSERT INTO [UserContact] ([UserID], [BusinessCardClass], [BusinessCardID])
				VALUES(@CurrentUserID, @Class, @ID)
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				EXEC sp_xml_removedocument @doc
				RETURN 1
			END
		END
	END
	ELSE
	BEGIN
		IF EXISTS(SELECT * FROM [UserContact] WHERE [UserID] = @CurrentUserID AND [BusinessCardClass] = @Class AND [BusinessCardID] = @ID)
		BEGIN
			DELETE [UserContact]
			WHERE [UserID] = @CurrentUserID AND [BusinessCardClass] = @Class AND [BusinessCardID] = @ID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				EXEC sp_xml_removedocument @doc
				RETURN 1
			END
		END
	END	

	UPDATE [ExtendedProperties]
	SET
		[ExtendedProperties]=@ExtendedProperties
	WHERE
		[Class] = @Class AND [ID] = @ID
	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	DECLARE @XPathRoot nvarchar(256)
	
	SET @XPathRoot = '/adfCompanyGet'
	
	EXEC @result = adfBusinessCardUpdate @doc = @doc, @XPathRoot = @XPathRoot, 
		@ID = @ID, @Class = @Class, @FileAs = @FileAs, @Comments = @Comments,
		@CompanyID = @ID, @PositionID = NULL, @LastContact = @LastContact, @NextContact=@NextContact
	
	IF @@error != 0 OR @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	DELETE [CompanyIndustryBranch] WHERE [CompanyID] = @ID
	IF @@error != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	

	INSERT INTO [CompanyIndustryBranch] ([CompanyID], [IndustryBranchID])
	SELECT 
		@ID, [IndustryBranchID] 
	FROM
		OPENXML(@doc, '/adfCompanyGet/CompanyIndustryBranch', 2)
			WITH (
				[IndustryBranchID] INT
				)
	IF @@error != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	EXEC @result = adfCompanyCalendarCreate @ID, @Own
	IF @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	IF @FileAsOld != @FileAs
	BEGIN
		UPDATE [Folder]
		SET
			[Folder].[FileAs] = @FileAs
		WHERE
			[Folder].[CompanyID] = @ID AND
			[Folder].[FolderID] IS NULL
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
	END

	COMMIT TRANSACTION	
	
	EXEC sp_xml_removedocument @doc
	
	EXEC adfCompanyGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfCompanyUpdate TO PUBLIC
GO
