﻿IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm6trLanguageCodeUpdate')
	BEGIN
		PRINT 'Dropping Trigger pjm6trLanguageCodeUpdate'
		DROP  Trigger pjm6trLanguageCodeUpdate
	END
GO

/******************************************************************************
**		File: pjm6trLanguageCodeUpdate.sql
**		Name: pjm6trLanguageCodeUpdate
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: Anton.Paramonov
**		Date: 22.11.11 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm6trLanguageCodeUpdate'
GO
CREATE Trigger pjm6trLanguageCodeUpdate 
ON [LanguageCode] FOR UPDATE
AS
BEGIN
	IF @@ROWCOUNT = 0
		RETURN
	
	UPDATE [Country]
	SET [AutofillingLanguageCode] = [inserted].[code]
	FROM [inserted]
	INNER JOIN [deleted]
		ON [deleted].[ID] = [inserted].[ID]
	WHERE
		[Country].[AutofillingLanguageCode] = [deleted].[Code]
END
GO

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm6trLanguageCodeDelete')
	BEGIN
		PRINT 'Dropping Trigger pjm6trLanguageCodeDelete'
		DROP  Trigger pjm6trLanguageCodeDelete
	END
GO