IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfMailItemBrowseByElement]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfMailItemBrowseByElement'
		DROP PROCEDURE [dbo].[adfMailItemBrowseByElement]
	END
GO

PRINT 'Creating procedure adfMailItemBrowseByElement'
GO

SET QUOTED_IDENTIFIER ON
GO

/******************************************************************************
**		File: adfMailItemBrowseByElement.sql
**		Name: adfMailItemBrowseByElement
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/17/2006
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfMailItemBrowseByElement] 
	@DocumentClass TClass, 
	@DocumentID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE	@UserID int
	SET	@UserID = dbo.adfGetCurrentUserID()
	
	DECLARE @Class TClass
	SET @Class = dbo.adfGetClassByName('Adf.MailItem')

	SELECT
		[MailItem].[Class],
		[MailItem].[ID],
		[MailItem].[State],
		[MailItem].[Flag],
		[MailItem].[FileAs],
		[MailItem].[EventType],
		[MailItem].[FromID],
		[MailItem].[ToID],
		[MailItem].[DocumentID],
		[MailItem].[DocumentClass],
		CAST(ISNULL([DocumentUserState].[Read], 0) as bit) as [Read],
		[MailItem].[Data],
		[MailItem].[Data].value('(./Mail/Body/Text)[1]', 'nvarchar(max)') as [Comments],
		[MailItem].[Created],
		[MailItem].[CreatedBy],
		[MailItem].[Modified],
		[MailItem].[ModifiedBy],
		[MailItem].[Timestamp]
	FROM
		[MailItem] LEFT OUTER JOIN [DocumentUserState]
			ON ([DocumentUserState].[UserID] = @UserID AND 
				[DocumentUserState].[DocumentClass] = @Class AND 
				[DocumentUserState].[DocumentID] = [MailItem].[ID])	
	WHERE
		[MailItem].[DocumentClass] = @DocumentClass
	AND
		[MailItem].[DocumentID] = @DocumentID
		
	RETURN 0
GO

GRANT EXECUTE ON [adfMailItemBrowseByElement] TO PUBLIC
GO
  