IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfActivityExpenseWizardProjectsBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfActivityExpenseWizardProjectsBrowse'
		DROP PROCEDURE [dbo].[adfActivityExpenseWizardProjectsBrowse]
	END
GO

PRINT 'Creating procedure adfActivityExpenseWizardProjectsBrowse'
GO

/******************************************************************************
**		File: adfServicePWProjectsBrowse.sql
**		Name: adfServicePWProjectsBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/07/2004 12:32:27
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    29.09.09		syv				  
*******************************************************************************/
CREATE PROCEDURE [adfActivityExpenseWizardProjectsBrowse]
	@CostCentersXML			XML,
	@ProjectManagerXML		XML,
	@CustomerXML			XML,
	@ProjectTypeXML			XML,
	@CostCenterSelector		TBool,
	@ManagerSelector		TBool,
	@CustomerSelector		TBool,
	@WithEmptyCostCenter	INT,
	@WithEmptyManager		INT,
	@WithEmptyCustomer		INT
	
AS
	SET NOCOUNT ON
	
	DECLARE @CostCenters INT, @ProjectManager INT, @Customer INT, @ProjectType INT
	
	EXEC sp_xml_preparedocument @CostCenters OUTPUT, @CostCentersXML
	EXEC sp_xml_preparedocument @ProjectManager OUTPUT, @ProjectManagerXML
	EXEC sp_xml_preparedocument @Customer OUTPUT, @CustomerXML
	EXEC sp_xml_preparedocument @ProjectType OUTPUT, @ProjectTypeXML
		
	SELECT
		[Project].[ID],
		[Project].[Number],
		[Project].[FileAs],
		[Project].[State]
	FROM
		[Project]
	WHERE
	(
		@CostCenterSelector = 0
		OR
		(
		@CostCenterSelector = 1
			AND
			(
				[Project].[CostCenterID] IN 
				(
					SELECT [CentersTable].[ID] 
					FROM OPENXML(@CostCenters, '/CostCenters/CostCenter', 2) 
					WITH ( [ID] int ) AS [CentersTable]
				)
				OR 
				(
					@WithEmptyCostCenter = 1 
					AND 
					[Project].[CostCenterID] IS NULL
				)
			)
		)
	)
	AND 
	(
		@ManagerSelector = 0
		OR
		(
		@ManagerSelector = 1
			AND
			(
				[Project].[ProjectManagerEmployeeID] IN 
				(
					SELECT [ManagersTable].[ID] 
					FROM OPENXML(@ProjectManager, '/Managers/Manager', 2) 
					WITH ( [ID] int ) AS [ManagersTable]
				)
				OR 
				(
					@WithEmptyManager = 1 
					AND 
					[Project].[ProjectManagerEmployeeID]  IS NULL
				)
			)
		)
	)
	AND 
	(
		@CustomerSelector = 0
		OR		
		(
		@CustomerSelector = 1
			AND
			(
				[Project].[CustomerCompanyID] IN 
				(
					SELECT [CustomersTable].[ID] 
					FROM OPENXML(@Customer, '/Customers/Customer', 2) 
					WITH ( [ID] int ) 
					AS [CustomersTable]
				) 
				OR 
				(
					@WithEmptyCustomer = 1 
					AND 
					[Project].[CustomerCompanyID] IS NULL
				)
			)
		)
	)
	AND 
	(
		[Project].[ProjectTypeID] IN 
		(
			SELECT [ProjectTypesTable].[ID] 
			FROM OPENXML(@ProjectType, '/ProjectTypes/ProjectType', 2) 
			WITH ( [ID] int ) 
			AS [ProjectTypesTable]
		) 
	)
	AND ([Project].[State] IN (1,2))
	
	IF @@ERROR != 0
	BEGIN
		EXEC sp_xml_removedocument @CostCenters
		EXEC sp_xml_removedocument @ProjectManager
		EXEC sp_xml_removedocument @Customer
		EXEC sp_xml_removedocument @ProjectType
		RETURN 1
	END

	EXEC sp_xml_removedocument @CostCenters
	EXEC sp_xml_removedocument @ProjectManager
	EXEC sp_xml_removedocument @Customer
	EXEC sp_xml_removedocument @ProjectType
		
	RETURN 0
GO

GRANT EXECUTE ON [adfActivityExpenseWizardProjectsBrowse] TO PUBLIC
GO
 
 
