 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfIndustryBranchBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfIndustryBranchBrowse'
		DROP PROCEDURE [dbo].[adfIndustryBranchBrowse]
	END
GO

PRINT 'Creating procedure adfIndustryBranchBrowse'
GO

/******************************************************************************
**		File: adfIndustryBranchBrowse.sql
**		Name: adfIndustryBranchBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 19:52:15
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfIndustryBranchBrowse]
	@StateSelector TIdentifier
AS
	SET NOCOUNT ON
	SELECT
		[IndustryBranch].[ID],
		[IndustryBranch].[Class],
		[IndustryBranch].[State],
		[IndustryBranch].[Flag],
		[IndustryBranch].[Code],
		[IndustryBranch].[FileAs],
		[IndustryBranch].[Comments],
		[IndustryBranch].[Created],
		[IndustryBranch].[CreatedBy],
		[IndustryBranch].[Modified],
		[IndustryBranch].[ModifiedBy],
		[IndustryBranch].[Timestamp]
	FROM
		[IndustryBranch]
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [IndustryBranch].[State] = @StateSelector))

	RETURN 0
GO

GRANT EXECUTE ON [adfIndustryBranchBrowse] TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfIndustryBranchGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfIndustryBranchGet'
		DROP PROCEDURE [dbo].[adfIndustryBranchGet]
	END
GO

PRINT 'Creating procedure adfIndustryBranchGet'
GO

/******************************************************************************
**		File: adfIndustryBranchGet.sql
**		Name: adfIndustryBranchGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 19:52:15
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfIndustryBranchGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[IndustryBranch].[ID],
		[IndustryBranch].[Class],
		[IndustryBranch].[State],
		[IndustryBranch].[Flag],
		[IndustryBranch].[Code],
		[IndustryBranch].[FileAs],
		[IndustryBranch].[Comments],
		[IndustryBranch].[Created],
		[IndustryBranch].[CreatedBy],
		[IndustryBranch].[Modified],
		[IndustryBranch].[ModifiedBy],
		[IndustryBranch].[Timestamp]
	FROM
		[IndustryBranch]
	WHERE
		[IndustryBranch].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [adfIndustryBranchGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfIndustryBranchCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfIndustryBranchCreate'
		DROP PROCEDURE [dbo].[adfIndustryBranchCreate]
	END
GO

PRINT 'Creating procedure adfIndustryBranchCreate'
GO

/******************************************************************************
**		File: adfIndustryBranchCreate.sql
**		Name: adfIndustryBranchCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 19:52:15
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfIndustryBranchCreate]
	@Code TCode,
	@FileAs TName,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('241f8cf7-5524-4ca3-a27c-82e85f8328ec')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [IndustryBranch]
		([Flag], [State], [Code], [FileAs], [Comments])
	VALUES
		(0, @State, @Code, @FileAs, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC adfIndustryBranchGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfIndustryBranchCreate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfIndustryBranchUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfIndustryBranchUpdate'
		DROP PROCEDURE [dbo].[adfIndustryBranchUpdate]
	END
GO

PRINT 'Creating procedure adfIndustryBranchUpdate'
GO

/******************************************************************************
**		File: adfIndustryBranchUpdate.sql
**		Name: adfIndustryBranchUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 19:52:15
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfIndustryBranchUpdate
	@ID TIdentifier,
	@Code TCode,
	@FileAs TName,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[IndustryBranch]
	SET
		[IndustryBranch].[Code] = @Code,
		[IndustryBranch].[FileAs] = @FileAs,
		[IndustryBranch].[Comments] = @Comments,
		[IndustryBranch].[Modified] = GETDATE(),
		[IndustryBranch].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[IndustryBranch].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC adfIndustryBranchGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfIndustryBranchUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfIndustryBranchDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfIndustryBranchDelete'
		DROP PROCEDURE [dbo].[adfIndustryBranchDelete]
	END
GO

PRINT 'Creating procedure adfIndustryBranchDelete'
GO

/******************************************************************************
**		File: adfIndustryBranchDelete.sql
**		Name: adfIndustryBranchDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 19:52:15
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfIndustryBranchDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [IndustryBranch] WHERE [IndustryBranch].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfIndustryBranchDelete TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfIndustryBranchChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfIndustryBranchChangeState'
		DROP PROCEDURE [dbo].[adfIndustryBranchChangeState]
	END
GO

PRINT 'Creating procedure adfIndustryBranchChangeState'
GO

/******************************************************************************
**		File: adfIndustryBranchChangeState.sql
**		Name: adfIndustryBranchChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 19:52:15
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfIndustryBranchChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [IndustryBranch].[Class],
		@FromState = [IndustryBranch].[State]
	FROM
		[IndustryBranch]
	WHERE
		[IndustryBranch].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[IndustryBranch]
	SET
		[IndustryBranch].[State] = @ToState,
		[IndustryBranch].[Modified] = GETDATE(),
		[IndustryBranch].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[IndustryBranch].[ID] = @ID
	AND
		[IndustryBranch].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfIndustryBranchChangeState TO PUBLIC
GO
