IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfPositionBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfPositionBrowse'
		DROP PROCEDURE [dbo].[adfPositionBrowse]
	END
GO

PRINT 'Creating procedure adfPositionBrowse'
GO

/******************************************************************************
**		File: adfPositionBrowse.sql
**		Name: adfPositionBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 17:46:43
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfPositionBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[Position].[ID],
		[Position].[Class],
		[Position].[State],
		[Position].[Flag],
		[Position].[Code],
		[Position].[FileAs],
		[Position].[Comments],
		[Position].[Created],
		[Position].[CreatedBy],
		[Position].[Modified],
		[Position].[ModifiedBy],
		[Position].[Timestamp]
	FROM
		[Position]
	WHERE
		[Position].[State] < 100
	AND
		(
			(@StateSelector = 0) OR
			(@StateSelector != 0 AND [Position].[State] = @StateSelector)
		 )

	RETURN 0
GO

GRANT EXECUTE ON [adfPositionBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfPositionGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfPositionGet'
		DROP PROCEDURE [dbo].[adfPositionGet]
	END
GO

PRINT 'Creating procedure adfPositionGet'
GO

/******************************************************************************
**		File: adfPositionGet.sql
**		Name: adfPositionGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 17:46:43
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfPositionGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[Position].[ID],
		[Position].[Class],
		[Position].[State],
		[Position].[Flag],
		[Position].[Code],
		[Position].[FileAs],
		[Position].[Comments],
		[Position].[Created],
		[Position].[CreatedBy],
		[Position].[Modified],
		[Position].[ModifiedBy],
		[Position].[Timestamp]
	FROM
		[Position]
	WHERE
		[Position].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [adfPositionGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfPositionCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfPositionCreate'
		DROP PROCEDURE [dbo].[adfPositionCreate]
	END
GO

PRINT 'Creating procedure adfPositionCreate'
GO

/******************************************************************************
**		File: adfPositionCreate.sql
**		Name: adfPositionCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 17:46:43
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfPositionCreate]
	@Code TCode,
	@FileAs TName,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('1da4d0a6-ed0f-4840-9d29-3090013ba2fb')
	IF @State != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	INSERT INTO [Position]
		([Flag], [State], [Code], [FileAs], [Comments])
	VALUES
		(0, @State, @Code, @FileAs, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC adfPositionGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfPositionCreate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfPositionUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfPositionUpdate'
		DROP PROCEDURE [dbo].[adfPositionUpdate]
	END
GO

PRINT 'Creating procedure adfPositionUpdate'
GO

/******************************************************************************
**		File: adfPositionUpdate.sql
**		Name: adfPositionUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 17:46:43
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfPositionUpdate
	@ID TIdentifier,
	@Code TCode,
	@FileAs TName,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[Position]
	SET
		[Position].[Code] = @Code,
		[Position].[FileAs] = @FileAs,
		[Position].[Comments] = @Comments,
		[Position].[Modified] = DEFAULT,
		[Position].[ModifiedBy] = DEFAULT
	WHERE
		[Position].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC adfPositionGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfPositionUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfPositionDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfPositionDelete'
		DROP PROCEDURE [dbo].[adfPositionDelete]
	END
GO

PRINT 'Creating procedure adfPositionDelete'
GO

/******************************************************************************
**		File: adfPositionDelete.sql
**		Name: adfPositionDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 17:46:43
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfPositionDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [Position] WHERE [Position].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfPositionDelete TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfPositionChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfPositionChangeState'
		DROP PROCEDURE [dbo].[adfPositionChangeState]
	END
GO

PRINT 'Creating procedure adfPositionChangeState'
GO

/******************************************************************************
**		File: adfPositionChangeState.sql
**		Name: adfPositionChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 17:46:43
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfPositionChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [Position].[Class],
		@FromState = [Position].[State]
	FROM
		[Position]
	WHERE
		[Position].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[Position]
	SET
		[Position].[State] = @ToState,
		[Position].[Modified] = GETDATE(),
		[Position].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[Position].[ID] = @ID
	AND
		[Position].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfPositionChangeState TO PUBLIC
GO
 