IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfGetTrusteeType]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function adfGetTrusteeType'
		DROP FUNCTION [dbo].[adfGetTrusteeType]
	END

GO

PRINT 'Creating function adfGetTrusteeType'
GO
/******************************************************************************
**		File: 
**		Name: adfGetTrusteeType
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION adfGetTrusteeType (@name TSysname)
RETURNS INT
AS
BEGIN
	DECLARE @ID INT
	SET @ID = dbo.adfGetTrusteeID(@name)
	IF EXISTS(SELECT * FROM [User] WHERE [ID] = @ID)
		RETURN 2
	IF EXISTS(SELECT * FROM [Role] WHERE [ID] = @ID AND [IsGroup] = 0)
		RETURN 1
	IF EXISTS(SELECT * FROM [Role] WHERE [ID] = @ID AND [IsGroup] = 1)
		RETURN 4
	RETURN NULL
END
GO

GRANT EXEC ON adfGetTrusteeType TO PUBLIC
GO
