IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfRightBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfRightBrowse'
		DROP  Procedure  adfRightBrowse
	END

GO

PRINT 'Creating Procedure adfRightBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfRightBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfRightBrowse
AS
	DECLARE @Class TClass
	SET NOCOUNT ON
	
	SET @Class = dbo.adfGetClassByName('Adf.Right')

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	
	SELECT
		[Right].[ID],
		@Class as [Class],
		[Right].[Name],
		ISNULL([RightGlobal].[DisplayName], [Right].[DisplayName]) as [DisplayName],
		[Right].[Group],
		ISNULL([RightGlobal].[Comments], [Right].[Comments]) as [Comments],
		CAST('2004-06-04 13:00' as datetime) as Created,
		CAST('2004-06-04 13:00' as datetime) as Modified,
		1 as CreatedBy,
		1 as ModifiedBy
	FROM
		[Right] LEFT OUTER JOIN [RightGlobal]
			ON ([Right].[ID] = [RightGlobal].[ID] AND [RightGlobal].[Language] = @Lang)
	ORDER BY
		[Right].[DisplayName]
		
	SELECT
		[AccessRight].[RightID],
		[AccessRight].[TrusteeID],
		[Trustee].[Name],
		ISNULL([TrusteeGlobal].[DisplayName], [Trustee].[DisplayName]) as [DisplayName]
	FROM
		[AccessRight] INNER JOIN [Trustee]
			ON ([AccessRight].[TrusteeID] = [Trustee].[ID])
		LEFT OUTER JOIN [TrusteeGlobal]
			ON ([Trustee].[ID] = [TrusteeGlobal].[ID] AND [TrusteeGlobal].[Language] = @Lang)
	ORDER BY
		[Trustee].[DisplayName]
	
	RETURN 0
GO

GRANT EXEC ON adfRightBrowse TO PUBLIC
GO
