IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfRoleBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfRoleBrowse'
		DROP  Procedure  adfRoleBrowse
	END

GO

PRINT 'Creating Procedure adfRoleBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfRoleBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfRoleBrowse
AS
	DECLARE @Class TClass
	SET NOCOUNT ON

	SET @Class = dbo.adfGetClassByName('Adf.Role')
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT     
		[Trustee].[ID], 
		@Class as [Class], 
		[Trustee].[Name], 
		ISNULL([TrusteeGlobal].[DisplayName], [Trustee].[DisplayName]) as [DisplayName], 
		[Trustee].[CreatedBy], 
		[Trustee].[ModifiedBy], 
		[Trustee].[Created], 
		[Trustee].[Modified], 
		ISNULL([TrusteeGlobal].[Comments], [Trustee].[Comments]) as [Comments]
	FROM         
		[Role] INNER JOIN [Trustee] 
			ON ([Role].[ID] = [Trustee].[ID])
		LEFT OUTER JOIN [TrusteeGlobal]
			ON ([Trustee].[ID] = [TrusteeGlobal].[ID] AND [TrusteeGlobal].[Language] = @Lang)
	WHERE
		[Role].[IsGroup] = 0
		
	RETURN 0
GO

GRANT EXEC ON adfRoleBrowse TO PUBLIC
GO
