IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfUserGet')
	BEGIN
		PRINT 'Dropping Procedure adfUserGet'
		DROP  Procedure  adfUserGet
	END

GO

PRINT 'Creating Procedure adfUserGet'
GO
/******************************************************************************
**		File: 
**		Name: adfUserGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfUserGet
	@Name TSysname
AS
	SET NOCOUNT ON

	SELECT     
		[Trustee].[ID], 
		[Trustee].[Name], 
		[Trustee].[DisplayName], 
		[Trustee].[CreatedBy], 
		[Trustee].[ModifiedBy], 
		[Trustee].[Created], 
		[Trustee].[Modified], 
		[Trustee].[Comments],
		[User].[SQLLogin],
		[User].[NTLogin],
		[User].[Locked],
		(CASE WHEN [User].[Locked]=0 THEN 1 ELSE 2 END) as [State],
		[User].[ProductKey],
		[User].[SerialNumber],
		[User].[IsPermanent],
		[User].[InitialDate],
		[User].[ValidationData]
	FROM         
		[User] INNER JOIN [Trustee] ON [User].[ID] = [Trustee].[ID]
	WHERE
		[User].[ID] = dbo.adfGetUserID(@Name)

	RETURN 0
GO

GRANT EXEC ON adfUserGet TO PUBLIC
GO
