IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfUserLicenseUpdate')
	BEGIN
		PRINT 'Dropping Procedure adfUserLicenseUpdate'
		DROP  Procedure  adfUserLicenseUpdate
	END

GO

PRINT 'Creating Procedure adfUserLicenseUpdate'
GO
/******************************************************************************
**		File: 
**		Name: adfUserLicenseUpdate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfUserLicenseUpdate
	@ID TIdentifier,
	@ProductKey TName,
	@SerialNumber TName,
	@IsPermanent TBool,
	@InitialDate TDateTime,
	@ValidationData TVariant
AS
	DECLARE @result INT
	
	SET NOCOUNT ON

	UPDATE [User]
	SET
		[ProductKey] = @ProductKey,
		[SerialNumber] = @SerialNumber,
		[IsPermanent] = @IsPermanent,
		[InitialDate] = @InitialDate,
		[ValidationData] = @ValidationData
	WHERE
		[User].[ID] = @ID
		
	IF @@ERROR != 0 
	BEGIN
		RETURN 1
	END
	
	RETURN 0
GO

GRANT EXEC ON adfUserLicenseUpdate TO PUBLIC
GO
