IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfUserRolesGet')
	BEGIN
		PRINT 'Dropping Procedure adfUserRolesGet'
		DROP  Procedure  adfUserRolesGet
	END

GO

PRINT 'Creating Procedure adfUserRolesGet'
GO
/******************************************************************************
**		File: 
**		Name: adfUserRolesGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfUserRolesGet
	@UserID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[Trustee].[Name],
		ISNULL([TrusteeGlobal].[DisplayName],[Trustee].[DisplayName]) as [DisplayName],
		[Role].[IsGroup]
	FROM
		[UserRole] INNER JOIN [Trustee]
			ON ([UserRole].[RoleID] = [Trustee].[ID])
		INNER JOIN [Role]
			ON ([Trustee].[ID] = [Role].[ID])-- AND [Role].[IsGroup] = 0)
		LEFT OUTER JOIN [TrusteeGlobal]
			ON ([Trustee].[ID] = [TrusteeGlobal].[ID] AND [TrusteeGlobal].[Language] = @Lang)
	WHERE
		[UserRole].[UserID] = @UserID
	
	RETURN 0
GO

GRANT EXEC ON adfUserRolesGet TO PUBLIC
GO
