IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfuiCommandUpdate')
	BEGIN
		PRINT 'Dropping Procedure adfuiCommandUpdate'
		DROP  Procedure  adfuiCommandUpdate
	END

GO

PRINT 'Creating Procedure adfuiCommandUpdate'
GO
/******************************************************************************
**		File: 
**		Name: adfuiCommandUpdate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfuiCommandUpdate
	@ID TIdentifier,
	@Class TClass,
	@ActionID TIdentifier,
	@Name TSysname,
	@Text TName,
	@AlternateText TName,
	@Shortcut TName,
	@Picture TBlob,
	@Comments TNotes,
	@Position TIdentifier,
	@BeginGroup TBool
AS
	SET NOCOUNT ON
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	BEGIN TRANSACTION

	IF @Lang = 'ru'
	BEGIN	
		UPDATE [UICommand]
		SET
			[UICommand].[Class] = @Class,
			[UICommand].[ActionID] = @ActionID,
			[UICommand].[Name] = @Name,
			[UICommand].[Text] = @Text,
			[UICommand].[AlternateText] = @AlternateText,
			[UICommand].[Shortcut] = @Shortcut,
			[UICommand].[Picture] = @Picture,
			[UICommand].[Comments] = @Comments,
			[UICommand].[Position] = @Position,
			[UICommand].[BeginGroup] = @BeginGroup
		WHERE
			[UICommand].[ID] = @ID
	END
	ELSE
	BEGIN
		UPDATE [UICommand]
		SET
			[UICommand].[Class] = @Class,
			[UICommand].[ActionID] = @ActionID,
			[UICommand].[Name] = @Name,
			[UICommand].[Shortcut] = @Shortcut,
			[UICommand].[Picture] = @Picture,
			[UICommand].[Position] = @Position,
			[UICommand].[BeginGroup] = @BeginGroup
		WHERE
			[UICommand].[ID] = @ID
	END
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF EXISTS(SELECT * FROM [UICommandGlobal] WHERE [ID] = @ID AND [Language] = @Lang)
	BEGIN
		UPDATE [UICommandGlobal]
		SET
			[Text] = @Text,
			[AlternateText] = @AlternateText,
			[Comments] = @Comments
		WHERE
			[ID] = @ID AND [Language] = @Lang
	END
	ELSE
	BEGIN
		INSERT INTO [UICommandGlobal]
			([ID], [Language], [Text], [AlternateText], [Comments])
		VALUES		
			(@ID, @Lang, @Text, @AlternateText, @Comments)
	END
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
				
	EXEC adfuiCommandGet @ID

	RETURN 0
GO

GRANT EXEC ON adfuiCommandUpdate TO PUBLIC
GO
