IF EXISTS(
	SELECT * 
	FROM [InvoiceLine]
	WHERE [InvoiceLine].[TotalWithVATBC] > ROUND([InvoiceLine].[TotalBC] * (1 + [InvoiceLine].[VATRate]), 2) + 1
)
BEGIN
DECLARE 
		@NationalCurrencyCode TCode3, 
		@BaseCurrencyCode TCode3,
		@value TVariant

	EXEC adfParameterGet 'NationalCurrency', 'CommonBusiness', @value OUTPUT	
	SET @NationalCurrencyCode = CAST(@value AS varchar(3))
	EXEC adfParameterGet 'BaseCurrency', 'CommonBusiness', @value OUTPUT	
	SET @BaseCurrencyCode = CAST(@value AS varchar(3))

	ALTER TABLE [InvoiceLine] DISABLE TRIGGER ALL
	
	UPDATE
		[InvoiceLine]
	SET
		[TotalBC] = ROUND(CASE 
						WHEN [Project].[CurrencyCode] = @BaseCurrencyCode
							THEN [InvoiceLine].[PricePC] * [InvoiceLine].[Amount] - [InvoiceLine].[VATIsIncluded] * [InvoiceLine].[VATPC]
						WHEN [Invoice].[CurrencyCode] = @BaseCurrencyCode
							THEN [InvoiceLine].[Price] * [InvoiceLine].[Amount] - [InvoiceLine].[VATIsIncluded] * [InvoiceLine].[VAT]
						WHEN [Project].[CurrencyCode] = @NationalCurrencyCode
							THEN ([InvoiceLine].[PricePC] * [InvoiceLine].[Amount] - [InvoiceLine].[VATIsIncluded] * [InvoiceLine].[VATPC]) / [Invoice].[BaseCurrencyRate]
						ELSE ([InvoiceLine].[PricePC] * [InvoiceLine].[Amount] - [InvoiceLine].[VATIsIncluded] * [InvoiceLine].[VATPC]) * [Invoice].[BaseCurrencyRate]
					END, 2),
		[TotalWithVATBC] = ROUND(CASE 
						WHEN [Project].[CurrencyCode] = @BaseCurrencyCode
							THEN [InvoiceLine].[PricePC] * [InvoiceLine].[Amount] + (1 - [InvoiceLine].[VATIsIncluded]) * [InvoiceLine].[VATPC]
						WHEN [Invoice].[CurrencyCode] = @BaseCurrencyCode
							THEN [InvoiceLine].[Price] * [InvoiceLine].[Amount] + (1 - [InvoiceLine].[VATIsIncluded]) * [InvoiceLine].[VAT]
						WHEN [Project].[CurrencyCode] = @NationalCurrencyCode
							THEN ([InvoiceLine].[PricePC] * [InvoiceLine].[Amount] + (1 - [InvoiceLine].[VATIsIncluded]) * [InvoiceLine].[VATPC]) / [Invoice].[BaseCurrencyRate]
						ELSE ([InvoiceLine].[PricePC] * [InvoiceLine].[Amount] + (1 - [InvoiceLine].[VATIsIncluded]) * [InvoiceLine].[VATPC]) * [Invoice].[BaseCurrencyRate]
					END, 2)
	FROM
		[InvoiceLine]
		INNER JOIN [Invoice]
			ON [Invoice].[ID] = [InvoiceLine].[InvoiceID]
		INNER JOIN [Project]
			ON [Project].[ID] = [Invoice].[ProjectID]
	WHERE 
		[InvoiceLine].[TotalWithVATBC] > ROUND([InvoiceLine].[TotalBC] * (1 + [InvoiceLine].[VATRate]), 2) + 1
	
	ALTER TABLE [InvoiceLine] ENABLE TRIGGER ALL
END