DECLARE @Param TVariant,
		@doc INT,
		@xml XML,
		@build INT,
		@major INT,
		@minor INT,
		@revision INT
EXEC adfParameterGet 'DatabaseVersion', 'VersionInfo', @Param OUTPUT
SET @xml = CAST(@Param as varchar(8000))
EXEC sp_xml_preparedocument @doc OUTPUT, @xml
SELECT 
	@major = [major],
	@minor = [minor],
	@build = [build],
	@revision = [revision]
FROM 
	OPENXML(@doc, '/version', 1)
	WITH (
		[major] INT,
		[minor] INT,
		[build] INT,
		[revision] INT
		)
IF (@build<=CAST('1955' AS INT) AND @major<=CAST('6' AS INT) 
	AND @minor<=CAST('0' AS INT) AND @revision<=CAST('0' AS INT))
	OR @major<CAST('6' AS INT)
BEGIN
	UPDATE [TaskRequest]
	SET
		[TaskRequest].[State] = '5',
		[TaskRequest].[Modified] = DEFAULT,
		[TaskRequest].[ModifiedBy] = DEFAULT
	WHERE
		[TaskRequest].[State] = '3'	
END

GO