﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6CanEditBudget]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6CanEditBudget'
		DROP FUNCTION [dbo].[fnPjm6CanEditBudget]
	END

GO

PRINT 'Creating function fnPjm6CanEditBudget'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm6CanEditBudget
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 25.04.2011
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm6CanEditBudget(
	@BudgetID TIdentifier
	)
RETURNS TBool
AS
BEGIN
	DECLARE
		@BudgetClass			TClass,
		@CurrentEmployeeID		TIdentifier,
		@ProjectID				TIdentifier,
		@SupervisorEmployeeID	TIdentifier

	SELECT
		@ProjectID = [DocumentID],
		@SupervisorEmployeeID = [SupervisorEmployeeID],
		@BudgetClass = (CASE WHEN [Budget].[State] IN (1,2,3) THEN dbo.adfGetClassByName('Pjm6.Budget') ELSE dbo.adfGetClassByName('Pjm6.BudgetTemplate') END)
	FROM
		[Budget]
	WHERE
		[Budget].[ID] = @BudgetID

	IF @BudgetClass = dbo.adfGetClassByName('Pjm6.Budget') OR @BudgetClass IS NULL
	BEGIN
		IF dbo.adfHasAccessRightByName('ManageAllBudgets') = 1 
			RETURN 1

		SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
		

		IF dbo.adfHasAccessRightByName('ManageBudgets') = 1 
		BEGIN
			IF EXISTS (
			SELECT [ID] FROM [Project] 
			WHERE 
				[ID] = @ProjectID AND 
				[ProjectManagerEmployeeID] = @CurrentEmployeeID
				)
				RETURN 1
		END	
	

		IF @SupervisorEmployeeID = @CurrentEmployeeID AND dbo.adfHasAccessRightByName('ManageBudgets') = 1 
			RETURN 1
	END
	ELSE IF @BudgetClass = dbo.adfGetClassByName('Pjm6.BudgetTemplate')
	BEGIN
		IF dbo.adfHasAccessRightByName('ManageBudgets') = 1 AND dbo.adfHasAccessRightByName('ManageBudgetTemplates') = 1 
			RETURN 1
	END
	RETURN 0
END
GO
GRANT EXEC ON fnPjm6CanEditBudget TO PUBLIC
GO
  