﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6CanEditBudgetForProject]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6CanEditBudgetForProject'
		DROP FUNCTION [dbo].[fnPjm6CanEditBudgetForProject]
	END

GO

PRINT 'Creating function fnPjm6CanEditBudgetForProject'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm6CanEditBudgetForProject
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 26.04.2011
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm6CanEditBudgetForProject(
	@ProjectID TIdentifier
	)
RETURNS TBool
AS
BEGIN
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllBudgets')) = 1 
		RETURN 1

	DECLARE 
		@CurrentEmployeeID		TIdentifier

	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()

	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageBudgets')) = 1 
	BEGIN
		IF EXISTS (
		SELECT [ID] FROM [Project] 
		WHERE 
			[ID] = @ProjectID AND 
			[ProjectManagerEmployeeID] = @CurrentEmployeeID
			)
			RETURN 1
	END

	RETURN 0
END
GO
GRANT EXEC ON fnPjm6CanEditBudgetForProject TO PUBLIC
GO
  