IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetAttachmentList]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetAttachmentList'
		DROP FUNCTION [dbo].[fnPjm5GetAttachmentList]
	END

GO

PRINT 'Creating function fnPjm5GetAttachmentList'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetAttachmentList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetAttachmentList(@ID TIdentifier, @Class TClass)
RETURNS TName
AS
BEGIN
	
	DECLARE
		@Name		varchar(256),
		@Counter	int,
		@Attachments	nvarchar(2048),
		@LastSymbol	char(8)		
			
	DECLARE my_cursor CURSOR READ_ONLY FAST_FORWARD LOCAL FOR
		SELECT
			[Attachment].[Name],
			COUNT(*)
		FROM 
			[Attachment] 				
		WHERE
			[Attachment].[DocumentID] = @ID AND
			[Attachment].[DocumentClass] = @Class
		GROUP BY
			[Attachment].[Name]	
			
	OPEN my_cursor
	FETCH NEXT FROM my_cursor INTO @Name, @Counter
	
	WHILE @@FETCH_STATUS = 0
	BEGIN
		IF @Counter > 0
		BEGIN
			IF @Attachments IS NULL
				SET @Attachments = @Name
			ELSE
				SET @Attachments = @Attachments + N'; ' + @Name
		END
		FETCH NEXT FROM my_cursor INTO @Name, @Counter
	END
	IF @Attachments IS NOT NULL
	BEGIN
		SET @Attachments = RTRIM(@Attachments)
		SET @LastSymbol = RIGHT(@Attachments,1)
			IF @LastSymbol != '.'
			BEGIN
				SET @Attachments = @Attachments + N'.'
			END
	END
	CLOSE my_cursor
	DEALLOCATE my_cursor		
	RETURN(@Attachments)
END
GO

GRANT EXEC ON fnPjm5GetAttachmentList TO PUBLIC
GO
