IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetContactList]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetContactList'
		DROP FUNCTION [dbo].[fnPjm5GetContactList]
	END

GO

PRINT 'Creating function fnPjm5GetContactList'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetTaskListByAssignment
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetContactList(@ID TIdentifier, @Class TClass)
RETURNS TName
AS
BEGIN
	
	DECLARE
		@Name		varchar(256),
		@Counter	int,
		@Contacts	nvarchar(2048),
		@LastSymbol	char(8)		
			
	DECLARE my_cursor_contacts CURSOR READ_ONLY FAST_FORWARD LOCAL FOR
		SELECT
			[BusinessCard].[FileAs],
			COUNT(*)
		FROM 
			[DocumentContact] 				
			INNER JOIN	[BusinessCard]
				ON [DocumentContact].[BusinessCardID] = [BusinessCard].[ID] AND
					[DocumentContact].[BusinessCardClass] = [BusinessCard].[Class]
		WHERE
			[DocumentContact].[DocumentID] = @ID AND
			[DocumentContact].[DocumentClass] = @Class
		GROUP BY
			[BusinessCard].[FileAs]	
			
	OPEN my_cursor_contacts
	FETCH NEXT FROM my_cursor_contacts INTO @Name, @Counter
	
	WHILE @@FETCH_STATUS = 0
	BEGIN
		IF @Counter > 0
		BEGIN
			IF @Contacts IS NULL
				SET @Contacts = @Name
			ELSE
				SET @Contacts = @Contacts + N'; ' + @Name
		END
		FETCH NEXT FROM my_cursor_contacts INTO @Name, @Counter
	END
	IF @Contacts IS NOT NULL
	BEGIN
		SET @Contacts = RTRIM(@Contacts)
		SET @LastSymbol = RIGHT(@Contacts,1)
			IF @LastSymbol != '.'
			BEGIN
				SET @Contacts = @Contacts + N'.'
			END
	END
	CLOSE my_cursor_contacts
	DEALLOCATE my_cursor_contacts	
	RETURN(@Contacts)
END
GO

GRANT EXEC ON fnPjm5GetContactList TO PUBLIC
GO
