IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetProjectListByEmployeeForDate]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetProjectListByEmployeeForDate'
		DROP FUNCTION [dbo].[fnPjm5GetProjectListByEmployeeForDate]
	END

GO

PRINT 'Creating function fnPjm5GetProjectListByEmployeeForDate'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetTaskListByAssignment
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetProjectListByEmployeeForDate(@EmployeeID TIdentifier, @Date datetime, @DecimalSeparator varchar(1))
RETURNS TName
AS
BEGIN
	DECLARE @ProjectName	TName,
			@tmpName		TName,
			@tmpStrTime		TName,
			@tmpPlanned		decimal(18,1)
			
	DECLARE project CURSOR READ_ONLY FAST_FORWARD LOCAL FOR
	SELECT
		[Project].[Number],
		SUM(ROUND((([BusyEntry].[Planned] - [BusyEntry].[Canceled]) / 60.0), 2))
	FROM 
		[Project]
		INNER JOIN [BusyEntry]
			ON [BusyEntry].[ProjectID] = [Project].[ID]
		INNER JOIN [Task]
			ON [BusyEntry].[TaskID] = [Task].[ID]	
	WHERE
		[BusyEntry].[EmployeeID] = @EmployeeID AND 
		[BusyEntry].[Date] = @Date AND 
		[BusyEntry].[Planned] > [BusyEntry].[Canceled] AND
		[Project].[State] IN (1,2,3) AND
		[Task].[State] in (2,5,8) 
	GROUP BY 
		[Project].[Number]		
			
	OPEN project
	FETCH NEXT FROM project INTO @tmpName, @tmpPlanned
	WHILE @@FETCH_STATUS = 0
	BEGIN
		--------------
		SET @tmpStrTime = CAST(@tmpPlanned AS varchar(256))
		SET @tmpStrTime = LEFT(@tmpStrTime, LEN(@tmpStrTime) - 2) + @DecimalSeparator + RIGHT(@tmpStrTime, 1)
		SELECT @ProjectName = ISNULL(@ProjectName + ', ', '') + @tmpName + '(' + @tmpStrTime + ')'
		--------------
		FETCH NEXT FROM project INTO @tmpName, @tmpPlanned
	END
	CLOSE project
	DEALLOCATE project
	RETURN(@ProjectName)
END
GO

GRANT EXEC ON fnPjm5GetProjectListByEmployeeForDate TO PUBLIC
GO
