IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetTimeEntryBillableHour]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetTimeEntryBillableHour'
		DROP FUNCTION [dbo].[fnPjm5GetTimeEntryBillableHour]
	END

GO

PRINT 'Creating function fnPjm5GetTimeEntryBillableHour'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetTaskListByAssignment
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetTimeEntryBillableHour(@Class TClass, @ID TIdentifier)
RETURNS TAmount
AS
BEGIN
	DECLARE 
		@Result TAmount
	
	SELECT
		@Result = [CalculationLine].[Amount]
	FROM
		[CalculationLine] 
		INNER JOIN [Calculation]
			ON ([Calculation].[ID] = [CalculationLine].[CalculationID] AND [Calculation].[State] != 4)
	WHERE
		[CalculationLine].[DocumentClass] = @Class AND 
		[CalculationLine].[DocumentID] = @ID
		
	IF @Result IS NULL
		SELECT
			@Result = [InvoiceLine].[Amount]
		FROM
			[InvoiceLine] 
			INNER JOIN [Invoice]
				ON ([Invoice].[ID] = [InvoiceLine].[InvoiceID] AND [Invoice].[State] != 4)
		WHERE
			[InvoiceLine].[DocumentClass] = @Class AND 
			[InvoiceLine].[DocumentID] = @ID

	IF @Result IS NULL
		SELECT
			@Result = [StatementLine].[Amount]
		FROM
			[StatementLine] 
			INNER JOIN [Statement]
				ON ([Statement].[ID] = [StatementLine].[StatementID] AND [Statement].[State] != 4)
		WHERE
			[StatementLine].[DocumentClass] = @Class AND 
			[StatementLine].[DocumentID] = @ID
	RETURN @Result
END
GO

GRANT EXEC ON fnPjm5GetTimeEntryBillableHour TO PUBLIC
GO
 