IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetWorkingDays]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetWorkingDays'
		DROP FUNCTION [dbo].[fnPjm5GetWorkingDays]
	END

GO

PRINT 'Creating function fnPjm5GetWorkingDays'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetTaskListByAssignment
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetWorkingDays(@StartDate datetime, @EndDate datetime)
RETURNS int
AS
BEGIN
	DECLARE @days int,
			@curdate datetime,
			@findate datetime,
			@value TVariant, @daymask int
	
	SET @days = 1
	
	SET @curdate = CAST(CONVERT(varchar(8), @StartDate, 112) AS DATETIME)
	SET @findate = CAST(CONVERT(varchar(8), @EndDate, 112) AS DATETIME)
	
	IF (@curdate > @findate)
	BEGIN
		RETURN 0
	END
	
	IF (@EndDate IS NULL)
	BEGIN
		RETURN 0
	END

	SELECT @value = Value FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Name]='WorkDaysOfWeek' AND [Group]='Pjm5'
	SET @daymask = CAST(@value as int)

	IF (dbo.fnPjm5IsWorkingDayByMask(@curdate, @daymask) = 0)
	BEGIN
		SET @days = 0
	END
	
	WHILE (@curdate != @findate)
	BEGIN
		SET @curdate = DATEADD(day, 1, @curdate)
		IF (dbo.fnPjm5IsWorkingDayByMask(@curdate, @daymask) = 1)
		BEGIN
			SET @days = @days + 1
		END
	END
	
	RETURN @days
END
GO

GRANT EXEC ON fnPjm5GetWorkingDays TO PUBLIC
GO
