IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5RoundedDuration]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5RoundedDuration'
		DROP FUNCTION [dbo].[fnPjm5RoundedDuration]
	END

GO

PRINT 'Creating function fnPjm5RoundedDuration'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5RoundedDuration
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5RoundedDuration(
	@Duration	TCount,
	@Interval	TCount,
	@Mode		int
	)
RETURNS int
AS
BEGIN
	IF @Mode = 0
		RETURN @Duration
		
	IF @Interval = 0
		RETURN @Duration
		
	DECLARE 
		@FixValue	int,
		@DecValue	int,
		@Value		int
		
	SELECT
		@FixValue = CAST(@Duration / @Interval AS int) * @Interval,
		@DecValue = @Duration - @FixValue

	IF (@FixValue = @Duration) OR
		(@Mode = 1) OR 
		(@Mode = 3 AND @DecValue < (CAST(@Interval AS decimal(8,2)) * 0.5))
		SET @Value = @FixValue
		
	IF (@Mode = 2 AND @FixValue < @Duration) OR 
		(@Mode = 3 AND @DecValue >= CAST(@Interval AS decimal(8,2)) * 0.5)
		SET @Value = @FixValue + @Interval
		
	RETURN @Value
END
