IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6PeriodTypeNameGet]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6PeriodTypeNameGet'
		DROP FUNCTION [dbo].[fnPjm6PeriodTypeNameGet]
	END

GO

PRINT 'Creating function fnPjm6PeriodTypeNameGet'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm6PeriodTypeNameGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm6PeriodTypeNameGet(@Type TIdentifier)
RETURNS TName
AS
BEGIN
	IF @Type IS NULL
		RETURN NULL

    /*
    Weekly = 0,
    Decade = 1,
    Monthly = 2,
    MonthNth = 3,
    Yearly = 4,
    YearNth = 5
    */
		
	DECLARE @language TLanguage
	SET @language = dbo.adfGetLanguage()
	IF @language = 'en'
	BEGIN
		IF @Type = 0
			RETURN 'Weekly'
		ELSE IF @Type = 1
			RETURN 'Decade'
		ELSE IF @Type = 2
			RETURN 'Monthly'
		ELSE IF @Type = 3
			RETURN 'Monthly'
		ELSE IF @Type = 4
			RETURN 'Yearly'
		ELSE IF @Type = 5
			RETURN 'Yearly'
	END
	ELSE
	BEGIN
		IF @Type = 0
			RETURN ''
		ELSE IF @Type = 1
			RETURN ''
		ELSE IF @Type = 2
			RETURN ''
		ELSE IF @Type = 3
			RETURN ''
		ELSE IF @Type = 4
			RETURN ''
		ELSE IF @Type = 5
			RETURN ''
	END
	RETURN NULL
END
GO

GRANT EXEC ON fnPjm6PeriodTypeNameGet TO PUBLIC
GO
  