IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'pjm5AssignmentGetByEmployee')
	BEGIN
		PRINT 'Dropping Procedure pjm5AssignmentGetByEmployee'
		DROP  Procedure  pjm5AssignmentGetByEmployee
	END

GO

PRINT 'Creating Procedure pjm5AssignmentGetByEmployee'
GO
/******************************************************************************
**		File: 
**		Name: pjm5AssignmentGetByEmployee
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure pjm5AssignmentGetByEmployee
	@ID			TIdentifier OUTPUT,
	@EmployeeID	TIdentifier,
	@ProjectID	TIdentifier
AS
	DECLARE @CurrentEmployeeID int

	SET NOCOUNT ON
		
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	
	IF @EmployeeID IS NULL OR @EmployeeID <= 0
	BEGIN
		SET @EmployeeID = @CurrentEmployeeID
	END
	ELSE IF @EmployeeID != @CurrentEmployeeID
	BEGIN
		IF dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0 AND
			dbo.fnPjm5IsProjectAdministrator(@ProjectID, @CurrentEmployeeID) = 0
		BEGIN
			RAISERROR('#NotEnoughPermissionsForCreateJournalEntry', 18, -1)
			RETURN 1
		END
	END
	
	SELECT
		@ID = [ID]
	FROM
		[vwAssignment]
	WHERE
		[ProjectID] = @ProjectID AND [EmployeeID] = @EmployeeID AND [State] = 1
		
	IF @ID IS NULL
	BEGIN
		RAISERROR('#NotEnoughPermissionsForCreate', 18, -1)
		RETURN 1
	END

	RETURN 0
GO

GRANT EXEC ON pjm5AssignmentGetByEmployee TO PUBLIC
GO
