IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6AssignmentsAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6AssignmentsAdd'
		DROP PROCEDURE [dbo].[pjm6AssignmentsAdd]
	END
GO

PRINT 'Creating procedure pjm6AssignmentsAdd'
GO

/******************************************************************************
**		File: pjm6AssignmentsAdd.sql
**		Name: pjm6AssignmentsAdd
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Yuriy.Soldatkin
**		Date: 10/27/2009
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    15.04.10		SYV				 ,        
*******************************************************************************/
CREATE PROCEDURE pjm6AssignmentsAdd
	@Xml XML,
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @State TState,
			@ID TIdentifier,
			@FileAs TName,
			@QualificationID TIdentifier,
			@StandardRate TMoney,
			@OvertimeRate TMoney,
			@RateVisible TBool,
			@Approver TBool,
			@Administrator TBool,
			@TaskReport TBool,
			@IssueReport TBool,
			@Comments TNotes,
			@AlwaysUseRate TBool,
			@IsMember TBool,
			@IsAssistant TBool,
			@IsAssignmentEditor TBool,
			@MsProjectID TIdentifier,
			@IsError TBool,
			@IsError_EmployeeFire TBool,
			@IsLocalError TBool,
			@rv INT,
			@doc INT
	
	SET @IsError_EmployeeFire = 0
	SET @IsError = 0
	SET @State = dbo.adfwfGetInitialState('7797bd53-86ce-415e-9e13-b11bcbd52359')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SELECT @MsProjectID = [MsProjectID] FROM [Project] WHERE [ID] = @ProjectID
	IF @MsProjectID IS NOT NULL
	BEGIN
		RAISERROR('#documentfrommsproject', 18, -1)
		RETURN 1
	END

	DECLARE @CurrentEmployeeID int, 
			@ProjectState TState,
			@IsPM TBool

	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0
	BEGIN
		SET @IsPM = dbo.adfHasAccessRight(dbo.adfGetRightID('ManageProjectTemplates'))
		SELECT @ProjectState = [State] FROM [Project] WHERE [ID] = @ProjectID
		
		SET @IsMember = dbo.fnPjm5IsProjectMember(@ProjectID, @CurrentEmployeeID)
		SET @IsAssistant = dbo.adfHasAccessRight(dbo.adfGetRightID('Assistant'))
		SET @IsAssignmentEditor = 
				(@IsAssistant | @IsMember) 
			& 
				(dbo.adfHasAccessRight(dbo.adfGetRightID('EditAssignment')) & dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')))
		IF	(
			NOT(
				(@ProjectState IN (5, 6) AND @IsPM = 1) OR
				(@ProjectState NOT IN (5, 6) AND @IsAssignmentEditor = 1)
				)
			)
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END
	
	IF EXISTS (SELECT * FROM [ProjectTemplate] WHERE [ID] = @ProjectID)
	BEGIN
		SET @State = 3
	END

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	DECLARE @AddEmployeeID TIdentifier
	DECLARE For_Add CURSOR LOCAL FAST_FORWARD FOR 
		SELECT 
			[ID] 
		FROM
		OPENXML(@doc, '/Employee/Assignments', 2)
			WITH (
				[ID] int
				)
	OPEN For_Add
	FETCH NEXT FROM For_Add INTO @AddEmployeeID
	WHILE @@FETCH_STATUS = 0
	BEGIN
		SELECT
			@FileAs = [FileAs], 
			@QualificationID = [QualificationID]
		FROM
			[Employee]
		WHERE
			[Employee].[ID] = @AddEmployeeID
		
		SET @StandardRate = 0
		SET @OvertimeRate = 0
		
		IF (@QualificationID IS NOT NULL)
		BEGIN
			SELECT 
				@StandardRate = [Standard],
				@OvertimeRate = [Overtime]
			FROM
				[QualificationRate], [Project]
			WHERE
				[QualificationRate].[QualificationID] = @QualificationID
			AND
				[Project].[ID] = @ProjectID
			AND
				[QualificationRate].[CurrencyCode] = [Project].[CurrencyCode]
		END
		ELSE
		BEGIN
			SET @StandardRate = NULL
			SET	@OvertimeRate = NULL
		END

		DECLARE @Param TVariant
		EXEC adfParameterGet 'ShowRateInTimeEntry', 'Pjm5', @Param OUTPUT
		IF(@Param IS NULL)
		BEGIN
			SET @Param = 0 
		END
	
		SET @RateVisible = 0
		SET @AlwaysUseRate = 0
		SET @Comments = NULL
		SET @Approver = 0
		SET @Administrator = 0
		SET @TaskReport = 0
		SET @IssueReport = 0
		
		SET @IsLocalError = 0
		IF @AddEmployeeID IS NOT NULL AND
			EXISTS (
			SELECT 
				*
			FROM
				[vwAssignment] AS [Assignment]
			WHERE
				[Assignment].[ProjectID]  = @ProjectID AND
				[Assignment].[EmployeeID]  = @AddEmployeeID AND
				[Assignment].[State] = @State
			) 
		BEGIN
			SET @IsError = 1
			SET @IsLocalError = 1
		END
		
		IF @AddEmployeeID IS NOT NULL AND
			EXISTS (
			SELECT 
				*
			FROM
				[Employee]
			WHERE
				[ID]  = @AddEmployeeID AND
				[State] = 2
			) 
		BEGIN
			SET @IsError_EmployeeFire = 1
			SET @IsLocalError = 1
		END
		
		IF(@IsLocalError = 0)
		BEGIN
			BEGIN TRANSACTION
			EXEC @rv = pjm5AssignmentCreateInternal
					@ID OUTPUT,
					0,
					@State,
					@FileAs,
					@AddEmployeeID,
					@ProjectID,
					@QualificationID,
					@StandardRate,
					@OvertimeRate,
					@RateVisible,
					@Approver,
					@Administrator,
					@TaskReport,
					@IssueReport,
					@Comments,
					@AlwaysUseRate
			IF @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
			END
			ELSE
			BEGIN
				COMMIT TRANSACTION
				EXEC pjm5AssignmentGet @ID
			END
		END
		FETCH NEXT FROM For_Add INTO @AddEmployeeID
	END
	CLOSE For_Add
	DEALLOCATE For_Add

	IF(@IsError = 1)
	BEGIN		
		RAISERROR('#AssignmentAlreadyExist', 18, -1)
	END
	IF(@IsError_EmployeeFire = 1)
	BEGIN		
		RAISERROR('#EmployeeFire', 18, -1)
	END
	EXEC sp_xml_removedocument @doc
	RETURN 0
GO

GRANT EXECUTE ON pjm6AssignmentsAdd TO PUBLIC
GO