IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6MasterUpdatesRates]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6MasterUpdatesRates'
		DROP PROCEDURE [dbo].[pjm6MasterUpdatesRates]
	END
GO

PRINT 'Creating procedure pjm6MasterUpdatesRates'
GO

/******************************************************************************
**		File: pjm6MasterUpdatesRates.sql
**		Name: pjm6MasterUpdatesRates
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: yuriy.soldatkin
**		Date: 25/10/2010
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		28.10.10	SYV				ProjectID   Xml
*******************************************************************************/

CREATE PROCEDURE [pjm6MasterUpdatesRates]
	@PeriodStart					TDateTime,
	@PeriodEnd						TDateTime,
	@UpdateServiceAssignmentEntry	TBool,
	@EmployeeXML					XML
AS
	SET NOCOUNT ON
	
	IF dbo.adfHasAccessRightByName('ManageAllTimeEntries') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	DECLARE @Employees INT,
			@ServiceAssignmentClass TClass,
			@HasManageTasksRight TBool,
			@HasAuthorIssueRight TBool,
			@HasEditIssueRight TBool,
			@HasAuthorTaskRight TBool,
			@HasManageServiceAssignmentRight TBool,
			@HasAuthorServiceRequestRight TBool,
			@HasManageTaskRequestRight TBool,
			@HasManageAllTaskRequestRight TBool,
			@HasAuthorJournalEntryRight TBool
			
	SET @HasManageTasksRight = 1
	SET @HasAuthorIssueRight = 1
	SET @HasEditIssueRight = 1
	SET @HasAuthorTaskRight = 1
	SET @HasManageServiceAssignmentRight = 1
	SET @HasAuthorServiceRequestRight = 1
	SET @HasManageTaskRequestRight = 1
	SET @HasManageAllTaskRequestRight = 1
	SET @HasAuthorJournalEntryRight = 1
	
	EXEC sp_xml_preparedocument @Employees OUTPUT, @EmployeeXML
			
	SET @ServiceAssignmentClass = dbo.adfGetClassByName('Pjm5.ServiceAssignment')


	BEGIN TRANSACTION

	--  

	INSERT INTO [Right] ([Name],[DisplayName],[Group]) VALUES('MasterUpdateTimeEntry', '', '')
	
	EXEC pjm6SetRightForMasters 'MasterUpdateTimeEntry'

	IF(dbo.adfHasAccessRightByName('ManageTasks') = 0)
	BEGIN
		SET @HasManageTasksRight = 0
		EXEC pjm6SetRightForMasters 'ManageTasks'
	END

	IF(dbo.adfHasAccessRightByName('AuthorIssue') = 0)
	BEGIN
		SET @HasAuthorIssueRight = 0
		EXEC pjm6SetRightForMasters 'AuthorIssue'
	END
	
	IF(dbo.adfHasAccessRightByName('EditIssue') = 0)
	BEGIN
		SET @HasEditIssueRight = 0
		EXEC pjm6SetRightForMasters 'EditIssue'
	END
	
	IF(dbo.adfHasAccessRightByName('AuthorTask') = 0)
	BEGIN
		SET @HasAuthorTaskRight = 0
		EXEC pjm6SetRightForMasters 'AuthorTask'
	END	
	
	IF(dbo.adfHasAccessRightByName('ManageServiceAssignment') = 0)
	BEGIN
		SET @HasManageServiceAssignmentRight = 0
		EXEC pjm6SetRightForMasters 'ManageServiceAssignment'
	END	
	
	IF(dbo.adfHasAccessRightByName('AuthorServiceRequest') = 0)
	BEGIN
		SET @HasAuthorServiceRequestRight = 0
		EXEC pjm6SetRightForMasters 'AuthorServiceRequest'
	END	
	
	IF(dbo.adfHasAccessRightByName('ManageTaskRequest') = 0)
	BEGIN
		SET @HasManageTaskRequestRight = 0
		EXEC pjm6SetRightForMasters 'ManageTaskRequest'
	END
	
	IF(dbo.adfHasAccessRightByName('ManageAllTaskRequest') = 0)
	BEGIN
		SET @HasManageAllTaskRequestRight = 0
		EXEC pjm6SetRightForMasters 'ManageAllTaskRequest'
	END	

	IF(dbo.adfHasAccessRightByName('AuthorJournalEntry') = 0)
	BEGIN
		SET @HasAuthorJournalEntryRight = 0
		EXEC pjm6SetRightForMasters 'AuthorJournalEntry'
	END

	DECLARE @StandardRate	TMoney,
			@OvertimeRate	TMoney,
			@EmployeeID		TIdentifier,
			@ProjectID		TIdentifier
			
	DECLARE RateUpdate CURSOR LOCAL FAST_FORWARD FOR 
		SELECT 
			[ID],
			[StandardRate],
			[OvertimeRate],
			[ProjectID]
		FROM
		OPENXML(@Employees, '/Employees/Employee', 2)
			WITH (
				[ID]	TIdentifier,
				[StandardRate]	TMoney,
				[OvertimeRate]	TMoney,
				[ProjectID] TIdentifier
				)
	
	--     
				
	OPEN RateUpdate
	FETCH NEXT FROM RateUpdate INTO @EmployeeID, @StandardRate, @OvertimeRate, @ProjectID
	WHILE @@FETCH_STATUS = 0
	BEGIN
		
		IF(@UpdateServiceAssignmentEntry = 0)
		BEGIN	
			--  ServiceAssignment
			UPDATE [TimeEntry]
			SET
				[TimeEntry].[Rate] = dbo.fnPjm6GetServiceAssignmentRate([Assignment].[ID], [ServiceAssignment].[ID], 
					CASE WHEN [TimeEntry].[Overtime] = 0 THEN @StandardRate ELSE @OvertimeRate END)
			FROM
				[TimeEntry]
				INNER JOIN [ServiceAssignment]
					ON [TimeEntry].[DocumentID] = [ServiceAssignment].[ID]
				INNER JOIN [Assignment]
					ON [TimeEntry].[AssignmentID] = [Assignment].[ID]	
			WHERE
				[TimeEntry].[DocumentClass] = @ServiceAssignmentClass
				AND			
				[TimeEntry].[ProjectID] = @ProjectID AND [TimeEntry].[EmployeeID] = @EmployeeID
				AND
				[TimeEntry].[State] IN (1, 2, 3, 5)
				AND
				NOT (
					[Assignment].[AlwaysUseRate] = 0
					AND
					[ServiceAssignment].[PaymentTermID] = 3
					AND
					[ServiceAssignment].[Price] IS NOT NULL
				)
				AND
				[TimeEntry].[StartTime] > @PeriodStart
				AND
				[TimeEntry].[StartTime] < @PeriodEnd
			
			--   ServiceAssignment
			UPDATE [TimeEntry]
			SET
				[TimeEntry].[Rate] = CASE WHEN [TimeEntry].[Overtime] = 0 THEN @StandardRate ELSE @OvertimeRate END
			FROM
				[TimeEntry]
			WHERE
				ISNULL([TimeEntry].[DocumentClass], -1) != @ServiceAssignmentClass
				AND
				[TimeEntry].[ProjectID] = @ProjectID AND [TimeEntry].[EmployeeID] = @EmployeeID
				AND
				[TimeEntry].[State] IN (1, 2, 3, 5)
				AND
				[TimeEntry].[StartTime] > @PeriodStart
				AND
				[TimeEntry].[StartTime] < @PeriodEnd
					
			IF @@ERROR != 0
			BEGIN
				CLOSE RateUpdate
				DEALLOCATE RateUpdate
				ROLLBACK TRANSACTION
				EXEC sp_xml_removedocument @Employees
				RETURN 1
			END
		END
		ELSE
		BEGIN
			-- 
			UPDATE [TimeEntry]
			SET
				[TimeEntry].[Rate] = CASE WHEN [TimeEntry].[Overtime] = 0 THEN @StandardRate ELSE @OvertimeRate END
			FROM
				[TimeEntry]
			WHERE
				[TimeEntry].[ProjectID] = @ProjectID AND [TimeEntry].[EmployeeID] = @EmployeeID
				AND
				[TimeEntry].[State] IN (1, 2, 3, 5)
				AND
				[TimeEntry].[StartTime] > @PeriodStart
				AND
				[TimeEntry].[StartTime] < @PeriodEnd
							
			IF @@ERROR != 0
			BEGIN
				CLOSE RateUpdate
				DEALLOCATE RateUpdate
				ROLLBACK TRANSACTION
				EXEC sp_xml_removedocument @Employees
				RETURN 1
			END
		END
		
		FETCH NEXT FROM RateUpdate INTO @EmployeeID, @StandardRate, @OvertimeRate, @ProjectID
	END

	CLOSE RateUpdate
	DEALLOCATE RateUpdate

	--     

	EXEC pjm6DelRightForMasters 'MasterUpdateTimeEntry'

	DELETE [Right] WHERE [Name] = 'MasterUpdateTimeEntry'

	IF(@HasManageTasksRight = 0)
	BEGIN
		EXEC pjm6DelRightForMasters 'ManageTasks'
	END

	IF(@HasAuthorIssueRight = 0)
	BEGIN
		EXEC pjm6DelRightForMasters 'AuthorIssue'
	END

	IF(@HasEditIssueRight = 0)
	BEGIN
		EXEC pjm6DelRightForMasters 'EditIssue'
	END

	IF(@HasAuthorTaskRight = 0)
	BEGIN
		EXEC pjm6DelRightForMasters 'AuthorTask'
	END

	IF(@HasManageServiceAssignmentRight = 0)
	BEGIN
		EXEC pjm6DelRightForMasters 'ManageServiceAssignment'
	END

	IF(@HasAuthorServiceRequestRight = 0)
	BEGIN
		EXEC pjm6DelRightForMasters 'AuthorServiceRequest'
	END
	
	IF(@HasManageTaskRequestRight = 0)
	BEGIN
		EXEC pjm6DelRightForMasters 'ManageTaskRequest'
	END

	IF(@HasManageAllTaskRequestRight = 0)
	BEGIN
		EXEC pjm6DelRightForMasters 'ManageAllTaskRequest'
	END

	IF(@HasAuthorJournalEntryRight = 0)
	BEGIN
		EXEC pjm6DelRightForMasters 'AuthorJournalEntry'
	END

	COMMIT TRANSACTION

	EXEC sp_xml_removedocument @Employees

	RETURN 0
	
GO

GRANT EXECUTE ON [pjm6MasterUpdatesRates] TO PUBLIC
GO