﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetCalculateActualTotalsForSubProjects]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetCalculateActualTotalsForSubProjects'
		DROP PROCEDURE [dbo].[pjm6BudgetCalculateActualTotalsForSubProjects]
	END
GO

PRINT 'Creating procedure pjm6BudgetCalculateActualTotalsForSubProjects'
GO

/******************************************************************************
**		File: BudgetCalculateActualTotalsForSubProjects.sql
**		Name: pjm6BudgetCalculateActualTotalsForSubProjects
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 21/01/2011 17:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetCalculateActualTotalsForSubProjects]
	@ProjectID TIdentifier,
	@RootBudgetTypeID		TIdentifier,
	@RootBudgetStartDate	TDate,
	@RootBudgetEndDate		TDate,
	@RootCurrencyCode		TCode3,
	@RootTimeEntryActualTotalsAccount			TIdentifier,
	@PlannedManHourWithSub						TAmount OUTPUT,
	@ActualManHourWithSub						TAmount OUTPUT,
	@TotalPCPlannedManHourWithSub				TMoney OUTPUT,
	@TotalWithVATPCPlannedManHourWithSub		TMoney OUTPUT,
	@TotalPCActualManHourWithSub				TMoney OUTPUT,
	@TotalWithVATPCActualManHourWithSub			TMoney OUTPUT,
	@TotalPCPlannedExpenseWithSub				TMoney OUTPUT,
	@TotalWithVATPCPlannedExpenseWithSub		TMoney OUTPUT,
	@TotalPCActualExpenseWithSub				TMoney OUTPUT,
	@TotalWithVATPCActualExpenseWithSub			TMoney OUTPUT,
	@TotalPCWDPlannedManHourWithSub				TMoney OUTPUT,
	@TotalWithVATPCWDPlannedManHourWithSub		TMoney OUTPUT,
	@TotalPCWDActualManHourWithSub				TMoney OUTPUT,
	@TotalWithVATPCWDActualManHourWithSub		TMoney OUTPUT,
	@TotalPCWDPlannedExpenseWithSub				TMoney OUTPUT,
	@TotalWithVATPCWDPlannedExpenseWithSub		TMoney OUTPUT,
	@TotalPCWDActualExpenseWithSub				TMoney OUTPUT,
	@TotalWithVATPCWDActualExpenseWithSub		TMoney OUTPUT,
	@CalculateWithSub		TBool OUTPUT,					--Признак того, что для дерева проектов возможен расчет с учетом вложенности
	@ProjectHasBudget		TBool OUTPUT					--Признак того, есть ли бюджет в данном подпроекте
AS
	DECLARE
		@SubProjectID					TIdentifier,		--Идентификатор подпроекта
		@SubLevelCalculateWithSub		TBool,				--Признак возможности расчета бюджета с влож. с более низкого уровня
		@SubLevelSubProjectHasBudget	TBool,				--Признак того, что на уровне ниже есть хотя бы один бюджет
		@BreakCalculation				int,				--Код ошибки в процессе расчета бюджета
		@StartCalculationTime			TDate,				--Время начала расчета

		@PlannedManHour						TAmount,
		@ActualManHour						TAmount,  
		@TotalPCPlannedManHour				TMoney, 
		@TotalWithVATPCPlannedManHour		TMoney,  
		@TotalPCActualManHour				TMoney, 
		@TotalWithVATPCActualManHour		TMoney, 
		@TotalPCPlannedExpense				TMoney, 
		@TotalWithVATPCPlannedExpense		TMoney,  
		@TotalPCActualExpense				TMoney, 
		@TotalWithVATPCActualExpense		TMoney,
		@TotalPCWDPlannedManHour			TMoney,	
		@TotalWithVATPCWDPlannedManHour		TMoney,
		@TotalPCWDActualManHour				TMoney,
		@TotalWithVATPCWDActualManHour		TMoney,
		@TotalPCWDPlannedExpense			TMoney,
		@TotalWithVATPCWDPlannedExpense		TMoney,
		@TotalPCWDActualExpense				TMoney,
		@TotalWithVATPCWDActualExpense		TMoney
		 

	SET @SubLevelCalculateWithSub = 1
	SET @SubLevelSubProjectHasBudget = 0
	SET @BreakCalculation = 0
	SET @CalculateWithSub = 1

	SET @PlannedManHourWithSub					= 0
	SET @ActualManHourWithSub					= 0
	SET @TotalPCPlannedManHourWithSub			= 0
	SET @TotalWithVATPCPlannedManHourWithSub	= 0
	SET @TotalPCActualManHourWithSub			= 0
	SET @TotalWithVATPCActualManHourWithSub		= 0
	SET @TotalPCPlannedExpenseWithSub			= 0
	SET @TotalWithVATPCPlannedExpenseWithSub	= 0
	SET @TotalPCActualExpenseWithSub			= 0
	SET @TotalWithVATPCActualExpenseWithSub		= 0
	SET	@TotalPCWDPlannedManHourWithSub			= 0
	SET	@TotalWithVATPCWDPlannedManHourWithSub	= 0
	SET	@TotalPCWDActualManHourWithSub			= 0
	SET	@TotalWithVATPCWDActualManHourWithSub	= 0
	SET	@TotalPCWDPlannedExpenseWithSub			= 0
	SET	@TotalWithVATPCWDPlannedExpenseWithSub	= 0
	SET	@TotalPCWDActualExpenseWithSub			= 0
	SET	@TotalWithVATPCWDActualExpenseWithSub	= 0
	
	SET @StartCalculationTime = GETDATE()
			
	--Курсор обхода всех подпроектов для текущего проекта
	DECLARE @SubProjects TABLE
	(
		[ID] int
	)

	INSERT INTO @SubProjects
		([ID])
	SELECT [SubprojectID] FROM [Task] WHERE [ProjectID] = @ProjectID AND [SubprojectID] IS NOT NULL

	DECLARE SubProjectsCursor CURSOR LOCAL FOR
		SELECT [ID] FROM @SubProjects

	OPEN SubProjectsCursor
	FETCH NEXT FROM SubProjectsCursor INTO @SubProjectID
	WHILE @@FETCH_STATUS = 0 AND @BreakCalculation = 0
	BEGIN
		--Проверить тип бюджета на соответствие родительскому бюджету
		IF (@RootBudgetTypeID = 1 AND EXISTS(SELECT *FROM Budget WHERE [DocumentID] = @SubProjectID AND [BudgetTypeID] > 1 AND [CurrencyCode] = @RootCurrencyCode)) OR
		(@RootBudgetTypeID = 0 AND EXISTS(SELECT *FROM Budget WHERE [DocumentID] = @SubProjectID AND [BudgetTypeID] = 1 AND [CurrencyCode] = @RootCurrencyCode))
			SET @BreakCalculation = 1
				
		IF @BreakCalculation = 0
		BEGIN
			DECLARE 
				@SubBudget							TBool
				 
			SET @SubBudget = 1
				
			EXEC @BreakCalculation = pjm6BudgetCalculateActualTotalsForSubProjects @SubProjectID, @RootBudgetTypeID, @RootBudgetStartDate, @RootBudgetEndDate, @RootCurrencyCode, @RootTimeEntryActualTotalsAccount,
				@CalculateWithSub						= @SubLevelCalculateWithSub OUTPUT, 
				@ProjectHasBudget						= @SubBudget OUTPUT,
				@PlannedManHourWithSub					= @PlannedManHour OUTPUT,								
				@ActualManHourWithSub					= @ActualManHour OUTPUT,								
				@TotalPCPlannedManHourWithSub			= @TotalPCPlannedManHour OUTPUT,						
				@TotalWithVATPCPlannedManHourWithSub	= @TotalWithVATPCPlannedManHour	OUTPUT,			
				@TotalPCActualManHourWithSub			= @TotalPCActualManHour OUTPUT,						
				@TotalWithVATPCActualManHourWithSub		= @TotalWithVATPCActualManHour OUTPUT,				
				@TotalPCPlannedExpenseWithSub			= @TotalPCPlannedExpense OUTPUT,						
				@TotalWithVATPCPlannedExpenseWithSub	= @TotalWithVATPCPlannedExpense	OUTPUT,									
				@TotalPCActualExpenseWithSub			= @TotalPCActualExpense OUTPUT,						
				@TotalWithVATPCActualExpenseWithSub		= @TotalWithVATPCActualExpense OUTPUT,
				@TotalPCWDPlannedManHourWithSub			= @TotalPCWDPlannedManHour OUTPUT,		
				@TotalWithVATPCWDPlannedManHourWithSub	= @TotalWithVATPCWDPlannedManHour OUTPUT,	
				@TotalPCWDActualManHourWithSub			= @TotalPCWDActualManHour OUTPUT,			
				@TotalWithVATPCWDActualManHourWithSub	= @TotalWithVATPCWDActualManHour OUTPUT,	
				@TotalPCWDPlannedExpenseWithSub			= @TotalPCWDPlannedExpense OUTPUT,		
				@TotalWithVATPCWDPlannedExpenseWithSub	= @TotalWithVATPCWDPlannedExpense OUTPUT,	
				@TotalPCWDActualExpenseWithSub			= @TotalPCWDActualExpense OUTPUT,			
				@TotalWithVATPCWDActualExpenseWithSub	= @TotalWithVATPCWDActualExpense OUTPUT				
									
			SET @PlannedManHourWithSub					= @PlannedManHourWithSub					+	@PlannedManHour						
			SET @ActualManHourWithSub					= @ActualManHourWithSub						+	@ActualManHour						
			SET @TotalPCPlannedManHourWithSub			= @TotalPCPlannedManHourWithSub				+	@TotalPCPlannedManHour				
			SET @TotalWithVATPCPlannedManHourWithSub	= @TotalWithVATPCPlannedManHourWithSub		+ 	@TotalWithVATPCPlannedManHour		
			SET @TotalPCActualManHourWithSub			= @TotalPCActualManHourWithSub				+	@TotalPCActualManHour				
			SET @TotalWithVATPCActualManHourWithSub		= @TotalWithVATPCActualManHourWithSub		+	@TotalWithVATPCActualManHour		
			SET @TotalPCPlannedExpenseWithSub			= @TotalPCPlannedExpenseWithSub				+	@TotalPCPlannedExpense				
			SET @TotalWithVATPCPlannedExpenseWithSub	= @TotalWithVATPCPlannedExpenseWithSub		+ 	@TotalWithVATPCPlannedExpense		
			SET @TotalPCActualExpenseWithSub			= @TotalPCActualExpenseWithSub				+	@TotalPCActualExpense				
			SET @TotalWithVATPCActualExpenseWithSub		= @TotalWithVATPCActualExpenseWithSub		+	@TotalWithVATPCActualExpense	
			SET @TotalPCWDPlannedManHourWithSub			= @TotalPCWDPlannedManHourWithSub			+	@TotalPCWDPlannedManHour		
			SET @TotalWithVATPCWDPlannedManHourWithSub	= @TotalWithVATPCWDPlannedManHourWithSub	+	@TotalWithVATPCWDPlannedManHour
			SET @TotalPCWDActualManHourWithSub			= @TotalPCWDActualManHourWithSub			+	@TotalPCWDActualManHour		
			SET @TotalWithVATPCWDActualManHourWithSub	= @TotalWithVATPCWDActualManHourWithSub		+	@TotalWithVATPCWDActualManHour
			SET @TotalPCWDPlannedExpenseWithSub			= @TotalPCWDPlannedExpenseWithSub			+	@TotalPCWDPlannedExpense	
			SET @TotalWithVATPCWDPlannedExpenseWithSub	= @TotalWithVATPCWDPlannedExpenseWithSub	+	@TotalWithVATPCWDPlannedExpense
			SET @TotalPCWDActualExpenseWithSub			= @TotalPCWDActualExpenseWithSub			+	@TotalPCWDActualExpense		
			SET @TotalWithVATPCWDActualExpenseWithSub	= @TotalWithVATPCWDActualExpenseWithSub		+	@TotalWithVATPCWDActualExpense
																							 
			--Есть ли хотя бы один бюджет на уровне ниже (только на том уровне, еще ниже не проверяется)
			IF @SubBudget = 1
				SET @SubLevelSubProjectHasBudget = 1
			--Проверить есть ли такие подпроекты, которые не позваляют рассчитать с учетом вложенности
			IF @SubLevelCalculateWithSub = 0
				SET @CalculateWithSub = 0
		END

		FETCH NEXT FROM SubProjectsCursor INTO @SubProjectID
	END
	CLOSE SubProjectsCursor
	DEALLOCATE	SubProjectsCursor

	--Если расчет возможен, то рассчитать бюджет
	IF @BreakCalculation = 0
	BEGIN
		--Расчитать бюджет, если он есть, для текущего проекта
		DECLARE @ProjectBudgetID	TIdentifier
		
		SET @ProjectBudgetID = (SELECT [ID] FROM [Budget] WHERE [BudgetTypeID] = @RootBudgetTypeID AND [DocumentID] = @ProjectID AND
			((@RootBudgetTypeID > 1 AND [StartDate] = @RootBudgetStartDate AND [EndDate] = @RootBudgetEndDate) OR
			(@RootBudgetTypeID = 1)) AND [State] in (2,3))

		IF @ProjectBudgetID IS NOT NULL
		BEGIN
			IF @RootTimeEntryActualTotalsAccount != (SELECT [TimeEntryActualTotalsAccount] FROM [Budget] WHERE [ID] = @ProjectBudgetID)
				RETURN 2

			SET @ProjectHasBudget = 1
			--Вызвать расчет бюджета для проекта
			EXEC @BreakCalculation = pjm6BudgetCalculateBudgetForProject @CalculateWithSub, 
											@ProjectBudgetID, @StartCalculationTime,	
											@PlannedManHourWithSub					= @PlannedManHourWithSub OUTPUT,								
											@ActualManHourWithSub					= @ActualManHourWithSub OUTPUT,								
											@TotalPCPlannedManHourWithSub			= @TotalPCPlannedManHourWithSub OUTPUT,						
											@TotalWithVATPCPlannedManHourWithSub	= @TotalWithVATPCPlannedManHourWithSub	OUTPUT,			
											@TotalPCActualManHourWithSub			= @TotalPCActualManHourWithSub OUTPUT,						
											@TotalWithVATPCActualManHourWithSub		= @TotalWithVATPCActualManHourWithSub OUTPUT,				
											@TotalPCPlannedExpenseWithSub			= @TotalPCPlannedExpenseWithSub OUTPUT,						
											@TotalWithVATPCPlannedExpenseWithSub	= @TotalWithVATPCPlannedExpenseWithSub	OUTPUT,			
											@TotalPCActualExpenseWithSub			= @TotalPCActualExpenseWithSub OUTPUT,						
											@TotalWithVATPCActualExpenseWithSub		= @TotalWithVATPCActualExpenseWithSub OUTPUT,								
											@TotalPCWDPlannedManHourWithSub			= @TotalPCWDPlannedManHourWithSub OUTPUT,						
											@TotalWithVATPCWDPlannedManHourWithSub	= @TotalWithVATPCWDPlannedManHourWithSub	OUTPUT,			
											@TotalPCWDActualManHourWithSub			= @TotalPCWDActualManHourWithSub OUTPUT,						
											@TotalWithVATPCWDActualManHourWithSub	= @TotalWithVATPCWDActualManHourWithSub OUTPUT,				
											@TotalPCWDPlannedExpenseWithSub			= @TotalPCWDPlannedExpenseWithSub OUTPUT,						
											@TotalWithVATPCWDPlannedExpenseWithSub	= @TotalWithVATPCWDPlannedExpenseWithSub	OUTPUT,			
											@TotalPCWDActualExpenseWithSub			= @TotalPCWDActualExpenseWithSub OUTPUT,						
											@TotalWithVATPCWDActualExpenseWithSub	= @TotalWithVATPCWDActualExpenseWithSub OUTPUT	
			IF @BreakCalculation != 0
				RETURN @BreakCalculation	
		END	
		ELSE
			SET @ProjectHasBudget = 0		

		--Определить нет ли ошибок, при которых невозможен расчет с вложенностью на более высоком уровне
		IF @CalculateWithSub = 1
			IF @ProjectHasBudget = 0 AND @SubLevelSubProjectHasBudget = 1
				SET @CalculateWithSub = 0
			ELSE
				SET @CalculateWithSub = 1	
		ELSE
			SET @CalculateWithSub = 0
				
	END
	ELSE
		RETURN @BreakCalculation
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetCalculateActualTotalsForSubProjects] TO PUBLIC
GO