IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetChangeState'
		DROP PROCEDURE [dbo].[pjm6BudgetChangeState]
	END
GO

PRINT 'Creating procedure pjm6BudgetChangeState'
GO

/******************************************************************************
**		File: pjm6BudgetChangeState.sql
**		Name: pjm6BudgetChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 23/09/2010 14:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		19.09.11	PAM				      
**									   
** 
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetChangeState
	@ID TIdentifier,
	@ToState TState,
	@AutoTransition TBool = 0
	
AS
	DECLARE
		@Class								TClass,
		@TransitionTemplateID				TIdentifier,
		@RightID							TIdentifier,
		@FromState							TIdentifier,
		@BudgetType							TIdentifier,
		@ProjectID							TIdentifier,
		@ProjectState						TIdentifier,
		@ProjectStartDate					TDate,
		@ProjectEndDate						TDate,
		@ProjectDurationDate				TDate,
		@WarningFlag						TIdentifier,
		@PlanningActivityForWork			TBool,
		@PlanningEmployeeForWork			TBool,
		@PlanningQualificationForWork		TBool,
		@PlanningRateForWork				TBool,
		@PlanningExpenseTypeForExpense		TBool,
		@PlanningEmployeeForExpense			TBool,
		@PlanningPriceForExpense			TBool,
		@Language							TCode,
		@RecurrenceID						TIdentifier,
		@ReminderID							TIdentifier,
		@rv									int
		
	IF dbo.fnPjm6CanEditBudget(@ID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

		SELECT
			@Class = [Budget].[Class],
			@FromState = [Budget].[State],
			@BudgetType = [Budget].[BudgetTypeID],
			@ProjectID = [Budget].[DocumentID],
			@PlanningActivityForWork = [Budget].[PlanningActivityForWork],
			@PlanningEmployeeForWork = [Budget].[PlanningEmployeeForWork],
			@PlanningQualificationForWork = [Budget].[PlanningQualificationForWork],
			@PlanningRateForWork = [Budget].[PlanningRateForWork],
			@PlanningExpenseTypeForExpense = [Budget].[PlanningExpenseTypeForExpense],
			@PlanningEmployeeForExpense = [Budget].[PlanningEmployeeForExpense],
			@PlanningPriceForExpense = [Budget].[PlanningPriceForExpense],
			@RecurrenceID  = [Document].[RecurrencePatternID],
			@ReminderID	= [Reminder].[ID]
		FROM
			[Budget]
			INNER JOIN [Document]
				ON [Document].[Class] = [Budget].[Class] AND [Document].[ID] = [Budget].[ID]	
			LEFT OUTER JOIN [Reminder]
				ON ([Reminder].[DocumentClass] = [Budget].[Class] AND
					[Reminder].[DocumentID] = [Budget].[ID] AND
					[Reminder].[Subtype] = 'BC')
		WHERE
			[Budget].[ID] = @ID

		SELECT
			@ProjectState = [Project].[State],
			@ProjectStartDate = [Project].[Date],
			@ProjectEndDate = [Project].[EndDate],		
			@ProjectDurationDate = [ProjectDetail].[DueDate]
		FROM
			[Project]
			INNER JOIN [ProjectDetail]
				ON [Project].[ID] = [ProjectDetail].[ID]
		WHERE
			[Project].[ID] = @ProjectID

		SET @WarningFlag = NULL
		SET @Language = dbo.adfGetLanguage()
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END

	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @BudgetType = 1
	BEGIN
		--       
		IF @AutoTransition = 0
		BEGIN	
			IF @ProjectState = 1 AND @FromState = 1 AND @ToState = 2
			BEGIN
				RAISERROR('#BudgetProjectIsNotOpen', 18, -1)
				RETURN
			END
			/*IF @ProjectState = 2 AND @FromState = 2 AND @ToState = 3
			BEGIN
				RAISERROR('#BudgetProjectIsNotFinished', 18, -1)
				RETURN 1
			END*/
			/*IF @ProjectState = 3 AND @ToState = 2
			BEGIN
				RAISERROR('#BudgetProjectIsPostponed', 18, -1)
				RETURN 1
			END*/
			IF @ProjectState = 4 AND @FromState = 3 AND @ToState = 2
			BEGIN
				RAISERROR('#BudgetProjectIsFinished', 18, -1)
				RETURN 1
			END
			IF @ProjectState = 4 AND @FromState = 1 AND @ToState = 2
			BEGIN
				RAISERROR('#BudgetProjectIsFinished', 18, -1)
				RETURN 1
			END
		END
	END
	ELSE
	BEGIN
		--     
		IF @AutoTransition = 0
		BEGIN
			IF @ProjectState = 1 AND @FromState = 1 AND @ToState = 2
			BEGIN
				RAISERROR('#BudgetProjectIsNotOpen', 18, -1)
				RETURN 1
			END
			IF @ProjectState = 4 AND @FromState = 3 AND @ToState = 2
			BEGIN
				RAISERROR('#BudgetProjectIsNotOpen', 18, -1)
				RETURN 1
			END
			IF @ProjectState = 4 AND @FromState = 1 AND @ToState = 2
			BEGIN
				RAISERROR('#BudgetProjectIsNotOpen', 18, -1)
				RETURN 1
			END
		END
	END
	
	--   ,    
	IF @FromState = 1 AND @ToState = 2
	BEGIN
		IF((@PlanningActivityForWork = 1 AND 
			EXISTS (SELECT *FROM [BudgetLineWork] WHERE [BudgetID] = @ID AND [ActivityTypeID] IS NULL)) OR
			(@PlanningEmployeeForWork = 1 AND
			EXISTS (SELECT *FROM [BudgetLineWork] WHERE [BudgetID] = @ID AND [EmployeeID] IS NULL)) OR
			(@PlanningQualificationForWork = 1 AND
			EXISTS (SELECT *FROM [BudgetLineWork] WHERE [BudgetID] = @ID AND  [QualificationID] IS NULL)) OR
			(@PlanningExpenseTypeForExpense = 1 AND
			EXISTS (SELECT *FROM [BudgetLineExpense] WHERE [BudgetID] = @ID AND  [ExpenseCodeID] IS NULL)) OR
			(@PlanningEmployeeForExpense = 1 AND
			EXISTS (SELECT *FROM [BudgetLineExpense] WHERE [BudgetID] = @ID AND  [EmployeeID] IS NULL)))
		BEGIN
			IF @AutoTransition = 1
			BEGIN
				SET @WarningFlag = 1
			END
			ELSE
			BEGIN
				RAISERROR('#BudgetLinePlanningParametersIsNull', 18, -1)
				RETURN 1
			END
		END
	END

	--  ,             
	IF @ToState = 2
	BEGIN
		IF(EXISTS(SELECT *FROM [Budget] WHERE [DocumentID] = @ProjectID AND [State] = 2))
		BEGIN
			IF @AutoTransition = 1
			BEGIN
				SET @WarningFlag = 2
			END
			ELSE
			BEGIN
				RAISERROR('#OpenBudgetExists', 18, -1)
				RETURN 1
			END
		END
	END

	BEGIN TRANSACTION
	
	IF @WarningFlag IS NULL
	BEGIN
		--     ,   
		IF @ToState = 1
		BEGIN
			EXEC @rv = pjm6BudgetDeleteActualTotals @ID
			IF @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END

			UPDATE [Budget]
			SET
				[Budget].[WarningFlagID] = @WarningFlag,
				[Budget].[State] = @ToState
			WHERE
				[Budget].[ID] = @ID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @ToState = 2
		BEGIN
			UPDATE [Budget]
			SET
				[Budget].[WarningFlagID] = @WarningFlag,
				[Budget].[State] = @ToState,
				[Budget].[StartDate] = CASE [Budget].[BudgetTypeID] WHEN 1 THEN @ProjectStartDate ELSE [Budget].[StartDate] END,
				[Budget].[EndDate] = CASE [Budget].[BudgetTypeID] WHEN 1 THEN ISNULL(@ProjectEndDate, @ProjectDurationDate) ELSE [Budget].[EndDate] END,
				[Budget].[Modified] = DEFAULT,
				[Budget].[ModifiedBy] = DEFAULT
			WHERE
				[Budget].[ID] = @ID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @ToState = 3
		BEGIN
			UPDATE [Budget]
			SET
				[Budget].[WarningFlagID] = @WarningFlag,
				[Budget].[State] = @ToState,
				[Budget].[StartDate] = CASE [Budget].[BudgetTypeID] WHEN 1 THEN @ProjectStartDate ELSE [Budget].[StartDate] END,
				[Budget].[EndDate] = CASE [Budget].[BudgetTypeID] WHEN 1 THEN ISNULL(@ProjectEndDate, @ProjectDurationDate) ELSE [Budget].[EndDate] END,
				[Budget].[Modified] = DEFAULT,
				[Budget].[ModifiedBy] = DEFAULT
			WHERE
				[Budget].[ID] = @ID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			
			IF @ReminderID IS NOT NULL
			BEGIN
				EXEC pjm5AllUserReminderDismiss @ReminderID
			END	
		END

		--  
		IF @FromState = 2 AND @ToState = 3 AND @ProjectState NOT IN (1, 4) AND
		@RecurrenceID IS NOT NULL AND @AutoTransition = 0
		BEGIN
			EXEC @rv = pjm6BudgetCreateRecurrence @ID
			IF @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END
	ELSE
	BEGIN
		--  
		UPDATE [Budget]
		SET
			[Budget].[WarningFlagID] = @WarningFlag,
			[Budget].[Modified] = DEFAULT,
			[Budget].[ModifiedBy] = DEFAULT
		WHERE
			[Budget].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetChangeState TO PUBLIC
GO