﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetFindBudgetExpenseLineAndUpdateActualTotals]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetFindBudgetExpenseLineAndUpdateActualTotals'
		DROP PROCEDURE [dbo].[pjm6BudgetFindBudgetExpenseLineAndUpdateActualTotals]
	END
GO

PRINT 'Creating procedure pjm6BudgetFindBudgetExpenseLineAndUpdateActualTotals'
GO

/******************************************************************************
**		File: BudgetFindBudgetExpenseLineAndUpdateActualTotals.sql
**		Name: pjm6BudgetFindBudgetExpenseLineAndUpdateActualTotals
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 25/01/2011 11:35:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		13.09.12	MAB				Изменение типа полей PlannedAmount и ActualAmount c TCount на TAmount
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetFindBudgetExpenseLineAndUpdateActualTotals]
	@BudgetID			TIdentifier,
	@EntryID			TIdentifier,
	@ExpenseDocumentClass					TClass,
	@ExpenseDocumentID						TIdentifier,
	@ExpenseFileAs							TName,
	@ExpenseEmployeeID						TIdentifier,
	@ExpenseCodeID							TIdentifier,
	@ExpenseAmount							TAmount,
	@ExpensePrice							TMoney,
	@ExpenseUOMID							TIdentifier,
	@ExpenseCurrencyCode					TCode3,
	@ExpenseVATIsIncluded					TBool,
	@ExpenseVATRate							TPercent,
	@ExpenseVATActualExpense				TMoney,
	@ExpenseCurrencyRate					TMoney,
	@ExpenseVATPCActualExpense				TMoney,
	@ExpenseTotalPCActualExpense			TMoney,
	@ExpenseTotalWithVATPCActualExpense		TMoney,
	@BudgetLineID							TIdentifier OUTPUT
AS
	DECLARE
		@ExpenseTotalActualExpense				TMoney,
		@ExpenseTotalWithVATActualExpense		TMoney,
		@rv										int

	--Расчитать фактические суммы записи о затратах
	SET @ExpenseTotalActualExpense = ROUND(@ExpensePrice * @ExpenseAmount, 2) - 
		(CASE @ExpenseVATIsIncluded WHEN 0 THEN 0 ELSE @ExpenseVATActualExpense END)
	SET @ExpenseTotalWithVATActualExpense = ROUND(@ExpensePrice * @ExpenseAmount, 2) + 
		(CASE @ExpenseVATIsIncluded WHEN 0 THEN @ExpenseVATActualExpense ELSE 0 END)

	IF @ExpenseDocumentClass != dbo.adfGetClassByName('Pjm5.TaskRequest')
	BEGIN
		SET @ExpenseDocumentClass = NULL
		SET @ExpenseDocumentID = NULL
	END
	--Определить линию бюджета для учета записи о времени, подставить фактические значения----------------------------
	DECLARE
		@BudgetPlanningEmployeeForExpense		TBool,
		@BudgetPlanningExpenseTypeForExpense	TBool,
		@BudgetPlanningPriceForExpense			TBool,
		@BudgetExpenseLineID					TIdentifier,
		@BudgetLineGroupID						TIdentifier
	
	SELECT
		@BudgetPlanningEmployeeForExpense		= [Budget].[PlanningEmployeeForExpense],
		@BudgetPlanningExpenseTypeForExpense	= [Budget].[PlanningExpenseTypeForExpense],
		@BudgetPlanningPriceForExpense			= [Budget].[PlanningPriceForExpense]
	FROM
		[Budget]
	WHERE
		[Budget].[ID] = @BudgetID

	SET @BudgetExpenseLineID = (SELECT [ID] FROM [BudgetLineExpense] WHERE [BudgetLineExpense].[BudgetID] = @BudgetID AND
		[BudgetLineExpense].[State] = 1 AND [BudgetLineExpense].[ExpenseID] IS NOT NULL AND 
		[BudgetLineExpense].[ExpenseID] = @EntryID)

	IF @BudgetExpenseLineID IS NULL
	BEGIN
		IF @ExpenseDocumentClass IS NOT NULL AND @ExpenseDocumentID IS NOT NULL
		BEGIN
			SELECT TOP 1
				@BudgetExpenseLineID = [BudgetLineExpense].[ID],
				@BudgetLineGroupID = [BudgetLineExpense].[BudgetLineGroupID]
			FROM
				[BudgetLineExpense]
			WHERE
				([BudgetLineExpense].[BudgetID] = @BudgetID) AND
				([BudgetLineExpense].[CurrencyCode] = @ExpenseCurrencyCode) AND
				([BudgetLineExpense].[ExpenseID] IS NULL) AND
				([BudgetLineExpense].[DocumentID] IS NOT NULL AND [BudgetLineExpense].[DocumentClass] = @ExpenseDocumentClass AND [BudgetLineExpense].[DocumentID] = @ExpenseDocumentID) AND
				(@BudgetPlanningEmployeeForExpense = 0 OR (@BudgetPlanningEmployeeForExpense = 1 AND [BudgetLineExpense].[EmployeeID] = @ExpenseEmployeeID)) AND
				(@BudgetPlanningExpenseTypeForExpense = 0 OR 
					(@BudgetPlanningExpenseTypeForExpense = 1 AND ((@ExpenseCodeID IS NOT NULL AND [BudgetLineExpense].[ExpenseCodeID] = @ExpenseCodeID) OR 
					(@ExpenseCodeID IS NULL AND [BudgetLineExpense].[ExpenseCodeID] IS NULL)))) AND
				(@BudgetPlanningPriceForExpense = 0 OR (@BudgetPlanningPriceForExpense = 1 AND [BudgetLineExpense].[Price] = @ExpensePrice)) AND
				((@ExpenseUOMID IS NULL AND [BudgetLineExpense].[UOMID] IS NULL) OR (@ExpenseUOMID IS NOT NULL AND [BudgetLineExpense].[UOMID] IS NOT NULL AND
					[BudgetLineExpense].[UOMID] = @ExpenseUOMID))
		END
		
		--Есть ли хотя бы одна линия, отнесенная на работу, по которой занесена запись о затрате	
		DECLARE
			@BudgetExpenseLineWithDocument	Tidentifier
		IF @BudgetExpenseLineID IS NULL
		BEGIN
			SELECT TOP 1
				@BudgetLineGroupID = [BudgetLineExpense].[BudgetLineGroupID],
				@BudgetExpenseLineWithDocument = [BudgetLineExpense].[ID]
			FROM
				[BudgetLineExpense]
			WHERE
				([BudgetLineExpense].[BudgetID] = @BudgetID) AND
				([BudgetLineExpense].[DocumentID] IS NOT NULL AND [BudgetLineExpense].[DocumentClass] = @ExpenseDocumentClass AND [BudgetLineExpense].[DocumentID] = @ExpenseDocumentID)
		END

		--Если нет линии с ассоциируемой работой, удовлетворяющей параметрам планирования, то искать линию бюджета
		--среди линий, которые не имеют ассоциаций
		IF @BudgetExpenseLineID IS NULL AND @BudgetExpenseLineWithDocument IS NULL
		BEGIN
			SELECT TOP 1
				@BudgetExpenseLineID = [BudgetLineExpense].[ID],
				@BudgetLineGroupID = [BudgetLineExpense].[BudgetLineGroupID]
			FROM
				[BudgetLineExpense]
			WHERE
				([BudgetLineExpense].[BudgetID] = @BudgetID) AND
				([BudgetLineExpense].[CurrencyCode] = @ExpenseCurrencyCode) AND
				([BudgetLineExpense].[DocumentID] IS NULL) AND
				([BudgetLineExpense].[ExpenseID] IS NULL) AND
				(@BudgetPlanningEmployeeForExpense = 0 OR (@BudgetPlanningEmployeeForExpense = 1 AND [BudgetLineExpense].[EmployeeID] = @ExpenseEmployeeID)) AND
				(@BudgetPlanningExpenseTypeForExpense = 0 OR 
					(@BudgetPlanningExpenseTypeForExpense = 1 AND ((@ExpenseCodeID IS NOT NULL AND [BudgetLineExpense].[ExpenseCodeID] = @ExpenseCodeID) OR 
					(@ExpenseCodeID IS NULL AND [BudgetLineExpense].[ExpenseCodeID] IS NULL)))) AND
				(@BudgetPlanningPriceForExpense = 0 OR (@BudgetPlanningPriceForExpense = 1 AND [BudgetLineExpense].[Price] = @ExpensePrice)) AND
				((@ExpenseUOMID IS NULL AND [BudgetLineExpense].[UOMID] IS NULL) OR (@ExpenseUOMID IS NOT NULL AND [BudgetLineExpense].[UOMID] IS NOT NULL AND
					[BudgetLineExpense].[UOMID] = @ExpenseUOMID))
		END
	END

	--Если подходящая линия найдена, то подставить в нее фактические данные для записи, иначе создать внеплановую 
	--линию
	IF @BudgetExpenseLineID IS NOT NULL
	BEGIN
		UPDATE [BudgetLineExpense]
		SET
			[BudgetLineExpense].[ActualAmount] = [BudgetLineExpense].[ActualAmount] + @ExpenseAmount,
			[BudgetLineExpense].[TotalActualExpense] = [BudgetLineExpense].[TotalActualExpense] + @ExpenseTotalActualExpense,
			[BudgetLineExpense].[TotalWithVATActualExpense] = [BudgetLineExpense].[TotalWithVATActualExpense] + @ExpenseTotalWithVATActualExpense,
			[BudgetLineExpense].[TotalPCActualExpense] = [BudgetLineExpense].[TotalPCActualExpense] + @ExpenseTotalPCActualExpense,
			[BudgetLineExpense].[TotalWithVATPCActualExpense] = [BudgetLineExpense].[TotalWithVATPCActualExpense] + @ExpenseTotalWithVATPCActualExpense
		WHERE
			[BudgetLineExpense].[ID] = @BudgetExpenseLineID
		IF @@ERROR != 0
			RETURN 2
	END
	ELSE
	BEGIN
		IF @BudgetLineGroupID IS NULL AND @ExpenseDocumentID IS NOT NULL AND @ExpenseDocumentClass IS NOT NULL
			SET @BudgetLineGroupID = (SELECT [BudgetLineGroupID] FROM [BudgetLineExpense] WHERE [BudgetLineExpense].[BudgetID] = @BudgetID AND
				[BudgetLineExpense].[DocumentClass] = @ExpenseDocumentClass AND [BudgetLineExpense].[DocumentID] = @ExpenseDocumentID)

		--Вызов создания внеплановой линии
		EXEC @rv = pjm6BudgetLineExpenseCreateUnplanned	@BudgetID,
														@BudgetLineGroupID,
														@BudgetPlanningPriceForExpense,
														@ExpenseDocumentClass,
														@ExpenseDocumentID,
														@ExpenseCurrencyCode,
														@ExpenseUOMID,
														@ExpenseEmployeeID,
														@ExpenseCodeID,
														@ExpenseAmount,
														@ExpenseVATIsIncluded,
														@ExpenseVATRate,
														@ExpenseTotalActualExpense,
														@ExpenseTotalWithVATActualExpense,
														@ExpenseTotalPCActualExpense,
														@ExpenseTotalWithVATPCActualExpense,
														@ExpensePrice,
														@BudgetPlanningEmployeeForExpense,
														@BudgetPlanningExpenseTypeForExpense,
														@BudgetExpenseLineID = @BudgetExpenseLineID OUTPUT
		IF @rv != 0
			return @rv
	END

	SET @BudgetLineID = @BudgetExpenseLineID
	RETURN 0
GRANT EXECUTE ON [pjm6BudgetFindBudgetExpenseLineAndUpdateActualTotals] TO PUBLIC
GO