﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineExpenseCreateUnplanned]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineExpenseCreateUnplanned'
		DROP PROCEDURE [dbo].[pjm6BudgetLineExpenseCreateUnplanned]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineExpenseCreateUnplanned'
GO

/******************************************************************************
**		File: BudgetLineExpenseCreateUnplanned.sql
**		Name: pjm6BudgetLineExpenseCreateUnplanned
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 27/01/2011 09:53:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		13.09.12	MAB				Изменение типа полей PlannedAmount и ActualAmount c TCount на TAmount
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineExpenseCreateUnplanned
	@BudgetID								TIdentifier,
	@BudgetLineGroupID						TIdentifier,
	@BudgetPlanningPriceForExpense			TBool,
	@DocumentClass							TClass,
	@DocumentID								TIdentifier,
	@CurrencyCode							TCode3,
	@UOMID									TIdentifier,
	@EmployeeID								TIdentifier,
	@ExpenseCodeID							TIdentifier,
	@ActualAmount							TAmount,
	@VATIsIncluded							TBool,
	@VATRate								TPercent,
	@TotalActualExpense						TMoney,
	@TotalWithVATActualExpense				TMoney,
	@TotalPCActualExpense					TMoney,
	@TotalWithVATPCActualExpense			TMoney,
	@Price									TMoney,
	@BudgetPlanningEmployeeForExpense		TBool,
	@BudgetPlanningExpenseTypeForExpense	TBool,
	@BudgetExpenseLineID					TIdentifier OUTPUT
AS
	DECLARE
		@State					TState,
		@FileAs					TName,
		@UnplannedExpenseCount	TCount,
		
		@CurrencyRate			TMoney,
		@VATPlannedExpense		TMoney

	IF @BudgetLineGroupID IS NULL
		SET @BudgetLineGroupID = (SELECT [ID] FROM [BudgetLineGroup] WHERE [BudgetLineGroup].[BudgetID] = @BudgetID AND 
			[BudgetLineGroup].[State] = 2 AND [BudgetLineGroup].[GroupTypeID] = 2)

	SET @UnplannedExpenseCount = (SELECT COUNT(*) + 1 FROM [BudgetLineExpense] WHERE [BudgetLineExpense].[BudgetID] = @BudgetID AND [BudgetLineExpense].[State] = 2)

	SET @State = 2 
	SET @FileAs = 'Внеплановая затрата №' + CAST(@UnplannedExpenseCount as nvarchar(256))
	IF @BudgetPlanningPriceForExpense = 0
		SET @Price = 0
	SET @VATPlannedExpense = 0
	SET @CurrencyRate = 1
	IF @BudgetPlanningEmployeeForExpense = 0
		SET @EmployeeID = NULL
	IF @BudgetPlanningExpenseTypeForExpense = 0
		SET @ExpenseCodeID = NULL

	INSERT INTO [BudgetLineExpense]
		([State], [FileAs], [BudgetID], [DocumentClass], [DocumentID],
		[BudgetLineGroupID], [Order], 
		[Price],
		[EmployeeID], [ExpenseCodeID], [CurrencyCode],
		[UOMID], [VATIsIncluded],[CurrencyRate],
		[VATRate],
		[VATPlannedExpense],
		[ActualAmount], [TotalActualExpense], [TotalWithVATActualExpense], [TotalPCActualExpense], [TotalWithVATPCActualExpense]
		)
	VALUES
		(@State, @FileAs, @BudgetID, @DocumentClass, @DocumentID,
		@BudgetLineGroupID, dbo.fnPjm6GetBudgetObjectsOrder(@BudgetID, 'ExpenseLine', 'Actual', NULL, @BudgetLineGroupID),  
		@Price,
		@EmployeeID, @ExpenseCodeID, @CurrencyCode,
		@UOMID, @VATIsIncluded, @CurrencyRate,
		@VATRate,
		@VATPlannedExpense,
		@ActualAmount, @TotalActualExpense, @TotalWithVATActualExpense, @TotalPCActualExpense, @TotalWithVATPCActualExpense
		)
	IF @@ERROR != 0
		RETURN 2

	SET @BudgetExpenseLineID = SCOPE_IDENTITY()
	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineExpenseCreateUnplanned TO PUBLIC
GO