IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineExpenseUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineExpenseUpdate'
		DROP PROCEDURE [dbo].[pjm6BudgetLineExpenseUpdate]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineExpenseUpdate'
GO

/******************************************************************************
**		File: pjm6BudgetLineExpenseUpdate.sql
**		Name: pjm6BudgetLineExpenseUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 17/11/2010 15:20:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		13.09.12	MAB				   PlannedAmount  ActualAmount c TCount  TAmount
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineExpenseUpdate
	@Xml	XML
	
AS
	DECLARE
		@ID								TIdentifier,
		@FileAs							TName,
		@State							TState,
		@BudgetID						TIdentifier,
		@BudgetState					TState,
		@StartDate						TDate,
		@EndDate						TDate,
		@Order							TCount,
		@DocumentClass					TIdentifier,
		@DocumentID						TIdentifier,
		@LineParrentClass				TName,
		@BudgetLineGroupID				TIdentifier,
		@EmployeeID						TIdentifier,
		@ExpenseCodeID        			TIdentifier,
		@ExpenseID						TIdentifier,
		@FromCurrencyCode				TCode3,
		@ToCurrencyCode					TCode3,
		@UOMID							TIdentifier,
		@Price							TMoney,
		@PlannedAmount					TAmount,  
		@ActualAmount					TAmount,  
		@Comments             			TNotes,  
		@VATIsIncluded        			TBool,   
		@CurrencyRate         			TMoney,  
		@VATRate              			TPercent,
		@VATPlannedExpense    			TMoney,  
		@VATPCPlannedExpense  			TMoney,  
		@TotalPCPlannedExpense			TMoney,
		@TotalWithVATPCPlannedExpense	TMoney,
		@PlanningExpenseTypeForExpense	TBool,
		@PlanningEmployeeForExpense		TBool,
		@PlanningPriceForExpense		TBool,
		@PlanningDateForExpense			TBool,
		@value							TVariant,
		@doc							int
	
	SET NOCOUNT ON

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	SELECT
		@ID 							= [ID],
		@FileAs 						= [FileAs],
		@State 							= [State],				
		@BudgetID 						= [BudgetID],			
		@StartDate 						= CAST([StartDate] as datetime), 			
		@EndDate 						= CAST([EndDate] as datetime),			 				
		@DocumentClass 					= dbo.adfGetClassByName([DocumentClass]),		
		@DocumentID 					= [DocumentID],
		@LineParrentClass 				= [BudgetClass], 	 			
		@BudgetLineGroupID 				= [BudgetLineGroupID],
		@Order							= [Order], 	
		@EmployeeID						= [EmployeeID],					
		@ExpenseCodeID					= [ExpenseCodeID],        		
		@ExpenseID						= [ExpenseID],					
		@FromCurrencyCode				= [FromCurrencyCode],
		@ToCurrencyCode					= [ToCurrencyCode],				
		@UOMID							= [UOMID],
		@Price							= [Price],						
		@PlannedAmount					= [PlannedAmount],						          		
		@VATIsIncluded					= [VATIsIncluded],     		
		@CurrencyRate					= [CurrencyRate],        		
		@VATRate						= [VATRate],             		
		@VATPlannedExpense				= [VATPlannedExpense],    		
		@VATPCPlannedExpense			= [VATPCPlannedExpense],	
		@TotalPCPlannedExpense			= [TotalPCPlannedExpense],	
		@TotalWithVATPCPlannedExpense	= [TotalWithVATPCPlannedExpense],		
		@Comments						= [Comments] 						
	FROM
		OPENXML(@doc, '/pjm6BudgetLineExpenseGet/BudgetLineExpense', 2)
			WITH (
				[ID] int,
				[FileAs] nvarchar(256),
				[State] int,
				[BudgetID] int,
				[StartDate] varchar(19),
				[EndDate] varchar(19),
				[DocumentClass] varchar(32),
				[DocumentID] int,
				[BudgetClass] int,
				[BudgetLineGroupID] int,
				[Order] int,
				[EmployeeID] int,					
				[ExpenseCodeID] int,        		
				[ExpenseID] int,					
				[FromCurrencyCode] char(3),
				[ToCurrencyCode] char(3),				
				[UOMID] int,
				[Price] decimal(18,4),						
				[PlannedAmount] decimal(18,4),					      
				[VATIsIncluded] bit,     		
				[CurrencyRate] decimal(18,4),        		
				[VATRate] decimal(18,4),             		
				[VATPlannedExpense] decimal(18,4),    		
				[VATPCPlannedExpense] decimal(18,4),	
				[TotalPCPlannedExpense] decimal(18,4),	
				[TotalWithVATPCPlannedExpense] decimal(18,4),
				[Comments] nvarchar(max)
				)
	IF dbo.fnPjm6CanEditBudget(@BudgetID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @State = 1
	BEGIN
		SELECT		
			@PlanningExpenseTypeForExpense	= [Budget].[PlanningExpenseTypeForExpense],
			@PlanningEmployeeForExpense		= [Budget].[PlanningEmployeeForExpense],
			@PlanningPriceForExpense		= [Budget].[PlanningPriceForExpense],
			@PlanningDateForExpense			= [Budget].[PlanningDateForExpense],
			@BudgetState					= [Budget].[State]
		FROM
			[Budget]
		WHERE
			[Budget].[ID] = @BudgetID

		IF @BudgetState <> 1 AND @LineParrentClass = dbo.adfGetClassByName('Pjm6.Budget')
		BEGIN
			RAISERROR('#budgetIsOpenOrClosed', 18, -1)
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END

		IF ((@PlanningExpenseTypeForExpense = 1 AND @ExpenseCodeID IS NULL) OR 
			(@PlanningEmployeeForExpense = 1 AND @EmployeeID IS NULL) OR
			(@PlanningDateForExpense = 1 AND (@StartDate IS NULL OR @EndDate IS NULL)))
		BEGIN
			RAISERROR('#budgetplanningparameterisnull', 18, -1)
			RETURN 1
		END

		IF @CurrencyRate = 0 OR @CurrencyRate IS NULL
		BEGIN
			RAISERROR('#CurrencyRateCannotBeNull', 18, -1)
			RETURN 1
		END

		IF EXISTS(SELECT TOP 1 * FROM [BudgetLineExpense] WHERE [BudgetLineExpense].[State] = 1 AND [BudgetLineExpense].[ID] != @ID AND
							[BudgetLineExpense].[BudgetID] = @BudgetID AND [BudgetLineExpense].[DocumentClass] = @DocumentClass AND
							[BudgetLineExpense].[DocumentID] = @DocumentID) OR
			EXISTS(SELECT * FROM [BudgetLineExpense] WHERE [BudgetLineExpense].[State] = 1 AND [BudgetLineExpense].[ID] != @ID AND
							[BudgetLineExpense].[BudgetID] = @BudgetID AND [BudgetLineExpense].[ExpenseID] = @ExpenseID)
		BEGIN
			RAISERROR('#BudgetLineAssociatedWithThisDocument', 18, -1)
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END

	END

	BEGIN TRANSACTION

	IF @DocumentID IS NULL
		SET @DocumentClass = NULL
	
	IF @State = 1
	BEGIN
		DECLARE @nationalCurrency TCode3
		EXEC adfParameterGet 'NationalCurrency', 'CommonBusiness', @value OUTPUT
		SET @nationalCurrency = CAST(@value as varchar(3))

		DECLARE @TotalWithVATPC TMoney, @TotalPC TMoney
		IF @VATIsIncluded = 1
		BEGIN
			SET @TotalPC = @PlannedAmount * @Price - @VATPlannedExpense
			SET @TotalWithVATPC = @PlannedAmount * @Price
		END
		ELSE
		BEGIN
			SET @TotalPC = @PlannedAmount * @Price
			SET @TotalWithVATPC = @PlannedAmount * @Price + @VATPlannedExpense
		END
	
		IF @FromCurrencyCode != @ToCurrencyCode
		BEGIN
			IF @FromCurrencyCode = @nationalCurrency
			BEGIN
				SET @TotalPC = ROUND(@TotalPC / @CurrencyRate, 2)
				SET @TotalWithVATPC = ROUND(@TotalWithVATPC / @CurrencyRate, 2)
			END
			ELSE
			BEGIN
				SET @TotalPC = ROUND(@TotalPC * @CurrencyRate, 2)
				SET @TotalWithVATPC = ROUND(@TotalWithVATPC * @CurrencyRate, 2)
			END
		 
			IF @PlannedAmount != 0
			BEGIN
				IF @VATIsIncluded = 1
				BEGIN
					SET @TotalWithVATPC = ROUND(@TotalWithVATPC / @PlannedAmount, 2) * @PlannedAmount
					SET @TotalPC = ROUND(@TotalWithVATPC / (1.0 + @VATRate), 2)
				END
				ELSE
				BEGIN
					SET @TotalPC = ROUND(@TotalPC / @PlannedAmount, 2) * @PlannedAmount
					SET @TotalWithVATPC = ROUND(@TotalPC * (1.0 + @VATRate), 2)
				END
			END
		END

		--   ,       
		DECLARE
			@OldLineGroup	TIdentifier
		SET @OldLineGroup = (SELECT [BudgetLineGroupID] FROM [BudgetLineExpense] WHERE [ID] = @ID)
	
		UPDATE
			[BudgetLineExpense]
		SET
			[FileAs] = @FileAs,
			[StartDate] = @StartDate,
			[EndDate] = @EndDate,
			[DocumentClass] = @DocumentClass,
			[DocumentID] = @DocumentID,
			[BudgetLineGroupID] = @BudgetLineGroupID,
			[Order] = (CASE 
						WHEN (@OldLineGroup IS NOT NULL AND @BudgetLineGroupID IS NOT NULL AND @OldLineGroup != @BudgetLineGroupID) OR
							(@OldLineGroup IS NOT NULL AND @BudgetLineGroupID IS NULL) OR (@OldLineGroup IS NULL AND @BudgetLineGroupID IS NOT NULL) THEN 
							dbo.fnPjm6GetBudgetObjectsOrder(@BudgetID, 'ExpenseLine', 'Planned', NULL, @BudgetLineGroupID)
						ELSE
							[Order]
						END),
			[Price] = @Price,
			[EmployeeID] = @EmployeeID,
			[ExpenseCodeID] = @ExpenseCodeID,
			[ExpenseID] = @ExpenseID,
			[CurrencyCode] = @FromCurrencyCode,
			[UOMID] = @UOMID,
			[PlannedAmount] = @PlannedAmount,
			[VATIsIncluded] = @VATIsIncluded,
			[CurrencyRate] = @CurrencyRate,
			[VATRate] = @VATRate,
			[VATPlannedExpense] = @VATPlannedExpense,
			[TotalPCPlannedExpense] = @TotalPC,
			[TotalWithVATPCPlannedExpense] = @TotalWithVATPC,
			[Comments] = @Comments
		WHERE
			[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
		
		IF (@OldLineGroup IS NOT NULL AND @BudgetLineGroupID IS NOT NULL AND @OldLineGroup != @BudgetLineGroupID) OR
		(@OldLineGroup IS NOT NULL AND @BudgetLineGroupID IS NULL) OR (@OldLineGroup IS NULL AND @BudgetLineGroupID IS NOT NULL)
		BEGIN
			UPDATE 
				[BudgetLineExpense] 
			SET 
				[Order] = [Order] - 1
			WHERE 
				[Order] > @Order AND
				[BudgetID] = @BudgetID AND ((@OldLineGroup IS NULL AND [BudgetLineGroupID] IS NULL) OR (@OldLineGroup IS NOT NULL AND [BudgetLineGroupID] IS NOT NULL AND [BudgetLineGroupID] = @OldLineGroup))
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END
	ELSE IF @State = 2
	BEGIN
		UPDATE
			[BudgetLineExpense]
		SET
			[FileAs] = @FileAs,
			[Comments] = @Comments
		WHERE
			[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
	END
	COMMIT TRANSACTION

	EXEC sp_xml_removedocument @doc

	EXEC pjm6BudgetLineExpenseGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineExpenseUpdate TO PUBLIC
GO