IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineGroupUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineGroupUpdate'
		DROP PROCEDURE [dbo].[pjm6BudgetLineGroupUpdate]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineGroupUpdate'
GO

/******************************************************************************
**		File: pjm6BudgetLineGroupUpdate.sql
**		Name: pjm6BudgetLineGroupUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 10/10/2010 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
** 
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineGroupUpdate
	@Xml	XML
	
AS
	DECLARE
		@State	TState,
		@Class		TClass,
		@ID			TIdentifier,
		@FileAs		TName,
		@BudgetID	TIdentifier,
		@StartDate	TDate,
		@EndDate	TDate,
		@Order		TCount,
		@Comments	TNotes,
		@GroupType	TIdentifier,
		@doc		int

	SET NOCOUNT ON

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	SELECT
		@ID	= [ID],
		@FileAs = [FileAs],
		@BudgetID = [BudgetID], 
		@StartDate =  CAST([StartDate] as datetime),
		@EndDate = CAST([EndDate] as datetime),
		@GroupType = [GroupTypeID],
		@Comments = [Comments]
	FROM
		OPENXML(@doc, '/pjm6BudgetLineGroupGet/BudgetLineGroup', 2)
			WITH (
				[ID] int,
				[FileAs] nvarchar(256),
				[BudgetID] int,
				[StartDate] varchar(19),
				[EndDate] varchar(19),
				[GroupTypeID] int,
				[Comments] nvarchar(max)
				)

	IF dbo.fnPjm6CanEditBudget(@BudgetID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	BEGIN TRANSACTION

	UPDATE BudgetLineGroup
	SET
		[FileAs] = @FileAs,
		[StartDate] = @StartDate,
		[EndDate] = @EndDate,
		[Comments] = @Comments
	WHERE
		[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	COMMIT TRANSACTION

	EXEC sp_xml_removedocument @doc

	EXEC pjm6BudgetLineGroupGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineGroupUpdate TO PUBLIC
GO