IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineWorkCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineWorkCreate'
		DROP PROCEDURE [dbo].[pjm6BudgetLineWorkCreate]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineWorkCreate'
GO

/******************************************************************************
**		File: pjm6BudgetLineWorkCreate.sql
**		Name: pjm6BudgetLineWorkCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 01/11/2010 14:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineWorkCreate
	@Xml	XML
	
AS
	DECLARE
		@State							TState,
		@Class							TClass,
		@ID								TIdentifier,
		@FileAs							TName,
		@BudgetID						TIdentifier,
		@BudgetState					TState,
		@LineParrentClass				TName,
		@StartDate						TDate,
		@EndDate						TDate,
		@Order							TCount,
		@DocumentClass					TIdentifier,
		@DocumentID						TIdentifier,
		@BudgetLineGroupID				TIdentifier,
		@Rate							TMoney,
		@EmployeeID						TIdentifier,
		@VATIsIncluded					TBool,
		@ActivityTypeID					TIdentifier,
		@QualificationID				TIdentifier,
		@PlannedManHour					TAmount,
		@VATPCPlannedManHour			TMoney,
		@TotalPCPlannedManHour			TMoney,
		@TotalWithVATPCPlannedManHour	TMoney,
		@Comments						TNotes,
		@PlanningActivityForWork		TBool,
		@PlanningEmployeeForWork		TBool,
		@PlanningQualificationForWork	TBool,
		@PlanningRateForWork			TBool,
		@PlanningDateForWork			TBool,
		@doc							int

	SET NOCOUNT ON

	SET @State = dbo.adfwfGetInitialState('af97690a-3eb9-41a4-bb20-bd145b566a85')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SET @Class = dbo.adfGetClassByName('Pjm6.BudgetLineWork')

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	SELECT												
		@FileAs = [FileAs],				
		@BudgetID = [BudgetID],			
		@StartDate = CAST([StartDate] as datetime), 			
		@EndDate = CAST([EndDate] as datetime),				 				
		@DocumentClass = dbo.adfGetClassByName([DocumentClass]),		
		@DocumentID = [DocumentID], 	
		@LineParrentClass = [BudgetClass],		
		@BudgetLineGroupID = [BudgetLineGroupID], 	
		@Rate = [Rate],				
		@EmployeeID = [EmployeeID],			
		@ActivityTypeID = [ActivityTypeID],	
		@QualificationID = [QualificationID],
		@PlannedManHour = [PlannedManHour],
		@VATPCPlannedManHour = [VATPCPlannedManHour],		
		@TotalPCPlannedManHour = [TotalPCPlannedManHour],			
		@TotalWithVATPCPlannedManHour = [TotalWithVATPCPlannedManHour],	 		
		@Comments = [Comments] 						
	FROM
		OPENXML(@doc, '/pjm6BudgetLineWorkGet/BudgetLineWork', 2)
			WITH (
				[FileAs] nvarchar(256),
				[BudgetID] int,
				[StartDate] varchar(19),
				[EndDate] varchar(19),
				[DocumentClass] varchar(32),
				[DocumentID] int,
				[BudgetClass] int,
				[BudgetLineGroupID] int,
				[Rate] decimal(18,4),
				[EmployeeID] int,
				[ActivityTypeID] int,
				[QualificationID] int,
				[PlannedManHour] decimal(18,4),
				[VATPCPlannedManHour] decimal(18,4),
				[TotalPCPlannedManHour] decimal(18,4),
				[TotalWithVATPCPlannedManHour] decimal(18,4),
				[Comments] nvarchar(max)
				)
	IF dbo.fnPjm6CanEditBudget(@BudgetID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END		

	SELECT		
		@PlanningActivityForWork		= [Budget].[PlanningActivityForWork],
		@PlanningEmployeeForWork		= [Budget].[PlanningEmployeeForWork],
		@PlanningQualificationForWork	= [Budget].[PlanningQualificationForWork],
		@PlanningRateForWork			= [Budget].[PlanningRateForWork],
		@PlanningDateForWork			= [Budget].[PlanningDateForWork],
		@VATIsIncluded					= [Budget].[VATIsIncluded],
		@BudgetState					= [Budget].[State]
	FROM
		[Budget]
	WHERE
		[Budget].[ID] = @BudgetID

	IF @BudgetState <> 1 AND @LineParrentClass = dbo.adfGetClassByName('Pjm6.Budget')
	BEGIN
		RAISERROR('#budgetIsOpenOrClosed', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	IF ((@PlanningActivityForWork = 1 AND @ActivityTypeID IS NULL) OR 
		(@PlanningEmployeeForWork = 1 AND @EmployeeID IS NULL) OR
		(@PlanningQualificationForWork = 1 AND @QualificationID IS NULL) OR
		(@PlanningDateForWork = 1 AND (@StartDate IS NULL OR @EndDate IS NULL)))
	BEGIN
		RAISERROR('#budgetplanningparameterisnull', 18, -1)
		RETURN 1
	END

	IF EXISTS(SELECT TOP 1 *FROM [BudgetLineWork] WHERE [BudgetLineWork].[State] = 1 AND
					[BudgetLineWork].[BudgetID] = @BudgetID AND [BudgetLineWork].[DocumentClass] = @DocumentClass AND
					[BudgetLineWork].[DocumentID] = @DocumentID)
	BEGIN
		RAISERROR('#BudgetLineAssociatedWithThisDocument', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	BEGIN TRANSACTION

	IF @DocumentID IS NULL
		SET @DocumentClass = NULL

	--IF @VATIsIncluded = 1
	--BEGIN
	--	SET @TotalPCPlannedManHour = @PlannedManHour * @Rate - @VATPCPlannedManHour
	--	SET @TotalWithVATPCPlannedManHour = @PlannedManHour * @Rate
	--END
	--ELSE
	--BEGIN
	--	SET @TotalPCPlannedManHour = @PlannedManHour * @Rate
	--	SET @TotalWithVATPCPlannedManHour = @PlannedManHour * @Rate + @VATPCPlannedManHour
	--END

	INSERT INTO [BudgetLineWork]
		([Class], [State], [FileAs], [BudgetID], [DocumentClass], [DocumentID],
		[BudgetLineGroupID], [StartDate], [EndDate],
		[Order], 
		[Rate],
		[EmployeeID], [ActivityTypeID], [QualificationID],
		[PlannedManHour], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour],
		[Comments])
	VALUES
		(@Class, @State, @FileAs, @BudgetID, @DocumentClass, @DocumentID,
		@BudgetLineGroupID, @StartDate, @EndDate, 
		dbo.fnPjm6GetBudgetObjectsOrder(@BudgetID, 'WorkLine', 'Planned', NULL, @BudgetLineGroupID), 
		@Rate,
		@EmployeeID, @ActivityTypeID, @QualificationID, 
		@PlannedManHour, @TotalPCPlannedManHour, @TotalWithVATPCPlannedManHour,
		@Comments
		)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()

	COMMIT TRANSACTION

	EXEC sp_xml_removedocument @doc

	EXEC pjm6BudgetLineWorkGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineWorkCreate TO PUBLIC
GO