IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetNextCalcDateGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetNextCalcDateGet'
		DROP PROCEDURE [dbo].[pjm6BudgetNextCalcDateGet]
	END
GO

PRINT 'Creating procedure pjm6BudgetNextCalcDateGet'
GO

/******************************************************************************
**		File: pjm6BudgetNextCalcDateGet.sql
**		Name: pjm6BudgetNextCalcDateGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 31/09/2010 14:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetNextCalcDateGet]
	@BudgetID TIdentifier, 
	@Date TDate = NULL,
	@ReturnValue TBool = NULL
AS
	SET NOCOUNT ON
	DECLARE 
		@Result TDate,
		@Occurrences int,
		@EndDate TDate,
		@AssistantRecurrenceID TIdentifier
	
	SELECT
		@AssistantRecurrenceID = [Budget].[CalculateBudgetPatternID]
		FROM [Budget]
		WHERE [Budget].[ID] = @BudgetID
		
	
	SELECT @Occurrences = [Occurrences] FROM [AssistantRecurrencePattern] WHERE [ID] = @AssistantRecurrenceID	
	SET DATEFIRST 7
	SELECT @Result = dbo.fnPjm6AssistantRecurrenceGetNextDateTime(@AssistantRecurrenceID, @Date, GETDATE())
	SET DATEFIRST 1
	
	IF (@Occurrences IS NOT NULL AND @Occurrences > 0)
	BEGIN		
		UPDATE [AssistantRecurrencePattern]
		SET [Occurrences] = @Occurrences - 1
		WHERE [ID] = @AssistantRecurrenceID	
	END	
	
	BEGIN TRANSACTION
		
	UPDATE
		[Budget]
	SET
		[NextCalculationDate] = @Result
	WHERE
		[ID] = @BudgetID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION

	IF @ReturnValue IS NULL
		SELECT @Result
	RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetNextCalcDateGet] TO PUBLIC
GO  