﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetTemplateCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetTemplateCreate'
		DROP PROCEDURE [dbo].[pjm6BudgetTemplateCreate]
	END
GO

PRINT 'Creating procedure pjm6BudgetTemplateCreate'
GO

/******************************************************************************
**		File: pjm6BudgetTemplateCreate.sql
**		Name: pjm6BudgetTemplateCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 09/12/2010 16:01:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetTemplateCreate]
	@Xml	XML
AS
	DECLARE
		@ID							TIdentifier,
		@State						TState,
		@FileAs						TName,
		@BudgetTypeID				TIdentifier,
		@UseWorkPlanning			TBool,
		@UseExpensePlanning			TBool,
		@CurrencyCode				TCode3,
		@VATIsIncluded				TBool,
		@VATRate					TPercent,
		@CalculateBudgetPatternID	TIdentifier,
		@SupervisorEmployeeID		TIdentifier,
		@Comments					TNotes,
		@value						TVariant,
		@doc						int

	SET NOCOUNT ON
	
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageBudgetTemplates')) != 1 
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END	

	DECLARE @TemplateClass TClass,
			@BudgetClass TClass
	SET @TemplateClass =  dbo.adfGetClassByName('Pjm6.BudgetTemplate')
	SET @BudgetClass = dbo.adfGetClassByName('Pjm6.Budget')
		
	SET @State = dbo.adfwfGetInitialState('b2b821f5-dc00-4f6c-a446-1fcfa8aa71a1')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	EXEC adfParameterGet @Name='VATRate', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @VATRate = CAST(@value as decimal(18,4))

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	SELECT
		@ID = [ID],
		@FileAs = [FileAs],
		@BudgetTypeID = [BudgetTypeID],
		@UseWorkPlanning = [UseWorkPlanning],
		@UseExpensePlanning = [UseExpensePlanning],
		@CurrencyCode = [CurrencyCode],
		@VATIsIncluded = [VATIsIncluded],
		@CalculateBudgetPatternID = [CalculateBudgetPatternID],
		@SupervisorEmployeeID = [SupervisorEmployeeID],
		@Comments = [Comments]
	FROM 
		OPENXML(@doc, '/pjm6BudgetTemplateGet/BudgetTemplate', 2)
			WITH (
			[ID] int,
			[FileAs] nvarchar(256),
			[BudgetTypeID] int,
			[UseWorkPlanning] bit,
			[UseExpensePlanning] bit,
			[CurrencyCode] char(3),
			[VATIsIncluded] bit,
			[CalculateBudgetPatternID] int,
			[SupervisorEmployeeID] int,
			[Comments] nvarchar(max)
			)
	
	IF @UseWorkPlanning = 0 AND @UseExpensePlanning = 0 
	BEGIN
		RAISERROR('#BudgetMustHaveItemForPlanning', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	BEGIN TRANSACTION

	INSERT INTO [Budget]
		([State], [Flag], [FileAs], [CurrencyCode], [BudgetTypeID], [UseWorkPlanning], [UseExpensePlanning],
		[WorkBudgetBottom], [WorkBudgetHigh], [WorkBudgetBottomEqualsPlan], [WorkBudgetHighEqualsPlan],
		[ExpenseBudgetBottom], [ExpenseBudgetHigh], [ExpenseBudgetBottomEqualsPlan], [ExpenseBudgetHighEqualsPlan],
		[VATRate], [VATIsIncluded], [CalculateBudgetPatternID],
		[DiscountViewWork], [DiscountPercentWork], [DiscountViewExpense], [DiscountPercentExpense], 
		[PlanningActivityForWork], [PlanningEmployeeForWork], [PlanningQualificationForWork], [PlanningRateForWork],
		[PlanningExpenseTypeForExpense], [PlanningEmployeeForExpense], [PlanningPriceForExpense],
		[PlanningDateForWork],[PlanningDateForExpense], [TimeEntryAccount], [ExpenseAccount],
		[TimeEntrySendingForApprovalAccount], [ExpenseSendingForApprovalAccount],
		[Comments], [SupervisorEmployeeID]
		)
	VALUES
		(@State, 0, @FileAs, @CurrencyCode, @BudgetTypeID, @UseWorkPlanning, @UseExpensePlanning,
		 0,0,1,1,
		 0,0,1,1, 
		 @VATRate, @VATIsIncluded, @CalculateBudgetPatternID,
		 0, NULL, 0, NULL,
		 0, 0, 0, 1, 
		 1, 0, 1,
		 0, 0, 0, 1,
		 1, 1,
		 @Comments, @SupervisorEmployeeID
		)
	IF @@ERROR != 0
	BEGIN
		EXEC sp_xml_removedocument @doc
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	INSERT INTO [Document]
		([Class], [ID], [State], [Flag], [FileAs], [Created], [CreatedBy],
		 [Modified], [ModifiedBy], [Timestamp])
	SELECT
		@TemplateClass,
		[ID],
		[State],
		[Flag],
		[FileAs],
		[Created],
		[CreatedBy],
		[Modified],
		[ModifiedBy],
		[Timestamp]
	FROM
		[Document]
	WHERE
		([ID] = @ID) AND ([Class] = @BudgetClass)

	COMMIT TRANSACTION
	
	EXEC sp_xml_removedocument @doc	

	EXEC pjm6BudgetTemplateGet @ID

	RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetTemplateCreate] TO PUBLIC
GO  