IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6CalculationLinesBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6CalculationLinesBrowse'
		DROP PROCEDURE [dbo].[pjm6CalculationLinesBrowse]
	END
GO

PRINT 'Creating procedure pjm6CalculationLinesBrowse'
GO

/******************************************************************************
**		File: pjm6CalculationLinesBrowse.sql
**		Name: pjm6CalculationLinesBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: yuriy.soldatkin
**		Date: 
*******************************************************************************
**		Change History
added calculationID to return values
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.03.11	SYV				    "  "
**		12.11.12	SAP				   ( )
**		14.11.12	SOV				     [State]     
*******************************************************************************/
CREATE PROCEDURE [pjm6CalculationLinesBrowse]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE
		@timeClass TClass,
		@CalculationClass TClass,
		@AdvanceValue TMoney,
		@AdvanceVAT TMoney,
		@ProjectID TIdentifier,
		@AdvanceFlag TBool,
		@serviceRequestClass TClass,
		@RatesWithVAT TBool,
		@VATRate TPercent
	
	SELECT 
		@AdvanceValue = ISNULL(SUM([Calculation].[TotalWithVATPC]), 0),
		@AdvanceVAT = ISNULL(SUM([Calculation].[VATPC]), 0),
		@AdvanceFlag = CASE WHEN COUNT(*) = 0 THEN 0 ELSE 1 END
	FROM
		[CalculationAdvance] 
		INNER JOIN [Calculation]
			ON [Calculation].[ID] = [CalculationAdvance].[AdvanceCalculationID]
	WHERE
		[CalculationAdvance].[CalculationID] = @ID

	SELECT 
		@CalculationClass = [DocumentClass],
		@ProjectID = [ProjectID],
		@VATRate = [VATRate],
		@RatesWithVAT = [RatesWithVAT]
	FROM
		[Calculation]
	WHERE
		[ID] = @ID

	SET @timeClass = dbo.adfGetClassByName('Pjm5.TimeEntry')
	SET @serviceRequestClass = dbo.adfGetClassByName('Pjm5.ServiceRequest')
	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, @CalculationClass, NULL) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @CalculationClass != @timeClass AND @CalculationClass != @serviceRequestClass
		SET @AdvanceFlag = 0
		
	DECLARE @lines TABLE (
		[ID] int,
		[DocumentState] int,
		[DocumentClass] int,
		[DocumentID] int,
		[Date] datetime,
		[EmployeeID] int,
		[EmployeeName] nvarchar(256),
		[Description] nvarchar(max),
		[Amount] decimal(18, 4),
		[Price] money,
		[PriceWithVAT] money,
		[Sum] money,
		[VATIsIncluded] bit,
		[VAT] money,
		[SumWithoutVAT] money,
		[SumWithVAT] money,
		[State] int
		)
	INSERT INTO @lines 
		(
		[ID],
		[DocumentState],
		[DocumentClass],
		[DocumentID],
		[Date],
		[EmployeeID],
		[EmployeeName],
		[Description],
		[Amount],
		[Price],
		[PriceWithVAT],
		[Sum],
		[VATIsIncluded],
		[VAT],
		[SumWithoutVAT],
		[SumWithVAT],
		[State])
	SELECT
		[pjm5vwCalculationLine].[ID],
		[pjm5vwCalculationLine].[DocumentState],
		[pjm5vwCalculationLine].[DocumentClass],
		[pjm5vwCalculationLine].[DocumentID],
		[pjm5vwCalculationLine].[Date],
		[Employee].[ID] AS [EmployeeID],
		[Employee].[FileAs] AS [EmployeeName],
		[pjm5vwCalculationLine].[Description],
		[pjm5vwCalculationLine].[Amount],
		ROUND(CASE
					WHEN  @CalculationClass != @timeClass
						THEN
							CASE 
								WHEN [pjm5vwCalculationLine].[VATIsIncluded] = 0
									THEN [pjm5vwCalculationLine].[Price]
								WHEN [pjm5vwCalculationLine].[Amount] != 0
									THEN [pjm5vwCalculationLine].[Price] - [pjm5vwCalculationLine].[VAT] / [pjm5vwCalculationLine].[Amount]
								ELSE [pjm5vwCalculationLine].[Price] / (1 + @VATRate)
							END
					ELSE CASE
							WHEN [pjm5vwCalculationLine].[VATIsIncluded] = @RatesWithVAT
								THEN [pjm5vwCalculationLine].[Price]
							WHEN [pjm5vwCalculationLine].[Amount] != 0
								THEN [pjm5vwCalculationLine].[Price] - 
									SIGN(([pjm5vwCalculationLine].[VATIsIncluded] * 2) - 1) * [pjm5vwCalculationLine].[VAT] / [pjm5vwCalculationLine].[Amount]
							WHEN [pjm5vwCalculationLine].[VATIsIncluded] = 0
								THEN [pjm5vwCalculationLine].[Price] * (1 + @VATRate)
							ELSE [pjm5vwCalculationLine].[Price] / (1 + @VATRate)
					END
				END
		, [Calculation].[Scale]) AS [Price],
		ROUND(CASE 
				WHEN [pjm5vwCalculationLine].[VAT] = 0 OR [pjm5vwCalculationLine].[VATIsIncluded] = 1
					THEN [pjm5vwCalculationLine].[Price]
				WHEN [pjm5vwCalculationLine].[Amount] != 0
					THEN [pjm5vwCalculationLine].[Price] + [pjm5vwCalculationLine].[VAT] / [pjm5vwCalculationLine].[Amount]
				ELSE [pjm5vwCalculationLine].[Price] * (1 + @VATRate)
			END
		, [Calculation].[Scale]) AS [PriceWithVAT],
		ROUND([pjm5vwCalculationLine].[Amount] * 
				CASE
					WHEN [pjm5vwCalculationLine].[VATIsIncluded] = @RatesWithVAT
						THEN [pjm5vwCalculationLine].[Price]
					WHEN [pjm5vwCalculationLine].[Amount] != 0
						THEN [pjm5vwCalculationLine].[Price] - 
							SIGN(([pjm5vwCalculationLine].[VATIsIncluded] * 2) - 1) * [pjm5vwCalculationLine].[VAT] / [pjm5vwCalculationLine].[Amount]
					WHEN [pjm5vwCalculationLine].[VATIsIncluded] = 0
						THEN [pjm5vwCalculationLine].[Price] * (1 + @VATRate)
					ELSE [pjm5vwCalculationLine].[Price] / (1 + @VATRate)
				END
		, [Calculation].[Scale]) AS [Sum],
		@RatesWithVAT AS [VATIsIncluded],
		--[pjm5vwCalculationLine].[VATIsIncluded],
		[pjm5vwCalculationLine].[VAT],
		ROUND([pjm5vwCalculationLine].[Amount] * [pjm5vwCalculationLine].[Price] - [pjm5vwCalculationLine].[VATIsIncluded] * [pjm5vwCalculationLine].[VAT]
		, [Calculation].[Scale]) AS [SumWithoutVAT],
		ROUND(CASE 
			WHEN [pjm5vwCalculationLine].[VATIsIncluded] = 0
				THEN [pjm5vwCalculationLine].[Amount] * [pjm5vwCalculationLine].[Price] + [pjm5vwCalculationLine].[VAT]
			ELSE [pjm5vwCalculationLine].[Price] * [pjm5vwCalculationLine].[Amount]
		END, [Calculation].[Scale]) AS [SumWithVAT],
		[Calculation].[State]
	FROM
		[pjm5vwCalculationLine]
		INNER JOIN [Calculation] 
			ON [pjm5vwCalculationLine].[CalculationID] = [Calculation].[ID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [pjm5vwCalculationLine].[EmployeeID]
	WHERE
		[pjm5vwCalculationLine].[CalculationID] = @ID

	SELECT
		[ID],
		[DocumentState],
		[DocumentClass],
		[DocumentID],
		CONVERT(datetime,CONVERT(varchar(8),[Date],112),112) AS [Date],
		[EmployeeID],
		[EmployeeName],
		[Description],
		[Amount],
		[Price],
		[PriceWithVAT],
		[Sum],
		[VATIsIncluded],
		[VAT],
		[SumWithoutVAT],
		[SumWithVAT],
		@ID AS [CalculationID],
		[State]
	FROM
		@lines
	RETURN 0
GO

GRANT EXECUTE ON [pjm6CalculationLinesBrowse] TO PUBLIC
GO
