IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'pjm5CaseDocumentNumberGet')
	BEGIN
		PRINT 'Dropping Procedure pjm5CaseDocumentNumberGet'
		DROP  Procedure  pjm5CaseDocumentNumberGet
	END

GO

PRINT 'Creating Procedure pjm5CaseDocumentNumberGet'
GO
/******************************************************************************
**		File: 
**		Name: pjm5CaseDocumentNumberGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**     ----------							-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure pjm5CaseDocumentNumberGet 
	@CaseID TIdentifier
AS
	DECLARE
		@CurrentNumber TCount,
		@NumberTemplate TName
	
	UPDATE 
		[Case]
	SET
		@CurrentNumber = [CurrentNumber],
		@NumberTemplate = [NumberTemplate],
		[CurrentNumber] = [CurrentNumber] + [Increment]
	WHERE
		[ID] = @CaseID
		
	IF @@ERROR != 0
		RETURN 1
	
	IF @CurrentNumber IS NULL 
	BEGIN
		RAISERROR('#CannotGenerateDocumentNumber', 18, -1)
		RETURN 1
	END

	SELECT
		@CurrentNumber AS [CurrentNumber],
		@NumberTemplate AS [NumberTemplate]

	RETURN 0
GO

GRANT EXEC ON pjm5CaseDocumentNumberGet TO PUBLIC

GO
