IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6ProjectNextPaymentDateGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6ProjectNextPaymentDateGet'
		DROP PROCEDURE [dbo].[pjm6ProjectNextPaymentDateGet]
	END
GO

PRINT 'Creating procedure pjm6ProjectNextPaymentDateGet'
GO

/******************************************************************************
**		File: pjm6ProjectNextPaymentDateGet.sql
**		Name: pjm6ProjectNextPaymentDateGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6ProjectNextPaymentDateGet]
	@ProjectID TIdentifier,
	@ClassName TName, 
	@Date TDate = NULL
AS
	SET NOCOUNT ON
	DECLARE 
		@Result TDate,
		@Occurrences int,
		@EndDate TDate,
		@AssistantRecurrenceID TIdentifier
	
	SELECT
		@AssistantRecurrenceID = CASE @ClassName 
			WHEN 'Pjm5.Calculation' THEN [Project].[CalculationRecurrencePatternID]
			WHEN 'Pjm5.Statement' THEN [Project].[StatementRecurrencePatternID]
			WHEN 'Pjm5.Invoice' THEN [Project].[InvoiceRecurrencePatternID] END
		FROM [Project]
		WHERE [Project].[ID] = @ProjectID
		
	
	SELECT @Occurrences = [Occurrences] FROM [AssistantRecurrencePattern] WHERE [ID] = @AssistantRecurrenceID	
	SET DATEFIRST 7
	SELECT @Result = dbo.fnPjm6AssistantRecurrenceGetNextDateTime(@AssistantRecurrenceID, @Date, GETDATE())
	SET DATEFIRST 1
	
	IF (@Occurrences IS NOT NULL AND @Occurrences > 0)
	BEGIN		
		UPDATE [AssistantRecurrencePattern]
		SET [Occurrences] = @Occurrences - 1
		WHERE [ID] = @AssistantRecurrenceID	
	END	
	
	BEGIN TRANSACTION
	IF @ClassName = 'Pjm5.Calculation'
	BEGIN
		UPDATE
			[PaymentPeriod]
		SET
			[CalculationNextPaymentDate] = @Result
		WHERE
			[ProjectID] = @ProjectID
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	IF @ClassName = 'Pjm5.Statement'
	BEGIN
		UPDATE
			[PaymentPeriod]
		SET
			[StatementNextPaymentDate] = @Result
		WHERE
			[ProjectID] = @ProjectID
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	IF @ClassName = 'Pjm5.Invoice'
	BEGIN
		UPDATE
			[PaymentPeriod]
		SET
			[InvoiceNextPaymentDate] = @Result
		WHERE
			[ProjectID] = @ProjectID
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	COMMIT TRANSACTION
	
	SELECT @Result
	RETURN 0
GO

GRANT EXECUTE ON [pjm6ProjectNextPaymentDateGet] TO PUBLIC
GO  