IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CreditMemoUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CreditMemoUpdate'
		DROP PROCEDURE [dbo].[pjm5CreditMemoUpdate]
	END
GO

PRINT 'Creating procedure pjm5CreditMemoUpdate'
GO

/******************************************************************************
**		File: pjm5CreditMemoUpdate.sql
**		Name: pjm5CreditMemoUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5CreditMemoUpdate
	@Xml XML
AS
	DECLARE
		@ID TIdentifier,
		@FileAs TName,
		@Date TDate,
		@Number TCode,
		@VAT TMoney,
		@PaymentTypeID TIdentifier,
		@PayeeCompanyID TIdentifier,
		@PayeeBankAccountID TIdentifier,
		@PayerCompanyID TIdentifier,
		@ProjectID	TIdentifier,
		@Value TMoney,
		@CurrencyCode TCode3,
		@ProjectCurrencyCode TCode3,
		@BaseCurrencyRate TMoney,
		@CurrencyRate TMoney,
		@Comments TNotes,
		@Reason TName,
		@Payer TName,
		@Doc int,
		@val TVariant,
		@TotalPC TMoney,
		@TotalWithVATPC TMoney,
		@TotalBC TMoney,
		@TotalWithVATBC TMoney
	
	SET NOCOUNT ON
	
	EXEC sp_xml_preparedocument @Doc OUTPUT, @Xml
	
	SELECT
		@ID = [XmlTable].[ID],
		@FileAs = [XmlTable].[FileAs],
		@Date = CAST([XmlTable].[Date] as datetime),
		@Number = [XmlTable].[Number],
		@VAT = [XmlTable].[VAT],
		@PaymentTypeID = [XmlTable].[PaymentTypeID],
		@PayeeCompanyID = [XmlTable].[SupplierCompanyID],
		@PayeeBankAccountID = [XmlTable].[PayeeBankAccountID],
		@PayerCompanyID = [XmlTable].[CustomerCompanyID],
		@ProjectID = [XmlTable].[ProjectID],
		@Value = [XmlTable].[Value],
		@CurrencyCode = [XmlTable].[CurrencyCode],
		@ProjectCurrencyCode = [Project].[CurrencyCode],
		@CurrencyRate = [XmlTable].[CurrencyRate],
		@BaseCurrencyRate = [XmlTable].[BaseCurrencyRate],
		@Comments = [XmlTable].[Comments],
		@Reason = [Reason],
		@Payer = [Payer]
	FROM
		OPENXML(@Doc, '/pjm5CreditMemoGet/CreditMemo', 2)
			WITH (
				[ID] int,
				[FileAs] nvarchar(256),
				[Date] varchar(19),
				[Number] varchar(32),
				[VAT] money,
				[PaymentTypeID] int,
				[SupplierCompanyID] int,
				[PayeeBankAccountID] int,
				[CustomerCompanyID] int,
				[ProjectID] int,
				[Value] money,
				[CurrencyCode] char(3),
				[CurrencyRate] money,
				[BaseCurrencyRate] money,
				[Comments] nvarchar(max),
				[Reason] nvarchar(256),
				[Payer] nvarchar(256)
			) as [XmlTable]
		LEFT JOIN [Project]
			ON [Project].[ID] = [XmlTable].[ProjectID]
	
	EXEC sp_xml_removedocument @Doc
	
	DECLARE 
		@BaseCurrencyCode TCode3,
		@NationalCurrency TCode3
	EXEC adfParameterGet @Name='BaseCurrency', @Group='CommonBusiness', @Value = @val OUTPUT
	SET @BaseCurrencyCode = CAST(@val as varchar(3))

	EXEC adfParameterGet 'NationalCurrency', 'CommonBusiness', @val OUTPUT	
	SET @NationalCurrency = CAST(@val AS varchar(8))
	
	IF @BaseCurrencyCode = @CurrencyCode
	BEGIN
		SET @BaseCurrencyRate = 1.0
	END
	
	IF @ProjectCurrencyCode = @CurrencyCode
	BEGIN
		SET @CurrencyRate = 1.0
	END
	
	SET	@TotalPC = ROUND(CASE 
						WHEN @CurrencyCode = @NationalCurrency THEN (@Value - @VAT) / @CurrencyRate
						ELSE (@Value - @VAT) * @CurrencyRate
					END, 2)
	SET	@TotalWithVATPC = ROUND(CASE 
						WHEN @CurrencyCode = @NationalCurrency
							THEN @Value / @CurrencyRate
						ELSE @Value * @CurrencyRate
					END, 2)

	SET	@TotalBC = ROUND(CASE 
						WHEN @CurrencyCode = @NationalCurrency
							THEN (@Value - @VAT) / @BaseCurrencyRate
						ELSE (@Value - @VAT) * @BaseCurrencyRate
					END, 2)
	SET	@TotalWithVATBC= ROUND(CASE 
						WHEN @CurrencyCode = @NationalCurrency
							THEN @Value / @BaseCurrencyRate
						ELSE @Value * @BaseCurrencyRate
					END, 2)

	BEGIN TRANSACTION
	UPDATE 
		[CreditMemo]
	SET
		[CreditMemo].[FileAs] = @FileAs,
		[CreditMemo].[Date] = @Date,
		[CreditMemo].[Number] = @Number,
		[CreditMemo].[VAT] = @VAT,
		[CreditMemo].[PaymentTypeID] = @PaymentTypeID,		
		[CreditMemo].[PayeeCompanyID] = @PayeeCompanyID,
		[CreditMemo].[PayeeBankAccountID]= @PayeeBankAccountID,
		[CreditMemo].[PayerCompanyID] = @PayerCompanyID,
		[CreditMemo].[ProjectID] = @ProjectID,
		[CreditMemo].[Value] = @Value,
		[CreditMemo].[CurrencyCode] = @CurrencyCode,
		[CreditMemo].[CurrencyRate] = @CurrencyRate,
		[CreditMemo].[BaseCurrencyRate] = @BaseCurrencyRate,	
		[CreditMemo].[Reason] = @Reason,
		[CreditMemo].[Payer] = @Payer,
		[CreditMemo].[Comments] = @Comments,
		[CreditMemo].[Modified] = GETDATE(),
		[CreditMemo].[ModifiedBy] = dbo.adfGetCurrentUserID(),
		[CreditMemo].[TotalPC] = @TotalPC,
		[CreditMemo].[TotalWithVATPC] = @TotalWithVATPC,
		[CreditMemo].[TotalBC] = @TotalBC,
		[CreditMemo].[TotalWithVATBC] = @TotalWithVATBC
	WHERE
		[CreditMemo].[ID] = @ID

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	COMMIT TRANSACTION

	EXEC pjm5CreditMemoGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5CreditMemoUpdate TO PUBLIC
GO
 