IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].pjm6fnCurrencyGetRateMonth') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function pjm6fnCurrencyGetRateMonth'
		DROP FUNCTION [dbo].pjm6fnCurrencyGetRateMonth
	END

GO

PRINT 'Creating function pjm6fnCurrencyGetRateMonth'
GO
/******************************************************************************
**		File: pjm6fnCurrencyGetRateMonth.sql
**		Name: pjm6fnCurrencyGetRateMonth
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAN
**		Date: 22/11/2010 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		22.11.2010	MAN				First Version
*******************************************************************************/

CREATE FUNCTION [dbo].[pjm6fnCurrencyGetRateMonth]
(
	@CurrencyCode TCode3,
	@Date TDate,
	@ToCurrencyCode TCode3
)
RETURNS TMoney
AS
BEGIN
DECLARE @Result TMoney

SET @Result = 1
	IF(@CurrencyCode != @ToCurrencyCode)
	BEGIN
		SELECT TOP 1
			@Result = 
			CASE 
				WHEN [CurrencyRate].[FromCurrencyCode] = @CurrencyCode
					THEN SUM([CurrencyRate].[Rate])/COUNT([CurrencyRate].[ValidFrom])
				ELSE 1/(SUM([CurrencyRate].[Rate])/COUNT([CurrencyRate].[ValidFrom]))
			END
			
			
		FROM
			[CurrencyRate]
		WHERE
			[CurrencyRate].[ValidFrom] >= DATEADD(mm, DATEDIFF(mm,0,@Date), 0)
			AND
			[CurrencyRate].[ValidTo] < DATEADD(ms,-5,DATEADD(mm, DATEDIFF(m,0,@Date)+1, 0))
			AND
			[CurrencyRate].[ValidFrom] < DATEADD(ms,-5,DATEADD(mm, DATEDIFF(m,0,@Date)+1, 0))
			AND
			(
				[CurrencyRate].[FromCurrencyCode] = @CurrencyCode
				AND 
				[CurrencyRate].[ToCurrencyCode] = @ToCurrencyCode
				OR
				[CurrencyRate].[FromCurrencyCode] = @ToCurrencyCode
				AND 
				[CurrencyRate].[ToCurrencyCode] = @CurrencyCode
			)
		GROUP BY
			[CurrencyRate].[FromCurrencyCode]
	END

RETURN @Result
END