 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentCardCreate'
		DROP PROCEDURE [dbo].[pjm5DocumentCardCreate]
	END
GO

PRINT 'Creating procedure pjm5DocumentCardCreate'
GO

/******************************************************************************
**		File: pjm5DocumentCardCreate.sql
**		Name: pjm5DocumentCardCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentCardCreate]
	@Xml XML
AS
	SET NOCOUNT ON
	DECLARE
		@ID TIdentifier,
		@State TState,
		@doc int
	
	SET @State = dbo.adfwfGetInitialState('6cc877ce-4425-4e49-a3d5-76b01ae709ae')
	IF @State != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	DECLARE 
		@FolderID TIdentifier,
		@FileAs TName,
		@DocumentTypeID TIdentifier,
		@DocumentCardClassID TIdentifier,
		@DocumentCardID TIdentifier,
		@Number TCode,
		@Date TDate,
		@NumberIn TCode,
		@DateIn TDate,
		@NumberOut TCode,
		@DateOut TDate,
		@CompanyID TIdentifier,
		@ContactID TIdentifier,
		@CorrespondentCompanyID TIdentifier,
		@CorrespondentContactID TIdentifier,
		@DivisionID TIdentifier,
		@CaseID TIdentifier,
		@DocumentSendTypeID TIdentifier,
		@SentTime TDateTime,
		@CardOwnerID TIdentifier,
		@HasToBeSentBack TBool,
		@SentBackTime TDateTime,
		@DocumentSendBackTypeID TIdentifier,
		@Comments TNotes

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	SELECT
		@FolderID = [XmlTable].[FolderID],
		@FileAs = [XmlTable].[FileAs],
		@DocumentCardClassID = [XmlTable].[DocumentCardClassID],
		@DocumentCardID = [XmlTable].[DocumentCardID],
		@Number = [XmlTable].[Number],
		@Date = CAST([XmlTable].[Date] AS datetime),
		@NumberIn = [XmlTable].[NumberIn],
		@DateIn = CAST([XmlTable].[DateIn] AS datetime),
		@NumberOut = [XmlTable].[NumberOut],
		@DateOut = CAST([XmlTable].[DateOut] AS datetime),
		@CompanyID = [XmlTable].[CompanyID],
		@ContactID = [XmlTable].[ContactID],
		@CorrespondentCompanyID = [XmlTable].[CorrespondentCompanyID],
		@CorrespondentContactID = [XmlTable].[CorrespondentContactID],
		@DivisionID = [XmlTable].[DivisionID],
		@CaseID = [XmlTable].[CaseID],
		@DocumentSendTypeID = [XmlTable].[DocumentSendTypeID],
		@SentTime = CAST([XmlTable].[SentTime] AS datetime),
		@CardOwnerID = [XmlTable].[CardOwnerID],
		@HasToBeSentBack = CASE WHEN [XmlTable].[HasToBeSentBack] = 'false' THEN 0 ELSE 1 END,
		@SentBackTime = CAST([XmlTable].[SentBackTime] AS datetime),
		@DocumentSendBackTypeID = [XmlTable].[DocumentSendBackTypeID],
		@Comments = [XmlTable].[Comments]
	FROM 
		OPENXML(@doc, '/pjm5DocumentCardGet/DocumentCard', 2)
			WITH (
				[FolderID] int,
				[FileAs] nvarchar(512),
				[FileName] nvarchar(512),
				[DocumentCardClassID] int,
				[DocumentCardID] int,
				[Number] varchar(32),
				[Date] nvarchar(19),
				[NumberIn] varchar(32),
				[DateIn] nvarchar(19),
				[NumberOut] varchar(32),
				[DateOut] nvarchar(19),
				[CompanyID] int,
				[ContactID] int,
				[CorrespondentCompanyID] int,
				[CorrespondentContactID] int,
				[DivisionID] int,
				[CaseID] int,
				[DocumentSendTypeID] int,
				[SentTime] nvarchar(19),
				[CardOwnerID] int,
				[HasToBeSentBack] varchar(5),
				[SentBackTime] nvarchar(19),
				[DocumentSendBackTypeID] int,
				[Comments] nvarchar(max)
				) AS [XmlTable]
	EXEC sp_xml_removedocument @doc

	BEGIN TRANSACTION
	INSERT INTO [DocumentCard]
		([State], 
		[Flag], 
		[FileAs], 
		[FolderID],
		[DocumentCardClassID],
		[DocumentCardID],
		[Number],
		[Date],
		[NumberIn],
		[DateIn],
		[NumberOut],
		[DateOut],
		[CompanyID],
		[ContactID],
		[CorrespondentCompanyID],
		[CorrespondentContactID],
		[DivisionID],
		[CaseID],
		[SentTime],
		[DocumentSendTypeID],
		[CardOwnerID],
		[HasToBeSentBack],
		[SentBackTime],
		[DocumentSendBackTypeID],
		[Comments])
	VALUES
		(@State, 
		0, 
		@FileAs, 
		@FolderID,
		@DocumentCardClassID,
		@DocumentCardID,
		@Number,
		@Date,
		@NumberIn,
		@DateIn,
		@NumberOut,
		@DateOut,
		@CompanyID,
		@ContactID,
		@CorrespondentCompanyID,
		@CorrespondentContactID,
		@DivisionID,
		@CaseID,
		@SentTime,
		@DocumentSendTypeID,
		@CardOwnerID,
		@HasToBeSentBack,
		@SentBackTime,
		@DocumentSendBackTypeID,
		@Comments)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()
	
	COMMIT TRANSACTION
	EXEC pjm5DocumentCardGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentCardCreate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5IncomingDocumentCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5IncomingDocumentCreate'
		DROP PROCEDURE [dbo].[pjm5IncomingDocumentCreate]
	END
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5OutgoingDocumentCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5OutgoingDocumentCreate'
		DROP PROCEDURE [dbo].[pjm5OutgoingDocumentCreate]
	END
GO

