IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm6DocumentCardUpdate')
	BEGIN
		PRINT 'Dropping Trigger pjm6DocumentCardUpdate'
		DROP  Trigger pjm6DocumentCardUpdate
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm6DocumentCardUpdate
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm6DocumentCardUpdate'
GO
CREATE TRIGGER pjm6DocumentCardUpdate 
ON [DocumentCard] FOR UPDATE
AS
BEGIN
    IF @@rowcount != 1
       RETURN
       
	SET NOCOUNT ON

	IF UPDATE([Flag])
	BEGIN
		UPDATE
			[DocumentItem]
		SET
			[Flag] = [inserted].[Flag]
		FROM
			[DocumentItem]
			INNER JOIN [inserted]
				ON [inserted].[ID] = [DocumentItem].[DocumentCardID]
		WHERE			
			[DocumentItem].[Flag] != [inserted].[Flag]
	END
END
GO
