 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentItemMoveTo]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentItemMoveTo'
		DROP PROCEDURE [dbo].[pjm5DocumentItemMoveTo]
	END
GO

PRINT 'Creating procedure pjm5DocumentItemMoveTo'
GO

/******************************************************************************
**		File: pjm5DocumentItemMoveTo.sql
**		Name: pjm5DocumentItemMoveTo
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
/*
CREATE PROCEDURE [pjm5DocumentItemMoveTo]
	@ID TIdentifier,
	@FolderID TIdentifier
AS
	SET NOCOUNT ON
	IF NOT EXISTS(SELECT * FROM [Folder] WHERE [ID] = @FolderID)
	BEGIN
		RAISERROR('#folderisdeleted', 18, -1)
		RETURN 1
	END
	
	DECLARE 
		@UserID TIdentifier,
		@PrevFolderID TIdentifier,
		@CreatedBy TIdentifier,
		@State TState

	SELECT 
		@PrevFolderID = [DocumentItem].[FolderID],
		@CreatedBy = [DocumentItem].[CreatedBy],
		@State = [DocumentItem].[State]
	FROM 
		[DocumentItem] 
	WHERE
		[ID] = @ID
	IF @PrevFolderID != @FolderID
	BEGIN

		SET @UserID = dbo.adfGetCurrentUserID()
		IF dbo.fnFolderHasRightAccess(@PrevFolderID, @UserID, 'DeleteAll') = 0
		BEGIN
			IF dbo.fnFolderHasRightAccess(@PrevFolderID, @UserID, 'DeleteOwn') = 0
			BEGIN
				RAISERROR('#accessdenied', 18, -1)
				RETURN 1
			END
			IF @UserID != @CreatedBy
			BEGIN
				RAISERROR('#accessdenied', 18, -1)
				RETURN 1
			END
		END

		IF dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'CreateItems') = 0
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
		
		IF @State = 3 -- Checked Out
		BEGIN
			RAISERROR('#cannotmovecheckedoutdocument', 18, -1)
			RETURN 1
		END
		
		BEGIN TRANSACTION
		UPDATE
			[DocumentItem]
		SET
			[FolderID] = @FolderID,
			[Modified] = DEFAULT,
			[ModifiedBy] = DEFAULT
		WHERE
			[ID] = @ID
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		UPDATE
			[DocumentCard]
		SET
			[FolderID] = @FolderID,
			[Modified] = DEFAULT,
			[ModifiedBy] = DEFAULT
		FROM 
			[DocumentCard]
			INNER JOIN [DocumentItem]
				ON [DocumentItem].[DocumentCardID] = [DocumentCard].[ID]
		WHERE
			[DocumentItem].[ID] = @ID
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		COMMIT TRANSACTION
	END	
	EXEC pjm5DocumentItemGet @ID

	RETURN 0
*/
GO

--GRANT EXECUTE ON pjm5DocumentItemMoveTo TO PUBLIC
GO
