/******************************************************************************
**		Name: pjm6ExchangeSyncCreateContact
**		Auth: pavel.svintsov
**		Date: 27.01.2011 16:00:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		15.06.11	SPV				    
**    
*******************************************************************************/
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6ExchangeSyncCreateContact]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6ExchangeSyncCreateContact'
		DROP PROCEDURE [dbo].[pjm6ExchangeSyncCreateContact]
	END
GO
PRINT 'Creating procedure pjm6ExchangeSyncCreateContact'
GO

SET QUOTED_IDENTIFIER ON
GO
-------------------------------------------------------------------------------
CREATE PROCEDURE [pjm6ExchangeSyncCreateContact]
	@UserID TIdentifier,
	@XContact XML,
	@ExtendedProperties XML
AS
	DECLARE
		@EmployeeID TIdentifier, @ExchangeID TGuid,
		@OperationType TName,
		@FirstName TName, @MiddleName TName, @LastName TName, @ShortName TName, @FullName TName, @Title TName, @Suffix TName,
		@BirthDate TDate, @Interaction TDate, @Gender int, @Comment TNotes,
		@Company TName, @Position TName, @Division TName,
		@Email TName, @Email2 TName, @Email3 TName, @WebPage TName,
		
		@WorkPhone TName, @HomePhone TName, @Work2Phone TName, @MobilePhone TName, @HelperPhone TName,
		@BasePhone TName, @OtherPhone TName, @CompanyPhone TName, @WorkFax TName, @HomeFax TName, @AddFax TName,
		
		@LegalCity TName, @LegalCountry TName, @LegalStreet TName, @LegalRegion TName, @LegalPostalCode TName, @LegalMail TBool,
		@HomeCity TName, @HomeCountry TName, @HomeStreet TName, @HomeRegion TName, @HomePostalCode TName, @HomeMail TBool,
		@OtherCity TName, @OtherCountry TName, @OtherStreet TName, @OtherRegion TName, @OtherPostalCode TName, @OtherMail TBool

	DECLARE @EmployeeClass TClass
	SET	@EmployeeClass = dbo.adfGetClassByName('Adf.Employee')

	SELECT
		@ExchangeID = T.C.value('@ExchangeID', 'TGuid'),
		@FirstName = T.C.value('@FirstName', 'TName'),
		@MiddleName = T.C.value('@MiddleName', 'TName'),
		@LastName = T.C.value('@LastName', 'TName'),
		@ShortName = SUBSTRING(T.C.value('@ShortName', 'TName'), 1, 32),
		@FullName = T.C.value('@FullName', 'TName'),
		@Title = T.C.value('@Title', 'TName'),
		@Suffix = T.C.value('@Suffix', 'TName'),
		@BirthDate = T.C.value('@BirthDate', 'TDate'),
		@Interaction = T.C.value('@Interaction', 'TDate'),
		@Gender = T.C.value('@Gender', 'int'),
		@Company = T.C.value('@Company', 'TName'),
		@Position = T.C.value('@Position', 'TName'),
		@Division = T.C.value('@Division', 'TName'),
		@Comment = T.C.value('@Comment', 'TNotes'),
	
		@Email = T.C.value('@Email', 'TName'),
		@Email2 = T.C.value('@Email2', 'TName'),
		@Email3 = T.C.value('@Email3', 'TName'),
		@WebPage = T.C.value('@WebPage', 'TName'),
	
		@Workphone = SUBSTRING(T.C.value('@WorkPhone', 'TName'), 1, 50),
		@HomePhone = SUBSTRING(T.C.value('@HomePhone', 'TName'), 1, 50),
		@Work2Phone = SUBSTRING(T.C.value('@Work2Phone', 'TName'), 1, 50),
		@MobilePhone = SUBSTRING(T.C.value('@MobilePhone', 'TName'), 1, 50),
		@HelperPhone = SUBSTRING(T.C.value('@HelperPhone', 'TName'), 1, 50),
		@BasePhone = SUBSTRING(T.C.value('@BasePhone', 'TName'), 1, 50),
		@OtherPhone = SUBSTRING(T.C.value('@OtherPhone', 'TName'), 1, 50),
		@CompanyPhone = SUBSTRING(T.C.value('@CompanyPhone', 'TName'), 1, 50),
		@WorkFax = SUBSTRING(T.C.value('@WorkFax', 'TName'), 1, 50),
		@HomeFax = SUBSTRING(T.C.value('@HomeFax', 'TName'), 1, 50),
		@AddFax = SUBSTRING(T.C.value('@AddFax', 'TName'), 1, 50),
		
		@LegalCity = T.C.value('@LegalCity', 'TName'),
		@LegalCountry = T.C.value('@LegalCountry', 'TName'),
		@LegalStreet = T.C.value('@LegalStreet', 'TName'),
		@LegalRegion = T.C.value('@LegalRegion', 'TName'),
		@LegalPostalCode = T.C.value('@LegalPostalCode', 'TName'),
		@LegalMail = T.C.value('@LegalMail', 'TBool'),
		
		@HomeCity = T.C.value('@HomeCity', 'TName'),
		@HomeCountry = T.C.value('@HomeCountry', 'TName'),
		@HomeStreet = T.C.value('@HomeStreet', 'TName'),
		@HomeRegion = T.C.value('@HomeRegion', 'TName'),
		@HomePostalCode = T.C.value('@HomePostalCode', 'TName'),
		@HomeMail = T.C.value('@HomeMail', 'TBool'),
		
		@OtherCity = T.C.value('@OtherCity', 'TName'),
		@OtherCountry = T.C.value('@OtherCountry', 'TName'),
		@OtherStreet = T.C.value('@OtherStreet', 'TName'),
		@OtherRegion = T.C.value('@OtherRegion', 'TName'),
		@OtherPostalCode = T.C.value('@OtherPostalCode', 'TName'),
		@OtherMail = T.C.value('@OtherMail', 'TBool')
	FROM
		@XContact.nodes('contact') T(C)	


	--    
	exec pjm6ExchangeSyncContactCreate @Title = @Title, @FirstName= @FirstName, @MiddleName = @MiddleName, @LastName = @LastName,
										@FileAs = @FullName, @Suffix = @Suffix, @Comments = @Comment, @Initials = @ShortName,
										@NextContact = @Interaction, @BirthDate = @BirthDate,
										@Email1 = @Email, @Email2 = @Email2, @Email3 = @Email3, @MobilePhone = @MobilePhone,
										@UserID = @UserID, @ID = @EmployeeID OUTPUT
	
	--    (NULL   pjm6ExchangeSyncContactCreate)
	IF @EmployeeID IS NULL
		RETURN 0

	UPDATE [ExtendedProperties]
	SET [ExtendedProperties] = @ExtendedProperties
	WHERE [ID] = @EmployeeID AND [Class] = @EmployeeClass

	IF EXISTS (SELECT * FROM [ExchangeSync] WHERE [DocumentClass] = @EmployeeClass AND [DocumentID] = @EmployeeID AND [UserID] = @UserID)
	BEGIN
		UPDATE [ExchangeSync]
		SET
			[Date] = GETDATE(),
			[ExchangeID] = @ExchangeID
		WHERE [DocumentClass] = @EmployeeClass AND [DocumentID] = @EmployeeID AND [UserID] = @UserID
	END
	ELSE
	BEGIN
		INSERT INTO [ExchangeSync] ([UserID], [DocumentClass], [DocumentID], [Date], [ExchangeID])
		VALUES (@UserID, @EmployeeClass, @EmployeeID, GETDATE(), @ExchangeID)
	END
	------------------Email
	IF NOT EXISTS (SELECT * FROM [Email] WHERE [EmailTypeID] = 1 AND [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = @EmployeeID)
	BEGIN
		IF @Email IS NOT NULL
		BEGIN
			INSERT INTO [Email] ([BusinessCardClass], [BusinessCardID], [EmailTypeID], [Email], [DisplayAs])
			VALUES (@EmployeeClass, @EmployeeID, 1, @Email, @Email)
		END
	END
	ELSE IF @Email IS NOT NULL
	BEGIN
		UPDATE [Email]
		SET [Email] = @Email, [DisplayAs] = @Email
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [EmailTypeID] = 1
	END
	ELSE
	BEGIN
		DELETE [Email]
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [EmailTypeID] = 1
	END

	IF NOT EXISTS (SELECT * FROM [Email] WHERE [EmailTypeID] = 2 AND [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = @EmployeeID)
	BEGIN
		IF @Email2 IS NOT NULL
		BEGIN
			INSERT INTO [Email] ([BusinessCardClass], [BusinessCardID], [EmailTypeID], [Email], [DisplayAs])
			VALUES (@EmployeeClass, @EmployeeID, 2, @Email2, @Email2)
		END
	END
	ELSE IF @Email2 IS NOT NULL
	BEGIN
		UPDATE [Email]
		SET [Email] = @Email2, [DisplayAs] = @Email2
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [EmailTypeID] = 2
	END
	ELSE
	BEGIN
		DELETE [Email]
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [EmailTypeID] = 2
	END

	IF NOT EXISTS (SELECT * FROM [Email] WHERE [EmailTypeID] = 3 AND [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = @EmployeeID)
	BEGIN
		IF @Email3 IS NOT NULL
		BEGIN
			INSERT INTO [Email] ([BusinessCardClass], [BusinessCardID], [EmailTypeID], [Email], [DisplayAs])
			VALUES (@EmployeeClass, @EmployeeID, 3, @Email3, @Email3)
		END
	END
	ELSE IF @Email3 IS NOT NULL
	BEGIN
		UPDATE [Email]
		SET [Email] = @Email3, [DisplayAs] = @Email3
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [EmailTypeID] = 3
	END
	ELSE
	BEGIN
		DELETE [Email]
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [EmailTypeID] = 3
	END

	IF NOT EXISTS (SELECT * FROM [Email] WHERE [EmailTypeID] = 4 AND [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = @EmployeeID)
	BEGIN
		IF @WebPage IS NOT NULL
		BEGIN
			INSERT INTO [Email] ([BusinessCardClass], [BusinessCardID], [EmailTypeID], [Email], [DisplayAs])
			VALUES (@EmployeeClass, @EmployeeID, 4, @WebPage, @WebPage)
		END
	END
	ELSE IF @WebPage IS NOT NULL
	BEGIN
		UPDATE [Email]
		SET [Email] = @WebPage, [DisplayAs] = @WebPage
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [EmailTypeID] = 4
	END
	ELSE
	BEGIN
		DELETE [Email]
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [EmailTypeID] = 4
	END
	-----------Address
	IF NOT EXISTS (SELECT * FROM [Address] WHERE [AddressTypeID] = 1 AND [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = @EmployeeID)
	BEGIN
		IF @LegalStreet IS NOT NULL OR @LegalCity IS NOT NULL OR @LegalRegion IS NOT NULL OR @LegalCountry IS NOT NULL OR @LegalPostalCode IS NOT NULL
		BEGIN
			INSERT INTO [Address] ([BusinessCardClass], [BusinessCardID], [AddressTypeID],
				[Street], [City], [Region], [Country], [PostalCode], [Mail])
			VALUES (@EmployeeClass, @EmployeeID, 1,
				@LegalStreet, @LegalCity, @LegalRegion, @LegalCountry, @LegalPostalCode, ISNULL(@LegalMail, 0))
		END
	END
	ELSE
	BEGIN
		UPDATE [Address]
		SET [Street] = @LegalStreet, [City] = @LegalCity, [Region] = @LegalRegion, [Country] = @LegalCountry, [PostalCode] = @LegalPostalCode
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [AddressTypeID] = 1
	END

	IF NOT EXISTS (SELECT * FROM [Address] WHERE [AddressTypeID] = 3 AND [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = @EmployeeID)
	BEGIN
		IF @HomeStreet IS NOT NULL OR @HomeCity IS NOT NULL OR @HomeRegion IS NOT NULL OR @HomeCountry IS NOT NULL OR @HomePostalCode IS NOT NULL
		BEGIN
			INSERT INTO [Address] ([BusinessCardClass], [BusinessCardID], [AddressTypeID],
				[Street], [City], [Region], [Country], [PostalCode], [Mail])
			VALUES (@EmployeeClass, @EmployeeID, 3,
				@HomeStreet, @HomeCity, @HomeRegion, @HomeCountry, @HomePostalCode, ISNULL(@HomeMail, 0))
		END
	END
	ELSE
	BEGIN
		UPDATE [Address]
		SET [Street] = @HomeStreet, [City] = @HomeCity, [Region] = @HomeRegion, [Country] = @HomeCountry, [PostalCode] = @HomePostalCode
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [AddressTypeID] = 3
	END

	IF NOT EXISTS (SELECT * FROM [Address] WHERE [AddressTypeID] = 4 AND [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = @EmployeeID)
	BEGIN
		IF @OtherStreet IS NOT NULL OR @OtherCity IS NOT NULL OR @OtherRegion IS NOT NULL OR @OtherCountry IS NOT NULL OR @OtherPostalCode IS NOT NULL
		BEGIN
			INSERT INTO [Address] ([BusinessCardClass], [BusinessCardID], [AddressTypeID],
				[Street], [City], [Region], [Country], [PostalCode], [Mail])
			VALUES (@EmployeeClass, @EmployeeID, 4,
				@OtherStreet, @OtherCity, @OtherRegion, @OtherCountry, @OtherPostalCode, ISNULL(@OtherMail, 0))
		END
	END
	ELSE
	BEGIN
		UPDATE [Address]
		SET [Street] = @OtherStreet, [City] = @OtherCity, [Region] = @OtherRegion, [Country] = @OtherCountry, [PostalCode] = @OtherPostalCode
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [AddressTypeID] = 4
	END
	-----------Phone
	IF NOT EXISTS (SELECT * FROM [Phone] WHERE [PhoneTypeID] = 1 AND [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = @EmployeeID)
	BEGIN
		IF @WorkPhone IS NOT NULL
		BEGIN
			INSERT INTO [Phone] ([BusinessCardClass], [BusinessCardID], [PhoneTypeID], [Phone])
			VALUES (@EmployeeClass, @EmployeeID, 1, @WorkPhone)
		END
	END
	ELSE IF @WorkPhone IS NOT NULL
	BEGIN
		UPDATE [Phone]
		SET [Phone] = @WorkPhone
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 1
	END
	ELSE BEGIN
		DELETE [Phone]
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 1
	END

	IF NOT EXISTS (SELECT * FROM [Phone] WHERE [PhoneTypeID] = 2 AND [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = @EmployeeID)
	BEGIN
		IF @HomePhone IS NOT NULL
		BEGIN
			INSERT INTO [Phone] ([BusinessCardClass], [BusinessCardID], [PhoneTypeID], [Phone])
			VALUES (@EmployeeClass, @EmployeeID, 2, @HomePhone)
		END
	END
	ELSE IF @HomePhone IS NOT NULL
	BEGIN
		UPDATE [Phone]
		SET [Phone] = @HomePhone
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 2
	END
	ELSE BEGIN
		DELETE [Phone]
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 2
	END

	IF NOT EXISTS (SELECT * FROM [Phone] WHERE [PhoneTypeID] = 3 AND [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = @EmployeeID)
	BEGIN
		IF @MobilePhone IS NOT NULL
		BEGIN
			INSERT INTO [Phone] ([BusinessCardClass], [BusinessCardID], [PhoneTypeID], [Phone])
			VALUES (@EmployeeClass, @EmployeeID, 3, @MobilePhone)
		END
	END
	ELSE IF @MobilePhone IS NOT NULL
	BEGIN
		UPDATE [Phone]
		SET [Phone] = @MobilePhone
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 3
	END
	ELSE BEGIN
		DELETE [Phone]
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 3
	END

	IF NOT EXISTS (SELECT * FROM [Phone] WHERE [PhoneTypeID] = 4 AND [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = @EmployeeID)
	BEGIN
		IF @OtherPhone IS NOT NULL
		BEGIN
			INSERT INTO [Phone] ([BusinessCardClass], [BusinessCardID], [PhoneTypeID], [Phone])
			VALUES (@EmployeeClass, @EmployeeID, 4, @OtherPhone)
		END
	END
	ELSE IF @OtherPhone IS NOT NULL
	BEGIN
		UPDATE [Phone]
		SET [Phone] = @OtherPhone
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 4
	END
	ELSE BEGIN
		DELETE [Phone]
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 4
	END

	IF NOT EXISTS (SELECT * FROM [Phone] WHERE [PhoneTypeID] = 5 AND [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = @EmployeeID)
	BEGIN
		IF @HelperPhone IS NOT NULL
		BEGIN
			INSERT INTO [Phone] ([BusinessCardClass], [BusinessCardID], [PhoneTypeID], [Phone])
			VALUES (@EmployeeClass, @EmployeeID, 5, @HelperPhone)
		END
	END
	ELSE IF @HelperPhone IS NOT NULL
	BEGIN
		UPDATE [Phone]
		SET [Phone] = @HelperPhone
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 5
	END
	ELSE BEGIN
		DELETE [Phone]
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 5
	END

	IF NOT EXISTS (SELECT * FROM [Phone] WHERE [PhoneTypeID] = 6 AND [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = @EmployeeID)
	BEGIN
		IF @Work2Phone IS NOT NULL
		BEGIN
			INSERT INTO [Phone] ([BusinessCardClass], [BusinessCardID], [PhoneTypeID], [Phone])
			VALUES (@EmployeeClass, @EmployeeID, 6, @Work2Phone)
		END
	END
	ELSE IF @Work2Phone IS NOT NULL
	BEGIN
		UPDATE [Phone]
		SET [Phone] = @Work2Phone
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 6
	END
	ELSE BEGIN
		DELETE [Phone]
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 6
	END

	IF NOT EXISTS (SELECT * FROM [Phone] WHERE [PhoneTypeID] = 7 AND [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = @EmployeeID)
	BEGIN
		IF @CompanyPhone IS NOT NULL
		BEGIN
			INSERT INTO [Phone] ([BusinessCardClass], [BusinessCardID], [PhoneTypeID], [Phone])
			VALUES (@EmployeeClass, @EmployeeID, 7, @CompanyPhone)
		END
	END
	ELSE IF @CompanyPhone IS NOT NULL
	BEGIN
		UPDATE [Phone]
		SET [Phone] = @CompanyPhone
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 7
	END
	ELSE BEGIN
		DELETE [Phone]
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 7
	END

	IF NOT EXISTS (SELECT * FROM [Phone] WHERE [PhoneTypeID] = 8 AND [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = @EmployeeID)
	BEGIN
		IF @WorkFax IS NOT NULL
		BEGIN
			INSERT INTO [Phone] ([BusinessCardClass], [BusinessCardID], [PhoneTypeID], [Phone])
			VALUES (@EmployeeClass, @EmployeeID, 8, @WorkFax)
		END
	END
	ELSE IF @WorkFax IS NOT NULL
	BEGIN
		UPDATE [Phone]
		SET [Phone] = @WorkFax
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 8
	END
	ELSE BEGIN
		DELETE [Phone]
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 8
	END

	IF NOT EXISTS (SELECT * FROM [Phone] WHERE [PhoneTypeID] = 9 AND [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = @EmployeeID)
	BEGIN
		IF @HomeFax IS NOT NULL
		BEGIN
			INSERT INTO [Phone] ([BusinessCardClass], [BusinessCardID], [PhoneTypeID], [Phone])
			VALUES (@EmployeeClass, @EmployeeID, 9, @HomeFax)
		END
	END
	ELSE IF @HomeFax IS NOT NULL
	BEGIN
		UPDATE [Phone]
		SET [Phone] = @HomeFax
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 9
	END
	ELSE BEGIN
		DELETE [Phone]
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 9
	END

	IF NOT EXISTS (SELECT * FROM [Phone] WHERE [PhoneTypeID] = 10 AND [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = @EmployeeID)
	BEGIN
		IF @AddFax IS NOT NULL
		BEGIN
			INSERT INTO [Phone] ([BusinessCardClass], [BusinessCardID], [PhoneTypeID], [Phone])
			VALUES (@EmployeeClass, @EmployeeID, 10, @AddFax)
		END
	END
	ELSE IF @AddFax IS NOT NULL
	BEGIN
		UPDATE [Phone]
		SET [Phone] = @AddFax
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 10
	END
	ELSE BEGIN
		DELETE [Phone]
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 10
	END

	IF NOT EXISTS (SELECT * FROM [Phone] WHERE [PhoneTypeID] = 11 AND [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = @EmployeeID)
	BEGIN
		IF @BasePhone IS NOT NULL
		BEGIN
			INSERT INTO [Phone] ([BusinessCardClass], [BusinessCardID], [PhoneTypeID], [Phone])
			VALUES (@EmployeeClass, @EmployeeID, 11, @BasePhone)
		END
	END
	ELSE IF @BasePhone IS NOT NULL
	BEGIN
		UPDATE [Phone]
		SET [Phone] = @BasePhone
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 11
	END
	ELSE BEGIN
		DELETE [Phone]
		WHERE [BusinessCardID] = @EmployeeID AND [BusinessCardClass] = @EmployeeClass AND [PhoneTypeID] = 11
	END

	-- Position, Company and Division
	DECLARE @CompanyID TIdentifier, @DivisionID TIdentifier, @PositionID TIdentifier, @State TState

	IF @Position IS NOT NULL
	BEGIN
		SELECT @PositionID = [ID] FROM [Position] WHERE [FileAs] = @Position
		IF @PositionID IS NULL
		BEGIN
			SET @State = dbo.adfwfGetInitialState('1da4d0a6-ed0f-4840-9d29-3090013ba2fb')
			INSERT INTO [Position]
				([State], [Code], [FileAs], [Comments])
			VALUES
				(@State, SUBSTRING(@Position, 1, 32), @Position, '')
			SET @PositionID = SCOPE_IDENTITY()
		END
	END

	IF @Company IS NOT NULL
	BEGIN
		SELECT @CompanyID = [ID] FROM [Company] WHERE [FileAs] = @Company
		IF @CompanyID IS NULL
		BEGIN	--     
			exec pjm6ExchangeSyncCompanyCreate @FileAs = @Company, @UserID = @UserID, @ID = @CompanyID OUTPUT
		END
	END
	
	IF @Division IS NOT NULL AND @Company IS NOT NULL
	BEGIN
		SELECT @DivisionID = [ID] FROM [Division] WHERE ([FileAs] = @Division OR [Code] = @Division) AND [CompanyID] = @CompanyID
		IF @DivisionID IS NULL
		BEGIN
			SET @State = dbo.adfwfGetInitialState('8aee3355-c878-4b7e-929f-29745719bd38')
			INSERT INTO [Division]
				([State], [CompanyID], [Code], [FileAs], [Comments])
			VALUES
				(@State, @CompanyID, @Division, @Division, 'from Exchange')
			SET @DivisionID = SCOPE_IDENTITY()
		END
	END
	ELSE
	BEGIN
		SET @DivisionID = NULL
	END

	UPDATE [Employee]
	SET
		[CompanyID] = @CompanyID,
		[DivisionID] = @DivisionID,
		[PositionID] = @PositionID
	WHERE
		[ID] = @EmployeeID	

	SELECT @EmployeeID as 'PjmID', NULL as 'ExchangeID'

	RETURN 0
GO

GRANT EXECUTE ON pjm6ExchangeSyncCreateContact TO PUBLIC
GO


