
/******************************************************************************
**		Name: pjm6ExchangeSyncContactGetUsers

**		Auth: pavel.svintsov
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		24.05.11	SPV				  NTLogin
**		15.06.11	SPV				  FileAs
*******************************************************************************/
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6ExchangeSyncContactGetUsers]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6ExchangeSyncContactGetUsers'
		DROP PROCEDURE [dbo].[pjm6ExchangeSyncContactGetUsers]
	END
GO
PRINT 'Creating procedure pjm6ExchangeSyncContactGetUsers'
GO

SET QUOTED_IDENTIFIER ON
GO
-------------------------------------------------------------------------------
CREATE PROCEDURE [pjm6ExchangeSyncContactGetUsers]
AS
	SET NOCOUNT ON
	
	SELECT
		[User].[ID] as 'PjmID',
		[Employee].[ID] as 'ExchangeID',
		[Employee].[FirstName],
		[Employee].[MiddleName],
		[Employee].[Lastname],
		[Employee].[FileAs],
		[Email].[Email],
		[Email2].[Email] as 'Email2',
		[Email3].[Email] as 'Email3',
		[Company].[FileAs] as 'Company',
		[User].[NTLogin]
	FROM
		[Employee]
		INNER JOIN [User]
			ON [User].[ID] = [Employee].[UserID]
		INNER JOIN [Company]
			ON [Company].[ID] = [Employee].[CompanyID]
		LEFT OUTER JOIN [Email]
			ON [Email].[BusinessCardClass] = [Employee].[Class] AND [Email].[BusinessCardID] = [Employee].[ID] AND [Email].[EmailTypeID] = 1
		LEFT OUTER JOIN [Email] [Email2]
			ON [Email2].[BusinessCardClass] = [Employee].[Class] AND [Email2].[BusinessCardID] = [Employee].[ID] AND [Email2].[EmailTypeID] = 2
		LEFT OUTER JOIN [Email] [Email3]
			ON [Email3].[BusinessCardClass] = [Employee].[Class] AND [Email3].[BusinessCardID] = [Employee].[ID] AND [Email3].[EmailTypeID] = 3
	WHERE
		EXISTS
		(
			SELECT
				AppSetings.Properties.query('SyncExchangeContacts').value('.[1]', 'nvarchar(max)')
			FROM
				[User].[ApplicationSettings].nodes('/ApplicationSettings/Properties') AS AppSetings(Properties)
			WHERE
				AppSetings.Properties.query('SyncExchangeContacts').value('.[1]', 'nvarchar(max)') = 'True'
		)
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm6ExchangeSyncContactGetUsers] TO PUBLIC
GO


/******************************************************************************
**		Name: pjm6ExchangeSyncMeetingRequestGetUsers
**
**		Auth: pavel.svintsov
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		24.05.11	SPV				  NTLogin
*******************************************************************************/
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6ExchangeSyncMeetingRequestGetUsers]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6ExchangeSyncMeetingRequestGetUsers'
		DROP PROCEDURE [dbo].[pjm6ExchangeSyncMeetingRequestGetUsers]
	END
GO
PRINT 'Creating procedure pjm6ExchangeSyncMeetingRequestGetUsers'
GO
-------------------------------------------------------------------------------
CREATE PROCEDURE [pjm6ExchangeSyncMeetingRequestGetUsers]
AS
	SET NOCOUNT ON
	
	SELECT
		[User].[ID] as 'PjmID',
		[Employee].[ID] as 'ExchangeID',
		[Employee].[FirstName],
		[Employee].[MiddleName],
		[Employee].[Lastname],
		[Email].[Email],
		[Company].[FileAs] as 'Company',
		[User].[NTLogin]
	FROM
		[Employee]
		INNER JOIN [User]
			ON [User].[ID] = [Employee].[UserID]
		INNER JOIN [Company]
			ON [Company].[ID] = [Employee].[CompanyID]
		LEFT OUTER JOIN [Email]
			ON [Email].[BusinessCardClass] = [Employee].[Class] AND [Email].[BusinessCardID] = [Employee].[ID] AND [EmailTypeID] = 1
	WHERE
	EXISTS
	(
		SELECT
			AppSetings.Properties.query('SyncExchangeContacts').value('.[1]', 'nvarchar(max)')
		FROM
			[User].[ApplicationSettings].nodes('/ApplicationSettings/Properties') AS AppSetings(Properties)
		WHERE
			AppSetings.Properties.query('SyncExchangeMeetings').value('.[1]', 'nvarchar(max)') = 'True'
	)
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm6ExchangeSyncMeetingRequestGetUsers] TO PUBLIC
GO


/******************************************************************************
**		Name: pjm6ExchangeSyncCalendarGetUsers

**		Auth: pavel.svintsov
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		24.05.11	SPV				  NTLogin
*******************************************************************************/
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6ExchangeSyncCalendarGetUsers]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6ExchangeSyncCalendarGetUsers'
		DROP PROCEDURE [dbo].[pjm6ExchangeSyncCalendarGetUsers]
	END
GO
PRINT 'Creating procedure pjm6ExchangeSyncCalendarGetUsers'
GO
-------------------------------------------------------------------------------
CREATE PROCEDURE [pjm6ExchangeSyncCalendarGetUsers]
AS
	SET NOCOUNT ON
	
	SELECT
		[User].[ID] as 'PjmID',
		[Employee].[ID] as 'ExchangeID',
		[Employee].[FirstName],
		[Employee].[MiddleName],
		[Employee].[Lastname],
		[Email].[Email],
		[Company].[FileAs] as 'Company',
		[User].[NTLogin]
	FROM
		[Employee]
		INNER JOIN [User]
			ON [User].[ID] = [Employee].[UserID]
		INNER JOIN [Company]
			ON [Company].[ID] = [Employee].[CompanyID]
		LEFT OUTER JOIN [Email]
			ON [Email].[BusinessCardClass] = [Employee].[Class] AND [Email].[BusinessCardID] = [Employee].[ID] AND [EmailTypeID] = 1
	WHERE
		EXISTS
		(
			SELECT
				AppSetings.Properties.query('SyncExchangeContacts').value('.[1]', 'nvarchar(max)')
			FROM
				[User].[ApplicationSettings].nodes('/ApplicationSettings/Properties') AS AppSetings(Properties)
			WHERE
				AppSetings.Properties.query('SyncExchangeCalendar').value('.[1]', 'nvarchar(max)') = 'True'
		)
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm6ExchangeSyncCalendarGetUsers] TO PUBLIC
GO