/******************************************************************************
**		Name: pjm6ExchangeSyncUpdateContactID
**		Auth: pavel.svintsov
**		Date: 27.01.2011 16:00:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		
**    
*******************************************************************************/

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6ExchangeSyncUpdateContactID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6ExchangeSyncUpdateContactID'
		DROP PROCEDURE [dbo].[pjm6ExchangeSyncUpdateContactID]
	END
GO
PRINT 'Creating procedure pjm6ExchangeSyncUpdateContactID'
GO

SET QUOTED_IDENTIFIER ON
GO
-------------------------------------------------------------------------------
CREATE PROCEDURE [pjm6ExchangeSyncUpdateContactID]
	@UserID TIdentifier,
	@PjmID TIdentifier,
	@ExchangeID TGuid
AS
	DECLARE @EmployeeClass TClass
	SET @EmployeeClass = dbo.adfGetClassByName('Adf.Employee')

	IF (@ExchangeID IS NULL)
	BEGIN
		DELETE [ExchangeSync]
		WHERE [DocumentClass] = @EmployeeClass AND [DocumentID] = @PjmID AND [UserID] = @UserID
	END
	ELSE
	BEGIN
		IF EXISTS (SELECT * FROM [ExchangeSync] WHERE [DocumentClass] = @EmployeeClass AND [DocumentID] = @PjmID AND [UserID] = @UserID)
		BEGIN
			UPDATE [ExchangeSync]
			SET
				[Date] = GETDATE(),
				[ExchangeID] = @ExchangeID
			WHERE [DocumentClass] = @EmployeeClass AND [DocumentID] = @PjmID AND [UserID] = @UserID
		END
		ELSE
		BEGIN
			IF EXISTS(
				SELECT * FROM [UserContact]
				WHERE
					[UserContact].[UserID] = @UserID AND 
					[UserContact].[BusinessCardClass] = @EmployeeClass AND
					[UserContact].[BusinessCardID] = @PjmID
				)
			BEGIN
				INSERT INTO [ExchangeSync] ([UserID], [DocumentClass], [DocumentID], [Date], [ExchangeID])
				VALUES (@UserID, @EmployeeClass, @PjmID, GETDATE(), @ExchangeID)
			END
		END
	END

	RETURN 0
GO

GRANT EXECUTE ON pjm6ExchangeSyncUpdateContactID TO PUBLIC
GO
