IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FactureDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FactureDelete'
		DROP PROCEDURE [dbo].[pjm5FactureDelete]
	END
GO

PRINT 'Creating procedure pjm5FactureDelete'
GO

/******************************************************************************
**		File: pjm5FactureDelete.sql
**		Name: pjm5FactureDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		29.06.10	KOV				    
*******************************************************************************/
CREATE PROCEDURE pjm5FactureDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE @ProjectID TIdentifier
	SELECT @ProjectID = [ProjectID] FROM [Facture] WHERE [ID] = @ID
	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllInvoices')) = 0  AND
		dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END	

	DECLARE @PaymentClass TClass, @FactureClass TClass
	SET @FactureClass = dbo.adfGetClassByName('Pjm5.Facture')
	SET @PaymentClass = dbo.adfGetClassByName('Adf.Payment')
	IF EXISTS(SELECT * FROM [SuperTimer] 
					WHERE [SuperTimer].[DocumentClass] = dbo.adfGetClassByName('Pjm5.Facture') AND [SuperTimer].[DocumentID] = @ID AND 
					([SuperTimer].[State] in (1,2) OR ([SuperTimer].[State] = 3 AND [SuperTimer].[Persistent] = 1)))
	BEGIN
		RAISERROR('#CannotDeleteDocumentWithActiveTimer', 18, -1)
		RETURN 1
	END
	BEGIN TRANSACTION

	DELETE FROM [Attachment]
	FROM
		[Attachment]
		INNER JOIN [FacturePayment]
			ON ([Attachment].[DocumentClass] = @PaymentClass AND [Attachment].[DocumentID] = [FacturePayment].[PaymentID] AND
				[Attachment].[LinkDocumentClass] = @FactureClass AND [Attachment].[LinkDocumentID] = [FacturePayment].[FactureID])
	WHERE 
		[LinkDocumentID] = @ID AND 
		[AttachmentTypeID] = 3
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [FacturePayment] WHERE [FactureID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [FactureLine] WHERE [FactureID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [RemovedDocument] ( [DocumentID], [DocumentClass], [DocumentNumber], [DocumentDate], [Date])
	SELECT
		[Facture].[ID],
		[Facture].[Class],
		[Facture].[Number],
		[Facture].[Date],
		GETDATE()
	FROM
		[Facture]
	WHERE
		[Facture].[ID] = @ID
	
	DELETE FROM [Facture] WHERE [Facture].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON pjm5FactureDelete TO PUBLIC
GO
