 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalculationFind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalculationFind'
		DROP PROCEDURE [dbo].[pjm5CalculationFind]
	END
GO

PRINT 'Creating procedure pjm5CalculationFind'
GO

/******************************************************************************
**		File: pjm5CalculationFind.sql
**		Name: pjm5CalculationFind
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		14.08.12	SOV				     [Calculation].[FileAs]
*******************************************************************************/
CREATE PROCEDURE [pjm5CalculationFind]
	@Text nvarchar(256), -- NULL -  , 
	@TextField int, -- 0 - FileAs, -- 1 - FileAs, Comments
	@State int, -- NULL - 
	@Flag tinyint, -- NULL -  , 0-7 
	@UserOption int,
	@TimeField int, -- 0 - , 1 - Created, 2 - Modified
	@StartTime datetime,
	@EndTime datetime,
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE @UserID TIdentifier, @EmployeeID TIdentifier, @ViewAllProjects TBool
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects'))

	SELECT
		[Calculation].[Class],
		[Calculation].[ID],
		[Calculation].[State],
		[Calculation].[Date],
		[Calculation].[Number],
		[Calculation].[FileAs],
		[Calculation].[Comments],
		[Calculation].[ProjectID],
		[Calculation].[Flag],
		[Calculation].[Created],
		[Calculation].[CreatedBy],
		[Calculation].[Modified],
		[Calculation].[ModifiedBy]
	FROM
		[Calculation] INNER JOIN dbo.fnPjm5GetAvailableProjects() as [P]
			ON ([Calculation].[ProjectID] = [P].[ID])
	WHERE
		(
			@ViewAllProjects = 1 OR 
			dbo.fnPjm5IsProjectManager([Calculation].[ProjectID], @EmployeeID) = 1
		) AND
		(
			@ProjectID IS NULL OR (@ProjectID IS NOT NULL AND [Calculation].[ProjectID] = @ProjectID)
		)
		AND
		(
			@Text IS NULL
			OR
			(@TextField = 0 AND [Calculation].[FileAs] LIKE '%' + @Text + '%')
			OR
			(@TextField = 1 AND ([Calculation].[FileAs] LIKE '%' + @Text + '%' OR [Calculation].[Comments] LIKE '%' + @Text + '%'))
			OR
			(@TextField = 2 AND ([Calculation].[Number] LIKE '%' + @Text + '%' OR [Calculation].[FileAs] LIKE '%' + @Text + '%' OR [Calculation].[Comments] LIKE '%' + @Text + '%'))			
		)
		AND
		(
			@State IS NULL
			OR
			(@State IS NOT NULL AND [Calculation].[State] = @State)
		)		
		AND
		(
			@Flag IS NULL
			OR
			(@Flag IS NOT NULL AND [Calculation].[Flag] = @Flag)
		)
		AND
		(
			@UserOption IS NULL
			OR
			(@UserOption = 0 AND dbo.fnPjm5IsProjectManager([Calculation].[ProjectID], @EmployeeID) = 1)
			OR
			(@UserOption = 1 AND ([Calculation].[CreatedBy] = @UserID OR [Calculation].[ModifiedBy] = @UserID))
			OR
			(@UserOption = 2 AND [Calculation].[CreatedBy] = @UserID)
			OR
			(@UserOption = 3 AND [Calculation].[ModifiedBy] = @UserID)
		)
		AND
		(
			@TimeField = 0
			OR
			(@TimeField = 1 AND [Calculation].[Created] BETWEEN @StartTime AND @EndTime)
			OR
			(@TimeField = 2 AND [Calculation].[Modified] BETWEEN @StartTime AND @EndTime)
		)
	ORDER BY
		[Calculation].[FileAs]
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CalculationFind] TO PUBLIC
GO 