 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FactureFind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FactureFind'
		DROP PROCEDURE [dbo].[pjm5FactureFind]
	END
GO

PRINT 'Creating procedure pjm5FactureFind'
GO

/******************************************************************************
**		File: pjm5FactureFind.sql
**		Name: pjm5FactureFind
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		14.08.12	SOV				     [Facture].[FileAs]
*******************************************************************************/
CREATE PROCEDURE [pjm5FactureFind]
	@Text nvarchar(256), -- NULL -  , 
	@TextField int, -- 0 - FileAs, -- 1 - FileAs, Comments
	@State int, -- NULL - 
	@Flag tinyint, -- NULL -  , 0-7 
	@UserOption int,
	@TimeField int, -- 0 - , 1 - Created, 2 - Modified
	@StartTime datetime,
	@EndTime datetime,
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE @UserID TIdentifier, @EmployeeID TIdentifier, @ViewAllProjects TBool
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects'))

	SELECT
		[Facture].[Class],
		[Facture].[ID],
		[Facture].[State],
		[Facture].[Date],
		[Facture].[Number],
		[Facture].[FileAs],
		[Facture].[Comments],
		[Facture].[ProjectID],
		[Facture].[Flag],
		[Facture].[Created],
		[Facture].[CreatedBy],
		[Facture].[Modified],
		[Facture].[ModifiedBy]
	FROM
		[Facture] INNER JOIN dbo.fnPjm5GetAvailableProjects() as [P]
			ON ([Facture].[ProjectID] = [P].[ID])
	WHERE
		(
			@ViewAllProjects = 1 OR 
			dbo.fnPjm5IsProjectManager([Facture].[ProjectID], @EmployeeID) = 1
		) AND
		(
			@ProjectID IS NULL OR (@ProjectID IS NOT NULL AND [Facture].[ProjectID] = @ProjectID)
		)
		AND
		(
			@Text IS NULL
			OR
			(@TextField = 0 AND [Facture].[FileAs] LIKE '%' + @Text + '%')
			OR
			(@TextField = 1 AND ([Facture].[FileAs] LIKE '%' + @Text + '%' OR [Facture].[Comments] LIKE '%' + @Text + '%'))
			OR
			(@TextField = 2 AND ([Facture].[Number] LIKE '%' + @Text + '%' OR [Facture].[FileAs] LIKE '%' + @Text + '%' OR [Facture].[Comments] LIKE '%' + @Text + '%'))			
		)
		AND
		(
			@State IS NULL
			OR
			(@State IS NOT NULL AND [Facture].[State] = @State)
		)		
		AND
		(
			@Flag IS NULL
			OR
			(@Flag IS NOT NULL AND [Facture].[Flag] = @Flag)
		)
		AND
		(
			@UserOption IS NULL
			OR
			(@UserOption = 0 AND dbo.fnPjm5IsProjectManager([Facture].[ProjectID], @EmployeeID) = 1)
			OR
			(@UserOption = 1 AND ([Facture].[CreatedBy] = @UserID OR [Facture].[ModifiedBy] = @UserID))
			OR
			(@UserOption = 2 AND [Facture].[CreatedBy] = @UserID)
			OR
			(@UserOption = 3 AND [Facture].[ModifiedBy] = @UserID)
		)
		AND
		(
			@TimeField = 0
			OR
			(@TimeField = 1 AND [Facture].[Created] BETWEEN @StartTime AND @EndTime)
			OR
			(@TimeField = 2 AND [Facture].[Modified] BETWEEN @StartTime AND @EndTime)
		)
	ORDER BY
		[Facture].[FileAs]
	RETURN 0
GO

GRANT EXECUTE ON [pjm5FactureFind] TO PUBLIC
GO 