 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceFind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceFind'
		DROP PROCEDURE [dbo].[pjm5ResourceFind]
	END
GO

PRINT 'Creating procedure pjm5ResourceFind'
GO

/******************************************************************************
**		File: pjm5ResourceFind.sql
**		Name: pjm5ResourceFind
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/15/2006 17:54:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		14.08.12	SOV				     [Resource].[FileAs]
*******************************************************************************/
CREATE PROCEDURE [pjm5ResourceFind]
	@Text nvarchar(256), -- NULL -  , 
	@TextField int, -- 0 - FileAs, -- 1 - FileAs, Comments
	@State int, -- NULL - 
	@Flag tinyint, -- NULL -  , 0-7 
	@UserOption int,
	@TimeField int, -- 0 - , 1 - Created, 2 - Modified
	@StartTime datetime,
	@EndTime datetime
AS
	SET NOCOUNT ON

	DECLARE @UserID TIdentifier, @EmployeeID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()

	SELECT
		[Resource].[Class],
		[Resource].[ID],
		[Resource].[State],
		[Resource].[Code],
		[Resource].[FileAs],
		[Resource].[Comments],
		[Resource].[Flag],
		[Resource].[Created],
		[Resource].[CreatedBy],
		[Resource].[Modified],
		[Resource].[ModifiedBy]
	FROM
		[Resource] 
	WHERE
		(
			@Text IS NULL
			OR
			(@TextField = 0 AND [Resource].[FileAs] LIKE '%' + @Text + '%')
			OR
			(@TextField = 1 AND ([Resource].[FileAs] LIKE '%' + @Text + '%' OR [Resource].[Comments] LIKE '%' + @Text + '%'))
			OR
			(@TextField = 2 AND ([Resource].[Code] LIKE '%' + @Text + '%' OR [Resource].[FileAs] LIKE '%' + @Text + '%' OR [Resource].[Comments] LIKE '%' + @Text + '%'))			
		)
		AND
		(
			@State IS NULL
			OR
			(@State IS NOT NULL AND [Resource].[State] = @State)
		)		
		AND
		(
			@Flag IS NULL
			OR
			(@Flag IS NOT NULL AND [Resource].[Flag] = @Flag)
		)
		AND
		(
			@UserOption IS NULL
			OR
			(@UserOption = 0 AND [ResponsibleEmployeeID] = @EmployeeID)
			OR
			(@UserOption = 1 AND ([CreatedBy] = @UserID OR [ModifiedBy] = @UserID))
			OR
			(@UserOption = 2 AND [CreatedBy] = @UserID)
			OR
			(@UserOption = 3 AND [ModifiedBy] = @UserID)
		)
		AND
		(
			@TimeField = 0
			OR
			(@TimeField = 1 AND [Resource].[Created] BETWEEN @StartTime AND @EndTime)
			OR
			(@TimeField = 2 AND [Resource].[Modified] BETWEEN @StartTime AND @EndTime)
		)
	ORDER BY
		[Resource].[FileAs]
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ResourceFind] TO PUBLIC
GO 