IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[IssueBrowseSelectorDialogCalculation]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure IssueBrowseSelectorDialogCalculation'
		DROP PROCEDURE [dbo].[IssueBrowseSelectorDialogCalculation]
	END
GO

PRINT 'Creating procedure IssueBrowseSelectorDialogCalculation'
GO

/******************************************************************************
**		File: pjm5IssueBrowseByCategory.sql
**		Name: pjm5IssueBrowseByCategory
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 14:40:18
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [IssueBrowseSelectorDialogCalculation]
	@EmployeeID TIdentifier,
	@ProjectID TIdentifier,
	@State TIdentifier,
	@View int
AS
	SET NOCOUNT ON
	
	DECLARE 
		@StateClass TClass,
		@IssueManager int
		
	SET @StateClass = dbo.adfGetClassByName('Pjm5.Issue')
	SET @IssueManager = dbo.adfHasAccessRightByName('ManageIssues')
	
	IF (@EmployeeID = 0)
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
		
	SELECT
		[Issue].[ID],
		[Issue].[State],
		[Issue].[ProjectID],
		[Issue].[Number],
		[Issue].[FileAs],
		[State].[Name] as [StateName],
		[Employee].[FileAs] as [Employee]
	FROM
		[Issue]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [Issue].[EmployeeID]
		INNER JOIN [State]
			ON [State].[State] = [Issue].[State]
			AND [State].[Class] = @StateClass
		INNER JOIN dbo.fnPjm6GetAvailableProjectsForTimeEntryGet(@EmployeeID, @ProjectID) AS [Project]
			ON [Project].[ID] = [Issue].[ProjectID]
	WHERE
		[Issue].[State] IN ( 3, 4, 5, 6) AND
		
		(
			@IssueManager = 1 OR
			[Issue].[EmployeeID] = @EmployeeID
		) AND 
		(
			@ProjectID IN (0, -1, -2, -3, -4) OR
			[Issue].[ProjectID] = @ProjectID
		) AND
		(
			[Issue].[State] = @State OR	-- только указанного состояния
			@State = 0 -- все доступные состояния
		) AND
		(
			@View = 0 OR -- все доступные запросы
			[Issue].[EmployeeID] = @EmployeeID -- только свои запросы
		)
		 
		
	RETURN 0
GO

GRANT EXECUTE ON [IssueBrowseSelectorDialogCalculation] TO PUBLIC
GO
 
