﻿IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmBudgetTypes')
	BEGIN
		PRINT 'Dropping Procedure lmBudgetTypes'
		DROP  Procedure  lmBudgetTypes
	END

GO

PRINT 'Creating Procedure lmBudgetTypes'
GO
/******************************************************************************
**		File: 
**		Name: lmBudgetTypes
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 10/12/2010 13::00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmBudgetTypes
AS
	SET NOCOUNT ON

	DECLARE 
		@res			int,
		@Lang			TLanguage
	
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[BudgetType].[ID],
		ISNULL([BudgetTypeGlobal].[FileAs], [BudgetType].[FileAs]) AS [Name]
	FROM
		[BudgetType]
	LEFT OUTER JOIN [BudgetTypeGlobal] 
			ON ([BudgetType].[ID] = [BudgetTypeGlobal].[ID]
				AND [BudgetTypeGlobal].[Language] = @Lang)

	RETURN 0
GO

GRANT EXEC ON lmBudgetTypes TO PUBLIC
GO