IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmProjectAccessible')
	BEGIN
		PRINT 'Dropping Procedure lmProjectAccessible'
		DROP  Procedure  lmProjectAccessible
	END

GO

PRINT 'Creating Procedure lmProjectAccessible'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure lmProjectAccessible
AS
	SET NOCOUNT ON

	DECLARE @EmployeeID TIdentifier
		
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')) = 1
		SELECT
			[ID],
			[Number] as [Code],
			[FileAs] as [Name],
			[State],
			[ProjectTypeID] as [Type]
		FROM
			[Project]
		WHERE
			[State] IN (1, 2, 3, 4)
	ELSE
	BEGIN
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
		SELECT
			[ID],
			[Number] as [Code],
			[FileAs] as [Name],
			[State],
			[ProjectTypeID] as [Type]
		FROM
			[Project]
		WHERE
			[State] IN (1, 2, 3, 4) AND
			[ProjectManagerEmployeeID] = @EmployeeID 
	END
	
	RETURN 0
GO

GRANT EXEC ON lmProjectAccessible TO PUBLIC

GO
