IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmProjectType')
	BEGIN
		PRINT 'Dropping Procedure lmProjectType'
		DROP  Procedure  lmProjectType
	END

GO

PRINT 'Creating Procedure lmProjectType'
GO
/******************************************************************************
**		File: 
**		Name: lmProjectType
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmProjectType
AS
	SET NOCOUNT ON

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[ProjectType].[ID],
		[DocumentGlobal].[FileAs] AS [Name]
	FROM
		[ProjectType] INNER JOIN [DocumentGlobal]
			ON ([ProjectType].[Class] = [DocumentGlobal].[Class] AND
				[ProjectType].[ID] = [DocumentGlobal].[ID] AND
				[DocumentGlobal].[Language] = @Lang)
		
	RETURN 0
GO

GRANT EXEC ON lmProjectType TO PUBLIC
GO
