SET QUOTED_IDENTIFIER ON
GO

 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5MeetingRequestBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5MeetingRequestBrowse'
		DROP PROCEDURE [dbo].[pjm5MeetingRequestBrowse]
	END
GO

PRINT 'Creating procedure pjm5MeetingRequestBrowse'
GO

/******************************************************************************
**		File: pjm5MeetingRequestBrowse.sql
**		Name: pjm5MeetingRequestBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/19/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5MeetingRequestBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[MeetingRequest].[Class],
		[MeetingRequest].[ID],
		[MeetingRequest].[State],
		[MeetingRequest].[Flag],
		[MeetingRequest].[FileAs],
		[MeetingRequest].[ProjectID],
		[MeetingRequest].[OriginatorEmployeeID],
		[MeetingRequest].[ActivityTypeID],
		[MeetingRequest].[PriorityID],
		[MeetingRequest].[StartTime],
		[MeetingRequest].[Duration],
		[MeetingRequest].[Location],
		[MeetingRequest].[Color],
		[MeetingRequest].[Comments],
		[MeetingRequest].[Created],
		[MeetingRequest].[CreatedBy],
		[MeetingRequest].[Modified],
		[MeetingRequest].[ModifiedBy],
		[MeetingRequest].[Timestamp]
	FROM
		[MeetingRequest]
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [MeetingRequest].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5MeetingRequestBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5MeetingRequestGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5MeetingRequestGet'
		DROP PROCEDURE [dbo].[pjm5MeetingRequestGet]
	END
GO

PRINT 'Creating procedure pjm5MeetingRequestGet'
GO

/******************************************************************************
**		File: pjm5MeetingRequestGet.sql
**		Name: pjm5MeetingRequestGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/19/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5MeetingRequestGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @EmployeeID TIdentifier, 
			@UserID TIdentifier,
			@RecurrencePatternID TIdentifier,
			@MeetingRequestClass TClass
	
	SET @MeetingRequestClass = dbo.adfGetClassByName('Pjm5.MeetingRequest')
	
	SELECT 
		@RecurrencePatternID = [RecurrencePatternID] 
	FROM 
		[Document] 
	WHERE 
		[Document].[Class] = @MeetingRequestClass AND [Document].[ID] = @ID
		
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID();
	SET @UserID = dbo.adfGetCurrentUserID();
	SELECT
		[MeetingRequest].[Class],
		[MeetingRequest].[ID],
		[MeetingRequest].[State],
		[MeetingRequest].[Flag],
		[MeetingRequest].[FileAs],
		[MeetingRequest].[ProjectID],
		[MeetingRequest].[OriginatorEmployeeID],
		[MeetingRequest].[ActivityTypeID],
		[MeetingRequest].[PriorityID],
		[MeetingRequest].[StartTime],
		[MeetingRequest].[Duration],
		[MeetingRequest].[Location],
		[MeetingRequest].[Color],
		[MeetingRequest].[Comments],
		(SELECT [ResponseType] FROM [Attendee] WHERE [MeetingRequestID] = @ID AND [EmployeeID] = @EmployeeID) as [ResponseType],
		@RecurrencePatternID as [RecurrencePatternID],
		ISNULL([UserReminder].[State], CAST(0 as int)) AS [ReminderState],
		ISNULL([UserReminder].[OriginalInterval], dbo.fnPjm5GetReminderInterval([MeetingRequest].[Class], 'MS', @UserID)) AS [ReminderInterval],
		[MeetingRequest].[Created],
		[MeetingRequest].[CreatedBy],
		[MeetingRequest].[Modified],
		[MeetingRequest].[ModifiedBy],
		[MeetingRequest].[Timestamp],
		[MeetingRequest].[SendUpdate]
	FROM
		[MeetingRequest] LEFT OUTER JOIN [Reminder]
			ON ([Reminder].[DocumentClass] = [MeetingRequest].[Class] AND
				[Reminder].[DocumentID] = [MeetingRequest].[ID] AND
				[Reminder].[Subtype] = 'MS')
		LEFT OUTER JOIN [UserReminder]
			ON ([Reminder].[ID] = [UserReminder].[ReminderID] AND
				[UserReminder].[UserID] = @UserID)
	WHERE
		[MeetingRequest].[ID] = @ID
		
	SELECT
		[EmployeeID],
		[Required],
		[Present],
		[ResponseType]
	FROM
		[Attendee]
	WHERE
		[MeetingRequestID] = @ID
	
	SELECT
		[MeetingResource].[ResourceID],
		[Resource].[ResourceTypeID],
		[MeetingResource].[Required]
	FROM
		[MeetingResource] INNER JOIN [Resource]
			On ([MeetingResource].[ResourceID] = [Resource].[ID])
	WHERE
		[MeetingRequestID] = @ID
		
	SELECT
		[ID],
		[EmployeeID],
		[FileAs],
		[Comments],
		[Created]
	FROM
		[AttendeeResponse]
	WHERE
		[MeetingRequestID] = @ID
		
	SELECT
		[RecurrencePattern].[ID],
		[RecurrencePattern].[StartDate],
		[RecurrencePattern].[EndDate],
		[RecurrencePattern].[Occurrences],
		[RecurrencePattern].[RecurrenceType],
		[RecurrencePattern].[Interval],
		[RecurrencePattern].[DayOfWeekMask],
		[RecurrencePattern].[Instance],
		[RecurrencePattern].[MonthOfYear],
		[RecurrencePattern].[DayOfMonth]
	FROM
		[RecurrencePattern]
	WHERE
		[RecurrencePattern].[ID] = @RecurrencePatternID
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5MeetingRequestGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5MeetingRequestCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5MeetingRequestCreate'
		DROP PROCEDURE [dbo].[pjm5MeetingRequestCreate]
	END
GO

PRINT 'Creating procedure pjm5MeetingRequestCreate'
GO

/******************************************************************************
**		File: pjm5MeetingRequestCreate.sql
**		Name: pjm5MeetingRequestCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/19/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5MeetingRequestCreate]
	@Xml XML
AS
	SET NOCOUNT ON

	DECLARE @State TState,
			@ID TIdentifier,
			@RecurrenceID TIdentifier
	
	SET @State = dbo.adfwfGetInitialState('8dd9c3da-a9a1-4bbb-90a2-a8f6fcff6ad6')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	DECLARE @_xml xml
	
	SET @_xml = @Xml
	
	DECLARE @CurrentEmployeeID TIdentifier, @result INT
	
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	
	BEGIN TRANSACTION

	INSERT INTO [RecurrencePattern]
		([StartDate], [EndDate], [RecurrenceType], [Occurrences],
		[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
	SELECT
		CAST(T.c.value('StartDate[1]', 'varchar(19)') as datetime),
		CAST(T.c.value('EndDate[1]', 'varchar(19)') as datetime),
		T.c.value('RecurrenceType[1]', 'int'),
		T.c.value('Occurrences[1]', 'int'),
		T.c.value('Interval[1]', 'int'),
		T.c.value('DayOfWeekMask[1]', 'int'),
		T.c.value('Instance[1]', 'int'),
		T.c.value('MonthOfYear[1]', 'int'),
		T.c.value('DayOfMonth[1]', 'int')
	FROM
		@_xml.nodes('/pjm5MeetingRequestGet/RecurrencePattern') T(c)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	SET @RecurrenceID = SCOPE_IDENTITY()
	
	INSERT INTO [MeetingRequest]
		([Flag], [State], [FileAs], [ProjectID], [OriginatorEmployeeID], 
		[ActivityTypeID], [PriorityID], [StartTime], [Duration], [Location], [Color], [Comments])
	SELECT
		0, 
		@State, 
		T.c.value('FileAs[1]', 'nvarchar(256)'),
		T.c.value('ProjectID[1]', 'int'),
		@CurrentEmployeeId,
		T.c.value('ActivityTypeID[1]', 'int'),
		T.c.value('PriorityID[1]', 'int'),
		CAST(T.c.value('StartTime[1]', 'varchar(19)') as datetime),
		T.c.value('Duration[1]', 'int'),
		T.c.value('Location[1]', 'nvarchar(256)'),
		T.c.value('Color[1]', 'int'),
		T.c.value('Comments[1]', 'nvarchar(max)')
	FROM
		@_xml.nodes('/pjm5MeetingRequestGet/MeetingRequest') T(c)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()
	
	IF @RecurrenceID IS NOT NULL
	BEGIN
		UPDATE [Document]
		SET 
			[RecurrencePatternID] = @RecurrenceID
		WHERE 
			[Class] = dbo.adfGetClassByName('Pjm5.MeetingRequest') AND [ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END	
	
	INSERT INTO [Attendee] ([MeetingRequestID], [EmployeeID], [Required])
	SELECT
		@ID,
		T.c.value('EmployeeID[1]', 'int'),
		T.c.value('Required[1]', 'bit')
	FROM
		@_xml.nodes('/pjm5MeetingRequestGet/Attendee') T(c)
	WHERE
		T.c.value('EmployeeID[1]', 'int') != @CurrentEmployeeID
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DECLARE @ReminderState TBool, @ReminderInterval TTimeSpan, @StartTime TDateTime
	
	SELECT
		@ReminderState = T.c.value('ReminderState[1]', 'bit'),
		@ReminderInterval = T.c.value('ReminderInterval[1]', 'int'),
		@StartTime = CAST(T.c.value('StartTime[1]', 'varchar(19)') as datetime)
	FROM
		@_xml.nodes('/pjm5MeetingRequestGet/MeetingRequest') T(c)

	EXEC @result = pjm5MeetingRequestReminderCreate @ID, @StartTime, @ReminderState, @ReminderInterval
	IF @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [MeetingResource] ([MeetingRequestID], [ResourceID], [Required])
	SELECT
		@ID,
		T.c.value('ResourceID[1]', 'int'),
		T.c.value('Required[1]', 'bit')
	FROM
		@_xml.nodes('/pjm5MeetingRequestGet/MeetingResource') T(c)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	EXEC @result = pjm6MeetingRequestAutoAssign @ID
	IF @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @result
	END

	COMMIT TRANSACTION

	EXEC pjm5MeetingRequestGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5MeetingRequestCreate TO PUBLIC
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5MeetingRequestUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5MeetingRequestUpdate'
		DROP PROCEDURE [dbo].[pjm5MeetingRequestUpdate]
	END
GO

PRINT 'Creating procedure pjm5MeetingRequestUpdate'
GO

/******************************************************************************
**		File: pjm5MeetingRequestUpdate.sql
**		Name: pjm5MeetingRequestUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/19/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5MeetingRequestUpdate
	@Xml XML
AS
		
	SET NOCOUNT ON
	DECLARE @ID TIdentifier, @_xml xml, @OriginatorEmployeeID TIdentifier, @StartTime TDateTime, @ReminderState TState,
			@ReminderInterval TTimeSpan, @CurrentEmployeeID TIdentifier, @OldStartTime TDateTime, @RecurrenceID TIdentifier,
			@ProjectID TIdentifier

	DECLARE -- RECURRENCE
		@StartDate TDate, 
		@EndDate TDate, 
		@RecurrenceType TIdentifier, 
		@Occurrences TCount,
		@Interval TCount, 
		@DayOfWeekMask TIdentifier, 
		@Instance TIdentifier, 
		@MonthOfYear TCount, 
		@DayOfMonth TCount,
		@Recurrence TBool
		
	SET @_xml = @Xml

	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
			
	SELECT 
		@ID = T.c.value('ID[1]', 'int'), 
		@ReminderState = T.c.value('ReminderState[1]', 'bit'),
		@ReminderInterval =	T.c.value('ReminderInterval[1]', 'int'),
		@RecurrenceID = T.c.value('RecurrencePatternID[1]', 'int')
	FROM 
		@_xml.nodes('/pjm5MeetingRequestGet/MeetingRequest') T(c)
		
	SET @Recurrence = 0
	IF EXISTS(SELECT * FROM @_xml.nodes('/pjm5MeetingRequestGet/RecurrencePattern') T(c))
	BEGIN 
		SET @Recurrence = 1
		SELECT
			@StartDate = CAST(T.c.value('StartDate[1]', 'varchar(19)') as datetime),
			@EndDate = CAST(T.c.value('EndDate[1]', 'varchar(19)') as datetime),
			@RecurrenceType = T.c.value('RecurrenceType[1]', 'int'),
			@Occurrences = T.c.value('Occurrences[1]', 'int'),
			@Interval = T.c.value('Interval[1]', 'int'),
			@DayOfWeekMask = T.c.value('DayOfWeekMask[1]', 'int'),
			@Instance = T.c.value('Instance[1]', 'int'),
			@MonthOfYear = T.c.value('MonthOfYear[1]', 'int'),
			@DayOfMonth = T.c.value('DayOfMonth[1]', 'int')
		FROM
			@_xml.nodes('/pjm5MeetingRequestGet/RecurrencePattern') T(c)
	END	

	BEGIN TRANSACTION
		
	SELECT 
		@OriginatorEmployeeID = [OriginatorEmployeeID],
		@OldStartTime = [StartTime],
		@ProjectID = [ProjectID]
	FROM 
		[MeetingRequest] 
	WHERE 
		[ID] = @ID
	DECLARE @IsProjectManager INT
	
	SET @IsProjectManager = 0
	IF @ProjectID IS NOT NULL
	BEGIN
		SET @IsProjectManager = dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID)
	END
	
	IF @OriginatorEmployeeID = @CurrentEmployeeID OR @IsProjectManager = 1
	BEGIN
		DECLARE @State TState
		SET @State = (SELECT [State] FROM [MeetingRequest] WHERE [ID] = @ID)
		
		UPDATE [MeetingRequest]
		SET
			@StartTime = [S].[StartTime],
			[MeetingRequest].[ProjectID] = [S].[ProjectID],
			[MeetingRequest].[FileAs] = [S].[FileAs],
			[MeetingRequest].[ActivityTypeID] = [S].[ActivityTypeID],
			[MeetingRequest].[PriorityID] = [S].[PriorityID],
			[MeetingRequest].[StartTime] = [S].[StartTime],
			[MeetingRequest].[Duration] = [S].[Duration],
			[MeetingRequest].[Location] = [S].[Location],
			[MeetingRequest].[Color] = [S].[Color],
			[MeetingRequest].[Comments] = [S].[Comments],
			[MeetingRequest].[Modified] = DEFAULT,
			[MeetingRequest].[ModifiedBy] = DEFAULT,
			[MeetingRequest].[SendUpdate] = CASE WHEN @State = 2 THEN [S].[SendUpdate]
			ELSE 0 END
		FROM
			(
				SELECT 
					T.c.value('ID[1]', 'int') as [ID],
					T.c.value('FileAs[1]', 'nvarchar(256)') as [FileAs],
					T.c.value('ProjectID[1]', 'int') as [ProjectID],
					T.c.value('ActivityTypeID[1]', 'int') as [ActivityTypeID],
					T.c.value('PriorityID[1]', 'int') as [PriorityID],
					CAST(T.c.value('StartTime[1]', 'varchar(19)') as datetime) as [StartTime], 
					T.c.value('Duration[1]', 'int') as [Duration],
					T.c.value('Location[1]', 'nvarchar(256)') as [Location],
					T.c.value('Color[1]', 'int') as [Color],
					T.c.value('Comments[1]', 'nvarchar(max)') as [Comments],
					T.c.value('SendUpdate[1]', 'bit') as [SendUpdate],
					T.c.value('ReminderState[1]', 'bit') as [ReminderState],
					T.c.value('ReminderInterval[1]', 'int') as [ReminderInterval]
				FROM
					@_xml.nodes('/pjm5MeetingRequestGet/MeetingRequest') T(c)
			) S INNER JOIN [MeetingRequest] D
				On ([S].[ID] = [D].[ID])
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		IF @Recurrence = 0 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE [Document] SET [RecurrencePatternID] = NULL WHERE [Class] = dbo.adfGetClassByName('Pjm5.MeetingRequest') AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NULL
		BEGIN
			INSERT INTO [RecurrencePattern]
				([StartDate], [EndDate], [RecurrenceType], [Occurrences],
				[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
			VALUES
				(@StartDate, @EndDate, @RecurrenceType, @Occurrences,
				@Interval, @DayOfWeekMask, @Instance, @MonthOfYear, @DayOfMonth)
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			SET @RecurrenceID = SCOPE_IDENTITY()
			
			UPDATE [Document] SET [RecurrencePatternID] = @RecurrenceID WHERE [Class] = dbo.adfGetClassByName('Pjm5.MeetingRequest') AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE	[RecurrencePattern]
			SET
				[StartDate] = @StartDate, 
				[EndDate] = @EndDate, 
				[RecurrenceType] = @RecurrenceType, 
				[Occurrences] = @Occurrences,
				[Interval] = @Interval, 
				[DayOfWeekMask] = @DayOfWeekMask, 
				[Instance] = @Instance, 
				[MonthOfYear] = @MonthOfYear, 
				[DayOfMonth] = @DayOfMonth
			WHERE
				[ID] = @RecurrenceID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END
	ELSE
	BEGIN
		SET @StartTime = @OldStartTime
	END
	
	DECLARE @result INT	

	IF @OriginatorEmployeeID = @CurrentEmployeeID OR @IsProjectManager = 1
	BEGIN
		DELETE [AttendeeResponse] WHERE [MeetingRequestID] = @ID
			AND [EmployeeID] NOT IN (
				SELECT T.c.value('EmployeeID[1]', 'int') 
				FROM @_xml.nodes('/pjm5MeetingRequestGet/Attendee') T(c)
				)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		DELETE [Attendee] WHERE [MeetingRequestID] = @ID 
			AND [EmployeeID] NOT IN (
				SELECT T.c.value('EmployeeID[1]', 'int') 
				FROM @_xml.nodes('/pjm5MeetingRequestGet/Attendee') T(c)
				)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		INSERT INTO [Attendee] ([MeetingRequestID], [EmployeeID], [Required])
		SELECT
			@ID,
			T.c.value('EmployeeID[1]', 'int'),
			T.c.value('Required[1]', 'bit')
		FROM
			@_xml.nodes('/pjm5MeetingRequestGet/Attendee') T(c)
		WHERE
			T.c.value('EmployeeID[1]', 'int') NOT IN (SELECT [EmployeeID] FROM [Attendee] WHERE [MeetingRequestID] = @ID)
			AND 
			T.c.value('EmployeeID[1]', 'int') != @OriginatorEmployeeID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		UPDATE [Attendee]
		SET
			[Required] = [E].[Required],
			[Present] = [E].[Present]
		FROM
			[Attendee] INNER JOIN (SELECT 
				T.c.value('EmployeeID[1]', 'int') as [EmployeeID],
				T.c.value('Required[1]', 'bit') as [Required],
				T.c.value('Present[1]', 'bit') as [Present]  
				FROM @_xml.nodes('/pjm5MeetingRequestGet/Attendee') T(c)) [E]
				ON ([Attendee].[EmployeeID] = [E].[EmployeeID] AND [Attendee].[MeetingRequestID] = @ID)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		EXEC @result = pjm5MeetingRequestReminderCreate @ID, @StartTime, @ReminderState, @ReminderInterval
		IF @result != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	
		DELETE [MeetingResource] WHERE [MeetingRequestID] = @ID AND 
			[ResourceID] NOT IN (
				SELECT 
					T.c.value('ResourceID[1]', 'int') 
				FROM
					@_xml.nodes('/pjm5MeetingRequestGet/MeetingResource') T(c))

		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		INSERT INTO [MeetingResource] ([MeetingRequestID], [ResourceID], [Required])
		SELECT
			@ID,
			T.c.value('ResourceID[1]', 'int'),
			T.c.value('Required[1]', 'bit')
		FROM
			@_xml.nodes('/pjm5MeetingRequestGet/MeetingResource') T(c)
		WHERE
			T.c.value('ResourceID[1]', 'int') NOT IN (SELECT [ResourceID] FROM [MeetingResource] WHERE [MeetingRequestID] = @ID)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	ELSE
	BEGIN
		EXEC @result = pjm5MeetingRequestReminderCreate @ID, @StartTime, @ReminderState, @ReminderInterval
		IF @result != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	COMMIT TRANSACTION

	EXEC pjm5MeetingRequestGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5MeetingRequestUpdate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5MeetingRequestDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5MeetingRequestDelete'
		DROP PROCEDURE [dbo].[pjm5MeetingRequestDelete]
	END
GO

PRINT 'Creating procedure pjm5MeetingRequestDelete'
GO

/******************************************************************************
**		File: pjm5MeetingRequestDelete.sql
**		Name: pjm5MeetingRequestDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/19/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5MeetingRequestDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	BEGIN TRANSACTION
	
	DECLARE curDeleted CURSOR LOCAL FORWARD_ONLY READ_ONLY FOR SELECT [MeetingRequestID], [ResourceID] FROM [MeetingResource] WHERE [MeetingRequestID] = @ID
	OPEN curDeleted
	
	DECLARE @MeetingRequestID TIdentifier, @ResourceID TIdentifier, @MeetingRequestState TState,
			@result int
	
	FETCH NEXT FROM curDeleted INTO @MeetingRequestID, @ResourceID
	WHILE @@FETCH_STATUS = 0
	BEGIN
		SELECT @MeetingRequestState = [State] FROM [MeetingRequest] WHERE [ID] = @MeetingRequestID
		EXEC @result = pjm5ResourceFree @ResourceID, @MeetingRequestID
		IF @@ERROR != 0 OR @result != 0
		BEGIN
			ROLLBACK TRANSACTION
			CLOSE curDeleted
			DEALLOCATE curDeleted
			RETURN 1
		END
		FETCH NEXT FROM curDeleted INTO @MeetingRequestID, @ResourceID
	END
	
	CLOSE curDeleted
	DEALLOCATE curDeleted
	
	DELETE [MeetingResource] WHERE [MeetingRequestID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE [AttendeeResponse] WHERE [MeetingRequestID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE [Attendee] WHERE [MeetingRequestID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE FROM [MeetingRequest] WHERE [MeetingRequest].[ID] = @ID

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON pjm5MeetingRequestDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5MeetingRequestChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5MeetingRequestChangeState'
		DROP PROCEDURE [dbo].[pjm5MeetingRequestChangeState]
	END
GO

PRINT 'Creating procedure pjm5MeetingRequestChangeState'
GO

/******************************************************************************
**		File: pjm5MeetingRequestChangeState.sql
**		Name: pjm5MeetingRequestChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/19/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5MeetingRequestChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [MeetingRequest].[Class],
		@FromState = [MeetingRequest].[State]
	FROM
		[MeetingRequest]
	WHERE
		[MeetingRequest].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF @ToState IN (2, 3, 4)
	BEGIN
		DECLARE @UserID TIdentifier, @EmployeeID TIdentifier, @ProjectID TIdentifier, @IsProjectManager TBool
		
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
		
		SELECT @ProjectID = [ProjectID] FROM [MeetingRequest] WHERE [ID] = @ID
		SET @IsProjectManager = 0
		IF @ProjectID IS NOT NULL
		BEGIN
			SET @IsProjectManager = dbo.fnPjm5IsProjectManager(@ProjectID, @EmployeeID)
		END
		
		IF (NOT EXISTS(SELECT * FROM [MeetingRequest] WHERE [ID] = @ID AND [OriginatorEmployeeID] = @EmployeeID)) AND @IsProjectManager = 0
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END
	
	DECLARE @RecurrenceID TIdentifier,
			@StartTime TDatetime,
			@CurrentDate TDatetime
	
	SELECT
		@RecurrenceID = [RecurrencePatternID],
		@StartTime = [MeetingRequest].[StartTime],
		@CurrentDate = GETDATE()
	FROM
		[MeetingRequest] INNER JOIN [Document]
			ON [MeetingRequest].[Class] = [Document].[Class] AND [MeetingRequest].[ID] = [Document].[ID]
	
	BEGIN TRANSACTION

	UPDATE [MeetingRequest]
	SET
		[MeetingRequest].[State] = @ToState,
		[MeetingRequest].[Modified] = DEFAULT,
		[MeetingRequest].[ModifiedBy] = DEFAULT
	WHERE
		[MeetingRequest].[ID] = @ID
	AND
		[MeetingRequest].[State] = @FromState
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF @FromState = 2 AND @ToState = 3 AND @RecurrenceID IS NOT NULL
	BEGIN	
		DECLARE @NewDate TDateTime, @rv INT
		
		SET @NewDate = dbo.fnPjm5RecurrenceGetNextDateTime(@RecurrenceID, @StartTime, @CurrentDate)
		
		IF ISNULL(@NewDate, @StartTime) > @StartTime
		BEGIN
			EXEC @rv = pjm5MeetingRequestCopy @ID, @NewDate, @RecurrenceID
			IF @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			
			DECLARE @Occurrences TCount
			SELECT 
				@Occurrences = [Occurrences] 
			FROM 
				[RecurrencePattern] 
			WHERE 
				[ID] = @RecurrenceID
			IF ISNULL(@Occurrences, 0) > 0
			BEGIN
				UPDATE [RecurrencePattern]
				SET
					[Occurrences] = @Occurrences - 1
				WHERE
					[ID] = @RecurrenceID
				IF @@ERROR != 0
				BEGIN
					ROLLBACK TRANSACTION
					RETURN 1
				END
			END			
		END
	END
	
	COMMIT TRANSACTION
	
	IF @ToState != 2
	BEGIN
		DECLARE @ReminderID INT
		SELECT
			@ReminderID = [ID] 
		FROM	
			[Reminder]
		WHERE
			[DocumentClass] = @Class AND [DocumentID] = @ID AND [Subtype]='MS';
		EXEC dbo.pjm5AllUserReminderDismiss @ReminderID
	END
	
	IF @ToState = 2
		EXEC pjm5PostDocumentChangeNotificationEvent 'MeetingRequestAppointed', 'Pjm5.MeetingRequest', @ID, NULL
	ELSE IF @ToState = 3
		EXEC pjm5PostDocumentChangeNotificationEvent 'MeetingRequestCompleted', 'Pjm5.MeetingRequest', @ID, NULL
	ELSE IF @ToState = 4
		EXEC pjm5PostDocumentChangeNotificationEvent 'MeetingRequestCanceled', 'Pjm5.MeetingRequest', @ID, NULL
	
	RETURN 0
GO

GRANT EXECUTE ON pjm5MeetingRequestChangeState TO PUBLIC
GO
