IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm6trMeetingRequestAttendeeDelete')
	BEGIN
		PRINT 'Dropping Trigger pjm6trMeetingRequestAttendeeDelete'
		DROP  Trigger pjm6trMeetingRequestAttendeeDelete
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm6trMeetingRequestAttendeeDelete
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: PAM
**		Date: 22.12.09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm6trMeetingRequestAttendeeDelete'
GO
CREATE TRIGGER pjm6trMeetingRequestAttendeeDelete 
ON [Attendee] FOR DELETE
AS
BEGIN
    IF @@rowcount = 0
       RETURN
	SET NOCOUNT ON
	DECLARE @CurrentUserID TIdentifier
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	
	DECLARE @user TIdentifier, @meetingrequest TIdentifier, @rv int
	DECLARE users CURSOR FAST_FORWARD FOR
		SELECT
			[deleted].[MeetingRequestID], [Employee].[UserID]
		FROM
			[deleted]
			INNER JOIN [MeetingRequest]
				ON [MeetingRequest].[ID] = [deleted].[MeetingRequestID]
			INNER JOIN [Employee]
				ON [deleted].[EmployeeID] = [Employee].[ID]
		WHERE
			[MeetingRequest].[State] = 2
	OPEN users
	FETCH NEXT FROM users INTO @meetingrequest, @user
	WHILE @@FETCH_STATUS = 0
	BEGIN
		EXEC pjm6MeetingRequestAttendeeDeleteNotification @meetingrequest, @user
		FETCH NEXT FROM users INTO @meetingrequest, @user
	END
	CLOSE users
	DEALLOCATE users
END
GO

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm6trMeetingRequestAttendeeInsert')
	BEGIN
		PRINT 'Dropping Trigger pjm6trMeetingRequestAttendeeInsert'
		DROP  Trigger pjm6trMeetingRequestAttendeeInsert
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm6trMeetingRequestAttendeeInsert
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: PAM
**		Date: 22.12.09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm6trMeetingRequestAttendeeInsert'
GO
CREATE TRIGGER pjm6trMeetingRequestAttendeeInsert 
ON [Attendee] FOR INSERT
AS
BEGIN
    IF @@rowcount = 0
       RETURN
	SET NOCOUNT ON
	DECLARE @CurrentUserID TIdentifier
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	
	DECLARE @user TIdentifier, @meetingrequest TIdentifier, @rv int
	DECLARE users CURSOR FAST_FORWARD FOR
		SELECT
			[inserted].[MeetingRequestID], [Employee].[UserID]
		FROM
			[inserted]
			INNER JOIN [MeetingRequest]
				ON [MeetingRequest].[ID] = [inserted].[MeetingRequestID]
			INNER JOIN [Employee]
				ON [inserted].[EmployeeID] = [Employee].[ID]
		WHERE
			[MeetingRequest].[State] = 2
	OPEN users
	FETCH NEXT FROM users INTO @meetingrequest, @user
	WHILE @@FETCH_STATUS = 0
	BEGIN
		EXEC pjm6MeetingRequestAttendeeAppointNotification @meetingrequest, @user
		FETCH NEXT FROM users INTO @meetingrequest, @user
	END
	CLOSE users
	DEALLOCATE users
END
GO