 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6MsAssignmentDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6MsAssignmentDelete'
		DROP PROCEDURE [dbo].[pjm6MsAssignmentDelete]
	END
GO

PRINT 'Creating procedure pjm6MsAssignmentDelete'
GO


CREATE PROCEDURE [pjm6MsAssignmentDelete]
					@ID TIdentifier
										
AS
	
SET NOCOUNT ON

	DECLARE @ProjectID TIdentifier,
			@TaskID TIdentifier,
			@AssignmentID TIdentifier,
			@TaskState TState
			
	SELECT
		@AssignmentID = [Assignment].[ID],
		@ProjectID = [Assignment].[ProjectID],
		@TaskID = [Task].[ID],
		@TaskState = [Task].[State]
	FROM
		[Assignment]
			INNER JOIN [MsResource]
				ON [Assignment].[MsResourceID] = [MsResource].[ID]
			INNER JOIN [MsAssignment]
				ON [MsAssignment].[ResourceID] = [MsResource].[ID]
			INNER JOIN [Task]
				ON [MsAssignment].[TaskID] = [Task].[MsTaskID]
	WHERE
		[MsAssignment].[ID] = @ID 
	
	IF @TaskState != 3
	BEGIN
		IF EXISTS 
			(SELECT * 
			FROM [TimeEntry]
			WHERE [TaskID] = @TaskID
				AND [AssignmentID] = @AssignmentID)
		BEGIN
			UPDATE [TaskAssignment]
			SET [MsAvailable] = 0,
				[RemainingWork] = 0,
				[RemainingOvertimeWork] = 0
			WHERE
				[AssignmentID] = @AssignmentID
				AND [TaskID] = @TaskID
				
			EXEC pjm6DeactivateTaskAssignments @AssignmentID, @TaskID		
		END
		ELSE
		BEGIN
			BEGIN TRANSACTION;
			DELETE
				[TaskAssignment]
			WHERE 
				[TaskAssignment].[AssignmentID] = @AssignmentID AND
				[TaskAssignment].[TaskID] = @TaskID

			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			
			DELETE [MsAssignment]
			WHERE [MsAssignment].[ID] = @ID
			
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		COMMIT TRANSACTION;
		END
	END
RETURN 0
GO

GRANT EXECUTE ON [pjm6MsAssignmentDelete] TO PUBLIC
GO
   