
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6MsProjectGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6MsProjectGet'
		DROP PROCEDURE [dbo].[pjm6MsProjectGet]
	END
GO

PRINT 'Creating procedure pjm6MsProjectGet'
GO
/******************************************************************************
**		File: pjm6MsProjectGet.sql
**		Name: pjm6MsProjectGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 20.06.2006 19:57
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6MsProjectGet]
	@ProjectID TIdentifier
AS
	
	SET NOCOUNT ON

	DECLARE @MsProjectID TIdentifier,
			@Instance TGuid,
			@val TVariant
	
	SELECT @MsProjectID = [MsProjectID] FROM [Project] WHERE [ID] = @ProjectID
	
	EXEC adfParameterGet @Name='Instance', @Group='Instance', @Value = @val OUTPUT
		SET @Instance = CAST(@val as uniqueidentifier)
	
	SELECT 
		[Project].[PriorityID],
		[MsProject].[UniqueID],
		[MsProject].[ID],
		[MsProject].[Guid],
		[MsProject].[Name],
		[MsProject].[FullName],
		[MsProject].[FileCreateDate],
		[MsProject].[DocumentItemID],
		@Instance as [DatabaseGuid],
		[Project].[CurrencyCode]
		FROM 
			[MsProject]
				 INNER JOIN [Project]
					ON [MsProject].[ID] = [Project].[MsProjectID]
	WHERE
		[Project].[ID] = @ProjectID
		
	SELECT
		[MsResource].[ID],
		[MsResource].[UniqueID],
		[MsResource].[Guid],
		[Assignment].[FileAs]
	FROM 
		[MsResource]
			INNER JOIN [Assignment]
				ON [Assignment].[MsResourceID] = [MsResource].[ID]
	WHERE
		[MsResource].[ProjectID] = @MsProjectID
		AND [Assignment].[State] != 2
		
	SELECT 
		[MsTask].[ID],
		[MsTask].[UniqueID],
		[MsTask].[Guid],
		[Task].[PriorityID],
		(
			SELECT COUNT([TimeEntry].[ID])
			FROM [TimeEntry]
				INNER JOIN [Assignment]
				ON [TimeEntry].[AssignmentID] = [Assignment].[ID]
			WHERE [TimeEntry].[TaskID] = [Task].[ID]
					AND [TimeEntry].[State] != 4
					AND [Assignment].[State] != 2
		) AS [TimeEntriesCount]
    FROM 
		[MsTask]
			INNER JOIN [Task]
				ON [MsTask].[ID] = [Task].[MsTaskID]
	WHERE
		[MsTask].[ProjectID] = @MsProjectID AND
		[MsTask].[SubprojectID] IS NULL
		
	SELECT
		[Project].[ID] AS [SubprojectID],
		[MsProject].[FullName],
		[MsTask].[Guid] AS [InsertedProjectSummaryGuid],
		[MsProject].[DocumentItemID],
		[MsProject].[ID] AS [MsProjectID],
		@Instance as [DatabaseGuid]
	FROM 
		[MsProject]
			INNER JOIN [MsTask]
				ON [MsTask].[SubprojectID] = [MsProject].[ID]
			INNER JOIN [Project]
				ON [MsProject].[ID] = [Project].[MsProjectID]
	WHERE
		[MsTask].[ProjectID] = @MsProjectID
			
	RETURN 0
GO

GRANT EXECUTE ON [pjm6MsProjectGet] TO PUBLIC
GO
 