/*===========================================================================*/
/* Function:        */
/*===========================================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fnPjm5GetInitialReminderState]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[fnPjm5GetInitialReminderState]
go

create function fnPjm5GetInitialReminderState ()
returns TState
as
begin
	DECLARE @State TState
	SELECT @State = 0
	RETURN @State
end
go

grant execute on [dbo].[fnPjm5GetInitialReminderState] to [public]
go

/*===============================================================================*/
/* Function:        */
/*===============================================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fnPjm5GetUserInitialReminderState]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[fnPjm5GetUserInitialReminderState]
go

create function fnPjm5GetUserInitialReminderState
(@Class TClass, @Subtype TCode2, @UserID TIdentifier)
returns TState
as
begin
	DECLARE @State TState
	SELECT @State = ISNULL([ReminderSetting].[InitialState], [ReminderType].[DefaultState])
	FROM [ReminderType]
		LEFT OUTER JOIN [ReminderSetting]
			ON ([ReminderType].[Class] = [ReminderSetting].[Class] AND
				[ReminderType].[Subtype] = [ReminderSetting].[Subtype] AND
				[ReminderSetting].[UserID] = @UserID)
	WHERE [ReminderType].[Class] = @Class AND [ReminderType].[Subtype] = @Subtype
	RETURN @State
end
go

grant execute on [dbo].[fnPjm5GetUserInitialReminderState] to [public]
go

/*===================================================================*/
/* Function:        */
/*===================================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fnPjm5GetReminderInterval]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[fnPjm5GetReminderInterval]
go

create function fnPjm5GetReminderInterval
(@Class TClass, @Subtype TCode2, @UserID TIdentifier)
returns TTimeSpan
as
begin
	DECLARE @Interval TTimeSpan
	SET @Interval = NULL
	
	SELECT @Interval = ISNULL([ReminderSetting].[InitialInterval], [ReminderType].[DefaultInterval])
	FROM [ReminderType]
		LEFT OUTER JOIN [ReminderSetting]
			ON ([ReminderType].[Class] = [ReminderSetting].[Class] AND
				[ReminderType].[Subtype] = [ReminderSetting].[Subtype] AND
				[ReminderSetting].[UserID] = @UserID)
	WHERE [ReminderType].[Class] = @Class AND [ReminderType].[Subtype] = @Subtype
	
	RETURN @Interval
end
go

grant execute on [dbo].[fnPjm5GetReminderInterval] to [public]
go

/*===============================================================================*/
/* Function:           */
/*===============================================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fnPjm5GetEmployeeUserID]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[fnPjm5GetEmployeeUserID]
go

create function fnPjm5GetEmployeeUserID
(@EmployeeID TIdentifier)
returns TIdentifier
as
begin
	DECLARE @UserID TIdentifier
	SELECT @UserID = [UserID] FROM [Employee] WHERE [ID] = @EmployeeID
	RETURN @UserID
end
go

grant execute on [dbo].[fnPjm5GetEmployeeUserID] to [public]
go