IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceReminderCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5InvoiceReminderCreate'
		DROP PROCEDURE [dbo].[pjm5InvoiceReminderCreate]
	END
GO

PRINT 'Creating procedure pjm5InvoiceReminderCreate'
GO

/******************************************************************************
**		File: pjm5InvoiceReminderCreate.sql
**		Name: pjm5InvoiceReminderCreate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 20/12/2005 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5InvoiceReminderCreate]
	@DocumentID TIdentifier,
	@Subtype TCode2,
	@ReminderEventTime TDateTime,
	@ReminderState TState,
	@ReminderInterval TTimeSpan
AS
	SET NOCOUNT ON
	
	DECLARE
		@CurrentUserID TIdentifier,
		@DocumentClass TClass,
		@rv int
		
	SET @ReminderEventTime = CAST(CONVERT(varchar(10), @ReminderEventTime, 112) as datetime)
		
	SELECT
		@CurrentUserID = dbo.adfGetCurrentUserID(),
		@DocumentClass = dbo.adfGetClassByName('Pjm5.Invoice')
		
	EXEC @rv = dbo.pjm5ReminderCreate @DocumentClass,
		@DocumentID,
		@Subtype,
		@ReminderEventTime,
		@CurrentUserID,
		@ReminderState,
		@ReminderInterval
	IF @rv != 0
	BEGIN
		RETURN @rv
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5InvoiceReminderCreate] TO PUBLIC
GO    