IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ReminderSettingsGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ReminderSettingsGet'
		DROP PROCEDURE [dbo].[pjm5ReminderSettingsGet]
	END
GO

PRINT 'Creating procedure pjm5ReminderSettingsGet'
GO

/******************************************************************************
**		File: pjm5ReminderSettingsGet.sql
**		Name: pjm5ReminderSettingsGet
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 20/12/2005 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ReminderSettingsGet]
AS
	SET NOCOUNT ON
	
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	
	DECLARE @reminders TABLE 
	([Class] smallint, [Subtype] char(2), [DefaultState] int, [DefaultInterval] int)
	
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('AuthorJournalEntry')) = 1
	BEGIN
		INSERT INTO @reminders ([Class], [Subtype], [DefaultState], [DefaultInterval])
		SELECT [Class], [Subtype], [DefaultState], [DefaultInterval]
		FROM [ReminderType]
		WHERE [Class] = dbo.adfGetClassByName('Pjm5.TimeEntry') AND [Subtype] = 'ES'
	END
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ResolveIssue')) = 1
	BEGIN
		INSERT INTO @reminders ([Class], [Subtype], [DefaultState], [DefaultInterval])
		SELECT [Class], [Subtype], [DefaultState], [DefaultInterval]
		FROM [ReminderType]
		WHERE [Class] = dbo.adfGetClassByName('Pjm5.Issue') AND [Subtype] = 'ID'
	END
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('AuthorTask')) = 1
	BEGIN
		INSERT INTO @reminders ([Class], [Subtype], [DefaultState], [DefaultInterval])
		SELECT [Class], [Subtype], [DefaultState], [DefaultInterval]
		FROM [ReminderType]
		WHERE [Class] = dbo.adfGetClassByName('Pjm5.Task') AND [Subtype] = 'TD'
	END
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageTaskRequest')) = 1
	BEGIN
		INSERT INTO @reminders ([Class], [Subtype], [DefaultState], [DefaultInterval])
		SELECT [Class], [Subtype], [DefaultState], [DefaultInterval]
		FROM [ReminderType]
		WHERE [Class] = dbo.adfGetClassByName('Pjm5.TaskRequest') AND [Subtype] = 'RD'
	END
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('AuthorServiceRequest')) = 1
	BEGIN
		INSERT INTO @reminders ([Class], [Subtype], [DefaultState], [DefaultInterval])
		SELECT [Class], [Subtype], [DefaultState], [DefaultInterval]
		FROM [ReminderType]
		WHERE [Class] = dbo.adfGetClassByName('Pjm5.ServiceRequest') AND [Subtype] = 'SD'
	END
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageContacts')) = 1
	BEGIN
		INSERT INTO @reminders ([Class], [Subtype], [DefaultState], [DefaultInterval])
		SELECT [Class], [Subtype], [DefaultState], [DefaultInterval]
		FROM [ReminderType]
		WHERE [Class] = dbo.adfGetClassByName('Adf.Employee') AND [Subtype] = 'NC'
	END
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageInvoices')) = 1
	BEGIN
		INSERT INTO @reminders ([Class], [Subtype], [DefaultState], [DefaultInterval])
		SELECT [Class], [Subtype], [DefaultState], [DefaultInterval]
		FROM [ReminderType]
		WHERE [Class] = dbo.adfGetClassByName('Pjm5.Invoice')
	END
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageStatements')) = 1
	BEGIN
		INSERT INTO @reminders ([Class], [Subtype], [DefaultState], [DefaultInterval])
		SELECT [Class], [Subtype], [DefaultState], [DefaultInterval]
		FROM [ReminderType]
		WHERE [Class] = dbo.adfGetClassByName('Pjm5.Statement') AND [Subtype] = 'MD'
	END
	
	SELECT [Class], [Subtype], [DefaultState], [DefaultInterval] FROM @reminders
	
	
	SELECT 
		[Class],
		[Subtype],
		[InitialState],
		[InitialInterval]
	FROM
		[ReminderSetting]
	WHERE
		[UserID] = @UserID
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ReminderSettingsGet] TO PUBLIC
GO  