IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ReminderSettingsUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ReminderSettingsUpdate'
		DROP PROCEDURE [dbo].[pjm5ReminderSettingsUpdate]
	END
GO

PRINT 'Creating procedure pjm5ReminderSettingsUpdate'
GO

/******************************************************************************
**		File: pjm5ReminderSettingsUpdate.sql
**		Name: pjm5ReminderSettingsUpdate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 20/12/2005 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ReminderSettingsUpdate]
	@DocumentClass TClass,
	@Subtype TCode2,
	@InitialState TState,
	@InitialInterval TTimeSpan
AS
	SET NOCOUNT ON
	
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	
	IF NOT EXISTS (
		SELECT * FROM [ReminderSetting]
		WHERE [Class] = @DocumentClass AND [Subtype] = @Subtype AND [UserID] = @UserID
  	)
  	BEGIN
  		INSERT INTO [ReminderSetting] ([UserID], [Class], [Subtype],
  			[InitialState], [InitialInterval])
  		VALUES (@UserID, @DocumentClass, @Subtype, @InitialState, @InitialInterval)
  	END
  	ELSE
  	BEGIN
  		UPDATE [ReminderSetting]
  		SET
  			[InitialState] = @InitialState,
  			[InitialInterval] = @InitialInterval
  		WHERE
  			[Class] = @DocumentClass AND [Subtype] = @Subtype AND [UserID] = @UserID
  	END

	IF @DocumentClass = dbo.adfGetClassByName('Pjm5.TimeEntry') AND @Subtype='ES'
	BEGIN
		SET @DocumentClass = dbo.adfGetClassByName('Pjm5.MeetingRequest')
		EXEC pjm5ReminderSettingsUpdate @DocumentClass, 'MS', @InitialState, @InitialInterval
	END  		
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ReminderSettingsUpdate] TO PUBLIC
GO   