IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ReminderSnooze]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ReminderSnooze'
		DROP PROCEDURE [dbo].[pjm5ReminderSnooze]
	END
GO

PRINT 'Creating procedure pjm5ReminderSnooze'
GO

/******************************************************************************
**		File: pjm5ReminderSnooze.sql
**		Name: pjm5ReminderSnooze
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 20/12/2005 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ReminderSnooze]
	@ReminderID TIdentifier,
	@Interval TTimeSpan
AS
	SET NOCOUNT ON
	
	DECLARE 
			@UserID TIdentifier,
			@DocumentClass TClass,
			@TaskClass TClass,
			@InvoiceClass TClass,
			@StatementClass TClass
			
	SELECT 
		@UserID = dbo.adfGetCurrentUserID(),
		@InvoiceClass = dbo.adfGetClassByName('Pjm5.Invoice'),
		@StatementClass = dbo.adfGetClassByName('Pjm5.Statement'),
		@TaskClass = dbo.adfGetClassByName('Pjm5.Task')	
	
	SELECT @DocumentClass = [DocumentClass] FROM [Reminder] WHERE [ID] = @ReminderID
	
	IF @UserID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE [UserReminder]
	SET [NextInterval] = CASE
			WHEN @DocumentClass IN (@TaskClass, @InvoiceClass, @StatementClass) THEN
				[OriginalInterval] + @Interval
			ELSE @Interval
		END
	WHERE
		[ReminderID] = @ReminderID AND [UserID] = @UserID
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ReminderSnooze] TO PUBLIC
GO