IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimeEntryReminderCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimeEntryReminderCreate'
		DROP PROCEDURE [dbo].[pjm5TimeEntryReminderCreate]
	END
GO

PRINT 'Creating procedure pjm5TimeEntryReminderCreate'
GO

/******************************************************************************
**		File: pjm5TimeEntryReminderCreate.sql
**		Name: pjm5TimeEntryReminderCreate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 20/12/2005 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5TimeEntryReminderCreate]
	@DocumentID TIdentifier,
	@ReminderEventTime TDateTime,
	@ReminderState TState,
	@ReminderInterval TTimeSpan
AS
	SET NOCOUNT ON
	
	DECLARE
		@CurrentUserID TIdentifier,
		@DocumentClass TClass,
		@rv int
		
	SELECT
		@CurrentUserID = dbo.adfGetCurrentUserID(),
		@DocumentClass = dbo.adfGetClassByName('Pjm5.TimeEntry')

	EXEC @rv = dbo.pjm5ReminderCreate @DocumentClass,
		@DocumentID,
		'ES',
		@ReminderEventTime,
		@CurrentUserID,
		@ReminderState,
		@ReminderInterval
	IF @rv != 0
	BEGIN
		RETURN @rv
	END
	
	IF @ReminderEventTime > GETDATE()
	BEGIN
		EXEC @rv = dbo.pjm5DocumentUserReminderCreate @DocumentClass,
			@DocumentID,
			@ReminderEventTime
		IF @rv != 0
		BEGIN
			RETURN @rv
		END
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TimeEntryReminderCreate] TO PUBLIC
GO 