﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetReminderCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetReminderCreate'
		DROP PROCEDURE [dbo].[pjm6BudgetReminderCreate]
	END
GO

PRINT 'Creating procedure pjm6BudgetReminderCreate'
GO

/******************************************************************************
**		File: pjm6BudgetReminderCreate.sql
**		Name: pjm6BudgetReminderCreate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 16/05/2011 15:07:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetReminderCreate]
	@DocumentID TIdentifier,
	@ReminderEventTime TDateTime,
	@ReminderState TState,
	@ReminderInterval TTimeSpan
AS
	SET NOCOUNT ON
	
	DECLARE
		@CurrentUserID TIdentifier,
		@DocumentClass TClass,
		@rv int
		
	SELECT
		@CurrentUserID = dbo.adfGetCurrentUserID(),
		@DocumentClass = dbo.adfGetClassByName('Pjm6.Budget')
		
	EXEC @rv = dbo.pjm5ReminderCreate @DocumentClass,
		@DocumentID,
		'BC',
		@ReminderEventTime,
		@CurrentUserID,
		@ReminderState,
		@ReminderInterval
	IF @rv != 0
	BEGIN
		RETURN @rv
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetReminderCreate] TO PUBLIC
GO     