IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6DismissEventsOnObject]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6DismissEventsOnObject'
		DROP PROCEDURE [dbo].[pjm6DismissEventsOnObject]
	END
GO

PRINT 'Creating procedure pjm6DismissEventsOnObject'
GO

/******************************************************************************
**		File: pjm6DismissEventsOnObject.sql
**		Name: pjm6DismissEventsOnObject
**		Desc:   ,     
**		  ""   
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Yuriy.Soldatkin
**		Date: 14/5/2010
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE [dbo].[pjm6DismissEventsOnObject]
	@DocumentClass TClass,
	@DocumentID TIdentifier
AS
SET NOCOUNT ON

	DECLARE @UserID TIdentifier,
			
			@InitialEventState TState,
			@AlertedEventState TState,
			@EventID TIdentifier
	
	SET @UserID = dbo.adfGetCurrentUserID()

	IF @UserID IS NULL
	BEGIN
		RETURN 0
	END
		
	SET @InitialEventState = dbo.fnPjm5GetInitialEventState()
	SET @AlertedEventState = dbo.fnPjm5GetAlertedEventState()
			
	DECLARE EventsOnObject CURSOR LOCAL FAST_FORWARD FOR 
		SELECT
			[Event].[ID]
		FROM
			[Event]
			INNER JOIN [SubscriptionRule]
				ON [SubscriptionRule].[ID] = [Event].[SubscriptionRuleID]
			WHERE 
				[SubscriptionRule].[UserID] = @UserID
				AND [Event].[DocumentClass] = @DocumentClass
				AND [Event].[DocumentID] = @DocumentID
				AND [Event].[State] IN (@AlertedEventState, @InitialEventState)
		
	OPEN EventsOnObject
	FETCH NEXT FROM EventsOnObject INTO @EventID
	WHILE @@FETCH_STATUS = 0
	BEGIN	
		EXEC pjm5EventDismiss @EventID
		FETCH NEXT FROM EventsOnObject INTO @EventID
	END	
		
	CLOSE EventsOnObject
	DEALLOCATE EventsOnObject			
	RETURN 0

GO

GRANT EXECUTE ON [pjm6DismissEventsOnObject] TO PUBLIC
GO