IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfPaymentDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfPaymentDelete'
		DROP PROCEDURE [dbo].[adfPaymentDelete]
	END
GO

PRINT 'Creating procedure adfPaymentDelete'
GO

/******************************************************************************
**		File: adfPaymentDelete.sql
**		Name: adfPaymentDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 17:11:09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    29.06.10		KOV				    
*******************************************************************************/
CREATE PROCEDURE adfPaymentDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	IF EXISTS(SELECT * FROM [SuperTimer] 
					WHERE [SuperTimer].[DocumentClass] = dbo.adfGetClassByName('Adf.Payment') AND [SuperTimer].[DocumentID] = @ID AND 
					([SuperTimer].[State] in (1,2) OR ([SuperTimer].[State] = 3 AND [SuperTimer].[Persistent] = 1)))
	BEGIN
		RAISERROR('#CannotDeleteDocumentWithActiveTimer', 18, -1)
		RETURN 1
	END
	DELETE FROM [Payment] WHERE [Payment].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfPaymentDelete TO PUBLIC
GO
 