IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5PhoneCallUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5PhoneCallUpdate'
		DROP PROCEDURE [dbo].[pjm5PhoneCallUpdate]
	END
GO

PRINT 'Creating procedure pjm5PhoneCallUpdate'
GO

/******************************************************************************
**		File: pjm5PhoneCallUpdate.sql
**		Name: pjm5PhoneCallUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		12.07.11	SYV				   
*******************************************************************************/
CREATE PROCEDURE pjm5PhoneCallUpdate
	@Xml XML
AS
	DECLARE
		@ID TIdentifier,
		@FileAs TName,
		@ActivityTypeID TIdentifier,
		@AssignmentID TIdentifier,
		@EmployeeID TIdentifier,
		@ProjectID TIdentifier,
		@TaskID TIdentifier,
		@StartTime TDateTime,
		@Duration TCount,
		@TimeBillable TBool,
		@ExpenseBillable TBool,
		@Overtime TBool,
		@ExpenseCodeID TIdentifier,
		@Amount TCount,
		@Price TMoney,
		@ExpenseCurrencyCode TCode3,
		@ProjectCurrencyCode TCode3,
		@BillableDuration TCount,
		@Rate TMoney,
		@VATRate TPercent,
		@VAT TMoney,
		@Comments TNotes,
		@PhoneCallCodeID TIdentifier,
		@TimeEntryID TIdentifier,
		@ExpenseID TIdentifier,
		@Doc int,
		@rv int,
		@MyEmployeeID int,
		@OldAssignmentID TIdentifier,
		@VatIsIncluded TBool,
		@UOMID TIdentifier,
		@value TVariant,
		@DocumentClass TIdentifier,
		@DocumentID TIdentifier,
		@PrevEmployeeID TIdentifier

	SET NOCOUNT ON
	
	EXEC sp_xml_preparedocument @Doc OUTPUT, @Xml
	SELECT
		@ID = [XmlTable].[ID],
		@FileAs = [XmlTable].[FileAs], 
		@PhoneCallCodeID = [XmlTable].[PhoneCallCodeID],
		@ActivityTypeID = [XmlTable].[ActivityTypeID],
		@ProjectID = [XmlTable].[ProjectID], 
		@TaskID = [XmlTable].[TaskID], 
		@StartTime = CAST([XmlTable].[StartTime] as datetime), 
		@Duration = [XmlTable].[Duration], 
		@TimeBillable = CASE WHEN [XmlTable].[Billable] = 'false' THEN 0 ELSE 1 END, 
		@ExpenseBillable = CASE WHEN [XmlTable].[ExpenseBillable] = 'false' THEN 0 ELSE 1 END, 
		@Overtime = CASE WHEN [XmlTable].[Overtime] = 'false' THEN 0 ELSE 1 END, 
		@ProjectCurrencyCode = [Project].[CurrencyCode], 
		@VATRate = dbo.fnPjm5GetVATRate(),
		@Price = ROUND([PhoneCallRate].[Price], 2), 
		@TimeEntryID = [XmlTable].[TimeEntryID],
		@ExpenseID = [XmlTable].[ExpenseID],
		@Comments = [XmlTable].[Comments],
		@EmployeeID = [XmlTable].[EmployeeID],
		@VatIsIncluded = [PhoneCallCode].[VatIsIncluded],
		@DocumentClass = dbo.adfGetClassByName([XmlTable].[DocumentClass]),
		@DocumentID = [XmlTable].[DocumentID]
	FROM
		OPENXML(@Doc, '/pjm5PhoneCallGet/PhoneCall', 2)
			WITH (
				[ID] int,
				[FileAs] nvarchar(256),
				[PhoneCallCodeID] int,
				[ActivityTypeID] int,
				[EmployeeID] int,
				[ProjectID] int,
				[TaskID] int,
				[StartTime] varchar(19),
				[Duration] int,
				[Billable] varchar(5),
				[Overtime] varchar(5),
				[ExpenseBillable] varchar(5),
				[TimeEntryID] int,
				[ExpenseID] int,
				[Comments] nvarchar(max),
				[DocumentClass] nvarchar(max),
				[DocumentID] TIdentifier
				) as [XmlTable]
		INNER JOIN [Project]
			ON [Project].[ID] = [XmlTable].[ProjectID]
		INNER JOIN [PhoneCallCode]
			ON [PhoneCallCode].[ID] = [XmlTable].[PhoneCallCodeID]
		LEFT OUTER JOIN [PhoneCallRate]
			ON ([PhoneCallRate].[PhoneCallCodeID] = [PhoneCallCode].[ID] AND
				[PhoneCallRate].[CurrencyCode] = [Project].[CurrencyCode])
		
			
	EXEC sp_xml_removedocument @Doc
	
	IF NOT EXISTS(
		SELECT *
		FROM [ProjectExpenseCode]
		WHERE
			[ProjectID] = @ProjectID AND
			[ExpenseCodeID] = 1
		)
	BEGIN
		RAISERROR('#phonecallisnotenabled', 18, -1)
		RETURN 1
	END

	IF @Price IS NULL
	BEGIN
		RAISERROR('#pricenotfound', 18, -1)
		RETURN 1
	END

	DECLARE @language TLanguage
	SET @language = dbo.adfGetLanguage()
	IF @FileAs IS NULL
		SELECT 
			@FileAs = CASE @language
				WHEN 'en' THEN 'Phone call, code '
				ELSE ' ,  '
			END + ISNULL([FileAs], [Code])
		FROM
			[PhoneCallCode]
		WHERE
			[ID] = @PhoneCallCodeID
	
	SELECT
		@PrevEmployeeID = [TimeEntry].[EmployeeID]
	FROM
		[TimeEntry]
	WHERE
		[TimeEntry].[ID] = @TimeEntryID

	BEGIN TRANSACTION
	EXEC @rv = pjm5TimeEntryUpdateInternal 
		@TimeEntryID, 
		@FileAs, 
		@ActivityTypeID,
		@EmployeeID,
		@ProjectID,
		@DocumentClass,
		@DocumentID, 
		@TaskID, 
		@StartTime, 
		@Duration, 
		@TimeBillable, 
		@Overtime, 
		@ProjectCurrencyCode, 
		@VATRate, 
		NULL,
		@Comments,
		@PrevEmployeeID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	IF @VATIsIncluded = 1
		SET @VAT = @Duration * @Price * @VATRate / (1 + @VATRate)
	ELSE
		SET @VAT = @Duration * @Price * @VATRate
		
	EXEC adfParameterGet @Name='MinuteUOMID', @Group='Pjm5', @Value = @value OUTPUT
	SET @UOMID = CAST(@value as int)
	
	EXEC @rv = pjm5ExpenseUpdateInternal 
		@ExpenseID, 
		@FileAs,
		@EmployeeID,
		@ProjectID,
		@DocumentClass,
		@DocumentID,
		@TaskID,
		1, --@ExpenseCodeID,
		@StartTime,
		@UOMID,
		@Duration, --@Amount,
		@ExpenseBillable,
		@Price,
		@ProjectCurrencyCode, --@ExpenseCurrencyCode,
		@ProjectCurrencyCode,
		1, --@CurrencyRate,
		@VATRate,
		@VatIsIncluded,
		@VAT, -- VAT
		@Comments
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	UPDATE 
		[PhoneCall]
	SET
		[PhoneCall].[FileAs] = @FileAs,
		[PhoneCall].[TimeEntryID] = @TimeEntryID,
		[PhoneCall].[ExpenseID] = @ExpenseID,
		[PhoneCall].[PhoneCallCodeID] = @PhoneCallCodeID,
		[PhoneCall].[Comments] = @Comments,
		[PhoneCall].[Modified] = GETDATE(),
		[PhoneCall].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[PhoneCall].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION

	EXEC pjm5PhoneCallGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5PhoneCallUpdate TO PUBLIC
GO
 