IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'pjm5ProjectBalanceBrowse')
	BEGIN
		PRINT 'Dropping Procedure pjm5ProjectBalanceBrowse'
		DROP  Procedure  pjm5ProjectBalanceBrowse
	END

GO

PRINT 'Creating Procedure pjm5ProjectBalanceBrowse'
GO
/******************************************************************************
**		File: 
**		Name: pjm5ProjectBalanceBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
/*CREATE Procedure pjm5ProjectBalanceBrowse
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE
		@ValueWOVAT TMoney,
		@VAT TMoney,
		@Value TMoney,
		@StatementValueWOVAT TMoney,
		@StatementVAT TMoney,
		@StatementValue TMoney,
		@PaymentVAT TMoney,
		@PaymentValue TMoney
	DECLARE @BalanceTable TABLE ([Name] varchar(256), ValueWOVAT money, VAT money, Value money)
	
	SELECT
		@StatementValueWOVAT = SUM(ISNULL(
			CASE
				WHEN [StatementLine].[VATIsIncluded] = 1
					THEN [StatementLine].[Amount] * [StatementLine].[Price] - [StatementLine].[VAT]
				ELSE [StatementLine].[Amount] * [StatementLine].[Price]
			END, 0) / [Statement].[CurrencyRate]),
		@StatementVAT = SUM(ISNULL([StatementLine].[VAT], 0) / [Statement].[CurrencyRate]),
		@StatementValue = SUM(ISNULL(
				CASE
				WHEN [StatementLine].[VATIsIncluded] = 1
					THEN [StatementLine].[Amount] * [StatementLine].[Price]
				ELSE [StatementLine].[Amount] * [StatementLine].[Price] + [StatementLine].[VAT]
			END, 0) / [Statement].[CurrencyRate])
	FROM
		[Statement]
		INNER JOIN [StatementLine]
			ON [StatementLine].[StatementID] = [Statement].[ID]
	WHERE
		[Statement].[ProjectID] = @ID AND
		[Statement].[State] IN (2, 3)

	INSERT INTO @BalanceTable
		VALUES('', @StatementValueWOVAT, @StatementVAT, @StatementValue)
	
	SELECT
		@ValueWOVAT = SUM(ISNULL(
			CASE
				WHEN [InvoiceLine].[VATIsIncluded] = 1
					THEN [InvoiceLine].[Amount] * [InvoiceLine].[Price] - [InvoiceLine].[VAT]
				ELSE [InvoiceLine].[Amount] * [InvoiceLine].[Price]
			END, 0) / [Invoice].[CurrencyRate]),
		@VAT = SUM(ISNULL([InvoiceLine].[VAT], 0) / [Invoice].[CurrencyRate]),
		@Value = SUM(ISNULL(
				CASE
				WHEN [InvoiceLine].[VATIsIncluded] = 1
					THEN [InvoiceLine].[Amount] * [InvoiceLine].[Price]
				ELSE [InvoiceLine].[Amount] * [InvoiceLine].[Price] + [InvoiceLine].[VAT]
			END, 0) / [Invoice].[CurrencyRate])
	FROM
		[Invoice]
		INNER JOIN [InvoiceLine]
			ON [InvoiceLine].[InvoiceID] = [Invoice].[ID]
	WHERE
		[Invoice].[ProjectID] = @ID AND
		[Invoice].[State] IN (2, 5)	
	INSERT INTO @BalanceTable
		VALUES('', @ValueWOVAT, @VAT, @Value)
	
	SELECT
		@PaymentVAT = SUM(ISNULL([PaymentDetail].[VAT], 0) / [Invoice].[CurrencyRate]),
		@PaymentValue = SUM(ISNULL([PaymentDetail].[Value], 0) / [Invoice].[CurrencyRate])
	FROM
		[Invoice]
		INNER JOIN [PaymentDetail]
			ON [PaymentDetail].[InvoiceID] = [Invoice].[ID]
		INNER JOIN [Payment]
			ON [Payment].[ID] = [PaymentDetail].[PaymentID]
	WHERE
		[Invoice].[ProjectID] = @ID AND
		[Invoice].[State] IN (2, 5)	AND
		[Payment].[State] IN (2, 3)
		
	INSERT INTO @BalanceTable
		VALUES('', @PaymentValue - @PaymentVAT, @PaymentVAT, @PaymentValue)

	INSERT INTO @BalanceTable
		VALUES('', @ValueWOVAT - (@PaymentValue - @PaymentVAT), @VAT - @PaymentVAT, @Value - @PaymentValue)

	IF @ValueWOVAT - @StatementValueWOVAT <= 0
		SET @ValueWOVAT = 0
	ELSE SET @ValueWOVAT = @ValueWOVAT - @StatementValueWOVAT
		
	IF @VAT - @StatementVAT <= 0
		SET @VAT = 0
	ELSE SET @VAT = @VAT - @StatementVAT
	
	IF @Value - @StatementValue <= 0
		SET @Value = 0
	ELSE SET @Value = @Value - @StatementValue	
	
	INSERT INTO @BalanceTable
		VALUES(' ', @ValueWOVAT, @VAT, @Value)
		
	SELECT 
		[Name],
		[ValueWOVAT],
		[VAT],
		[Value]
	FROM
		@BalanceTable
		
	RETURN 0*/
GO

--GRANT EXEC ON pjm5ProjectBalanceBrowse TO PUBLIC
GO
