IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6ProjectStatementAssistantBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6ProjectStatementAssistantBrowse'
		DROP PROCEDURE [dbo].[pjm6ProjectStatementAssistantBrowse]
	END
GO

PRINT 'Creating procedure pjm6ProjectStatementAssistantBrowse'
GO

/******************************************************************************
**		File: pjm6ProjectStatementAssistantBrowse.sql
**		Name: pjm6ProjectStatementAssistantBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    11/11/2009	SYV				 @PeriodEnd = NULL    
**									         
*******************************************************************************/
CREATE PROCEDURE [pjm6ProjectStatementAssistantBrowse]
	@DateSelector	INT,
	@PeriodEnd		datetime,
	@EmployeeID		TIdentifier,
	@CostCenterSelector int,
	@CostCenterID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE 
		@date datetime,
		@ViewAllProjects TBool,
		@ViewAllFinance TBool,
		@ViewFinance TBool,
		@Assistant TBool,
		@CurrentEmployeeID TIdentifier,
		@Class TClass
		
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()	
	SET @ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects'))
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SET @ViewFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewFinance'))
	SET @Assistant = dbo.adfHasAccessRight(dbo.adfGetRightID('Assistant'))
	SET @Class = dbo.adfGetClassByName('Pjm5.Statement')
	SET @date = DATEADD(day, 1, CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime))
	
	IF @DateSelector = 0
		SET @PeriodEnd = NULL
	IF @DateSelector = 1
		SET @PeriodEnd = @date
	IF @DateSelector = 2
		SET @PeriodEnd = DATEADD(day, 7, @date)
	IF @DateSelector = 3
		SET @PeriodEnd = DATEADD(month, 1, DATEADD(day, 1-DAY(@date), @date))
	IF @DateSelector = 4
		SET @PeriodEnd = DATEADD(month, 2, DATEADD(day, 1-DAY(@date), @date))
	IF @DateSelector = 5
		SET @PeriodEnd = DATEADD(day, 1, CAST(CONVERT(varchar(8), @PeriodEnd, 112) AS datetime))

	SELECT
		[Project].[Class],
		[Project].[ID],
		--[Project].[State],
		-1 AS [State],
		[Project].[Flag],
		[Project].[Date],
		[Project].[Number],
		[Project].[FileAs],
		[Project].[ProjectTypeID],
		[Project].[SupplierCompanyID],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CustomerCompanyID],
		[Project].[CustomerFinanceManagerID],
		[Project].[ResponsiblePersonEmployeeID],
		[Project].[PriorityID],
		[Project].[EndDate],
		[Project].[CurrencyCode],
		[Project].[CostCenterID],
		[Project].[ContractNumber],
		[Project].[ContractDate],
		[Project].[ContractEndDate],
		[Project].[ContractSubject],
		[Project].[ServiceLevelID],
		
		dbo.fnPjm6PeriodTypeNameGet([AssistantRecurrencePattern].[RecurrenceType]) AS [PeriodType],
		--dbo.fnPjm6DayTypeNameGet([PaymentPeriod].[StatementDayType]) AS [DayType],
		[PaymentPeriod].[StatementNextPaymentDate] AS [NextPaymentDate],
		@Class AS [DocumentClass],
		[Statement].[ID] AS [DocumentID],
		[Statement].[State] AS [DocumentState],
		dbo.adfGetStateName(@Class, [Statement].[State]) AS [DocumentStateName],
		[Statement].[FileAs] AS [DocumentFileAs],
		
		[Project].[PaymentCurrencyPoint],
		[Project].[Comments],
		[Project].[Created],
		[Project].[CreatedBy],
		[Project].[Modified],
		[Project].[ModifiedBy],
		[Project].[Timestamp],
		[PaymentPeriod].[InvoiceNextPaymentDate],
		[PaymentPeriod].[StatementNextPaymentDate],
		[PaymentPeriod].[CalculationNextPaymentDate],
		[Project].[ContractComments]
	FROM
		[Project]
		INNER JOIN [PaymentPeriod]
			ON [PaymentPeriod].[ProjectID] = [Project].[ID]
		LEFT OUTER JOIN [AssistantRecurrencePattern]
			ON [AssistantRecurrencePattern].[ID] = [Project].[StatementRecurrencePatternID]
		LEFT OUTER JOIN [Statement]
			ON [Project].[ID] = [Statement].[ProjectID] AND
				(
					[Statement].[Date] = [PaymentPeriod].[StatementNextPaymentDate]
				OR
					@PeriodEnd IS NULL
				 )
				 AND
				[Statement].[State] != 4
	WHERE
		[Project].[State] IN (2, 3) AND
		(
			@CostCenterSelector = 0 OR
			ISNULL([Project].[CostCenterID], -1) = ISNULL(@CostCenterID, -1)
		) AND
		(
			([PaymentPeriod].[StatementNextPaymentDate] IS NOT NULL AND [PaymentPeriod].[StatementNextPaymentDate] < @PeriodEnd)
			OR
			([PaymentPeriod].[StatementNextPaymentDate] IS NULL AND @PeriodEnd IS NULL)
		) AND
		(
			@ViewAllFinance = 1 OR 
			(@Assistant = 1 AND @ViewAllProjects = 1) OR
			dbo.fnPjm5IsProjectManager([Project].[ID], @CurrentEmployeeID) = 1 OR
			(
				@ViewFinance = 1 AND
				dbo.fnPjm5IsProjectMember([Project].[ID], @CurrentEmployeeID) = 1
			)
		) AND
		(
			@EmployeeID IS NULL OR
			[Project].[ProjectManagerEmployeeID] = @EmployeeID
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm6ProjectStatementAssistantBrowse] TO PUBLIC
GO