IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6SubProjectInsert]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6SubProjectInsert'
		DROP PROCEDURE [dbo].[pjm6SubProjectInsert]
	END
GO

PRINT 'Creating procedure pjm6SubProjectInsert'
GO

/******************************************************************************
**		File: pjm6SubProjectInsert.sql
**		Name: pjm6SubProjectInsert
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6SubProjectInsert]
	@ParentProjectID int,
	@SubProjectID int
AS
	SET NOCOUNT ON

	IF EXISTS (SELECT * FROM [Task] WHERE [Task].[ProjectID] = @ParentProjectID AND [Task].[SubProjectID] = @SubProjectID)
	BEGIN
		RAISERROR('#projectalreadyinserted', 18, -1)
		RETURN 1
	END
	
	IF EXISTS (SELECT *FROM [Task] WHERE [Task].[SubprojectID] = @SubProjectID)
	BEGIN
		RAISERROR('#projectalreadyinsertedinotherproject', 18, -1)
		RETURN 1
	END
	
	IF @ParentProjectID = @SubProjectID
	BEGIN
		RAISERROR('#subprojectisproject', 18, -1)
		RETURN 1
	END
	
	DECLARE @SearchResult int;
	
	WITH SubProjects (ID, Level)
	AS
	(
		SELECT 
			[Task].[SubProjectID], 
			0 AS Level
		FROM 
			[Task]
		WHERE 
			[Task].[SuBprojectID] IS NOT NULL AND 
			[Task].[ProjectID] = @SubProjectID	
		UNION ALL
		SELECT 
			[Task].[SubprojectID],
			Level + 1
		FROM 
			[Task]
			INNER JOIN [SubProjects]
				ON [Task].[ProjectID] = [SubProjects].[ID]
		WHERE 
			[Task].[SubProjectID] IS NOT NULL 
	)
	SELECT @SearchResult = [ID] FROM [SubProjects] WHERE ID = @ParentProjectID
	IF @SearchResult = @ParentProjectID
	BEGIN
		RAISERROR('#subprojectisaparentproject', 18, -1)
		RETURN 1
	END
	
	DECLARE @ParentProjectCurrency nvarchar(5)
	SELECT @ParentProjectCurrency = [CurrencyCode] FROM [Project] WHERE [Project].[ID] = @ParentProjectID

	DECLARE @SubProjectCurrency nvarchar(5)
	SELECT @SubProjectCurrency = [CurrencyCode] FROM [Project] WHERE [Project].[ID] = @SubProjectID
	IF @ParentProjectCurrency != @SubProjectCurrency
	BEGIN
		RAISERROR('#subprojecthasdifferentcurrency', 18, -1)
		RETURN 1
	END

	DECLARE 
		@ID TIdentifier,
		@TaskIndex TCount,
		@rv int
		
	SELECT 
		@TaskIndex = MAX([TaskWbs].[TaskIndex])
	FROM 
		[TaskWbs] 
		INNER JOIN [Task]
			ON [Task].[ID] = [TaskWbs].[TaskID]
	WHERE 
		[Task].[ProjectID] = @ParentProjectID
	SET @TaskIndex = ISNULL(@TaskIndex, 0) + 1
	BEGIN TRANSACTION
	INSERT INTO [Task]
	(
		[State], [Flag], 
		[FileAs], 
		[ProjectID], 
		[PriorityID],
		[StartDate], [DueDate], [EndDate], 
		[Duration], 
		[ManHour], [Budget],
		[PercentComplete], [Milestone], [SendStatusReport],
		[Created], [CreatedBy], [Modified], [ModifiedBy], 
		[SubProjectID]
	)
	SELECT
		8, [Project].[Flag],
		[Project].[FileAs],
		@ParentProjectID, 
		[Project].[PriorityID], 
		[Project].[Date], [ProjectDetail].[DueDate], [Project].[EndDate], 
		dbo.fnPjm5GetWorkingDays([Project].[Date], [ProjectDetail].[DueDate]),
		[ProjectDetail].[PlannedManHour], [ProjectDetail].[PlannedBudget],
		[PercentComplete], 	0, 0, 
		[Project].[Created], [Project].[CreatedBy], [Project].[Modified], [Project].[ModifiedBy],
		[Project].[ID]
	FROM
		[Project]
		INNER JOIN [ProjectDetail]
			ON [ProjectDetail].[ID] = [Project].[ID]
	WHERE 
		[Project].[ID] = @SubProjectID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	SET @ID = SCOPE_IDENTITY()
	EXEC @rv = pjm6TaskUpdateWbs @ID, @TaskIndex, NULL
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	UPDATE [Task]
	SET [State] = 2
	WHERE 
		[Task].[SubProjectID] = @SubProjectID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm6SubProjectInsert TO PUBLIC
GO