IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportResourcePlanAbsentHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportResourcePlanAbsentHeader'
		DROP  Procedure  ReportResourcePlanAbsentHeader
	END

GO

PRINT 'Creating Procedure ReportResourcePlanAbsentHeader'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportResourcePlanAbsentHeader
	
	@PeriodSelector	int,
	@DateSelector	int,
	@PeriodStart	TDateTime,
	@PeriodEnd		TDateTime,
	@CompanyID		TIdentifier,
	@DivisionID     TIdentifier,
	@DivisionSelector int
	
AS
	SET NOCOUNT ON
	SET DATEFIRST 7
	DECLARE
		@UserID			TIdentifier,
		@UserName		TName,
		@CompanyName	TName,
		@DivisionName	TName,
		@ExecutiveEmployeeName TName,
		@ExecutivePositionName TName
		
		
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @CompanyName = '()'
	SET @DivisionName = CASE @DivisionSelector
         WHEN 0 THEN '()'
         WHEN 1 THEN ' '
	END	
		
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID
	
	SELECT 
		@CompanyName = [Company].[FileAs],
		@ExecutiveEmployeeName = [Employee].[FileAs],
		@ExecutivePositionName = [Position].[FileAs]	 
	FROM ([Company]
		LEFT JOIN [Employee] ON [Company].[ExecutiveEmployeeID] = [Employee].[ID])
		LEFT JOIN [Position] ON [Employee].[PositionID] = [Position].[ID]
	where [Company].[ID] = @CompanyID and [Company].[Own]=1	

	SELECT
		@DivisionName = [Division].[FileAs]
	FROM
		[Division]
	WHERE
		[Division].[ID] = @DivisionID
	
	SELECT
		@CompanyName	AS [CompanyName],
		@DivisionName AS [DivisionName],
		@PeriodSelector	AS [PeriodSelector],
		@DateSelector	AS [DateSelector],
		@PeriodStart	AS [PeriodStart],
		@PeriodEnd		AS [PeriodEnd],		
		@UserName AS [UserName],
		@ExecutivePositionName AS [ExecutivePositionName],
		@ExecutiveEmployeeName AS [ExecutiveEmployeeName]
		
		
RETURN 0
GO

GRANT EXEC ON ReportResourcePlanAbsentHeader TO PUBLIC

GO
