IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportResourcePlanPeriodHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportResourcePlanPeriodHeader'
		DROP  Procedure  ReportResourcePlanPeriodHeader
	END

GO

PRINT 'Creating Procedure ReportResourcePlanPeriodHeader'
GO
--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportResourcePlanPeriodHeader
	@PeriodSelector	int,
	@PeriodStart	datetime,
	@PeriodEnd		datetime,
	@PeriodEnd1		datetime,
	@PeriodEnd2		datetime,
	@TodayDate		datetime,
	@CompanyID		int,
	@DivisionSelector int,
	@DivisionID     TIdentifier
	
AS
	SET NOCOUNT ON
	SET DATEFIRST 7
	DECLARE
		@UserID			TIdentifier,
		@UserName		TName,
		@CompanyName	TName,
		@DivisionName   TName,
		@value			TVariant,
		@WorkTime		decimal(18,2)
	EXEC adfParameterGet 'WorkTime', 'Pjm5', @value OUTPUT  
	SET @WorkTime = CAST(@value AS decimal(18,2))
	SET @WorkTime = @WorkTime / 60.00			
		
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @CompanyName = '()'
		SET @DivisionName = CASE @DivisionSelector
         WHEN 0 THEN '()'
         WHEN 1 THEN ' '
	END		
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID
	
	SELECT
		@CompanyName = [Company].[FileAs]
	FROM
		[Company]
	WHERE
		[Company].[ID] = @CompanyID			
		
			SELECT
		@DivisionName = [Division].[FileAs]
	FROM
		[Division]
	WHERE
		[Division].[ID] = @DivisionID	
		
	SELECT
		@CompanyName AS [CompanyName],
		@DivisionName AS [DivisionName],
		@PeriodSelector AS [PeriodSelector],
		@PeriodStart AS [PeriodStart],
		DATEADD(day, -1, @PeriodEnd) AS [PeriodEnd],
		@TodayDate  AS [TodayDate],
		dbo.fnPjm5GetWorkingDays(@PeriodStart, DATEADD(day, -1, @PeriodEnd1)) AS [WorkingDays1],
		dbo.fnPjm5GetWorkingDays(@PeriodEnd1, DATEADD(day, -1, @PeriodEnd2)) AS [WorkingDays2],
		dbo.fnPjm5GetWorkingDays(@PeriodEnd2, DATEADD(day, -1, @PeriodEnd)) AS [WorkingDays3],
		@WorkTime AS [WorkTime],
		@UserName AS [UserName]


		
RETURN 0
GO

GRANT EXEC ON ReportResourcePlanPeriodHeader TO PUBLIC

GO
