IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportRevenueAnalysisByClientsHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportRevenueAnalysisByClientsHeader'
		DROP  Procedure  ReportRevenueAnalysisByClientsHeader
	END

GO

PRINT 'Creating Procedure ReportRevenueAnalysisByClientsHeader'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/ 
CREATE PROCEDURE [dbo].[ReportRevenueAnalysisByClientsHeader]
       @CompanyID TIdentifier,
       @CurrencySelector int,
       @ManagerID TIdentifier,
	   @CompanyManagerSelector int,
       @CostCenterID TIdentifier,
	   @CostCenterSelector int,
       @ServiceTypeID TIdentifier,
       @ServiceTypeSelector int,
       @InvoiceSelector int,
       @DateSelector int,
       @CountSelector int,
       @Count	int

AS

   SET NOCOUNT ON

   DECLARE
          @CompanyName TName,	
          @Value TVariant,
          @ManagerName TName,
          @CostCenterName TName,
          @ServiceTypeName TName,
          @ServiceIncludedName TName,
          @InvoiceState TName,
          @DatePeriod TName,
          @UserName TName,
          @UserID TIdentifier,
          @CountName TName 

   SET @CompanyName = '()'
   SET @ManagerName  = '()'
   SET @CostCenterName  = '()'
   SET @ServiceTypeName = '( )'
   
   SELECT 
         @CompanyName = [Company].[FileAs]
   FROM
         [Company]
   WHERE 
         [Company].[ID] = @CompanyID
   
   IF @CurrencySelector = 0
      EXEC adfParameterGet 'BaseCurrency', 'CommonBusiness', @Value OUTPUT
   
   IF @CurrencySelector = 1
      EXEC adfParameterGet 'NationalCurrency', 'CommonBusiness', @Value OUTPUT
   
   IF @CompanyManagerSelector = 1 AND @ManagerID IS NULL
		SET @ManagerName = '( )'
   ELSE IF @CompanyManagerSelector = 1 AND @ManagerID IS NOT NULL
      SELECT
         @ManagerName = [Employee].[FileAs]
	  FROM
         [Employee]
	  WHERE
         [Employee].[ID] = @ManagerID	
  
	IF @CostCenterSelector = 1 AND @CostCenterID IS NULL
		SET @CostCenterName = '( )'
	ELSE IF @CostCenterSelector = 1 AND @CostCenterID IS NOT NULL
	   SELECT 
			 @CostCenterName = [CostCenter].[FileAs]
	   FROM
			 [CostCenter]
	   WHERE 
			 [CostCenter].[ID] = @CostCenterID

   IF @ServiceTypeSelector = 3 AND @ServiceTypeID IS NOT NULL
   SELECT
         @ServiceTypeName = [ServiceType].[FileAs]
   FROM
         [ServiceType]
   WHERE
         [ServiceType].[ID] = @ServiceTypeID

   SET @ServiceIncludedName = CASE @ServiceTypeSelector
                                   WHEN 0 THEN '    '
                                   WHEN 1 THEN ' '
                                   WHEN 2 THEN '  '
                              END
   IF @InvoiceSelector=0
           SET @InvoiceState = '  '
   ELSE
           SET @InvoiceState = '  '

   SET @DatePeriod = CASE @DateSelector
                          WHEN 0 THEN  ' '
                          WHEN 1 THEN  ' '
                          WHEN 2 THEN  ' '
                          ELSE  ' '
                     END

   SET @CountName = CASE @CountSelector 
                         WHEN 0 THEN  ' 5 '
                         WHEN 1 THEN  ' 10 '
                         WHEN 2 THEN  ' ' + CAST(@Count as varchar(10)) + ' '
                         ELSE  ' '
                    END

   SET @UserID = dbo.adfGetCurrentUserID()
	
   SELECT
         @UserName = [Trustee].[DisplayName]
   FROM 
         [Trustee]
   WHERE 
         [Trustee].[ID] = @UserID
   
   SELECT
         @CompanyName  AS [CompanyName],
         CAST(@Value AS nvarchar(32)) AS [CurrencyCode],
         @ManagerName AS [ManagerName],
         @CostCenterName AS [CostCenterName],
         @ServiceTypeName AS [ServiceTypeName],
         @ServiceIncludedName AS [SeriveIncludedName],
         @InvoiceState AS [InvoiceState],
         @DatePeriod AS [DatePeriod],
         @UserName AS [UserName],
         @CountName AS [Count]

RETURN 0
GO

GRANT EXEC ON ReportRevenueAnalysisByClientsHeader TO PUBLIC

GO
