IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportTimeEntryOfTaskHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportTimeEntryOfTaskHeader'
		DROP  Procedure  ReportTimeEntryOfTaskHeader
	END

GO

PRINT 'Creating Procedure ReportTimeEntryOfTaskHeader'
GO
--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/

CREATE Procedure ReportTimeEntryOfTaskHeader
	@Date			TDateTime,
	@ProjectID		TIdentifier
AS
	SET NOCOUNT ON
	DECLARE
		@UserID			TIdentifier,
		@UserName		TName
		
	SET @UserID = dbo.adfGetCurrentUserID()
		
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID

	SELECT
		@Date AS [Date],
		[Project].[FileAs] AS [ProjectName],
		[Project].[Number] AS [ProjectCode],
		[SupplierCompany].[LegalName] AS [SupplierCompanyName],
		[CostCenter].[FileAs] AS [CostCenter],
		[Employee].[FileAs] AS [ManagerName],
		[CustomerCompany].[LegalName] AS [CustomerCompanyName],
		[Project].[Date] AS [StartDate],
		[Project].[EndDate] AS [EndDate],
		DATEDIFF(day,@Date,[Project].[EndDate]) AS [Duration],
		[Project].[State] AS [State],
		@UserName AS [UserName]
	FROM [Project]
		LEFT OUTER JOIN [Company] AS [CustomerCompany]
			ON [Project].[CustomerCompanyID] = [CustomerCompany].[ID]
		LEFT OUTER JOIN [Company] AS [SupplierCompany]
			ON [Project].[SupplierCompanyID] = [SupplierCompany].[ID]	
		LEFT OUTER JOIN [Employee]
			ON [Project].[ProjectManagerEmployeeID] = [Employee].[ID]
		LEFT OUTER JOIN [CostCenter]
			ON [Project].[CostCenterID] = [CostCenter].[ID]
	WHERE
		[Project].[ID] = @ProjectID

RETURN 0
GO

GRANT EXEC ON ReportTimeEntryOfTaskHeader TO PUBLIC

GO
