IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportTimesheetOfProjectHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportTimesheetOfProjectHeader'
		DROP  Procedure  ReportTimesheetOfProjectHeader
	END

GO

PRINT 'Creating Procedure ReportTimesheetOfProjectHeader'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportTimesheetOfProjectHeader
	@EmployeeID			int,
	@WeekStart			Tdatetime,
	@NextDate			Tdatetime,
	@ProjectID			TIdentifier
	
AS
	SET NOCOUNT ON

	DECLARE
		@UserID			TIdentifier,
		@UserName		TName,
		@EmployeeName	TName,
		@StandartRate	decimal(18,2),
		@OvertimeRate	decimal(18,2)
							
	SET @UserID = dbo.adfGetCurrentUserID()
		
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID
		
	SELECT
		@EmployeeName = [Employee].[FileAs],
		@StandartRate = [Assignment].[StandardRate],
		@OvertimeRate = [Assignment].[OvertimeRate]
	FROM 
		[Employee]
		INNER JOIN [AssignmentEntry]	
			ON [Employee].[ID] = [AssignmentEntry].[EmployeeID]
		INNER JOIN [Assignment]
			ON [AssignmentEntry].[AssignmentID] = [Assignment].[ID]	
	WHERE
		[Employee].[ID] = @EmployeeID AND
		[Assignment].[ProjectID] = @ProjectID		 
	
			
	SELECT
		[Project].[FileAs] AS [ProjectName],
		[Project].[ContractNumber] AS [ContractNumber],
		[SupplierCompany].[FileAs] AS [SupplierCompanyName],
		[CustomerCompany].[FileAs] AS [CustomerCompanyName],
		@EmployeeName AS [Name],
		@StandartRate AS [StandartRate],
		@OvertimeRate AS [OvertimeRate],
		@WeekStart AS [WeekStart],
		DATEADD(second, -1, DATEADD(week, 1, @WeekStart)) AS [WeekEnd],
		@UserName AS [UserName]	
	FROM 
		[Project]
		LEFT OUTER JOIN [Company] AS [CustomerCompany]
			ON [Project].[CustomerCompanyID] = [CustomerCompany].[ID]
		LEFT OUTER JOIN [Company] AS [SupplierCompany]
			ON [Project].[SupplierCompanyID] = [SupplierCompany].[ID]		
	WHERE
		[Project].[ID] = @ProjectID		
		
RETURN 0
GO

GRANT EXEC ON ReportTimesheetOfProjectHeader TO PUBLIC

GO
