IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceAssignmentInfo]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceAssignmentInfo'
		DROP PROCEDURE [dbo].[pjm5ServiceAssignmentInfo]
	END
GO

PRINT 'Creating procedure pjm5ServiceAssignmentInfo'
GO

/******************************************************************************
**		File: pjm5ServiceAssignmentInfo.sql
**		Name: pjm5ServiceAssignmentInfo
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 01/27/2005 15:57:09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceAssignmentInfo]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier,
		@UserID TIdentifier
	
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))	
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @UserID = dbo.adfGetCurrentUserID()
	
	DECLARE @VATRate TPercent
	SET @VATRate = dbo.fnPjm5GetVATRate()

	SELECT
		[ServiceAssignment].[Class],
		[ServiceAssignment].[ID],
		[ServiceAssignment].[State],
		[ServiceAssignment].[Flag],
		[ServiceAssignment].[FileAs],
		[Service].[PaymentTermID],
		[ServiceAssignment].[ProjectID],
		[ServiceAssignment].[ServiceID],
		[ServiceAssignment].[RateMultiplier],
		[ServiceAssignment].[Price],
		[ServiceAssignment].[VATIsIncluded],
		CASE
			WHEN @ViewAllFinance = 1 OR
				dbo.fnPjm5HasFinansDataAccess([Project].[ID], @CurrentEmployeeID, NULL, NULL) = 1 OR
				dbo.fnPjm5IsProjectApprover([Project].[ID], @CurrentEmployeeID) = 1
				THEN
					CASE 
						WHEN [ServiceAssignment].[VATIsIncluded] != 1
							THEN [ServiceAssignment].[Price]
						ELSE [ServiceAssignment].[Price] / (1 + @VATRate)
					END 
			ELSE -1
		END AS [Sum],
		CASE
			WHEN @ViewAllFinance = 1 OR
				dbo.fnPjm5HasFinansDataAccess([Project].[ID], @CurrentEmployeeID, NULL, NULL) = 1 OR
				dbo.fnPjm5IsProjectApprover([Project].[ID], @CurrentEmployeeID) = 1
				THEN
					CASE 
						WHEN [ServiceAssignment].[VATIsIncluded] != 1
							THEN [ServiceAssignment].[Price] * @VATRate
						ELSE [ServiceAssignment].[Price] * @VATRate / (1 + @VATRate)
					END 
			ELSE -1
		END AS [VAT],
		CASE
			WHEN @ViewAllFinance = 1 OR
				dbo.fnPjm5HasFinansDataAccess([Project].[ID], @CurrentEmployeeID, NULL, NULL) = 1 OR
				dbo.fnPjm5IsProjectApprover([Project].[ID], @CurrentEmployeeID) = 1
				THEN
					CASE 
						WHEN [ServiceAssignment].[VATIsIncluded] != 1
							THEN [ServiceAssignment].[Price] * (1 + @VATRate)
						ELSE [ServiceAssignment].[Price]
					END 
			ELSE -1
		END AS [SumWithVAT],
		[Project].[ProjectTypeID],
		[Project].[CurrencyCode],
		[Project].[SupplierCompanyID],
		[Project].[CustomerCompanyID],
		[ServiceAssignment].[Comments],
		[ServiceAssignment].[Created],
		[ServiceAssignment].[CreatedBy],
		[ServiceAssignment].[Modified],
		[ServiceAssignment].[ModifiedBy],
		[ServiceAssignment].[Timestamp],
		[ServiceAssignment].[ContractAddendumID],
		[Project].[ApplyVAT] AS [ProjectApplyVAT],
		[Service].[UOMID] AS [UOMID],
		[ServiceAssignment].[ServiceTypeID],
		[ServiceAssignment].[ActualBudget],
		[ServiceAssignment].[ActualManHour],
		[ServiceAssignment].[ManHour],
		[ServiceAssignment].[Budget]
	FROM
		[ServiceAssignment]
		INNER JOIN [Service]
			ON [Service].[ID] = [ServiceAssignment].[ServiceID]
		INNER JOIN [Project]
			ON [Project].[ID] = [ServiceAssignment].[ProjectID]
	WHERE
		[ServiceAssignment].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ServiceAssignmentInfo] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceAssignmentGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceAssignmentGet'
		DROP PROCEDURE [dbo].[pjm5ServiceAssignmentGet]
	END
GO

PRINT 'Creating procedure pjm5ServiceAssignmentGet'
GO

/******************************************************************************
**		File: pjm5ServiceAssignmentGet.sql
**		Name: pjm5ServiceAssignmentGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 01/27/2005 15:57:09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceAssignmentGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE 
		@ProjectID TIdentifier,
		@IsFinanceEnable	bit,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier,
		@ViewFinance TBool,
		@IsPM TBool,
		@IsMember TBool
		
	SELECT @ProjectID = [ProjectID] FROM [ServiceAssignment] WHERE [ID] = @ID
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	
	SET @ViewFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewFinance'))
	SET @IsPM = dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID)
	SET @IsMember = dbo.fnPjm5IsProjectMember(@ProjectID, @CurrentEmployeeID)
	SELECT  @IsFinanceEnable = CASE
				WHEN @IsPM = 1 THEN 1
				WHEN @ViewFinance = 1 AND @IsMember = 1 THEN 1
				ELSE @ViewAllFinance
			END
	IF @IsFinanceEnable = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
		
	DECLARE @VATRate TPercent
	SET @VATRate = dbo.fnPjm5GetVATRate()

	SELECT
		[ServiceAssignment].[Class],
		[ServiceAssignment].[ID],
		[ServiceAssignment].[State],
		[ServiceAssignment].[Flag],
		[ServiceAssignment].[FileAs],
		[Service].[PaymentTermID],
		[ServiceAssignment].[ProjectID],
		[ServiceAssignment].[ServiceID],
		[ServiceAssignment].[RateMultiplier],
		[ServiceAssignment].[Price],
		[ServiceAssignment].[VATIsIncluded],
		CASE 
			WHEN [ServiceAssignment].[VATIsIncluded] != 1
				THEN [ServiceAssignment].[Price]
			ELSE [ServiceAssignment].[Price] / (1 + @VATRate)
		END AS [Sum],
		CASE 
			WHEN [ServiceAssignment].[VATIsIncluded] != 1
				THEN [ServiceAssignment].[Price] * @VATRate
			ELSE [ServiceAssignment].[Price] * @VATRate / (1 + @VATRate)
		END AS [VAT],
		CASE 
			WHEN [ServiceAssignment].[VATIsIncluded] != 1
				THEN [ServiceAssignment].[Price] * (1 + @VATRate)
			ELSE [ServiceAssignment].[Price]
		END AS [SumWithVAT],
		CASE WHEN @ViewAllFinance = 1 OR
				dbo.fnPjm5HasFinansDataAccess([Project].[ID], @CurrentEmployeeID, NULL, NULL) = 1 OR
				dbo.fnPjm5IsProjectApprover([Project].[ID], @CurrentEmployeeID) = 1 THEN 1 ELSE 0
		END AS [FinanceEnable],
		[Project].[CurrencyCode],
		[Project].[SupplierCompanyID],
		[Project].[CustomerCompanyID],
		[ServiceAssignment].[Comments],
		[ServiceAssignment].[Created],
		[ServiceAssignment].[CreatedBy],
		[ServiceAssignment].[Modified],
		[ServiceAssignment].[ModifiedBy],
		[ServiceAssignment].[Timestamp],
		[ServiceAssignment].[ContractAddendumID],
		[Project].[ApplyVAT] AS [ProjectApplyVAT],
		[Service].[UOMID] AS [UOMID],
		[ServiceAssignment].[ServiceTypeID],
		[ServiceAssignment].[Budget],
		[ServiceAssignment].[ManHour],
		[ServiceAssignment].[ActualManHour],
		[ServiceAssignment].[ActualBudget]
	FROM
		[ServiceAssignment]
		INNER JOIN [Service]
			ON [Service].[ID] = [ServiceAssignment].[ServiceID]
		INNER JOIN [Project]
			ON [Project].[ID] = [ServiceAssignment].[ProjectID]
	WHERE
		[ServiceAssignment].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ServiceAssignmentGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceAssignmentCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceAssignmentCreate'
		DROP PROCEDURE [dbo].[pjm5ServiceAssignmentCreate]
	END
GO

PRINT 'Creating procedure pjm5ServiceAssignmentCreate'
GO

/******************************************************************************
**		File: pjm5ServiceAssignmentCreate.sql
**		Name: pjm5ServiceAssignmentCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 01/27/2005 16:00:03
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceAssignmentCreate]
	@Xml	XML
AS
	SET NOCOUNT ON

	DECLARE 
			@ServiceClass TClass,
			@Class TClass,
			@State TState,
			@ID TIdentifier,
			@FileAs TName,
			@PaymentTermID TIdentifier,
			@ProjectID TIdentifier,
			@ServiceID TIdentifier,
			@ServiceTypeID TIdentifier,
			@RateMultiplier TAmount,
			@Price TMoney,
			@VATRate TPercent,
			@CurrencyCode TCode3,
			@Comments TNotes,
			@doc INT,
			@rv int,
			@Duration int,
			@ContractAddendumID TIdentifier,
			@VATIsIncluded TBool,
			@PropertyID TIdentifier,
			@Value TPropertyValue,
			@ManHour TCount,
			@Budget TAmount


	SET	@Class = dbo.adfGetClassByName('Pjm5.ServiceAssignment')
	SET @VATRate = dbo.fnPjm5GetVATRate()
	SET @State = dbo.adfwfGetInitialState('8cece7ca-a901-42cc-bdb8-60b87a26cd1d')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	SELECT
		@FileAs = [Table].[FileAs],
		@ServiceClass = [Service].[Class],
		@ServiceID = [Table].[ServiceID],
		@ServiceTypeID = ISNULL([Table].[ServiceTypeID], [Service].[ServiceTypeID]),
		@Duration = [Table].[Duration],
		@ProjectID = [Table].[ProjectID],
		@RateMultiplier = [Table].[RateMultiplier],
		@Price = [Table].[Price],
		@PaymentTermID = [Service].[PaymentTermID],
		@Comments = [Table].[Comments],
		@ContractAddendumID = [Table].[ContractAddendumID],
		@VATIsIncluded = [Table].[VATIsIncluded],
		@ManHour = [Table].[ManHour],
		@Budget = [Table].[Budget]
	FROM
		[Project]
		INNER JOIN
			(
				SELECT
					[FileAs],
					[ServiceID],
					[ServiceTypeID],
					[Duration],
					[ProjectID],
					[RateMultiplier],
					[Price],
					[PaymentTermID],
					[Comments],
					[ContractAddendumID],
					[ManHour],
					[Budget],
					(CASE [VATIsIncluded] WHEN 'false' THEN 0 ELSE 1 END) AS [VATIsIncluded]
				FROM
					OPENXML(@doc, '/pjm5ServiceAssignmentGet/ServiceAssignment', 2)
						WITH (
							[FileAs] nvarchar(256),
							[ServiceID] int,
							[ServiceTypeID] int,
							[Duration] int,
							[ProjectID] int,
							[RateMultiplier] decimal(18,4),
							[Price] money,
							[PaymentTermID] int,
							[Comments] nvarchar(max),
							[ContractAddendumID] int,
							[VATIsIncluded] varchar(5),
							[ManHour] int,
							[Budget] decimal(18,4)
							)
			) AS [Table]
			ON [Project].[ID] = [Table].[ProjectID]
		LEFT OUTER JOIN [Service]
			ON [Table].[ServiceID] = [Service].[ID]
	EXEC sp_xml_removedocument @doc

	IF @ProjectID IS NULL
	BEGIN
		RAISERROR('#ProjectIsNotDefined', 18, -1)
		RETURN 1
	END

	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @ServiceID IS NULL
	BEGIN
		RAISERROR('#ServiceIsNotDefined', 18, -1)
		RETURN 1
	END
	
	
	IF EXISTS (SELECT * FROM [ProjectTemplate] WHERE [ID] = @ProjectID)
	BEGIN
		SET @State = 6
	END
	
	IF @Price IS NOT NULL
		SET @RateMultiplier = NULL
	BEGIN TRANSACTION
	INSERT INTO [ServiceAssignment]
		([Flag], [State], [FileAs], 
		[ProjectID], [ServiceID], 
		[RateMultiplier], [Price],
		[PaymentTermID],
		[Comments], [ContractAddendumID],
		[VATIsIncluded],[ServiceTypeID],
		[ManHour], [Budget])
	VALUES(
		0,
		@State,
		@FileAs,
		@ProjectID,
		@ServiceID,
		@RateMultiplier,
		@Price,
		@PaymentTermID,
		@Comments,
		@ContractAddendumID,
		@VATIsIncluded,
		@ServiceTypeID,
		ISNULL(@ManHour, 0),
		ISNULL(@Budget, 0)
		)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()
	
	SELECT
		@Value = [PropertyValue].[Value]
	FROM
		[PropertyValue] 
		INNER JOIN [Property]
			ON ([PropertyValue].[PropertyID] = [Property].[ID])
	WHERE
		[PropertyValue].[DocumentClass] = @ServiceClass AND
		[PropertyValue].[DocumentID] = @ServiceID AND
		[Property].[Guid] = '00000001-0000-0000-0000-000000000000'
		
	SELECT
		@PropertyID = [Property].[ID]
	FROM
		[Property]
	WHERE
		[Property].[Class] = @Class AND
		[Property].[Guid] = '00000001-0000-0000-0000-000000000000'

	EXEC @rv = adfPropertyValueUpdate @Class, @ID, @PropertyID, @Value
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	
	EXEC pjm5ServiceAssignmentGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceAssignmentCreate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceAssignmentUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceAssignmentUpdate'
		DROP PROCEDURE [dbo].[pjm5ServiceAssignmentUpdate]
	END
GO

PRINT 'Creating procedure pjm5ServiceAssignmentUpdate'
GO

/******************************************************************************
**		File: pjm5ServiceAssignmentUpdate.sql
**		Name: pjm5ServiceAssignmentUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 01/27/2005 16:00:03
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ServiceAssignmentUpdate
	@Xml	XML
AS
	DECLARE @ID TIdentifier,
			@FileAs TName,
			@PaymentTermID TIdentifier,
			@ProjectID TIdentifier,
			@ServiceID TIdentifier,
			@RateMultiplier TAmount,
			@Price TMoney,
			@CurrencyCode TCode3,
			@Comments TNotes,
			@doc int,
			@ManHour TCount,
			@Budget TAmount
	
	SET NOCOUNT ON
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	SELECT @ProjectID = [ProjectID] FROM OPENXML(@doc, '/pjm5ServiceAssignmentGet/ServiceAssignment', 2) WITH ([ProjectID] int)
			
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0
	BEGIN
		EXEC sp_xml_removedocument @doc
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	UPDATE 
		[ServiceAssignment]
	SET
		@ID = [XmlTable].[ID],
		[ServiceAssignment].[FileAs] = [XmlTable].[FileAs],
		[ServiceAssignment].[ProjectID] = [XmlTable].[ProjectID],
		[ServiceAssignment].[ServiceID] = [XmlTable].[ServiceID],
		[ServiceAssignment].[ServiceTypeID] = [XmlTable].[ServiceTypeID],
		[ServiceAssignment].[PaymentTermID] = [Service].[PaymentTermID],
		[ServiceAssignment].[RateMultiplier] = CASE 
			WHEN [XmlTable].[Price] IS NULL THEN [XmlTable].[RateMultiplier]
			ELSE NULL
		END,
		[ServiceAssignment].[Price] = [XmlTable].[Price],
		[ServiceAssignment].[Comments] = [XmlTable].[Comments],
		[ServiceAssignment].[Modified] = GETDATE(),
		[ServiceAssignment].[ModifiedBy] = dbo.adfGetCurrentUserID(),
		[ServiceAssignment].[ContractAddendumID] = [XmlTable].[ContractAddendumID],
		[ServiceAssignment].[VATIsIncluded] = [XmlTable].[VATIsIncluded],
		[ServiceAssignment].[ManHour] = [XmlTable].[ManHour],
		[ServiceAssignment].[Budget] = [XmlTable].[Budget]
	FROM
		[ServiceAssignment]
		INNER JOIN 
			(
			SELECT
				[ID],
				[FileAs],
				[ProjectID],
				[ServiceID],
				[ServiceTypeID],
				[RateMultiplier],
				[Price],
				[Comments],
				[ContractAddendumID],
				[ManHour],
				[Budget],
				(CASE [VATIsIncluded] WHEN 'false' THEN 0 ELSE 1 END) AS [VATIsIncluded]
			FROM
				OPENXML(@doc, '/pjm5ServiceAssignmentGet/ServiceAssignment', 2)
					WITH (
						[ID] int,
						[FileAs] nvarchar(256),
						[ProjectID] int,
						[ServiceID] int,
						[ServiceTypeID] int,
						[RateMultiplier] decimal(18,4),
						[Price] money,
						[Comments] nvarchar(max),
						[ContractAddendumID] int,
						[VATIsIncluded] varchar(5),
						[ManHour] int,
						[Budget] decimal(18,4)
						)
			) AS [XmlTable]
			ON [XmlTable].[ID] = [ServiceAssignment].[ID]
		LEFT OUTER JOIN [Service]
			ON [XmlTable].[ServiceID] = [Service].[ID]
	IF @@ERROR != 0
	BEGIN
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	EXEC sp_xml_removedocument @doc
	EXEC pjm5ServiceAssignmentGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceAssignmentUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceAssignmentDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceAssignmentDelete'
		DROP PROCEDURE [dbo].[pjm5ServiceAssignmentDelete]
	END
GO

PRINT 'Creating procedure pjm5ServiceAssignmentDelete'
GO

/******************************************************************************
**		File: pjm5ServiceAssignmentDelete.sql
**		Name: pjm5ServiceAssignmentDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 01/27/2005 16:00:03
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ServiceAssignmentDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE 
		@ProjectID int,
		@CurrentEmployeeID int
	SELECT @ProjectID = [ProjectID] FROM [ServiceAssignment] WHERE [ID] = @ID
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	DELETE FROM [ServiceAssignment] WHERE [ServiceAssignment].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceAssignmentDelete TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceAssignmentChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceAssignmentChangeState'
		DROP PROCEDURE [dbo].[pjm5ServiceAssignmentChangeState]
	END
GO

PRINT 'Creating procedure pjm5ServiceAssignmentChangeState'
GO

/******************************************************************************
**		File: pjm5ServiceAssignmentChangeState.sql
**		Name: pjm5ServiceAssignmentChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 01/27/2005 16:00:03
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ServiceAssignmentChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass,
			@ProjectID TIdentifier,
			@ContractAddendumID TIdentifier
	
	SET NOCOUNT ON

	SELECT
		@Class = [ServiceAssignment].[Class],
		@FromState = [ServiceAssignment].[State],
		@ProjectID = [ProjectID],
		@ContractAddendumID = [ContractAddendumID]
	FROM
		[ServiceAssignment]
	WHERE
		[ServiceAssignment].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1) 
		RETURN 1
	END

	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF @FromState = 1 AND @ToState = 2 AND
		(SELECT [State] FROM [Project] WHERE [ID] = @ProjectID) = 1
	BEGIN
		RAISERROR('#CannotApproveServiceAssignmentProjectIsDraft', 18, -1)
		RETURN 1
	END
	IF @FromState = 1 AND @ToState = 2 AND
		(SELECT [State] FROM [ContractAddendum] WHERE [ID] = @ContractAddendumID) = 1
	BEGIN
		RAISERROR('#CannotApproveServiceAssignmentContractAddendumIsDraft', 18, -1)
		RETURN 1
	END
	
	UPDATE [ServiceAssignment]
	SET
		[ServiceAssignment].[State] = @ToState,
		[ServiceAssignment].[Modified] = DEFAULT,
		[ServiceAssignment].[ModifiedBy] = DEFAULT
	WHERE
		[ServiceAssignment].[ID] = @ID
	AND
		[ServiceAssignment].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceAssignmentChangeState TO PUBLIC
GO
