SET QUOTED_IDENTIFIER ON
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[GenerateEventsMeetingRequestCompleted]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure GenerateEventsMeetingRequestCompleted'
		DROP PROCEDURE [dbo].[GenerateEventsMeetingRequestCompleted]
	END
GO

PRINT 'Creating procedure GenerateEventsMeetingRequestCompleted'
GO

/******************************************************************************
**		File: GenerateEventsMeetingRequestCompleted.sql
**		Name: GenerateEventsMeetingRequestCompleted
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/18/2006
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		23.11.09	PAM				 ,   
**									,   
**    
*******************************************************************************/
CREATE PROCEDURE [GenerateEventsMeetingRequestCompleted]
	@FromID TIdentifier,
	@EventType TName,
	@DocumentClass TClass,
	@DocumentID TIdentifier,
	@Data XML
AS
	SET NOCOUNT ON;

	INSERT INTO [MailItem]
		([State], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	SELECT
		1,
		[MeetingRequest].[FileAs],
		@EventType,
		@FromID,
		[Employee].[UserID],
		@DocumentClass,
		@DocumentID,
		0,
		@Data,
		[MeetingRequest].[Comments]
	FROM
		[MeetingRequest] INNER JOIN [Attendee]
			ON ([MeetingRequest].[ID] = [Attendee].[MeetingRequestID])
		INNER JOIN [Employee]
			ON ([Attendee].[EmployeeID] = [Employee].[ID])
	WHERE
		[MeetingRequest].[ID] = @DocumentID 
	AND
		[Employee].[UserID] != @FromID
	AND
		[Attendee].[ResponseType] != 'Decline'
	

	RETURN 0
GO

   