SET QUOTED_IDENTIFIER ON
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[GenerateEventsResourceRequestRejected]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure GenerateEventsResourceRequestRejected'
		DROP PROCEDURE [dbo].[GenerateEventsResourceRequestRejected]
	END
GO

PRINT 'Creating procedure GenerateEventsResourceRequestRejected'
GO

/******************************************************************************
**		File: GenerateEventsResourceRequestRejected.sql
**		Name: GenerateEventsResourceRequestRejected
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/12/2006
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [GenerateEventsResourceRequestRejected]
	@FromID TIdentifier,
	@EventType TName,
	@DocumentClass TClass,
	@DocumentID TIdentifier,
	@Data XML
AS
	SET NOCOUNT ON;

	DECLARE @EmployeeID TIdentifier, @ToID TIdentifier
	
	SELECT 
		@EmployeeID = [ResourceRequest].[EmployeeID]
	FROM
		[ResourceRequest]
	WHERE
		[ResourceRequest].[ID] = @DocumentID
	
	SELECT @ToID = (SELECT [UserID] FROM [Employee] WHERE [ID] = @EmployeeID)
	
	IF @ToID IS NULL OR @ToID = @FromID
		RETURN 0
	
	INSERT INTO [MailItem]
		([State], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	SELECT
		1,
		[ResourceRequest].[FileAs],
		@EventType,
		@FromID,
		@ToID,
		@DocumentClass,
		@DocumentID,
		0,
		@Data,
		[ResourceRequest].[Comments]
	FROM
		[ResourceRequest]
	WHERE
		[ResourceRequest].[ID] = @DocumentID
		
	RETURN 0
GO

  