IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceRequestGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceRequestGet'
		DROP PROCEDURE [dbo].[pjm5ServiceRequestGet]
	END
GO

PRINT 'Creating procedure pjm5ServiceRequestGet'
GO

/******************************************************************************
**		File: pjm5ServiceRequestGet.sql
**		Name: pjm5ServiceRequestGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 08/02/2005 14:07:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceRequestGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier,
		@UserID TIdentifier
	
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))	
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @UserID = dbo.adfGetCurrentUserID()
	
	DECLARE
		@Class TClass,
		@RecurrencePatternID TIdentifier
	SET @Class = dbo.adfGetClassByName('Pjm5.ServiceRequest')
	SELECT @RecurrencePatternID = [RecurrencePatternID] FROM [Document] WHERE [Document].[Class] = @Class AND [Document].[ID] = @ID

	SELECT
		[ServiceRequest].[Class],
		[ServiceRequest].[ID],
		[ServiceRequest].[ProjectID],
		[Project].[SupplierCompanyID],
		[Project].[CustomerCompanyID],
		[ServiceRequest].[EmployeeID],
		[ServiceRequest].[PriorityID],
		[ServiceRequest].[State],
		[ServiceRequest].[Flag],
		[ServiceRequest].[Date],
		[ServiceRequest].[Number],
		[ServiceRequest].[FileAs],
		[ServiceRequest].[StartDate],
		[ServiceRequest].[DueDate],
		[ServiceRequest].[Billable],
		[ServiceRequest].[VATIsIncluded],
		[ServiceRequest].[Total],
		[ServiceRequest].[TotalWithVAT],
		[ServiceRequest].[VAT],
		[ServiceRequest].[ServiceTypeID],
		[ServiceRequest].[Comments],
		[ServiceRequest].[Created],
		[ServiceRequest].[CreatedBy],
		[ServiceRequest].[Modified],
		[ServiceRequest].[ModifiedBy],
		[ServiceRequest].[Timestamp],
		[Project].[ProjectTypeID],
		[Project].[CurrencyCode],
		[Project].[ContractNumber],
		[Project].[ApplyVAT] AS [ProjectApplyVAT],
		CASE 
			WHEN (@ViewAllFinance = 1 OR
				dbo.fnPjm5HasFinansDataAccess([Project].[ID], @CurrentEmployeeID, NULL, NULL) = 1 OR
				dbo.fnPjm5IsProjectApprover([Project].[ID], @CurrentEmployeeID) = 1) AND [Project].[ProjectTypeID] = 1
				THEN 1
			ELSE 0
		END AS [FinanceEnable],
		ISNULL([UserReminder].[State], CAST(0 as int)) AS [ReminderState],
		ISNULL([UserReminder].[OriginalInterval], dbo.fnPjm5GetReminderInterval([ServiceRequest].[Class], 'SD', @UserID)) AS [ReminderInterval],
		[ServiceRequest].[Description],
		@RecurrencePatternID AS [RecurrencePatternID],
		[ServiceRequest].[ManHour],
		[ServiceRequest].[ActualManHour],
		[ServiceRequest].[ActualBudget]
	FROM
		[ServiceRequest]
		INNER JOIN [Project]
			ON [Project].[ID] = [ServiceRequest].[ProjectID]
		LEFT OUTER JOIN [Reminder]
			ON ([Reminder].[DocumentClass] = [ServiceRequest].[Class] AND
				[Reminder].[DocumentID] = [ServiceRequest].[ID] AND
				[Reminder].[Subtype] = 'SD')
		LEFT OUTER JOIN [UserReminder]
			ON ([Reminder].[ID] = [UserReminder].[ReminderID] AND
				[UserReminder].[UserID] = @UserID)
	WHERE
		[ServiceRequest].[ID] = @ID
	--IF @@ROWCOUNT = 0
	--	RETURN 1
	
	SELECT
		[ServiceRequestLine].[ID],
		[ServiceRequestLine].[ServiceRequestID],
		[ServiceRequestLine].[ServiceAssignmentID],
		[ServiceAssignment].[FileAs],
		[ServiceRequestLine].[Description],
		[ServiceRequestLine].[RequestAmount],
		[ServiceRequestLine].[FactAmount],
		CASE 
			WHEN @ViewAllFinance = 1 OR
				dbo.fnPjm5HasFinansDataAccess([Project].[ID], @CurrentEmployeeID, NULL, NULL) = 1 OR
				dbo.fnPjm5IsProjectApprover([Project].[ID], @CurrentEmployeeID) = 1
				THEN [ServiceRequestLine].[Price]
			ELSE -1
		END AS [Price],
		CASE 
			WHEN @ViewAllFinance = 1 OR
				dbo.fnPjm5HasFinansDataAccess([Project].[ID], @CurrentEmployeeID, NULL, NULL) = 1 OR
				dbo.fnPjm5IsProjectApprover([Project].[ID], @CurrentEmployeeID) = 1
				THEN [ServiceRequestLine].[Price] * [ServiceRequestLine].[FactAmount] 
			ELSE -1
		END AS [Sum],
		[UOM].[Code] AS [Unit],
		[Service].[Code]
	FROM
		[ServiceRequestLine]
		INNER JOIN [ServiceAssignment]
			ON [ServiceAssignment].[ID] = [ServiceRequestLine].[ServiceAssignmentID]
		INNER JOIN [Service]
			ON [ServiceAssignment].[ServiceID] = [Service].[ID]
		INNER JOIN [ServiceRequest]
			ON [ServiceRequest].[ID] = [ServiceRequestLine].[ServiceRequestID]
		INNER JOIN [Project]
			ON [Project].[ID] = [ServiceRequest].[ProjectID]
		LEFT OUTER JOIN [UOM]
			ON [UOM].[ID] = [Service].[UOMID]
	WHERE
		([ServiceRequestLine].[ServiceRequestID] = @ID)
	
	SELECT
		[RecurrencePattern].[ID],
		[RecurrencePattern].[StartDate],
		[RecurrencePattern].[EndDate],
		[RecurrencePattern].[Occurrences],
		[RecurrencePattern].[RecurrenceType],
		[RecurrencePattern].[Interval],
		[RecurrencePattern].[DayOfWeekMask],
		[RecurrencePattern].[Instance],
		[RecurrencePattern].[MonthOfYear],
		[RecurrencePattern].[DayOfMonth]
	FROM
		[RecurrencePattern]
	WHERE
		[RecurrencePattern].[ID] = @RecurrencePatternID

	RETURN 0
GO

GRANT EXECUTE ON [pjm5ServiceRequestGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceRequestDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceRequestDelete'
		DROP PROCEDURE [dbo].[pjm5ServiceRequestDelete]
	END
GO

PRINT 'Creating procedure pjm5ServiceRequestDelete'
GO

/******************************************************************************
**		File: pjm5ServiceRequestDelete.sql
**		Name: pjm5ServiceRequestDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 08/02/2005 14:07:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    28.06.10		KOV				    
*******************************************************************************/
CREATE PROCEDURE pjm5ServiceRequestDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
		IF EXISTS(SELECT * FROM [SuperTimer] 
					WHERE [SuperTimer].[DocumentClass] = dbo.adfGetClassByName('Pjm5.ServiceRequest') AND [SuperTimer].[DocumentID] = @ID AND 
					([SuperTimer].[State] in (1,2) OR ([SuperTimer].[State] = 3 AND [SuperTimer].[Persistent] = 1)))
	BEGIN
		RAISERROR('#CannotDeleteDocumentWithActiveTimer', 18, -1)
		RETURN 1
	END	
	DELETE FROM [ServiceRequest] WHERE [ServiceRequest].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceRequestDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceRequestChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceRequestChangeState'
		DROP PROCEDURE [dbo].[pjm5ServiceRequestChangeState]
	END
GO

PRINT 'Creating procedure pjm5ServiceRequestChangeState'
GO

/******************************************************************************
**		File: pjm5ServiceRequestChangeState.sql
**		Name: pjm5ServiceRequestChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 08/02/2005 14:07:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    14.05.10		SYV				  pjm6DismissEventsOnObject 
**    24.08.10		SYV				  pjm6DismissEventsOnObject .. 
**									         
*******************************************************************************/
CREATE PROCEDURE pjm5ServiceRequestChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@EmployeeID TIdentifier,
			@DivisionID TIdentifier,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass,
			@rv int
	
	SET NOCOUNT ON
	SELECT
		@Class = [ServiceRequest].[Class],
		@FromState = [ServiceRequest].[State],
		@EmployeeID = [ServiceRequest].[EmployeeID],
		@DivisionID = [Employee].[DivisionID]
	FROM
		[ServiceRequest]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [ServiceRequest].[EmployeeID]
	WHERE
		[ServiceRequest].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF @FromState = 1 AND @ToState = 2 AND @EmployeeID IS NULL-- 
	BEGIN
		RAISERROR('#ServiceRequestExecutorNotFound', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION	
	IF @FromState = 2 AND @ToState = 3
	BEGIN
		EXEC @rv = pjm5ServiceRequestCreateRecurrence @ID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	UPDATE
		[ServiceRequest]
	SET
		[ServiceRequest].[DivisionID] = CASE 
			WHEN @FromState = 3 AND @ToState = 4
				THEN @DivisionID
			ELSE [ServiceRequest].[DivisionID]
		END,
		[ServiceRequest].[State] = @ToState,
		[ServiceRequest].[Modified] = GETDATE(),
		[ServiceRequest].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[ServiceRequest].[ID] = @ID
	AND
		[ServiceRequest].[State] = @FromState

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF @ToState = 4
	BEGIN
		DECLARE 
			@ReminderID TIdentifier
			
		SET @ReminderID = (SELECT [ID] FROM [Reminder] WHERE DocumentClass = @Class AND DocumentID = @ID)
		
		EXEC @rv = pjm5AllUserReminderDismiss @ReminderID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	/*IF (@ToState = 4 OR @ToState = 5 OR @ToState = 6)
	BEGIN
		EXEC pjm6DismissEventsOnObject @Class, @ID
	END*/
	
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceRequestChangeState TO PUBLIC
GO
