IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceRequestUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceRequestUpdate'
		DROP PROCEDURE [dbo].[pjm5ServiceRequestUpdate]
	END
GO

PRINT 'Creating procedure pjm5ServiceRequestUpdate'
GO

/******************************************************************************
**		File: pjm5ServiceRequestUpdate.sql
**		Name: pjm5ServiceRequestUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 08/02/2005 14:07:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.07.10	MAN				 ,     .
*******************************************************************************/
CREATE PROCEDURE pjm5ServiceRequestUpdate
	@Xml XML
AS
	DECLARE @ID TIdentifier,
			@EmployeeID TIdentifier,
			@ProjectID TIdentifier,
			@ExecutorID TIdentifier,
			@PriorityID TIdentifier,
			@Date TDate,
			@Number TCode,
			@FileAs TName,
			@StartDate TDate,
			@DueDate TDate,
			@Billable TBool,
			@VATIsIncluded TBool,
			@ServiceTypeID TIdentifier,
			@Comments TNotes,
			@Description TNotes,
			@doc int,
			@RecurrenceID TIdentifier,
			@ReminderState TState,
			@ReminderInterval TTimeSpan,
			@ManHour TCount

	DECLARE -- RECURRENCE
		@RStartDate TDate, 
		@REndDate TDate, 
		@RRecurrenceType TIdentifier, 
		@ROccurrences TCount,
		@RInterval TCount, 
		@RDayOfWeekMask TIdentifier, 
		@RInstance TIdentifier, 
		@RMonthOfYear TCount, 
		@RDayOfMonth TCount,
		@Recurrence TBool
	
	SET NOCOUNT ON
	
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	
	SELECT
		@ID = [XmlTable].[ID],
		@ProjectID = [XmlTable].[ProjectID],
		@ExecutorID = [XmlTable].[EmployeeID],
		@PriorityID = [XmlTable].[PriorityID],
		@Date = CONVERT(datetime, [XmlTable].[Date]),
		@Number = ISNULL([XmlTable].[Number], ''),
		@FileAs = ISNULL([XmlTable].[FileAs], ''),
		@StartDate = [XmlTable].[StartDate],
		@DueDate = [XmlTable].[DueDate],
		@Billable = CASE WHEN [XmlTable].[Billable] = 'false' THEN 0 ELSE 1 END,
		@VATIsIncluded = CASE WHEN [XmlTable].[VATIsIncluded] = 'false' THEN 0 ELSE 1 END,
		@ServiceTypeID = [XmlTable].[ServiceTypeID],
		@Comments = [XmlTable].[Comments],
		@Description = [XmlTable].[Description],
		@RecurrenceID = [XmlTable].[RecurrencePatternID],
		@ReminderState = CASE WHEN [XmlTable].[ReminderState] = 'false' THEN 0 ELSE 1 END,
		@ReminderInterval = [XmlTable].[ReminderInterval],
		@ManHour = [XmlTable].[ManHour]
	FROM
		OPENXML(@doc, '/pjm5ServiceRequestGet/ServiceRequest', 2)
			WITH (
			[ID] int 'ID',
			[ProjectID] int 'ProjectID',
			[EmployeeID] int 'EmployeeID',
			[PriorityID] int 'PriorityID',
			[Date] nvarchar(19) 'Date',
			[Number] varchar(32) 'Number',
			[FileAs] nvarchar(512) 'FileAs',
			[StartDate] nvarchar(19) 'StartDate',
			[DueDate] nvarchar(19) 'DueDate',
			[Billable] varchar(5) 'Billable',
			[VATIsIncluded] varchar(5) 'VATIsIncluded',
			[ServiceTypeID] int 'ServiceTypeID',
			[Comments] nvarchar(max) 'Comments',
			[Description] nvarchar(max) 'Description',
			[RecurrencePatternID] int,
			[ReminderState] varchar(5) 'ReminderState',
			[ReminderInterval] int 'ReminderInterval',
			[ManHour] int 'ManHour'
			) AS [XmlTable]
			
		
	SET @Recurrence = 0
	IF EXISTS(SELECT * FROM OPENXML(@doc, '/pjm5ServiceRequestGet/RecurrencePattern', 2) WITH ([ID] int))
	BEGIN
		SET @Recurrence = 1
		SELECT
			@RStartDate = [XmlTable].[StartDate], 
			@REndDate = [XmlTable].[EndDate], 
			@RRecurrenceType = [XmlTable].[RecurrenceType], 
			@ROccurrences = [XmlTable].[Occurrences],
			@RInterval = [XmlTable].[Interval], 
			@RDayOfWeekMask = [XmlTable].[DayOfWeekMask], 
			@RInstance = [XmlTable].[Instance], 
			@RMonthOfYear = [XmlTable].[MonthOfYear], 
			@RDayOfMonth = [XmlTable].[DayOfMonth]
		FROM
			OPENXML(@doc, '/pjm5ServiceRequestGet/RecurrencePattern', 2)
			WITH (
				[StartDate] varchar(19), 
				[EndDate] varchar(19), 
				[RecurrenceType] int, 
				[Occurrences] int,
				[Interval] int, 
				[DayOfWeekMask] int, 
				[Instance] int, 
				[MonthOfYear] int, 
				[DayOfMonth] int
				) as [XmlTable] 
	END
	EXEC sp_xml_removedocument @doc

	IF dbo.fnPjm5AllowCreateProjectEntry(@ProjectID, NULL) = 0 AND
		dbo.fnPjm5IsProjectMember(@ProjectID, @EmployeeID) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	BEGIN
		IF NOT EXISTS(SELECT * FROM [vwAssignment] WHERE [ProjectID] = @ProjectID AND [EmployeeID] = @ExecutorID AND [State]=1)
		BEGIN
			RAISERROR('#notassignedtospecifiedproject', 18, -1)
			RETURN 1
		END
	END
	
	DECLARE
		@Total TMoney,
		@TotalWithVAT TMoney,
		@VATRate TPercent,
		@value TVariant		
	
	EXEC adfParameterGet @Name='VATRate', @Group='CommonBusiness', @Value = @value OUTPUT
	SET	@VATRate = ISNULL(CAST(@value as decimal(18,4)), 0)
	
	SELECT
		@Total = SUM(CASE @VATIsIncluded
					WHEN 0 THEN ISNULL(([ServiceRequestLine].[FactAmount] * [ServiceRequestLine].[Price]), 0.00) 
					ELSE ISNULL(ROUND(([ServiceRequestLine].[FactAmount] * [ServiceRequestLine].[Price] / (1 + @VATRate)), 2), 0.00)
				END),	
		@TotalWithVAT = SUM(CASE @VATIsIncluded
					WHEN 0 THEN ISNULL(ROUND(([ServiceRequestLine].[FactAmount] * [ServiceRequestLine].[Price] * (1 + @VATRate)), 2), 0.00)
					ELSE ISNULL(([ServiceRequestLine].[FactAmount] * [ServiceRequestLine].[Price]), 0.00)
				END)
	FROM
		[ServiceRequestLine]
	WHERE
		[ServiceRequestLine].[ServiceRequestID] = @ID
	
	DECLARE 
		@Class TClass,
		@State TState
	SELECT
		@State = [State],
		@Class = [Class]
	FROM
		[ServiceRequest]
	WHERE
		[ID] = @ID

	BEGIN TRANSACTION
	IF @State IN (1, 2)
	BEGIN
		IF @Recurrence = 0 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE [Document] SET [RecurrencePatternID] = NULL WHERE [Class] = @Class AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NULL
		BEGIN
			INSERT INTO [RecurrencePattern]
				([StartDate], [EndDate], [RecurrenceType], [Occurrences],
				[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
			VALUES
				(@RStartDate, @REndDate, @RRecurrenceType, @ROccurrences,
				@RInterval, @RDayOfWeekMask, @RInstance, @RMonthOfYear, @RDayOfMonth)
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			SET @RecurrenceID = SCOPE_IDENTITY()
			
			UPDATE [Document] SET [RecurrencePatternID] = @RecurrenceID WHERE [Class] = @Class AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE
				[RecurrencePattern]
			SET
				[StartDate] = @RStartDate, 
				[EndDate] = @REndDate, 
				[RecurrenceType] = @RRecurrenceType, 
				[Occurrences] = @ROccurrences,
				[Interval] = @RInterval, 
				[DayOfWeekMask] = @RDayOfWeekMask, 
				[Instance] = @RInstance, 
				[MonthOfYear] = @RMonthOfYear, 
				[DayOfMonth] = @RDayOfMonth
			WHERE
				[ID] = @RecurrenceID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END

	UPDATE 
		[ServiceRequest]
	SET
		[ServiceRequest].[ProjectID] = @ProjectID,
		[ServiceRequest].[EmployeeID] = @ExecutorID,
		[ServiceRequest].[PriorityID] = @PriorityID,
		[ServiceRequest].[Date] = @Date,
		[ServiceRequest].[Number] = @Number,
		[ServiceRequest].[FileAs] = @FileAs,
		[ServiceRequest].[StartDate] = @StartDate,
		[ServiceRequest].[DueDate] = @DueDate,
		[ServiceRequest].[Billable] = @Billable,
		[ServiceRequest].[VATIsIncluded] = @VATIsIncluded,
		[ServiceRequest].[ServiceTypeID] = @ServiceTypeID,
		[ServiceRequest].[Total] = ISNULL(@Total, 0),
		[ServiceRequest].[TotalWithVAT] = ISNULL(@TotalWithVAT, 0),
		[ServiceRequest].[Comments] = @Comments,
		[ServiceRequest].[Description] = @Description,
		[ServiceRequest].[Modified] = GETDATE(),
		[ServiceRequest].[ModifiedBy] = dbo.adfGetCurrentUserID(),
		[ServiceRequest].[ManHour] = ISNULL(@ManHour, 0)
	WHERE
		[ServiceRequest].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DECLARE @rv int
	EXEC @rv = pjm5ServiceRequestReminderCreate @ID,
		@DueDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	COMMIT TRANSACTION
	
	EXEC pjm5ServiceRequestGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceRequestUpdate TO PUBLIC
GO 