IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5StatementCreateSimple]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5StatementCreateSimple'
		DROP PROCEDURE [dbo].[pjm5StatementCreateSimple]
	END
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5StatementCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5StatementCreate'
		DROP PROCEDURE [dbo].[pjm5StatementCreate]
	END
GO

PRINT 'Creating procedure pjm5StatementCreate'
GO

/******************************************************************************
**		File: pjm5StatementCreate.sql
**		Name: pjm5StatementCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5StatementCreate]
	@Xml XML
AS
	DECLARE @State TState,
			@ID TIdentifier,
			@ProjectID TIdentifier,
			@PeriodStart TDate,
			@PeriodEnd TDate,
			@Date TDate,
			@FileAs TName,
			@Number TName,
			@Comments TNotes,
			@ApplyVAT bit,
			@VATRate TPercent,
			@ProjectType TIdentifier,
			@value TVariant,
			@doc int,
			@rv int,
			@ProjectCurrencyCode TCode3,
			@CurrencyCode TCode3,
			@CurrencyRate TMoney,
			@BaseCurrencyRate TMoney,
			@ReminderState TState,
			@ReminderInterval TTimeSpan,
			@ReminderTime TDateTime,
			@ReturnDate TDate,
			@UserID TIdentifier,
			@StatementClass TClass,
			@SupplierCompanyID TIdentifier,
			@CustomerCompanyID TIdentifier,
			@Scale TCount
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('5f1bcdeb-edaf-44ae-bcc0-3d37e6516a60')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	DECLARE @BaseCurrencyCode TCode3
	EXEC adfParameterGet @Name='BaseCurrency', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @BaseCurrencyCode = CAST(@value as varchar(3))

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	SELECT
		@Date = [XmlTable].[Date],
		@ProjectID = [XmlTable].[ProjectID],
		@Number = ISNULL([XmlTable].[Number], ''),
		@FileAs = [XmlTable].[FileAs],
		@PeriodStart = ISNULL([XmlTable].[PeriodStart], @Date),
		@PeriodEnd = ISNULL([XmlTable].[PeriodEnd], @Date),
		@Comments = [XmlTable].[Comments],
		@ApplyVAT = [Project].[ApplyVAT],
		@VATRate = 0,
		@ProjectType = [Project].[ProjectTypeID],
		@CurrencyCode = [XmlTable].[CurrencyCode],
		@CurrencyRate = [XmlTable].[CurrencyRate],
		@BaseCurrencyRate = [XmlTable].[BaseCurrencyRate],
		@ProjectCurrencyCode = [Project].[CurrencyCode],
		@ReturnDate = CONVERT(datetime, [XmlTable].[ReturnDate]),
		@ReminderState = CASE [XmlTable].[ReminderState] WHEN 'false' THEN 0 ELSE 1 END,
		@ReminderTime = CONVERT(datetime, [XmlTable].[ReminderTime]),
		@SupplierCompanyID = [XmlTable].[SupplierCompanyID],
		@CustomerCompanyID = [XmlTable].[CustomerCompanyID],
		@Scale = [Project].[Scale]
	FROM
		OPENXML(@doc, '/pjm5StatementGet/Statement', 2)
			WITH (
				[Date] nvarchar(19),
				[Number] varchar(32),
				[FileAs] nvarchar(512),
				[ProjectID] int,
				[PeriodStart] nvarchar(19),
				[PeriodEnd] nvarchar(19),
				[CurrencyCode] char(3),
				[CurrencyRate] decimal(18, 4),
				[BaseCurrencyRate] decimal(18, 4),
				[Comments] nvarchar(max),
				[ReminderState] varchar(5),
				[ReminderTime] varchar(19),
				[ReturnDate] varchar(19),
				[SupplierCompanyID] int,
				[CustomerCompanyID] int
				) AS [XmlTable]
		INNER JOIN [Project]
			ON [Project].[ID] = [XmlTable].[ProjectID]

	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllStatements')) = 0 AND
		dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END	
	
	IF @ProjectType NOT IN (1, 2)
	BEGIN
		RAISERROR('#wrongprojecttype', 18, -1)
		RETURN 1
	END

	SELECT
		@Date = CAST(CONVERT(varchar(8), @Date, 112) AS DATETIME),
		@PeriodStart = CAST(CONVERT(varchar(8), @PeriodStart, 112) AS DATETIME),
		@PeriodEnd = CAST(CONVERT(varchar(8), @PeriodEnd, 112) AS DATETIME)
		
	IF @BaseCurrencyCode = @ProjectCurrencyCode
		SET @BaseCurrencyRate = 1.0
	IF @ProjectCurrencyCode = @CurrencyCode
		SET @CurrencyRate = 1.0
	
	DECLARE @DefaultReturnDays int
	SET @value = 5
	EXEC adfParameterGet @Name='StatementReturnPeriod', @Group='Pjm5', @Value = @value OUTPUT
	SET @DefaultReturnDays = CAST(@value as int)
	IF @ReturnDate IS NULL
	BEGIN
		SET @ReturnDate = DATEADD(day, @DefaultReturnDays, @Date)
	END
	
	SELECT
		@UserID = dbo.adfGetCurrentUserID(),
		@StatementClass = dbo.adfGetClassByName('Pjm5.Statement'),
		@ReminderState = dbo.fnPjm5GetUserInitialReminderState(@StatementClass, 'MD', @UserID),
		@ReminderInterval = dbo.fnPjm5GetReminderInterval(@StatementClass, 'MD', @UserID)

	BEGIN TRANSACTION
	-----------------------------------------rec-----------------------------------------------------
	DECLARE
		@RecurrenceID TIdentifier,
		@RStartDate TDatetime, 
		@REndDate TDatetime, 
		@RRecurrenceType TIdentifier, 
		@ROccurrences TCount,
		@RInterval TCount, 
		@RDayOfWeekMask TIdentifier, 
		@RInstance TIdentifier, 
		@RMonthOfYear TCount, 
		@RDayOfMonth TCount
	SELECT
		@RStartDate = CAST([StartDate] as datetime),
		@REndDate = CAST([EndDate] as datetime),
		@RRecurrenceType = [RecurrenceType],
		@ROccurrences = [Occurrences],
		@RInterval = [Interval],
		@RDayOfWeekMask = [DayOfWeekMask],
		@RInstance = [Instance],
		@RMonthOfYear = [MonthOfYear],
		@RDayOfMonth = [DayOfMonth]
	FROM
		OPENXML(@doc, '/pjm5StatementGet/RecurrencePattern', 2)
			WITH (
				[StartDate] varchar(19) 'StartDate',
				[EndDate] varchar(19) 'EndDate',
				[RecurrenceType] int 'RecurrenceType',
				[Occurrences] int 'Occurrences',
				[Interval] int 'Interval',
				[DayOfWeekMask] int 'DayOfWeekMask',
				[Instance] int 'Instance',
				[MonthOfYear] int 'MonthOfYear',
				[DayOfMonth] int 'DayOfMonth'
				)

	
	IF @RRecurrenceType IS NOT NULL
	BEGIN
		INSERT INTO [RecurrencePattern]
			([StartDate], [EndDate], [RecurrenceType], [Occurrences],
			[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
		VALUES
			(@RStartDate, @REndDate, @RRecurrenceType, @ROccurrences,
			@RInterval, @RDayOfWeekMask, @RInstance, @RMonthOfYear, @RDayOfMonth)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
		SET @RecurrenceID = SCOPE_IDENTITY()
	END
	--------------------------------------------------------------------------

	INSERT INTO [Statement]
		([Flag], [State], [Date], [Number], [FileAs], [ProjectID],
		 [Periodical], 
		 [CurrencyCode], [CurrencyRate], [BaseCurrencyRate],
		 [PeriodStart], [PeriodEnd], 
		 [Comments],
		 [TotalPC], [TotalWithVATPC], [TotalBC], [TotalWithVATBC], [ReturnDate],
		 [SupplierCompanyID], [CustomerCompanyID],
		 [Scale])
	VALUES
		(0, @State, @Date, @Number, @FileAs, @ProjectID,
		0,
		@CurrencyCode, @CurrencyRate, @BaseCurrencyRate,
		@PeriodStart, @PeriodEnd, 
		@Comments,
		0,0,0,0, @ReturnDate,
		@SupplierCompanyID, @CustomerCompanyID,
		@Scale)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()

	IF @RecurrenceID IS NOT NULL
	BEGIN
		UPDATE
			[Document]
		SET
			[RecurrencePatternID] = @RecurrenceID
		WHERE
			[Class] = @StatementClass AND [ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
	END
	
	EXEC @rv = pjm5StatementReminderCreate @ID,
		@ReturnDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	COMMIT TRANSACTION
	EXEC sp_xml_removedocument @doc

	EXEC pjm5StatementGet @ID
	RETURN 0
GO

GRANT EXECUTE ON pjm5StatementCreate TO PUBLIC
GO

