IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5StatementDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5StatementDelete'
		DROP PROCEDURE [dbo].[pjm5StatementDelete]
	END
GO

PRINT 'Creating procedure pjm5StatementDelete'
GO

/******************************************************************************
**		File: pjm5StatementDelete.sql
**		Name: pjm5StatementDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    28.06.10		KOV				    
*******************************************************************************/
CREATE PROCEDURE pjm5StatementDelete
	@ID TIdentifier,
	@Forced TBool
AS
	SET NOCOUNT ON
	
	DECLARE @ProjectID TIdentifier
	SELECT @ProjectID = [ProjectID] FROM [Statement] WHERE [ID] = @ID
	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllStatements')) = 0 AND
		dbo.fnPjm5IsProjectManager(@ProjectID, @EmployeeID) = 0 AND
		dbo.fnPjm5IsProjectMember(@ProjectID, @EmployeeID) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END	
	IF EXISTS(SELECT * FROM [SuperTimer] 
					WHERE [SuperTimer].[DocumentClass] = dbo.adfGetClassByName('Pjm5.Statement') AND [SuperTimer].[DocumentID] = @ID AND 
					([SuperTimer].[State] in (1,2) OR ([SuperTimer].[State] = 3 AND [SuperTimer].[Persistent] = 1)))
	BEGIN
		RAISERROR('#CannotDeleteDocumentWithActiveTimer', 18, -1)
		RETURN 1
	END		
	BEGIN TRANSACTION
	DELETE FROM [StatementLine] WHERE [StatementID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	INSERT INTO [RemovedDocument] ( [DocumentID], [DocumentClass], [DocumentNumber], [DocumentDate], [Date])
	SELECT
		[Statement].[ID],
		[Statement].[Class],
		[Statement].[Number],
		[Statement].[Date],
		GETDATE()
	FROM
		[Statement]
	WHERE
		[Statement].[ID] = @ID

	DELETE FROM [Statement] WHERE [Statement].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON pjm5StatementDelete TO PUBLIC
GO
