IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskCreate'
		DROP PROCEDURE [dbo].[pjm5TaskCreate]
	END
GO

PRINT 'Creating procedure pjm5TaskCreate'
GO

/******************************************************************************
**		File: pjm5TaskCreate.sql
**		Name: pjm5TaskCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5TaskCreate]
	@Xml XML
AS
	DECLARE @State TState,
			@ID TIdentifier,
			@FileAs TName,
			@ProjectID TIdentifier,
			@PriorityID TIdentifier,
			@ParentID TIdentifier,
			@StartDate TDate,
			@DueDate TDate,
			@EndDate TDate,
			@Duration TAmount,
			@Estimated TBool,
			@ManHour TAmount,
			@Budget TMoney,
			@PercentComplete TPercent,
			@Milestone TBool,
			@SendStatusReport TBool,
			@Comments TNotes,
			@AssignmentState TState,
			@CurrencyCode TCode3,
			@EmployeeID TIdentifier,
			@AssignmentID TIdentifier,
			@value TVariant,
			@sendToExecute bit,
			@ProjectState TState,
			@CurrentEmployeeID TIdentifier,
			@ReminderState TState,
			@ReminderTime TDateTime,
			@ReminderInterval TTimeSpan,
			@MsProjectID TIdentifier,
			@TaskIndex TCount,
			@Wbs TName,
			@rv int,
			@doc int
	
	SET NOCOUNT ON
	
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	SELECT
		@ProjectID = [XmlTable].[ProjectID],
		@ManHour = [XmlTable].[ManHour], 
		@Budget = [XmlTable].[Budget],
		@PercentComplete = [XmlTable].[PercentComplete],
		@CurrencyCode = [Project].[CurrencyCode],
		@FileAs = [XmlTable].[FileAs],
		@PriorityID = [XmlTable].[PriorityID],
		@StartDate = CAST([XmlTable].[StartDate] as datetime),
		@DueDate = CAST([XmlTable].[DueDate] as datetime),
		@Duration = [XmlTable].[Duration],
		@Milestone = (CASE [XmlTable].[Milestone] WHEN 'false' THEN 0 ELSE 1 END),
		@SendStatusReport = (CASE [XmlTable].[SendStatusReport] WHEN 'false' THEN 0 ELSE 1 END),
		@Comments = [XmlTable].[Comments],
		@ProjectState = [Project].[State],
		@ReminderState = (CASE [XmlTable].[ReminderState] WHEN 'false' THEN 0 ELSE 1 END),
		@ReminderTime = CAST([XmlTable].[ReminderTime] as datetime),
		@TaskIndex = [XmlTable].[TaskIndex],
		@Wbs = [XmlTable].[Wbs]
	FROM
		OPENXML(@doc, '/pjm5TaskGet/Task', 2)
			WITH (
				[ProjectID] int,
				[ManHour] decimal(18,4),
				[Budget] money,
				[PercentComplete] int,
				[FileAs] nvarchar(256),
				[PriorityID] int,
				[StartDate] varchar(19),
				[DueDate] varchar(19),
				[EndDate] varchar(19),
				[Duration] decimal(18,4),
				[Milestone] varchar(5),
				[SendStatusReport] varchar(5),
				[Comments] nvarchar(max),
				[ReminderState] varchar(5),
				[ReminderTime] varchar(19),
				[TaskIndex] int,
				[Wbs] nvarchar(256)
			) AS [XmlTable]
		INNER JOIN [Project]
			ON [XmlTable].[ProjectID] = [Project].[ID]
	
	IF(EXISTS(SELECT *FROM [Budget] WHERE [DocumentID] = @ProjectID AND [DocumentClass] = dbo.adfGetClassByName('Pjm5.Project')))
	BEGIN
		RAISERROR('#ProjectHasBudgetPlanning', 18, -1)
		RETURN 1
	END

	SELECT @MsProjectID = [MsProjectID] FROM [Project] WHERE [ID] = @ProjectID
	IF @MsProjectID IS NOT NULL
	BEGIN
		RAISERROR('#documentfrommsproject', 18, -1)
		RETURN 1
	END
			
	IF @ManHour IS NOT NULL AND @ManHour < 0
	BEGIN
		RAISERROR('#ManHourIsInvalid', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	IF @ProjectState IN (5, 6)
		SET @State = 7 --Template
	ELSE
	BEGIN
		SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
		IF dbo.fnPjm5IsProjectMember(@ProjectID, @CurrentEmployeeID) = 0 AND
			dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
		SET @State = 8 -- New
	END

	IF @ProjectState IN (2, 3)
	BEGIN
		EXEC adfParameterGet @Name='StartTaskAfterCreate', @Group='Pjm5', @Value = @value OUTPUT
	END
	SET @sendToExecute = ISNULL(CAST(@value as bit), 0)
	
	DECLARE
		@employees TABLE (
			[ID] int,
			[Class] int,
			[FileAs] varchar(256),
			[Units] decimal(18,4),
			[Work] int,
			[ProjectID] int
			)
	INSERT INTO @employees
	SELECT 
		[ID],
		[Class],
		[FileAs],
		[Units],
		[Work],
		@ProjectID AS [ProjectID]
	FROM
		OPENXML(@doc, '/pjm5TaskGet/BusinessCard', 2)
			WITH (
				[ID] int,
				[Class] int,
				[Units] decimal(18,4),
				[Work] int,
				[FileAs] nvarchar(256)
				)
				
	DECLARE @busyEntry TABLE ([AssignmentID] int, [TaskID] int, [Date] datetime, [Planned] int, [Committed] bit)
	INSERT INTO @busyEntry ([AssignmentID], [Date], [Planned], [Committed])
	SELECT
		[TaskAssignmentBooking].[AssignmentID],
		CAST([TaskAssignmentBooking].[Date] AS datetime),
		[TaskAssignmentBooking].[Planned],
		(CASE [TaskAssignmentBooking].[Committed] WHEN 'false' THEN 0 ELSE 1 END)
	FROM
		OPENXML(@doc, '/pjm5TaskGet/TaskAssignmentBooking', 2)
			WITH (
				[TaskID] int,
				[AssignmentID] int,
				[Date] varchar(19),
				[Planned] int,
				[Committed] varchar(5)
				) AS [TaskAssignmentBooking]
	IF @@ERROR != 0
	BEGIN
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	EXEC sp_xml_removedocument @doc
	
	IF (@State = 7)
		SET @AssignmentState = 3 --Template
	ELSE
		SET @AssignmentState = 4 -- New

	SELECT
		@Budget = SUM([BC].[Work] * [Assignment].[StandardRate] / 60.0)
	FROM
		@employees AS [BC]
		INNER JOIN [Assignment]
			ON [BC].[ID] = [Assignment].[ID]
	
	IF @TaskIndex IS NULL
	BEGIN
		SELECT 
			@TaskIndex = MAX([TaskWbs].[TaskIndex])
		FROM 
			[TaskWbs] 
			INNER JOIN [Task]
				ON [Task].[ID] = [TaskWbs].[TaskID]
		WHERE 
			[Task].[ProjectID] = @ProjectID
		SET @TaskIndex = ISNULL(@TaskIndex, 0) + 1
	END
	
	IF NOT EXISTS(SELECT * FROM @employees)
		SET @ManHour = 0
	BEGIN TRANSACTION
	INSERT INTO [Task]
		([State], [Flag], [FileAs], [ProjectID], 
		[PriorityID], 
		[StartDate], [DueDate], 
		[Duration], 
		[ManHour], [Budget],
		[PercentComplete], 
		[Milestone], [SendStatusReport], 
		[Comments])
	VALUES (
		@State, 0, @FileAs, @ProjectID,
		@PriorityID, 
		@StartDate, @DueDate,
		@Duration, 
		CAST(@ManHour * 60 AS int), @Budget,
		CAST(@PercentComplete as decimal(5, 2)) / CAST(100 as decimal(5, 2)),
		@Milestone, @SendStatusReport, 
		@Comments)
				
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()
	
	EXEC @rv = pjm6TaskUpdateWbs @ID, @TaskIndex, @Wbs
	--UPDATE [TaskWbs] SET [TaskIndex] = @TaskIndex WHERE [TaskID] = @ID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	IF EXISTS(SELECT * FROM @employees)
	BEGIN
		INSERT INTO [TaskAssignment] ([TaskID], [AssignmentID], [Units], [Work], [RemainingWork])
		SELECT
			@ID,
			[BC].[ID],
			[BC].[Units],
			[BC].[Work],
			[BC].[Work]
		FROM
			@employees AS [BC]

		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	IF EXISTS(SELECT * FROM @busyEntry)
	BEGIN
		INSERT INTO [BusyEntry] ([AssignmentID], [ProjectID], [TaskID], [Date], [EmployeeID], [Planned])
		SELECT
			[vwAssignment].[ID],
			[vwAssignment].[ProjectID],
			@ID,
			[TaskAssignmentBooking].[Date],
			[vwAssignment].[EmployeeID],
			[TaskAssignmentBooking].[Planned]
		FROM
			@busyEntry AS [TaskAssignmentBooking]
			INNER JOIN [vwAssignment]
				ON [vwAssignment].[ID] = [TaskAssignmentBooking].[AssignmentID]
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	IF @sendToExecute = 1
	BEGIN
		EXEC @rv = pjm5TaskChangeState @ID, 1
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END

	SET @ReminderInterval = DATEDIFF(minute, @ReminderTime, @DueDate)
	EXEC @rv = pjm5TaskReminderCreate @ID,
		@DueDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	COMMIT TRANSACTION

	EXEC pjm5TaskGet @ID
	RETURN 0
GO

GRANT EXECUTE ON pjm5TaskCreate TO PUBLIC
GO
 