IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskRequestCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskRequestCreate'
		DROP PROCEDURE [dbo].[pjm5TaskRequestCreate]
	END
GO

PRINT 'Creating procedure pjm5TaskRequestCreate'
GO

/******************************************************************************
**		File: pjm5TaskRequestCreate.sql
**		Name: pjm5TaskRequestCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/21/2006 18:26:20
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.07.10	MAN				 ,     .
*******************************************************************************/
CREATE PROCEDURE [pjm5TaskRequestCreate]
	@Xml XML
AS
	DECLARE @State TState,
			@ID TIdentifier,
			@FileAs TName,
			@ProjectID TIdentifier,
			@PriorityID TIdentifier,
			@DueTime TDateTime,
			@StartTime TDateTime,
			@SendStatusReport TBool,
			@TaskRequestStatusID TIdentifier,
			@PercentComplete int,
			@Comments TNotes,
			@ExternalID TExternalIdentifier,
			@ReminderState TState,
			@ReminderInterval TTimeSpan,
			@doc INT,

			@DocumentCardID TIdentifier,
			@EmployeeID TIdentifier,
			@SupervisorEmployeeID TIdentifier,
			@EndTime TDateTime,
			@Resolution TNotes,
			@DocumentEditAccess TBool,
			@ManHour TCount,
			@Budget TMoney,
			@ActualManHour TCount,
			@ActualBudget TMoney
	
	SET NOCOUNT ON
	
	DECLARE @Class TClass
	SET @Class = dbo.adfGetClassByName('Pjm5.TaskRequest')
	
	SET @State = dbo.adfwfGetInitialState('87a91fee-cef2-4262-9019-30f8c6effd9d')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	
	

	SELECT
		@DocumentCardID = [DocumentCardID],
		@FileAs = [FileAs],
		@ProjectID = [ProjectID],
		@EmployeeID = [EmployeeID],
		@SupervisorEmployeeID = [SupervisorEmployeeID],
		@PriorityID = [PriorityID],
		@PercentComplete = [PercentComplete],
		@DueTime = CAST([DueTime] as datetime),
		@StartTime = CAST([StartTime] as datetime),
		@EndTime = CAST([EndTime] as datetime),
		@SendStatusReport = (CASE [SendStatusReport] WHEN 'false' THEN 0 ELSE 1 END),
		@TaskRequestStatusID = [TaskRequestStatusID],
		@Resolution = [Resolution],
		@DocumentEditAccess = [DocumentEditAccess],
		@Comments = [Comments],
		@ReminderState = (CASE [ReminderState] WHEN 'false' THEN 0 ELSE 1 END),
		@ReminderInterval = [ReminderInterval],
		@ManHour = ISNULL([ManHour], 0),
		@Budget = ISNULL([Budget], 0),
		@ActualManHour = 0,
		@ActualBudget = 0
	FROM
		OPENXML(@doc, '/pjm5TaskRequestGet/TaskRequest', 2)
			WITH (
				[DocumentCardID] int,
				[FileAs] nvarchar(256),
				[ProjectID] int,
				[EmployeeID] int,
				[SupervisorEmployeeID] int,
				[PriorityID] int,
				[PercentComplete] int,
				[DueTime] varchar(19),
				[StartTime] varchar(19),
				[EndTime] varchar(19),
				[SendStatusReport] varchar(5),
				[TaskRequestStatusID] int,
				[Resolution] nvarchar(max),
				[DocumentEditAccess] bit,
				[Comments] nvarchar(max),
				[ReminderState] varchar(5),
				[ReminderInterval] int,
				[ManHour] int,
				[Budget] decimal(18,4)
			)


	IF @ProjectID IS NOT NULL 
	BEGIN 
		IF ((SELECT COUNT(*)
             FROM OPENXML (@doc, '/pjm5TaskRequestGet/TaskRequestAssignment', 2) 
             WITH ([EmployeeID] INT) AS [XmlTable]) !=
			(SELECT COUNT(*) AS Expr1
			 FROM vwAssignment
			 WHERE (ProjectID = @ProjectID) AND (State = 1) AND [EmployeeID] IN
                    (SELECT EmployeeID
                     FROM OPENXML (@doc, '/pjm5TaskRequestGet/TaskRequestAssignment', 2) 
                     WITH ([EmployeeID] INT) AS [XmlTable])
            )) 
		BEGIN 
			RAISERROR ('#notassignedtospecifiedproject', 18, - 1) 
			RETURN 1 
		END 
	END
	
	
	DECLARE
		@RecurrenceID TIdentifier,
		@RStartDate TDatetime, 
		@REndDate TDatetime, 
		@RRecurrenceType TIdentifier, 
		@ROccurrences TCount,
		@RInterval TCount, 
		@RDayOfWeekMask TIdentifier, 
		@RInstance TIdentifier, 
		@RMonthOfYear TCount, 
		@RDayOfMonth TCount
	SELECT
		@RStartDate = CAST([StartDate] as datetime),
		@REndDate = CAST([EndDate] as datetime),
		@RRecurrenceType = [RecurrenceType],
		@ROccurrences = [Occurrences],
		@RInterval = [Interval],
		@RDayOfWeekMask = [DayOfWeekMask],
		@RInstance = [Instance],
		@RMonthOfYear = [MonthOfYear],
		@RDayOfMonth = [DayOfMonth]
	FROM
		OPENXML(@doc, '/pjm5TaskRequestGet/RecurrencePattern', 2)
			WITH (
				[StartDate] varchar(19) 'StartDate',
				[EndDate] varchar(19) 'EndDate',
				[RecurrenceType] int 'RecurrenceType',
				[Occurrences] int 'Occurrences',
				[Interval] int 'Interval',
				[DayOfWeekMask] int 'DayOfWeekMask',
				[Instance] int 'Instance',
				[MonthOfYear] int 'MonthOfYear',
				[DayOfMonth] int 'DayOfMonth'
				)
	IF @DueTime IS NULL AND @RRecurrenceType IS NOT NULL
		SET @DueTime = @RStartDate
	ELSE IF @DueTime IS NOT NULL AND @RRecurrenceType IS NOT NULL
	BEGIN	
		IF CAST(CONVERT(varchar(8), @DueTime, 112) AS datetime) < @RStartDate
			SET @RStartDate = CAST(CONVERT(varchar(8), @DueTime, 112) AS datetime)
	END
	
	BEGIN TRANSACTION
	IF @RRecurrenceType IS NOT NULL
	BEGIN
		INSERT INTO [RecurrencePattern]
			([StartDate], [EndDate], [RecurrenceType], [Occurrences],
			[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
		VALUES
			(@RStartDate, @REndDate, @RRecurrenceType, @ROccurrences,
			@RInterval, @RDayOfWeekMask, @RInstance, @RMonthOfYear, @RDayOfMonth)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
		SET @RecurrenceID = SCOPE_IDENTITY()
	END

	INSERT INTO [TaskRequest]
		([Flag], [State], [FileAs], [ProjectID], [PriorityID], [DueTime], [StartTime], 
		[SendStatusReport], [TaskRequestStatusID], 
		[PercentComplete], [Comments],
		[DocumentCardID], [EmployeeID], [SupervisorEmployeeID], [EndTime], [Resolution], [DocumentEditAccess],
		[ManHour], [Budget], [ActualManHour], [ActualBudget])
	VALUES
		(0, @State, @FileAs, @ProjectID, @PriorityID, @DueTime, @StartTime, 
		@SendStatusReport, @TaskRequestStatusID, 
		CAST(@PercentComplete as decimal(5, 2)) / CAST(100 as decimal(5, 2)), @Comments,
		@DocumentCardID, @EmployeeID, @SupervisorEmployeeID, @EndTime, @Resolution, @DocumentEditAccess,
		@ManHour, @Budget, @ActualManHour, @ActualBudget)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()
	
	INSERT INTO [TaskRequestAssignment]
		([TaskRequestID], [EmployeeID])
	SELECT
		@ID, [EmployeeID]
	FROM
		OPENXML(@doc, '/pjm5TaskRequestGet/TaskRequestAssignment', 2)	
			WITH ([EmployeeID] INT)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	DECLARE @Employee TIdentifier
		SET @Employee = (SELECT [ID] FROM [Employee] WHERE [UserID] = dbo.adfGetCurrentUserID())
	UPDATE [TaskRequestAssignment] SET [Accepted] = 1 WHERE [TaskRequestID] = @ID and
		[EmployeeID] = @Employee 
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	IF @RecurrenceID IS NOT NULL
	BEGIN
		UPDATE
			[Document]
		SET
			[RecurrencePatternID] = @RecurrenceID
		WHERE
			[Class] = @Class AND [ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
	END
	
	DECLARE @rv int		
	EXEC @rv = pjm5TaskRequestReminderCreate @ID,
		@DueTime, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN @rv
	END
	
	EXEC @rv = pjm6TaskRequestAutoAssign @ID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN @rv
	END
	
	COMMIT TRANSACTION
	
	EXEC sp_xml_removedocument @doc
	
	EXEC pjm5TaskRequestGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5TaskRequestCreate TO PUBLIC
GO
 