IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskRequestSendResponse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6TaskRequestSendResponse'
		DROP PROCEDURE [dbo].[pjm6TaskRequestSendResponse]
	END
GO

PRINT 'Creating procedure pjm6TaskRequestSendResponse'
GO
/******************************************************************************
**		File: pjm6TaskRequestSendResponse.sql
**		Name: pjm6TaskRequestSendResponse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 29/10/2009 16:28:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6TaskRequestSendResponse]
	@TaskRequestID TIdentifier,
	@ResponseType TCode,
	@FileAs TName,
	@Comments TNotes
AS

SET NOCOUNT ON
	DECLARE 
		@CurrentUserID TIdentifier,
		@CurrentEmployeeID TIdentifier,
		@Author TIdentifier,
		@Employee TIdentifier,
		@Supervisor TIdentifier
		
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SELECT
		@Author = [TaskRequest].[CreatedBy],
		@Employee = [TaskRequest].[EmployeeID],
		@Supervisor = [TaskRequest].[SupervisorEmployeeID]
	FROM
		[TaskRequest]
	WHERE
		[TaskRequest].[ID] = @TaskRequestID
	
	BEGIN TRANSACTION
	
	IF(@ResponseType = 'Accept')
	BEGIN
		UPDATE 
			[TaskRequestAssignment] 
		SET
			[Accepted] = (CASE WHEN @ResponseType = 'Accept' THEN 1 
				WHEN @ResponseType = 'Decline' THEN 0 END)
		WHERE 
			[TaskRequestID] = @TaskRequestID AND
			[EmployeeID] = @CurrentEmployeeID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		COMMIT TRANSACTION
		
		IF @CurrentUserID != @Author
			EXEC pjm6TaskRequestAssignmentAcceptNotification @TaskRequestID, @Author, @FileAs, @Comments
		IF @Supervisor IS NOT NULL
		BEGIN
			SELECT @Supervisor = [UserID] FROM [Employee] WHERE [ID] = @Supervisor
			IF @CurrentUserID != @Supervisor AND @Author != @Supervisor
				EXEC pjm6TaskRequestAssignmentAcceptNotification @TaskRequestID, @Supervisor, @FileAs, @Comments
		END
	END
	ELSE IF(@ResponseType = 'Decline')
	BEGIN
		DELETE 
			[TaskRequestAssignment]
		WHERE 
			[TaskRequestID] = @TaskRequestID AND
			[EmployeeID] = @CurrentEmployeeID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		UPDATE
			[TaskRequestAssignmentResponse]
		SET
			[TaskRequestAssignmentResponse].[Response] = 2
		WHERE
			[TaskRequestAssignmentResponse].[TaskRequestID] = @TaskRequestID AND
			[TaskRequestAssignmentResponse].[EmployeeID] = @CurrentEmployeeID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END	
		
		DECLARE @ReminderID TIdentifier, @result int
		SELECT 
			@ReminderID = [ID]
		FROM 
			[Reminder]
		WHERE 
			[DocumentClass] = dbo.adfGetClassByName('Pjm5.TaskRequest') 
			AND 
			[DocumentID] = @TaskRequestID 
			AND
			[Subtype] = 'RD'
			
		IF @ReminderID IS NOT NULL
		BEGIN
			EXEC @result = pjm5ReminderDismiss @ReminderID
			IF @result != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		
		COMMIT TRANSACTION
			
		IF @CurrentEmployeeID = @Employee
			EXEC pjm6TaskRequestDeclineEmployee @TaskRequestID

		IF @CurrentUserID != @Author
			EXEC pjm6TaskRequestAssignmentDeclineNotification @TaskRequestID, @Author, @FileAs, @Comments
		IF @Supervisor IS NOT NULL
		BEGIN
			SELECT @Supervisor = [UserID] FROM [Employee] WHERE [ID] = @Supervisor
			IF @CurrentUserID != @Supervisor AND @Author != @Supervisor
				EXEC pjm6TaskRequestAssignmentDeclineNotification @TaskRequestID, @Supervisor, @FileAs, @Comments
		END
	END
	RETURN 0
GO	


GRANT EXECUTE ON pjm6TaskRequestSendResponse TO PUBLIC
GO
 