IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskRequestUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskRequestUpdate'
		DROP PROCEDURE [dbo].[pjm5TaskRequestUpdate]
	END
GO

PRINT 'Creating procedure pjm5TaskRequestUpdate'
GO

/******************************************************************************
**		File: pjm5TaskRequestUpdate.sql
**		Name: pjm5TaskRequestUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/21/2006 18:26:20
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.07.10	MAN				 ,     .
*******************************************************************************/
CREATE PROCEDURE pjm5TaskRequestUpdate
	@Xml XML
AS
	DECLARE 	
		@ID TIdentifier,
		@FileAs TName,
		@ProjectID TIdentifier,
		@PriorityID TIdentifier,
		@DueTime TDateTime,
		@StartTime TDateTime,
		@SendStatusReport TBool,
		@TaskRequestStatusID TIdentifier,
		@PercentComplete int,
		@Comments TNotes,
		@doc int,
		@CurrentUserID TIdentifier,
		@CurrentEmployeeID TIdentifier,
		@RecurrenceID TIdentifier,
		@ReminderState TState,
		@ReminderInterval TTimeSpan,

		@DocumentCardID TIdentifier,
		@EmployeeID TIdentifier,
		@SupervisorEmployeeID TIdentifier,
		@EndTime TDateTime,
		@Resolution TNotes,
		@DocumentEditAccess TBool,
		@ManageAllTaskRequest TBool,
		@ManHour TCount,
		@Budget TMoney
		
	SET @ManageAllTaskRequest = dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllTaskRequest'))
	
	DECLARE -- RECURRENCE
		@RStartDate TDate, 
		@REndDate TDate, 
		@RRecurrenceType TIdentifier, 
		@ROccurrences TCount,
		@RInterval TCount, 
		@RDayOfWeekMask TIdentifier, 
		@RInstance TIdentifier, 
		@RMonthOfYear TCount, 
		@RDayOfMonth TCount,
		@Recurrence TBool,
		@Class TClass,
		@State TState,
		@Creator TIdentifier
	
	SET NOCOUNT ON
	
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	SELECT
		@DocumentCardID = [DocumentCardID],
		@ID = [ID],
		@FileAs = [FileAs],
		@ProjectID = [ProjectID],
		@EmployeeID = [EmployeeID],
		@SupervisorEmployeeID = [SupervisorEmployeeID],
		@PriorityID = [PriorityID],
		@PercentComplete = [PercentComplete],
		@DueTime = CAST([DueTime] as datetime),
		@StartTime = CAST([StartTime] as datetime),
		@EndTime = CAST([EndTime] as datetime),
		@SendStatusReport = (CASE [SendStatusReport] WHEN 'false' THEN 0 ELSE 1 END),
		@TaskRequestStatusID = [TaskRequestStatusID],
		@RecurrenceID = [RecurrencePatternID],
		@Resolution = [Resolution],
		@DocumentEditAccess = [DocumentEditAccess],
		@Comments = [Comments],
		@ReminderState = (CASE [ReminderState] WHEN 'false' THEN 0 ELSE 1 END),
		@ReminderInterval = [ReminderInterval],
		@ManHour = [ManHour],
		@Budget = [Budget]
	FROM
		OPENXML(@doc, '/pjm5TaskRequestGet/TaskRequest', 2)
			WITH (
				[ID] int,
				[DocumentCardID] int,
				[FileAs] nvarchar(256),
				[ProjectID] int,
				[EmployeeID] int,
				[SupervisorEmployeeID] int,
				[PriorityID] int,
				[PercentComplete] int,
				[DueTime] varchar(19),
				[StartTime] varchar(19),
				[EndTime] varchar(19),
				[SendStatusReport] varchar(5),
				[TaskRequestStatusID] int,
				[Resolution] nvarchar(max),
				[DocumentEditAccess] bit,
				[Comments] nvarchar(max),
				[RecurrencePatternID] int,
				[ReminderState] varchar(5),
				[ReminderInterval] int,
				[ManHour] int,
				[Budget] decimal(18,4)
			)
	
	IF @ProjectID IS NOT NULL 
	BEGIN 
		IF ((SELECT COUNT(*)
             FROM OPENXML (@doc, '/pjm5TaskRequestGet/TaskRequestAssignment', 2) 
             WITH ([EmployeeID] INT) AS [XmlTable]) !=
			(SELECT COUNT(*) AS Expr1
			 FROM vwAssignment
			 WHERE (ProjectID = @ProjectID) AND (State = 1) AND [EmployeeID] IN
                    (SELECT EmployeeID
                     FROM OPENXML (@doc, '/pjm5TaskRequestGet/TaskRequestAssignment', 2) 
                     WITH ([EmployeeID] INT) AS [XmlTable])
            )) 
		BEGIN 
			RAISERROR ('#notassignedtospecifiedproject', 18, - 1) 
			RETURN 1 
		END 
	END

	IF EXISTS
	(
		SELECT *
		FROM
			[TaskRequest]
		WHERE
			[TaskRequest].[ID] = @ID AND
			@ManageAllTaskRequest <> 1 AND
			[CreatedBy] <> @CurrentUserID AND
			dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) <> 1 AND
			--   
			(
				ISNULL([EmployeeID], 0) <> ISNULL(@EmployeeID, 0) OR
				ISNULL([PercentComplete], 0) <> ISNULL(@PercentComplete, 0) AND
				ISNULL(@SupervisorEmployeeID, 0) <> @CurrentEmployeeID AND			
				ISNULL(@EmployeeID, 0) <> @CurrentEmployeeID
			)
	)
	BEGIN
		RAISERROR('#NotEnoughPermissionsForUpdate', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	
	
	SET @Recurrence = 0
	IF EXISTS(SELECT * FROM OPENXML(@doc, '/pjm5TaskRequestGet/RecurrencePattern', 2) WITH ([ID] int))
	BEGIN
		SET @Recurrence = 1
		SELECT
			@RStartDate = [XmlTable].[StartDate], 
			@REndDate = [XmlTable].[EndDate], 
			@RRecurrenceType = [XmlTable].[RecurrenceType], 
			@ROccurrences = [XmlTable].[Occurrences],
			@RInterval = [XmlTable].[Interval], 
			@RDayOfWeekMask = [XmlTable].[DayOfWeekMask], 
			@RInstance = [XmlTable].[Instance], 
			@RMonthOfYear = [XmlTable].[MonthOfYear], 
			@RDayOfMonth = [XmlTable].[DayOfMonth]
		FROM
			OPENXML(@doc, '/pjm5TaskRequestGet/RecurrencePattern', 2)
			WITH (
				[StartDate] varchar(19), 
				[EndDate] varchar(19), 
				[RecurrenceType] int, 
				[Occurrences] int,
				[Interval] int, 
				[DayOfWeekMask] int, 
				[Instance] int, 
				[MonthOfYear] int, 
				[DayOfMonth] int
				) as [XmlTable] 
	END
	
	IF @DueTime IS NULL AND @Recurrence = 1
		SET @DueTime = @RStartDate
	ELSE IF @DueTime IS NOT NULL AND @Recurrence = 1
	BEGIN	
		IF CAST(CONVERT(varchar(8), @DueTime, 112) AS datetime) < @RStartDate
			SET @RStartDate = CAST(CONVERT(varchar(8), @DueTime, 112) AS datetime)
	END

	SELECT
		@State = [State],
		@Class = [Class],
		@Creator = [CreatedBy]
	FROM
		[TaskRequest]
	WHERE
		[ID] = @ID

	BEGIN TRANSACTION
	IF @State IN (1, 2)
	BEGIN
		IF @Recurrence = 0 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE [Document] SET [RecurrencePatternID] = NULL WHERE [Class] = @Class AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				EXEC sp_xml_removedocument @doc
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NULL
		BEGIN
			INSERT INTO [RecurrencePattern]
				([StartDate], [EndDate], [RecurrenceType], [Occurrences],
				[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
			VALUES
				(@RStartDate, @REndDate, @RRecurrenceType, @ROccurrences,
				@RInterval, @RDayOfWeekMask, @RInstance, @RMonthOfYear, @RDayOfMonth)
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				EXEC sp_xml_removedocument @doc
				RETURN 1
			END
			SET @RecurrenceID = SCOPE_IDENTITY()
			
			UPDATE [Document] SET [RecurrencePatternID] = @RecurrenceID WHERE [Class] = @Class AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				EXEC sp_xml_removedocument @doc
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE
				[RecurrencePattern]
			SET
				[StartDate] = @RStartDate, 
				[EndDate] = @REndDate, 
				[RecurrenceType] = @RRecurrenceType, 
				[Occurrences] = @ROccurrences,
				[Interval] = @RInterval, 
				[DayOfWeekMask] = @RDayOfWeekMask, 
				[Instance] = @RInstance, 
				[MonthOfYear] = @RMonthOfYear, 
				[DayOfMonth] = @RDayOfMonth
			WHERE
				[ID] = @RecurrenceID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				EXEC sp_xml_removedocument @doc
				RETURN 1
			END
		END
	END

	IF @State IN (1, 2, 4) AND
		(
		@ManageAllTaskRequest = 1 OR
		@Creator = @CurrentUserID OR 
		@SupervisorEmployeeID = @CurrentEmployeeID OR
		dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 1
		)
	BEGIN
		UPDATE [TaskRequest]
		SET
			[TaskRequest].[FileAs] = @FileAs,
			[TaskRequest].[DocumentCardID] = @DocumentCardID,
			[TaskRequest].[ProjectID] = @ProjectID,
			[TaskRequest].[EmployeeID] = @EmployeeID,
			[TaskRequest].[SupervisorEmployeeID] = @SupervisorEmployeeID,
			[TaskRequest].[PriorityID] = @PriorityID,
			[TaskRequest].[DueTime] = @DueTime,
			[TaskRequest].[StartTime] = @StartTime,
			[TaskRequest].[EndTime] = @EndTime,
			[TaskRequest].[SendStatusReport] = @SendStatusReport,
			[TaskRequest].[TaskRequestStatusID] = @TaskRequestStatusID,
			[TaskRequest].[PercentComplete] = CAST(@PercentComplete as decimal(5, 2)) / CAST(100 as decimal(5, 2)),
			[TaskRequest].[Resolution] = @Resolution,
			[TaskRequest].[DocumentEditAccess] = @DocumentEditAccess,
			[TaskRequest].[Comments] = @Comments,
			[TaskRequest].[Modified] = DEFAULT,
			[TaskRequest].[ModifiedBy] = DEFAULT,
			[TaskRequest].[ManHour] = ISNULL(@ManHour, 0),
			[TaskRequest].[Budget] = ISNULL(@Budget, 0)
		WHERE
			[TaskRequest].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
	
		DELETE 
			[TaskRequestAssignment]
		FROM
			[TaskRequestAssignment]
		WHERE 
			[TaskRequestID] = @ID AND
			NOT EXISTS(
				SELECT *
				FROM OPENXML(@doc, '/pjm5TaskRequestGet/TaskRequestAssignment', 2) WITH ([EmployeeID] INT) AS [XmlTable]
				WHERE [XmlTable].[EmployeeID] = [TaskRequestAssignment].[EmployeeID]
			)		
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
		
		DELETE 
			[TaskRequestAssignmentResponse]
		FROM
			[TaskRequestAssignmentResponse]
		WHERE 
			[TaskRequestID] = @ID AND
			NOT EXISTS(
				SELECT *
				FROM OPENXML(@doc, '/pjm5TaskRequestGet/TaskRequestAssignment', 2) WITH ([EmployeeID] INT) AS [XmlTable]
				WHERE [XmlTable].[EmployeeID] = [TaskRequestAssignmentResponse].[EmployeeID]
			)		
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
		
		INSERT INTO [TaskRequestAssignment]
			([TaskRequestID], [EmployeeID])
		SELECT
			@ID, [EmployeeID]
		FROM
			OPENXML(@doc, '/pjm5TaskRequestGet/TaskRequestAssignment', 2) WITH ([EmployeeID] INT) AS [XmlTable]
		WHERE
			NOT EXISTS(
				SELECT *
				FROM [TaskRequestAssignment]
				WHERE 
					[TaskRequestAssignment].[TaskRequestID] = @ID AND
					[XmlTable].[EmployeeID] = [TaskRequestAssignment].[EmployeeID]
			)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
		
		DECLARE @OriginatorEmployeeID TIdentifier
		SET @OriginatorEmployeeID = (SELECT [ID] FROM [Employee] WHERE [UserID] = (SELECT [CreatedBy] FROM [TaskRequest] WHERE ID = @ID))
		IF @OriginatorEmployeeID IS NOT NULL
		BEGIN
			IF EXISTS (SELECT @ID, [EmployeeID]
				FROM
				OPENXML(@doc, '/pjm5TaskRequestGet/TaskRequestAssignment', 2) WITH ([EmployeeID] INT) AS [XmlTable]
				WHERE [EmployeeID] = @OriginatorEmployeeID)
			BEGIN
				UPDATE [TaskRequestAssignment] SET [Accepted] = 1 WHERE [TaskRequestID] = @ID AND [EmployeeID] = @OriginatorEmployeeID 
			END
		END
			
	END
	ELSE IF @State = 2
	BEGIN
		UPDATE [TaskRequest]
		SET
			[TaskRequest].[PriorityID] = @PriorityID,
			[TaskRequest].[TaskRequestStatusID] = @TaskRequestStatusID,
			[TaskRequest].[PercentComplete] = CAST(@PercentComplete as decimal(5, 2)) / CAST(100 as decimal(5, 2)),
			[TaskRequest].[EndTime] = @EndTime,
			[TaskRequest].[Resolution] = @Resolution,
			[TaskRequest].[DocumentEditAccess] = @DocumentEditAccess,
			[TaskRequest].[Modified] = DEFAULT,
			[TaskRequest].[ModifiedBy] = DEFAULT,
			[TaskRequest].[ManHour] = ISNULL(@ManHour, 0),
			[TaskRequest].[Budget] = ISNULL(@Budget, 0)
		WHERE
			[TaskRequest].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
	END
	ELSE IF @State = 5
	BEGIN
		ROLLBACK TRANSACTION
		RAISERROR('#TransitionTemplateCouldNotBeFound', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	ELSE 
	BEGIN
		ROLLBACK TRANSACTION
		RAISERROR('#accessdenied', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	DECLARE @rv int		
	EXEC @rv = pjm5TaskRequestReminderCreate @ID,
		@DueTime, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN @rv
	END
	
	COMMIT TRANSACTION	

	EXEC pjm5TaskRequestGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5TaskRequestUpdate TO PUBLIC
GO
 