IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TimeEntryCopy]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6TimeEntryCopy'
		DROP PROCEDURE [dbo].[pjm6TimeEntryCopy]
	END
GO

PRINT 'Creating procedure pjm6TimeEntryCopy'
GO

/******************************************************************************
**		File: pjm6TimeEntryCopy.sql
**		Name: pjm6TimeEntryCopy
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		08.10.09	syv				 Rate    
**		13.10.09	syv				 AssignmentID    
**		13.10.09	syv				        Rate
**		28.01.09	pam				  
*******************************************************************************/
CREATE PROCEDURE [pjm6TimeEntryCopy]
	@ID TIdentifier,
	@StartTime TDateTime,
	@EndTime TDateTime,
	@Owner TIdentifier
AS
	SET NOCOUNT ON

	DECLARE
		@Class TClass,
		@NewID TIdentifier,
		@State TState,
		@UserID TIdentifier,
		@rv int
	
	DECLARE 
		@RoundedDuration TCount,
		@ProjectState TState,
		@Rate TMoney,
		@ActivityTypeIsMandatory bit,
		@value TVariant,
		@CurrentEmployeeID TIdentifier,
		@DivisionID TIdentifier,
		@Duration TCount,
		@Overtime TBool,
		@DocumentClass TClass,
		@DocumentID TIdentifier

	SET @Class = dbo.adfGetClassByName('Pjm5.TimeEntry')
	SET @UserID = dbo.adfGetCurrentUserID()

	SET @State = dbo.adfwfGetInitialState('6719512d-42ee-4848-a57e-f76500e67ee7')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	DECLARE @ProjectID TIdentifier, @TaskID TIdentifier, @EmployeeID TIdentifier
	DECLARE @InsertedVar TABLE(ID int,ProjectID int null, TaskID int null, EmployeeID int null)
	
	IF @EndTime IS NOT NULL
	BEGIN
		SET @Duration = DATEDIFF(minute, @StartTime, @EndTime)
		SELECT 
			@RoundedDuration = dbo.fnPjm5RoundedDuration(@Duration, [Project].[RoundingInterval], [Project].[RoundingMode]),
			@ProjectState = [Project].[State],
			@ProjectID = [TimeEntry].[ProjectID],
			@TaskID = [TimeEntry].[TaskID]
		FROM
			[TimeEntry]
			INNER JOIN [Project]
				ON [Project].[ID] = [TimeEntry].[ProjectID]
		WHERE
			[TimeEntry].[ID] = @ID
	END
	
	IF @Owner IS NULL
		SET @Owner = dbo.adfGetCurrentEmployeeID()
	SET @CurrentEmployeeID = (SELECT [EmployeeID] FROM [TimeEntry] WHERE [ID] = @ID)
	SELECT
		@Overtime = [TimeEntry].[Overtime],
		@DocumentID = [TimeEntry].[DocumentID],
		@ProjectID = [TimeEntry].[ProjectID],
		@DocumentClass = [TimeEntry].[DocumentClass]
	FROM
		[TimeEntry]
	WHERE
		[TimeEntry].[ID] = @ID
	
	DECLARE @AssignmentID TIdentifier
	IF @ProjectID IS NOT NULL
	BEGIN
		SELECT @AssignmentID = dbo.fnPjm5GetProjectAssignment(@ProjectID, @Owner)
		IF @AssignmentID IS NULL
		BEGIN
			RAISERROR('#assignmentnotfound', 18, -1)
			RETURN 1
		END
		SET @Rate = dbo.fnPjm5GetEmployeeRate(@Owner, @ProjectID, @Overtime, CASE @DocumentClass WHEN dbo.adfGetClassByName('Pjm5.ServiceAssignment') THEN @DocumentID ELSE NULL END, 0)
	END
	ELSE
	BEGIN
		SET @Rate = 0
	END

	BEGIN TRANSACTION
	INSERT INTO [TimeEntry]
		([State], [Flag], [FileAs], [ActivityTypeID], [EmployeeID], [AssignmentID], [ProjectID], [TaskID], 
		[StartTime], [Duration], [RoundedDuration], [Billable], 
		[Overtime], [Rate], [CurrencyCode], [VATRate], [Color],
		[Comments], [DocumentClass], [DocumentID], [DivisionID])
	OUTPUT INSERTED.ID, INSERTED.ProjectID, INSERTED.TaskID, INSERTED.EmployeeID INTO @InsertedVar
	SELECT
		@State,
		[TimeEntry].[Flag],
		[TimeEntry].[FileAs],
		[TimeEntry].[ActivityTypeID],
		@Owner,
		@AssignmentID,
		[TimeEntry].[ProjectID],
		[TimeEntry].[TaskID],
		
		ISNULL(@StartTime, [TimeEntry].[StartTime]),
		ISNULL(@Duration, [TimeEntry].[Duration]),
		ISNULL(@RoundedDuration, [TimeEntry].[RoundedDuration]),
		[TimeEntry].[Billable],
		
		[TimeEntry].[Overtime],
		@Rate,
		[TimeEntry].[CurrencyCode],
		[TimeEntry].[VATRate],
		[TimeEntry].[Color],
		
		[TimeEntry].[Comments],
		[TimeEntry].[DocumentClass],
		[TimeEntry].[DocumentID],
		[TimeEntry].[DivisionID]
	FROM
		[TimeEntry]
	WHERE
		[TimeEntry].[ID] = @ID
		
	IF @@error != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SELECT
		@NewID = [ID],
		@EmployeeID = [EmployeeID]
	FROM
		@InsertedVar
		
	IF @EmployeeID IS NULL
	BEGIN
		ROLLBACK TRANSACTION
		RAISERROR('#assignmentnotfound', 18, -1)
		RETURN 1
	END

	IF dbo.fnPjm5AllowCreateProjectEntry(@ProjectID, @EmployeeID) = 0
	BEGIN
		ROLLBACK TRANSACTION
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @ProjectID IS NOT NULL
	BEGIN
		IF @ProjectState != 2
		BEGIN
			ROLLBACK TRANSACTION
			RAISERROR('#ProjectIsNotActive', 18, -1)
			RETURN 1
		END

		IF @TaskID IS NOT NULL 
		BEGIN
			IF NOT EXISTS (SELECT * FROM [Task] WHERE [ID] = @TaskID AND [ProjectID] = @ProjectID)
			BEGIN
				ROLLBACK TRANSACTION
				RAISERROR('#TaskFromAnotherProject', 18, -1)
				RETURN 1
			END
			IF NOT EXISTS (SELECT * FROM [Task] WHERE [ID] = @TaskID AND [State] = 2)
			BEGIN
				ROLLBACK TRANSACTION
				RAISERROR('#TaskIsDraft', 18, -1)
				RETURN 1
			END
			IF dbo.fnPjm5IsTaskAssigned(@TaskID, @EmployeeID) = 0
			BEGIN
				ROLLBACK TRANSACTION
				RAISERROR('#taskassignmentnotfound', 18, -1)
				RETURN 1
			END
			IF EXISTS(SELECT * FROM [TaskAssignment] 
						WHERE [TaskID] = @TaskID AND [AssignmentID] = @AssignmentID AND [TaskAssignment].[MsAvailable] = 0)
			BEGIN
				ROLLBACK TRANSACTION
				RAISERROR('#taskassignmentnotfound', 18, -1)
				RETURN 1
			END			
		END
	END

	EXEC @rv = adfDocumentUDFCopy @Class, @ID, @NewID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	EXEC @rv = adfDocumentCategoryCopy @Class, @ID, @NewID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	EXEC @rv = adfDocumentContactCopy @Class, @ID, @NewID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	EXEC @rv = pjm5TimeEntryReminderCopy @Class, @ID, @NewID, @CurrentEmployeeID,@Owner
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	/*EXEC @rv = pjm6TaskAssignmentRemainingUpdate @NewID
	IF @rv = 1
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END*/
	
	IF @ProjectID IS NOT NULL
	BEGIN
		EXEC @rv = pjm5TimeEntryAutoApprove @NewID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END
	IF @TaskID IS NOT NULL
	BEGIN
		EXEC @rv = pjm6TaskPercentUpdate @TaskID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	COMMIT TRANSACTION
	SELECT @NewID
	RETURN 0
GO

GRANT EXECUTE ON [pjm6TimeEntryCopy] TO PUBLIC
GO

 