IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimeEntryUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimeEntryUpdate'
		DROP PROCEDURE [dbo].[pjm5TimeEntryUpdate]
	END
GO

PRINT 'Creating procedure pjm5TimeEntryUpdate'
GO

/******************************************************************************
**		File: pjm5TimeEntryUpdate.sql
**		Name: pjm5TimeEntryUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		06.10.09	SYV				  pjm6AssignmentCheckBudgetOverdraft
**		12.07.11	SYV				   
*******************************************************************************/
CREATE PROCEDURE pjm5TimeEntryUpdate 
	@Xml XML
AS
	DECLARE
		@Class TClass,
		@ID TIdentifier,
		@FileAs TName,
		@ActivityTypeID TIdentifier,
		@EmployeeID TIdentifier,
		@ProjectID TIdentifier,
		@DocumentClass TClass,
		@DocumentID TIdentifier,
		@TaskID TIdentifier,
		@StartTime TDateTime,
		@Duration TCount,
		@RoundedDuration TCount,
		@Billable TBool,
		@Overtime TBool,
		@Rate TMoney,
		@CurrencyCode TCode3,
		@VATRate TPercent,
		@Comments TNotes,
		@Doc int,
		@rv int,
		@MyEmployeeID int,
		@State TState,
		@Color TColor,
		@RecurrenceID TIdentifier,
		@ReminderState TState,
		@ReminderInterval TTimeSpan,
		@RemainingWork TAmount,
		@RemainingOvertimeWork TAmount,
		@PrevTaskID TIdentifier,
		@PrevAssignmentID Tidentifier,
		@PrevProgectID TIdentifier,
		@PrevEmployeeID TIdentifier,
		@result TBool

	DECLARE -- RECURRENCE
		@StartDate TDate, 
		@EndDate TDate, 
		@RecurrenceType TIdentifier, 
		@Occurrences TCount,
		@Interval TCount, 
		@DayOfWeekMask TIdentifier, 
		@Instance TIdentifier, 
		@MonthOfYear TCount, 
		@DayOfMonth TCount,
		@Recurrence TBool
	SET NOCOUNT ON

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	SELECT
		@ID = [XmlTable].[ID],
		@Class = [TimeEntry].[Class],
		@State = [TimeEntry].[State],
		@FileAs = [XmlTable].[FileAs],
		@ActivityTypeID = [XmlTable].[ActivityTypeID],
		@EmployeeID = [XmlTable].[EmployeeID],
		@ProjectID = [XmlTable].[ProjectID],
		@DocumentClass = dbo.adfGetClassByName([XmlTable].[DocumentClass]),
		@DocumentID = [XmlTable].[DocumentID],
		@TaskID = [XmlTable].[TaskID],
		@StartTime = CAST([XmlTable].[StartTime] as datetime),
		@Duration = [XmlTable].[Duration],
		@RoundedDuration = [XmlTable].[RoundedDuration],
		@Billable = (CASE WHEN [XmlTable].[Billable] = 'false' THEN 0 ELSE 1 END),
		@Overtime = (CASE WHEN [XmlTable].[Overtime] = 'false' THEN 0 ELSE 1 END),
		@CurrencyCode = [Project].[CurrencyCode],
		@VATRate = dbo.fnPjm5GetVATRate(),
		@Comments = [XmlTable].[Comments],
		@Color = [XmlTable].[Color],
		@RecurrenceID = [XmlTable].[RecurrencePatternID],
		@ReminderState = CASE WHEN [XmlTable].[ReminderState] = 'false' THEN 0 ELSE 1 END,
		@ReminderInterval = [XmlTable].[ReminderInterval],
		@RemainingWork = [XmlTable].[RemainingWork],
		@RemainingOvertimeWork = [XmlTable].[RemainingOvertimeWork],
		@PrevTaskID = [TimeEntry].[TaskID],
		@PrevEmployeeID = [TimeEntry].[EmployeeID],
		@PrevAssignmentID = dbo.fnPjm5GetProjectAssignment([TimeEntry].[ProjectID], [TimeEntry].[EmployeeID])
	FROM
		OPENXML(@doc, '/pjm5TimeEntryGet/TimeEntry', 2)
			WITH (
				[ID] int,
				[State] int,
				[FileAs] nvarchar(256),
				[ActivityTypeID] int,
				[EmployeeID] int,
				[ProjectID] int,
				[DocumentClass] varchar(32),
				[DocumentID] int,
				[TaskID] int,
				[StartTime] varchar(19),
				[Duration] int,
				[RoundedDuration] int,
				[Billable] varchar(5),
				[Overtime] varchar(5),
				[Comments] nvarchar(max),
				[Color] int,
				[RecurrencePatternID] int,
				[ReminderState] varchar(5),
				[ReminderInterval] int,
				[RemainingWork] decimal(18,4),
				[RemainingOvertimeWork] decimal(18,4)
				) as [XmlTable] 
		INNER JOIN [TimeEntry]
			ON [TimeEntry].[ID] = [XmlTable].[ID]
		LEFT OUTER JOIN [Project]
			ON [Project].[ID] = [TimeEntry].[ProjectID]
	
	SET @Recurrence = 0
	IF EXISTS(SELECT * FROM OPENXML(@doc, '/pjm5TimeEntryGet/RecurrencePattern', 2) WITH ([ID] int))
	BEGIN
		SET @Recurrence = 1
		SELECT
			@StartDate = [XmlTable].[StartDate], 
			@EndDate = [XmlTable].[EndDate], 
			@RecurrenceType = [XmlTable].[RecurrenceType], 
			@Occurrences = [XmlTable].[Occurrences],
			@Interval = [XmlTable].[Interval], 
			@DayOfWeekMask = [XmlTable].[DayOfWeekMask], 
			@Instance = [XmlTable].[Instance], 
			@MonthOfYear = [XmlTable].[MonthOfYear], 
			@DayOfMonth = [XmlTable].[DayOfMonth]
		FROM
			OPENXML(@doc, '/pjm5TimeEntryGet/RecurrencePattern', 2)
			WITH (
				[StartDate] varchar(19), 
				[EndDate] varchar(19), 
				[RecurrenceType] int, 
				[Occurrences] int,
				[Interval] int, 
				[DayOfWeekMask] int, 
				[Instance] int, 
				[MonthOfYear] int, 
				[DayOfMonth] int
				) as [XmlTable] 
	END
	EXEC sp_xml_removedocument @doc
	
	IF @TaskID IS NOT NULL
	BEGIN
		IF (dbo.fnPjm5IsTaskAssigned(@TaskID, @EmployeeID) = 0)
		BEGIN
			RAISERROR('#NotAssignmentByTask', 18, -1)
			RETURN 1
		END
	END
	
	DECLARE @AssignmentID TIdentifier
	SET @AssignmentID = dbo.fnPjm5GetProjectAssignment(@ProjectID, @EmployeeID)




	/*IF @PrevTaskID IS NOT NULL AND @PrevAssignmentID IS NOT NULL AND
		(@PrevTaskID != ISNULL(@TaskID, 0) OR @PrevAssignmentID != ISNULL(@AssignmentID, 0)) AND*/
	
	
/*	IF @TaskID IS NOT NULL AND @AssignmentID IS NOT NULL AND
		(ISNULL(@PrevTaskID, 0) != @TaskID OR ISNULL(@PrevAssignmentID, 0) != @AssignmentID) AND
		@State = 2
		EXEC @result = pjm6AssignmentCheckBudgetOverdraft @TaskID, @AssignmentID, NULL
	IF @result = 1
		RETURN 1
	*/
--	IF @State = 2
--		EXEC @result = pjm6AssignmentCheckBudgetOverdraft @TaskID, @AssignmentID, @ID
	
--	IF @result = 1
--		RETURN 1




	BEGIN TRANSACTION
	IF @State = 1
	BEGIN
		IF @Recurrence = 0 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE [Document] SET [RecurrencePatternID] = NULL WHERE [Class] = @Class AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NULL
		BEGIN
			INSERT INTO [RecurrencePattern]
				([StartDate], [EndDate], [RecurrenceType], [Occurrences],
				[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
			VALUES
				(@StartDate, @EndDate, @RecurrenceType, @Occurrences,
				@Interval, @DayOfWeekMask, @Instance, @MonthOfYear, @DayOfMonth)
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			SET @RecurrenceID = SCOPE_IDENTITY()
			
			UPDATE [Document] SET [RecurrencePatternID] = @RecurrenceID WHERE [Class] = @Class AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE
				[RecurrencePattern]
			SET
				[StartDate] = @StartDate, 
				[EndDate] = @EndDate, 
				[RecurrenceType] = @RecurrenceType, 
				[Occurrences] = @Occurrences,
				[Interval] = @Interval, 
				[DayOfWeekMask] = @DayOfWeekMask, 
				[Instance] = @Instance, 
				[MonthOfYear] = @MonthOfYear, 
				[DayOfMonth] = @DayOfMonth
			WHERE
				[ID] = @RecurrenceID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END

	EXEC @rv = pjm5TimeEntryUpdateInternal
		@ID,
		@FileAs,
		@ActivityTypeID,
		@EmployeeID,
		@ProjectID,
		@DocumentClass,
		@DocumentID,
		@TaskID,
		@StartTime,
		@Duration,
		@Billable,
		@Overtime,
		@CurrencyCode,
		@VATRate,
		@Color,
		@Comments,
		@PrevEmployeeID

	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	IF @State = 5
	BEGIN
		EXEC @rv = pjm5TimeEntryChangeState @ID, 1
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	IF @State = 6
	BEGIN
		ROLLBACK TRANSACTION
		RAISERROR('#CannotApproveCalculationTimeEntry', 18, -1)
		RETURN 1
	END
	
	
	IF @DocumentID IS NULL SET @DocumentClass = NULL
	EXEC @rv = pjm5TimeEntryUpdateInternal
		@ID,
		@FileAs,
		@ActivityTypeID,
		@EmployeeID,
		@ProjectID,
		@DocumentClass,
		@DocumentID,
		@TaskID,
		@StartTime,
		@Duration,
		@Billable,
		@Overtime,
		@CurrencyCode,
		@VATRate,
		@Color,
		@Comments,
		@PrevEmployeeID

	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	EXEC @rv = pjm5TimeEntryReminderCreate @ID,
		@StartTime, @ReminderState,	@ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	/* IF @PrevTaskID != ISNULL(@TaskID, 0) OR @PrevAssignmentID != ISNULL(@AssignmentID, 0)
	BEGIN
		UPDATE [TaskAssignment]
		SET 
			[RemainingWork] = [RemainingWork] + @Duration,
			[RemainingOvertimeWork] = CASE 
				WHEN ([Task].[MsTaskID] IS NOT NULL AND @Overtime = 1)
					THEN [RemainingOvertimeWork] + @Duration 
				ELSE [RemainingOvertimeWork] 
			END
		FROM
			[TaskAssignment]
			INNER JOIN [Task]
				ON [Task].[ID] = [TaskAssignment].[TaskID]
			INNER JOIN [Project]
				ON [Project].[ID] = [Task].[ProjectID]
		WHERE
			[TaskID] = @PrevTaskID AND
			[AssignmentID] = @PrevAssignmentID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
		
	UPDATE [TaskAssignment]
	SET 
		[RemainingWork] = @RemainingWork,
		[RemainingOvertimeWork] = @RemainingOvertimeWork
	WHERE
		[TaskID] = @TaskID AND
		[AssignmentID] = @AssignmentID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END*/
	
	EXEC @rv = pjm6TaskPercentUpdate @TaskID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	EXEC @rv = pjm6TaskPercentUpdate @PrevTaskID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION
	

	EXEC pjm6TimeEntryGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5TimeEntryUpdate TO PUBLIC
GO
 