IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TimeEntryApproveBrowseParameters]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6TimeEntryApproveBrowseParameters'
		DROP PROCEDURE [dbo].[pjm6TimeEntryApproveBrowseParameters]
	END
GO

PRINT 'Creating procedure pjm6TimeEntryApproveBrowseParameters'
GO

/******************************************************************************
**		File:	pjm6TimeEntryApproveBrowseParameters.sql
**		Name: 	pjm6TimeEntryApproveBrowseParameters
**		Desc:	Процедура устанавливает параметры для вышестоящей процедуры, 
** 				которая броузит записи о времени
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	11.03.09	SSA			Первая версия
*******************************************************************************/
CREATE PROCEDURE [dbo].[pjm6TimeEntryApproveBrowseParameters]
	@DateSelector	int,
	@PeriodStart	datetime OUTPUT,
	@PeriodEnd		datetime OUTPUT
AS

	SET NOCOUNT ON	
	SET DATEFIRST 1	

	DECLARE 
		@date datetime

	SET @date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime)

	IF @DateSelector = 1 -- last seven days
		SELECT
			--@PeriodEnd = DATEADD(day, 1, @date),
			@PeriodEnd = GETDATE(),
			@PeriodStart = DATEADD(day, -6, @date)

	IF @DateSelector = 2 -- current month
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), @date, 112) AS datetime),
			@PeriodStart = DATEADD(day, 1-DATEPART(day, @PeriodStart), @PeriodStart),
			@PeriodEnd = GETDATE()
			--@PeriodEnd = DATEADD(month, 1, @PeriodStart)

	IF @DateSelector = 3 -- last month
		SELECT
			@PeriodEnd = DATEADD(day, 1 - DATEPART(day, @date), @date),
			@PeriodStart = DATEADD(month, -1, @PeriodEnd)
			
	IF @DateSelector = 4 -- arbitrary period
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), @PeriodStart, 112) AS datetime),
			@PeriodEnd = CAST(CONVERT(varchar(8), @PeriodEnd, 112) AS datetime),
			@PeriodEnd = DATEADD(day, 1, @PeriodEnd)

	RETURN 0
GO

GRANT EXECUTE ON [pjm6TimeEntryApproveBrowseParameters] TO PUBLIC
GO
 
