IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5UDFGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5UDFGet'
	DROP PROCEDURE [dbo].[pjm5UDFGet]
END
GO

CREATE PROCEDURE pjm5UDFGet
	@Class TName,
	@ID TIdentifier,
	@Name TName,
	@Value TPropertyValue OUTPUT
AS
	
	DECLARE
		@Guid uniqueidentifier,
		@DocumentClass TClass

	SET @DocumentClass = dbo.adfGetClassByName(@Class)
	BEGIN TRY
		SET @Guid = CAST(@Name as uniqueidentifier)
	END TRY
	BEGIN CATCH
		SET @Guid = CAST('00000000-0000-0000-0000-000000000000' as uniqueidentifier)
	END CATCH

	SELECT
		@Value = [PropertyValue].[Value]
	FROM
		[PropertyValue] 
		INNER JOIN [Property]
			ON ([PropertyValue].[PropertyID] = [Property].[ID])
		LEFT OUTER JOIN [PropertyGlobal]
			ON ([Property].[ID] = [PropertyGlobal].[ID] AND 
				[PropertyGlobal].[Language] = dbo.adfGetLanguage())
	WHERE
		(
			ISNULL([PropertyGlobal].[Name], [Property].[Name]) = @Name OR
			[Property].[Guid] = @Guid
		) AND
		[PropertyValue].[DocumentClass] = @DocumentClass AND
		[PropertyValue].[DocumentID] = @ID
		
	RETURN @@error
GO

GRANT EXEC ON pjm5UDFGet TO PUBLIC
GO
