/****** Object:  StoredProcedure [pjmams].[CreateProcessEntry]    Script Date: 12/12/2006 12:24:37 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[pjmams].[CreateProcessEntry]') AND type in (N'P', N'PC'))
BEGIN
	PRINT 'Dropping procedure [pjmams].[CreateProcessEntry]'
	DROP PROCEDURE [pjmams].[CreateProcessEntry]
END
GO

PRINT 'Creating procedure [pjmams].[CreateProcessEntry]'
GO

CREATE PROCEDURE [pjmams].[CreateProcessEntry] 
	@SessionID INT, 
	@Pid INT, 
	@ModuleName nvarchar(max), 
	@ModuleDescription nvarchar(max), 
	@Version varchar(32),
	@Lang varchar(32),
	@UserName nvarchar(128)
AS
	SET NOCOUNT ON
	
	DECLARE @ModuleID INT

	IF RTRIM(LTRIM(@ModuleDescription)) = ''
		SET @ModuleDescription = NULL
		
	SELECT
		@ModuleID = [ID]
	FROM
		[PJMAMS].[Module]
	WHERE
		[Name] = @ModuleName 
		AND ([Description] = @ModuleDescription OR ([Description] IS NULL AND @ModuleDescription IS NULL))
		AND ([Version] = @Version OR ([Version] IS NULL AND @Version IS NULL))
		AND ([Lang] = @Lang OR ([Lang] IS NULL AND @Lang IS NULL))
	
	BEGIN TRANSACTION
	
	IF @ModuleID IS NULL
	BEGIN
		INSERT INTO [pjmams].[Module]
			([Name], [Description], [Version], [Lang])
		VALUES
			(@ModuleName, @ModuleDescription, @Version, @Lang)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END	
		SET @ModuleID = SCOPE_IDENTITY()
	END
	
	INSERT INTO [PJMAMS].[Process] 
		([SessionID], [ModuleID], [PID], [UserName]) 
	VALUES
		(@SessionID, @ModuleID, @Pid, @UserName); 
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SELECT SCOPE_IDENTITY(); 
	COMMIT TRANSACTION
	
	RETURN 0
GO

GRANT EXECUTE ON [pjmams].[CreateProcessEntry] TO [NT AUTHORITY\NETWORK SERVICE]
GO
