/****** Object:  StoredProcedure [pjmams].[ProgramActivityBrowse]    Script Date: 12/12/2006 12:24:37 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[pjmams].[ProgramActivityBrowse]') AND type in (N'P', N'PC'))
BEGIN
	PRINT 'Dropping procedure [pjmams].[ProgramActivityBrowse]'
	DROP PROCEDURE [pjmams].[ProgramActivityBrowse]
END
GO

PRINT 'Creating procedure [pjmams].[ProgramActivityBrowse]'
GO

CREATE PROCEDURE [pjmams].[ProgramActivityBrowse] 
	@Date datetime,
	@Module nvarchar(max)
AS
	SET NOCOUNT ON
	
	DECLARE @Total decimal(18, 2)

	SELECT TOP 1
		@Total = SUM(DATEDIFF(second, [Created], [Closed])) / 60.0
	FROM 
		[pjmams].[Session] 
		INNER JOIN [pjmams].[Process] 
			ON ([Session].[ID] = [Process].[SessionID])
		INNER JOIN [pjmams].[Module]
			ON [Process].[ModuleID] = [Module].[ID]
	WHERE
		CONVERT(datetime, CONVERT(varchar(8), [Created], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		CONVERT(datetime, CONVERT(varchar(8), [Closed], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		ISNULL([Module].[Description], [Module].[Name]) = @Module
	AND
		[Process].[UserName] != '\'
	GROUP BY
		[Process].[UserName],
		[Session].[MachineName]
	ORDER BY 
		 1 DESC
		 
	SELECT
		@Module as [Module],
		@Date as [Date]

	SELECT TOP 20
		ISNULL((SELECT [Employee].[FileAs] FROM [Employee] INNER JOIN [User] ON ([Employee].[UserID]=[User].[ID]) 
			WHERE [User].[NTLogin] = [Process].[UserName]), [Process].[UserName]) as [EmployeeName],
		[Process].[UserName],
		[Session].[MachineName],
		CAST(SUM(DATEDIFF(second, [Created], [Closed])) / CAST(3600 as decimal(18,4)) as decimal(18,2)) as [Duration],
		CAST(SUM(DATEDIFF(second, [Created], [Closed])) / CAST(60 as decimal(18,4)) as decimal(18,2)) * 100 / @Total as [RelativeDuration]
	FROM 
		[pjmams].[Session] 
		INNER JOIN [pjmams].[Process] 
			ON ([Session].[ID] = [Process].[SessionID])
		INNER JOIN [pjmams].[Module]
			ON [Process].[ModuleID] = [Module].[ID]
	WHERE
		CONVERT(datetime, CONVERT(varchar(8), [Created], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		CONVERT(datetime, CONVERT(varchar(8), [Closed], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		ISNULL([Module].[Description], [Module].[Name]) = @Module
	AND
		[Process].[UserName] != '\'
	GROUP BY
		[Process].[UserName],
		[Session].[MachineName]
	ORDER BY 
		 5 DESC
	
	RETURN 0
GO

    