/****** Object:  StoredProcedure [pjmams].[UserActivityBrowse]    Script Date: 12/12/2006 12:24:37 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[pjmams].[UserActivityBrowse]') AND type in (N'P', N'PC'))
BEGIN
	PRINT 'Dropping procedure [pjmams].[UserActivityBrowse]'
	DROP PROCEDURE [pjmams].[UserActivityBrowse]
END
GO

PRINT 'Creating procedure [pjmams].[UserActivityBrowse]'
GO

CREATE PROCEDURE [pjmams].[UserActivityBrowse] 
	@Date datetime,
	@UserName nvarchar(128),
	@MachineName nvarchar(128)
AS
	SET NOCOUNT ON
	
	DECLARE @EmployeeName TName
	
	SELECT
		@EmployeeName = [FileAs]
	FROM
		[Employee] INNER JOIN [User]
			ON ([Employee].[UserID] = [User].[ID])
	WHERE
		[User].[NTLogin] = @UserName
	
	SET @EmployeeName = ISNULL(@EmployeeName, @UserName)
	
	DECLARE @Total decimal(18, 2)

	SELECT TOP 1
		@Total = CAST(SUM(DATEDIFF(second, [Created], [Closed])) / CAST(60 as decimal(18,4)) as decimal(18,2))
	FROM 
		[pjmams].[Session] 
		INNER JOIN [pjmams].[Process] 
			ON ([Session].[ID] = [Process].[SessionID])
		INNER JOIN [pjmams].[Module]
			ON [Process].[ModuleID] = [Module].[ID]
	WHERE
		CONVERT(datetime, CONVERT(varchar(8), [Created], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		CONVERT(datetime, CONVERT(varchar(8), [Closed], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		[Process].[UserName] = @UserName AND [Session].[MachineName]=@MachineName
	GROUP BY
		ISNULL([Module].[Description], [Module].[Name])
	ORDER BY
		1 DESC;
		
	SELECT
		@EmployeeName as [EmployeeName],
		@Date as [Date]

	SELECT TOP 10
		ISNULL([Module].[Description], [Module].[Name]) as [Name], 
		CAST(SUM(DATEDIFF(second, [Created], [Closed])) / CAST(3600 as decimal(18,4)) as decimal(18,2)) as [Duration],
		CAST(SUM(DATEDIFF(second, [Created], [Closed])) / CAST(60 as decimal(18,4)) as decimal(18,2)) * 100 / @Total as [RelativeDuration],
		ISNULL([Module].[Description], [Module].[Name]) as [Module]
	FROM 
		[pjmams].[Session] 
		INNER JOIN [pjmams].[Process] 
			ON ([Session].[ID] = [Process].[SessionID])
		INNER JOIN [pjmams].[Module]
			ON [Process].[ModuleID] = [Module].[ID]
	WHERE
		CONVERT(datetime, CONVERT(varchar(8), [Created], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		CONVERT(datetime, CONVERT(varchar(8), [Closed], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		[Process].[UserName] = @UserName AND [Session].[MachineName]=@MachineName
	GROUP BY
		ISNULL([Module].[Description], [Module].[Name])
	HAVING
		CAST(SUM(DATEDIFF(second, [Created], [Closed])) / CAST(60 as decimal(18,4)) as decimal(18,1)) >= 0.1
	ORDER BY 
		 3 DESC	
	
	RETURN 0
GO

  