/****** Object:  StoredProcedure [pjmams].[UserModuleActivityBrowse]    Script Date: 12/12/2006 12:24:37 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[pjmams].[UserModuleActivityBrowse]') AND type in (N'P', N'PC'))
BEGIN
	PRINT 'Dropping procedure [pjmams].[UserModuleActivityBrowse]'
	DROP PROCEDURE [pjmams].[UserModuleActivityBrowse]
END
GO

PRINT 'Creating procedure [pjmams].[UserModuleActivityBrowse]'
GO

CREATE PROCEDURE [pjmams].[UserModuleActivityBrowse] 
	@Date datetime,
	@UserName nvarchar(128),
	@MachineName nvarchar(128),
	@Module nvarchar(max)
AS
	SET NOCOUNT ON
	
	DECLARE @EmployeeName TName
	
	SELECT
		@EmployeeName = [FileAs]
	FROM
		[Employee] INNER JOIN [User]
			ON ([Employee].[UserID] = [User].[ID])
	WHERE
		[User].[NTLogin] = @UserName
	
	SET @EmployeeName = ISNULL(@EmployeeName, @UserName)
	
	SELECT
		@EmployeeName as [EmployeeName],
		@MachineName as [MachineName],
		@Module as [Module],
		@Date as [Date]

	SELECT
		[Window].[Caption] as [Window],
		MIN([Window].[Created]) as [Created]
	FROM 
		[pjmams].[Session] 
		INNER JOIN [pjmams].[Process] 
			ON ([Session].[ID] = [Process].[SessionID])
		INNER JOIN [pjmams].[Module]
			ON ([Process].[ModuleID] = [Module].[ID])
		INNER JOIN [pjmams].[Window]
			ON ([Window].[ProcessID] = [Process].[ID])
	WHERE
		CONVERT(datetime, CONVERT(varchar(8), [Window].[Created], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		[Process].[UserName] = @UserName AND [Session].[MachineName]=@MachineName
	AND
		ISNULL([Module].[Description], [Module].[Name]) = @Module
	GROUP BY
		[Window].[Caption]
	ORDER BY
		2 DESC
			
	RETURN 0
GO

   