/****** Object:  StoredProcedure [pjmams].[WorkstationsActivityBrowse]    Script Date: 12/12/2006 12:24:37 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[pjmams].[WorkstationsActivityBrowse]') AND type in (N'P', N'PC'))
BEGIN
	PRINT 'Dropping procedure [pjmams].[WorkstationsActivityBrowse]'
	DROP PROCEDURE [pjmams].[WorkstationsActivityBrowse]
END
GO

PRINT 'Creating procedure [pjmams].[WorkstationsActivityBrowse]'
GO

CREATE PROCEDURE [pjmams].[WorkstationsActivityBrowse] @Date datetime
AS
	SET NOCOUNT ON
	
	SELECT
		@Date as [Date]
		
	DECLARE @Total decimal(18, 2)
	
	SELECT TOP 1
		@Total = SUM(DATEDIFF(second, [Created], [Closed])) / 60.0
	FROM 
		[pjmams].[Session] 
		INNER JOIN [pjmams].[Process] 
			ON ([Session].[ID] = [Process].[SessionID])
		INNER JOIN [pjmams].[Module]
			ON [Process].[ModuleID] = [Module].[ID]
	WHERE
		[Process].[UserName] != '\' 
	AND
		CONVERT(datetime, CONVERT(varchar(8), [Created], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		CONVERT(datetime, CONVERT(varchar(8), [Closed], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	GROUP BY
		[Session].[MachineName]
	ORDER BY
		1 DESC;

	SELECT
		[Session].[MachineName],
		CAST(SUM(DATEDIFF(second, [Created], [Closed])) / CAST(3600 as decimal(18,4)) as decimal(18,2)) as [Duration],
		CAST(SUM(DATEDIFF(second, [Created], [Closed])) / CAST(60 as decimal(18,4)) as decimal(18,2)) * 100 / @Total as [RelativeDuration]
	FROM 
		[pjmams].[Session] 
		INNER JOIN [pjmams].[Process] 
			ON ([Session].[ID] = [Process].[SessionID])
		INNER JOIN [pjmams].[Module]
			ON [Process].[ModuleID] = [Module].[ID]
	WHERE
		[Process].[UserName] != '\' 
	AND
		CONVERT(datetime, CONVERT(varchar(8), [Created], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		CONVERT(datetime, CONVERT(varchar(8), [Closed], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	GROUP BY
		[Session].[MachineName]
	ORDER BY 
		 3 DESC
	
	RETURN 0
GO

    